-- This file consists of a generic synchronious register

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY registers IS
	GENERIC (n : INTEGER := 14;  --default is 14bit
		rising_falling : INTEGER := 1); --if =1 the the register triggers on rising. 0 gives opposite operation	
	PORT (
		input: IN STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		clock: IN STD_LOGIC;
		output: OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0)
	);
END registers;

ARCHITECTURE structure OF registers IS

--SIGNAL CLK <= NOT(clock) WHEN rising_falling == '1' ELSE clock;

BEGIN
	GENERIC_REGISTER : PROCESS (clock)
	BEGIN
		IF(rising_edge(clock)) THEN
			output <= input;
		END IF;
	END PROCESS;
END structure;