/*
 * colorManipulation.h
 *
 *  Created on: 10.mai.2010
 *      Author: Cato
 */

#ifndef COLORMANIPULATION_H_
#define COLORMANIPULATION_H_

#include "raw2rbg.h"

typedef struct
{
	float Y;
	float CB;
	float CR;
} YCBCR;

//YCbCr to RGB = factors * (Y - 16, Cb - 128, Cr - 128)
static float ycbcrTOrgb_factors[3][3] = {{1.164f,0.000f,1.596f},{1.164f,-0.392f,-0.813f},{1.164f,2.017f,0.000f}};

//RGB to YCbCr = [16;128;128] + factors * RGB_data
static float rbgTOycbcr_factors[3][3] = {{0.257f,0.504f,0.098f},{-0.148f,-0.291f,0.439f},{0.439f,-0.368f,-0.071f}};



RGB YCbCrtoRGB_SW(YCBCR);
YCBCR RGBtoYCbCr_SW(RGB);
float MULT_float_SW(float, float,int);
RGB colorInversion_SW(RGB);

RGB YCbCrtoRGB_HW(YCBCR);
YCBCR RGBtoYCbCr_HW(RGB);
float MULT_float_HW(float, float,int);
RGB colorInversion_HW(RGB);

#endif /* COLORMANIPULATION_H_ */
