/*
 * colorManipulationHW.c
 *
 *  Created on: 10.mai.2010
 *      Author: Cato
 */

#include "colorManipulation.h"

RGB colorInversion_HW(RGB data)
{
	//The software implementation of inverting the colors is much more demanding vs. the HW one. In software this
	//operation demands subtraction vs. in HW one can simply invert the binary value with use of an inverter.
	data.R = 4095 - data.R; //4095 = 2^12 -1 which is the highest value of 12 bits.
	data.G = 4095 - data.G;
	data.B = 4095 - data.B;

	return data;

}

YCBCR RGBtoYCbCr_HW(RGB data)
{
	YCBCR result;
	float tmp_result[3];
	unsigned int RGB[3] = {(data.R),(data.G),(data.B)};
	int n = 0;
	int m = 0;
	for(;n<3;n++)
	{
		tmp_result[n] = 0;
		m = 0;
		for(;m<3;m++)
		{
			tmp_result[n] += rbgTOycbcr_factors[n][m] * RGB[m];
		}
	}
	result.Y = 16 + tmp_result[0];
	result.CB = 128 + tmp_result[1];
	result.CR = 128 + tmp_result[2];

	return result;

}

RGB YCbCrtoRGB_HW(YCBCR data)
{
	float tmp_result[3];
	RGB result;
	int n = 0;
	int m = 0;
	float YCBCR[3] = {data.Y - 16,data.CB - 128,data.CR - 128};
	for(;n<3;n++)
	{
		tmp_result[n] = 0;
		m = 0;
		for(;m<3;m++)
		{
			tmp_result[n] += ycbcrTOrgb_factors[n][m] * YCBCR[m];
		}
	}
	if(tmp_result[0]<0) result.R = 0;
	else result.R = (int) tmp_result[0]+1;

	if(tmp_result[1]<0) result.G = 0;
	else result.G = (int) tmp_result[1]+1;

	if(tmp_result[2]<0) result.B = 0;
	else result.B = (int) tmp_result[2]+1;

	return result;

}

float MULT_float_HW(float a, float b,int times)
{
	int i = 0;
		for(;i<times;i++)
		{
			a*b;
		}
		return a * b;
}
