/*
 * main.c
 *
 *  Created on: 09.apr.2010
 *      Author: Cato
 */

#include "camera.h"
#include "switches.h"
#include "timer.h"
#include "LCD.h"
#include "raw2rbg.h"
#include "sys/alt_stdio.h"
#include <stdio.h>
#include "system.h"
#include "sys/alt_irq.h"


void interrupt_init(void);
static void push_isr(void*, alt_u32);
static void cameraConfig_isr(void*, alt_u32);
static void raw2rbg_isr(void*, alt_u32);
//static void handleTimerInterrupt (void*, alt_u32);

unsigned int EDGE_CAP_VAL_buttons = 0;
unsigned char xy = 0;
unsigned int mDATA_0,mDATA_1 = 0;
unsigned int mDATAd_0,mDATAd_1 = 0;


int main()
{
//	alt_putstr("Hello from Nios II master Marwell!\n");
	interrupt_init();
	camera_init();
//	timer_init(); //Activates the timer and its service routine
	lcd_init();
	while(1)
	{

	}

	return 0;
}

void interrupt_init(void)
{
	//	This part activates interrupt on 8 switches SW[8..0] and links the
	//	interrupt on falling edge to the push_isr() interrupt service routine
	IOWR_ALTERA_AVALON_PIO_IRQ_MASK(SWINT_BASE,0xFF);
	alt_irq_register(SWINT_IRQ,(void *) 0, push_isr);

	//Activates the interrupt on the 6bits. Any changes on the masked bits will trigger an interrupt
	//Links the interrupt and the ISR it should trigger
	IOWR_ALTERA_AVALON_PIO_IRQ_MASK(LUT_INDEX_BASE,0x3F);
	alt_irq_register(LUT_INDEX_IRQ,(void *) 0, cameraConfig_isr);

	IOWR_ALTERA_AVALON_PIO_IRQ_MASK(PIX_VALCLK_BASE,0x00);
	alt_irq_register(PIX_VALCLK_IRQ,(void *) 0, raw2rbg_isr);

	//Binding the counter to the correct IRS
//	alt_irq_register(TIMER_0_IRQ, (void *) 0, handleTimerInterrupt);

}

static void cameraConfig_isr(void* contex, alt_u32 id)
{
	// Value = 0, clears the interrupt reg and makes it ready to trigger on a new interrupt
	IOWR_ALTERA_AVALON_PIO_EDGE_CAP(LUT_INDEX_BASE,LUT_INDEX_BIT_CLEARING_EDGE_REGISTER);
	camera_config();
}

static void push_isr(void* contex, alt_u32 id)
{
	EDGE_CAP_VAL_buttons = IORD_ALTERA_AVALON_PIO_EDGE_CAP(SWINT_BASE);
//	printf("EDGE_CAP_VALUE aka ''The Button switched'': %x \n", EDGE_CAP_VAL_buttons);
	buttonHandler(EDGE_CAP_VAL_buttons);
	IOWR_ALTERA_AVALON_PIO_EDGE_CAP(SWINT_BASE,SWINT_BIT_CLEARING_EDGE_REGISTER);
}

static void raw2rbg_isr(void* contex, alt_u32 id)
{
	IOWR_ALTERA_AVALON_PIO_EDGE_CAP(PIX_VALCLK_BASE,PIX_VALCLK_BIT_CLEARING_EDGE_REGISTER);
	xy = IORD_ALTERA_AVALON_PIO_DATA(CCD_XY_BASE);
	mDATA_0 = IORD_ALTERA_AVALON_PIO_DATA(IN_MDATA_0_BASE);
	mDATAd_0 = IORD_ALTERA_AVALON_PIO_DATA(IN_MDATAD_0_BASE);
	mDATA_1 = IORD_ALTERA_AVALON_PIO_DATA(IN_MDATA_1_BASE);
	mDATAd_1 = IORD_ALTERA_AVALON_PIO_DATA(IN_MDATAD_1_BASE);
	demosaic(0xFFF,mDATAd_0,mDATA_1,mDATAd_1,xy);
}

/*
static void handleTimerInterrupt(void* contex, alt_u32 id)
{
	// Display the value with leds
	IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE, 0xFF);
	// Clear the interrupt flag - setting the TO to 0, the TO is set to 1 when an interrupt occurs
	IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER_0_BASE, 0);
}
*/

