
#include "raw2rbg.h"
#include "colorManipulation.h"

RGB data;

unsigned int counter = 0;
static unsigned char invert_flag = 0;
int i = 0;

//This demosaic alg. does just use the neighboring pixels to calculate the missing colors.
void demosaic(unsigned int mDATA_0,unsigned int mDATAd_0,unsigned int mDATA_1,unsigned int mDATAd_1,char xy)
{

	//If the coordinate is (0,0) then calculate the other color data for the pixel.
	if(xy == 0x0) // x = 0, y = 0
	{
		data.R = mDATA_1;
		data.G = mDATAd_1;
		data.B = mDATAd_0;
		if(invert_flag) transmit_RGB(colorInversion_HW(data));
		else transmit_RGB(data);
	}

}

void setInvertFlag(unsigned char inn)
{
	invert_flag = inn;
}

static unsigned char counter_flag = 0;

void reset_counter_flag(void)
{
	counter_flag = 0;
}

void video_test(void)
{

	if(counter_flag == 0)
	{
		lcd_string_write("Color Processing..",0);
		lcd_string_write("Display RGB",1);
	}
	else if(counter_flag == 1)
	{
		lcd_string_write("Color invert",1);
	}
	else if(counter_flag == 2)
	{
		lcd_string_write("RGB<->YCbCr (HW)",1);
	}
	else if(counter_flag == 3)
	{
		lcd_string_write("Color invert",1);
	}
	else if(counter_flag == 4)
	{
		lcd_string_write("RGB<->YCbCr (SW)",1);
	}
	else if(counter_flag == 5)
	{
		lcd_string_write("All Done",1);
	}

	data.R = 0xFFF;
	data.G = 0x000;
	data.B = 0x000;

	i = 0;

	for(;i < 640*160;i++)
	{
		if(counter_flag == 0) transmit_RGB(data);
		if(counter_flag == 1) transmit_RGB(colorInversion_HW(data));
		if(counter_flag == 2) transmit_RGB(YCbCrtoRGB_HW(RGBtoYCbCr_HW(data)));
		if(counter_flag == 3) transmit_RGB(colorInversion_SW(data));
		if(counter_flag == 4) transmit_RGB(YCbCrtoRGB_SW(RGBtoYCbCr_SW(data)));
	}

	i = 0;
	data.R = 0x000;
	data.G = 0xFFF;
	data.B = 0x000;

	for(;i < 640*160;i++)
	{
		if(counter_flag == 0) transmit_RGB(data);
		if(counter_flag == 1) transmit_RGB(colorInversion_HW(data));
		if(counter_flag == 2) transmit_RGB(YCbCrtoRGB_HW(RGBtoYCbCr_HW(data)));
		if(counter_flag == 3) transmit_RGB(colorInversion_SW(data));
		if(counter_flag == 4) transmit_RGB(YCbCrtoRGB_SW(RGBtoYCbCr_SW(data)));
	}
	i = 0;
	data.R = 0x000;
	data.G = 0x000;
	data.B = 0xFFF;

	for(;i < 640*160;i++)
	{
		if(counter_flag == 0) transmit_RGB(data);
		else if(counter_flag == 1) transmit_RGB(colorInversion_HW(data));
		else if(counter_flag == 2) transmit_RGB(YCbCrtoRGB_HW(RGBtoYCbCr_HW(data)));
		else if(counter_flag == 3) transmit_RGB(colorInversion_SW(data));
		else if(counter_flag == 4) transmit_RGB(YCbCrtoRGB_SW(RGBtoYCbCr_SW(data)));
	}

	if(counter_flag == 5)
	{
		counter_flag = 0;
		transmit_RGB_black_screen();
	}
	else counter_flag++;

}

void transmit_RGB_black_screen(void)
{
	data.R = 0x000;
	data.G = 0x000;
	data.B = 0x000;
	int n = 0;
	for(;n<640*480;n++)	transmit_RGB(data);
}

void transmit_RGB(RGB inndata)
{
	IOWR_ALTERA_AVALON_PIO_DATA(RED_BASE,inndata.R);
	IOWR_ALTERA_AVALON_PIO_DATA(GREEN_BASE,inndata.G);
	IOWR_ALTERA_AVALON_PIO_DATA(BLUE_BASE,inndata.B);
	IOWR_ALTERA_AVALON_PIO_DATA(DVAL_BASE,0x1);
	IOWR_ALTERA_AVALON_PIO_DATA(DVAL_BASE,0x0);

}



