/*
 * switches.c
 *
 *  Created on: 09.apr.2010
 *      Author: Cato
 */

#include "switches.h"


static unsigned char invert_flag = 0;
static int exposuretime_HW_adj_count,exposuretime_SW_adj_count = 0;

void switches_init()
{

}

void buttonHandler(unsigned int EDGE_CAP_VAL)
{
	switch(EDGE_CAP_VAL)
	{

		case(0x01): //Start capture device
		{
			//alt_printf("START\n");
			IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE, IORD_ALTERA_AVALON_PIO_DATA(LEDS_BASE)|0x01); //setting out_nios_start_cam '1'
			usleep(1);
			IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE, IORD_ALTERA_AVALON_PIO_DATA(LEDS_BASE)&0xFE); //setting out_nios_start_cam back to '1'
			break;
		}

		case (0x02): //Stop capture device
		{
			//alt_printf("STOP\n");
			IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE, IORD_ALTERA_AVALON_PIO_DATA(LEDS_BASE)|0x02); //setting out_nios_stop_cam '1'
			usleep(1);
			IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE, IORD_ALTERA_AVALON_PIO_DATA(LEDS_BASE)&0xFD); //setting out_nios_stop_cam back to '1'
			break;
		}

		case (0x04): //Activate Hardware video mode
		{
			lcd_string_write("Video",0);
			lcd_string_write("RAW2RGB in HW...",1);
			IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE,0x4);
			//Deactivates potential interrupt on PIX_VALCLK
			IOWR_ALTERA_AVALON_PIO_IRQ_MASK(PIX_VALCLK_BASE,0x00);
			//Activate HW readout on MUX
			IOWR_ALTERA_AVALON_PIO_DATA(RAW2RGB_CONTROL_OUT_BASE, 0x0);
			//Set to high frame rate -> Now is set to 75MHz PIXCLK 0x111802 ->50MHZ
			set_LUT_DATA_CFG_array(11,0x111801);
			set_LUT_DATA_CFG_array(12,0x120003);
			//Set contrast and reset count
			set_LUT_DATA_CFG_array(2,0x0907c0);
			exposuretime_HW_adj_count = 0;
			//Reset color mode
			reset_counter_flag();
			//setting out_nios_RST '1'
			IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x01);
			//setting out_nios_RST back to '0'
			IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x00);
			break;
		}

		case (0x08): //Activate Software video mode
		{

			lcd_string_write("Video",0);
			lcd_string_write("RAW2RGB in SW...",1);
			IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE,0x8);
			set_LUT_DATA_CFG_array(11,0x11183F); //Very low frame rate 
			set_LUT_DATA_CFG_array(12,0x12001f); //Very low frame rate 
			set_LUT_DATA_CFG_array(2,0x090020); //Setting a short exposure time
			exposuretime_SW_adj_count = 0; //Reset exposure time count
			set_LUT_DATA_CFG_array(22,0x220011); //Setting row mode
			set_LUT_DATA_CFG_array(23,0x230011); //Setting column mode
			//Reset color mode
			reset_counter_flag();
			//Activate SW readout on MUX
			IOWR_ALTERA_AVALON_PIO_DATA(RAW2RGB_CONTROL_OUT_BASE,IORD_ALTERA_AVALON_PIO_DATA(RAW2RGB_CONTROL_OUT_BASE)|0x8);
			//Activate interrupt on PIX_VALCLK
			IOWR_ALTERA_AVALON_PIO_IRQ_MASK(PIX_VALCLK_BASE,0x01);
			//setting out_nios_RST '1'
			IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x01);
			//setting out_nios_RST back to '0'
			IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x00);

/*			PERF_RESET(PERFORMANCE_COUNTER_0_BASE);
			PERF_START_MEASURING(PERFORMANCE_COUNTER_0_BASE);
			PERF_BEGIN(PERFORMANCE_COUNTER_0_BASE,1);
			float n1,n2,sum;
			n1 = 125.5678;
			n2 = 456.234;
			sum = n1 * n2;
			PERF_END(PERFORMANCE_COUNTER_0_BASE,1);
			PERF_STOP_MEASURING(PERFORMANCE_COUNTER_0_BASE);
			printf("CPU frequency: %d \n",(int) alt_get_cpu_freq());
			printf("Performance result: %d \n",(int) perf_get_section_time((void *) PERFORMANCE_COUNTER_0_BASE,1));
			IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE, 0x00);

*/			break;
		}

		case (0x10): //Activates color test mode
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE,0x10);
			//Deactivates potential interrupt on PIX_VALCLK
			IOWR_ALTERA_AVALON_PIO_IRQ_MASK(PIX_VALCLK_BASE,0x00);
			//Activate SW readout on MUX
			IOWR_ALTERA_AVALON_PIO_DATA(RAW2RGB_CONTROL_OUT_BASE, 0x8);
			//Run video test
			video_test();
			//Deactivate software readout on MUX
			IOWR_ALTERA_AVALON_PIO_DATA(RAW2RGB_CONTROL_OUT_BASE, 0x0);

/*			PERF_RESET(PERFORMANCE_COUNTER_0_BASE);
			PERF_START_MEASURING(PERFORMANCE_COUNTER_0_BASE);
			PERF_BEGIN(PERFORMANCE_COUNTER_0_BASE,2);
			int n1,n2,sum;
			n1 = 125;
			n2 = 456;
			sum = n1 * n2;
			PERF_END(PERFORMANCE_COUNTER_0_BASE,2);
			PERF_STOP_MEASURING(PERFORMANCE_COUNTER_0_BASE);
			printf("CPU frequency: %d \n",(int)alt_get_cpu_freq());
			printf("Performance result: %d \n",(int) perf_get_section_time((void *) PERFORMANCE_COUNTER_0_BASE,2));
		*/	break;
		}

		case (0x20): //Activate/deactivate inverting of video signal. Takes into account which of the modes the system is in
		{
			invert_flag = ~invert_flag;

			if(invert_flag)
			{
				IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE,IORD_ALTERA_AVALON_PIO_DATA(LEDS_BASE)|0x20);
				if(IORD_ALTERA_AVALON_PIO_IRQ_MASK(PIX_VALCLK_BASE)==0x00)
				{
					IOWR_ALTERA_AVALON_PIO_DATA(RAW2RGB_CONTROL_OUT_BASE, IORD_ALTERA_AVALON_PIO_DATA(RAW2RGB_CONTROL_OUT_BASE)|0x1);
				}
				else setInvertFlag(1);
			}
			else
			{
				IOWR_ALTERA_AVALON_PIO_DATA(LEDS_BASE,IORD_ALTERA_AVALON_PIO_DATA(LEDS_BASE)&0xDF);
				if(IORD_ALTERA_AVALON_PIO_IRQ_MASK(PIX_VALCLK_BASE)==0x00)
				{
					IOWR_ALTERA_AVALON_PIO_DATA(RAW2RGB_CONTROL_OUT_BASE, IORD_ALTERA_AVALON_PIO_DATA(RAW2RGB_CONTROL_OUT_BASE)&0xFE);
				}
				else setInvertFlag(0);

			}
			break;
		}

		case (0x40): //Increase exposure, takes the video mode into account
		{
			//If in HW
			if(IORD_ALTERA_AVALON_PIO_IRQ_MASK(PIX_VALCLK_BASE)==0x00)
			{
				if(exposuretime_HW_adj_count<=5)
				{
					//Increases the exposure time with 200
					set_LUT_DATA_CFG_array(2,get_LUT_DATA_CFG_array(2)+exposure_HW_const);
					exposuretime_HW_adj_count++;

					//---- Transmitting the new contrast-----
					//setting out_nios_RST '1'
					IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x01);
					//setting out_nios_RST back to '0'
					IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x00);
					//---- end transmission
				}
			}
			else
			{
				if(exposuretime_SW_adj_count<=5)
				{
					//Increases the exposure time with 5
					set_LUT_DATA_CFG_array(2,get_LUT_DATA_CFG_array(2)+exposure_SW_const);
					exposuretime_SW_adj_count++;

					//---- Transmitting the new contrast-----
					//setting out_nios_RST '1'
					IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x01);
					//setting out_nios_RST back to '0'
					IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x00);
					//---- end transmission
				}
			}

			/*
			 *
			PERF_RESET(PERFORMANCE_COUNTER_0_BASE);
			PERF_START_MEASURING(PERFORMANCE_COUNTER_0_BASE);
			PERF_BEGIN(PERFORMANCE_COUNTER_0_BASE,1);

			PERF_END(PERFORMANCE_COUNTER_0_BASE,1);
			PERF_STOP_MEASURING(PERFORMANCE_COUNTER_0_BASE);
			printf("CPU frequency: %d \n",(int)alt_get_cpu_freq());
			printf("Performance result SW: %d \n",(int) perf_get_section_time((void *) PERFORMANCE_COUNTER_0_BASE,1));
			*/
			break;
		}

		case (0x80): //Increase exposure, takes the video mode into account
		{
			//If in HW
			if(IORD_ALTERA_AVALON_PIO_IRQ_MASK(PIX_VALCLK_BASE)==0x00)
			{
				if(exposuretime_HW_adj_count>=-5)
				{
					//Increases the exposure time with 200
					set_LUT_DATA_CFG_array(2,get_LUT_DATA_CFG_array(2)-exposure_HW_const);
					exposuretime_HW_adj_count--;

					//---- Transmitting the new contrast-----
					//setting out_nios_RST '1'
					IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x01);
					//setting out_nios_RST back to '0'
					IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x00);
					//---- end transmission
				}
			}
			else
			{
				if(exposuretime_SW_adj_count>=-5)
				{
					//Increases the exposure time with 5
					set_LUT_DATA_CFG_array(2,get_LUT_DATA_CFG_array(2)-exposure_SW_const);
					exposuretime_SW_adj_count--;

					//---- Transmitting the new contrast-----
					//setting out_nios_RST '1'
					IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x01);
					//setting out_nios_RST back to '0'
					IOWR_ALTERA_AVALON_PIO_DATA(RESET_OUT_BASE, 0x00);
					//---- end transmission
				}
			}

/*
			RGB testdataRGB;
			testdataRGB.R = 0xF0F;
			testdataRGB.G = 0x000;
			testdataRGB.B = 0x000;
			YCBCR resultYCBCR;
			RGB resultRGB;

			PERF_RESET(PERFORMANCE_COUNTER_0_BASE);
			PERF_START_MEASURING(PERFORMANCE_COUNTER_0_BASE);
			PERF_BEGIN(PERFORMANCE_COUNTER_0_BASE,1);
			resultYCBCR = RGBtoYCbCr_SW(testdataRGB);
			PERF_END(PERFORMANCE_COUNTER_0_BASE,1);
			PERF_STOP_MEASURING(PERFORMANCE_COUNTER_0_BASE);
			printf("CPU frequency: %d \n",(int) alt_get_cpu_freq());
			printf("Performance result HW: %d \n",(int) perf_get_section_time((void *) PERFORMANCE_COUNTER_0_BASE,1));*/
			break;
		}

		default:
		{
			break;
		}

	}

}
