--megafunction wizard: %Altera SOPC Builder%
--GENERATION: STANDARD
--VERSION: WM1.0


--Legal Notice: (C)2010 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity BLUE_s1_arbitrator is 
        port (
              -- inputs:
                 signal BLUE_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal BLUE_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal BLUE_s1_chipselect : OUT STD_LOGIC;
                 signal BLUE_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal BLUE_s1_reset_n : OUT STD_LOGIC;
                 signal BLUE_s1_write_n : OUT STD_LOGIC;
                 signal BLUE_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal cpu_0_data_master_granted_BLUE_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_BLUE_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_BLUE_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_BLUE_s1 : OUT STD_LOGIC;
                 signal d1_BLUE_s1_end_xfer : OUT STD_LOGIC
              );
end entity BLUE_s1_arbitrator;


architecture europa of BLUE_s1_arbitrator is
                signal BLUE_s1_allgrants :  STD_LOGIC;
                signal BLUE_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal BLUE_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal BLUE_s1_any_continuerequest :  STD_LOGIC;
                signal BLUE_s1_arb_counter_enable :  STD_LOGIC;
                signal BLUE_s1_arb_share_counter :  STD_LOGIC;
                signal BLUE_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal BLUE_s1_arb_share_set_values :  STD_LOGIC;
                signal BLUE_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal BLUE_s1_begins_xfer :  STD_LOGIC;
                signal BLUE_s1_end_xfer :  STD_LOGIC;
                signal BLUE_s1_firsttransfer :  STD_LOGIC;
                signal BLUE_s1_grant_vector :  STD_LOGIC;
                signal BLUE_s1_in_a_read_cycle :  STD_LOGIC;
                signal BLUE_s1_in_a_write_cycle :  STD_LOGIC;
                signal BLUE_s1_master_qreq_vector :  STD_LOGIC;
                signal BLUE_s1_non_bursting_master_requests :  STD_LOGIC;
                signal BLUE_s1_reg_firsttransfer :  STD_LOGIC;
                signal BLUE_s1_slavearbiterlockenable :  STD_LOGIC;
                signal BLUE_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal BLUE_s1_unreg_firsttransfer :  STD_LOGIC;
                signal BLUE_s1_waits_for_read :  STD_LOGIC;
                signal BLUE_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_BLUE_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_BLUE_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_BLUE_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_BLUE_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_BLUE_s1 :  STD_LOGIC;
                signal shifted_address_to_BLUE_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_BLUE_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT BLUE_s1_end_xfer;
    end if;

  end process;

  BLUE_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_BLUE_s1);
  --assign BLUE_s1_readdata_from_sa = BLUE_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  BLUE_s1_readdata_from_sa <= BLUE_s1_readdata;
  internal_cpu_0_data_master_requests_BLUE_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000011110000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --BLUE_s1_arb_share_counter set values, which is an e_mux
  BLUE_s1_arb_share_set_values <= std_logic'('1');
  --BLUE_s1_non_bursting_master_requests mux, which is an e_mux
  BLUE_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_BLUE_s1;
  --BLUE_s1_any_bursting_master_saved_grant mux, which is an e_mux
  BLUE_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --BLUE_s1_arb_share_counter_next_value assignment, which is an e_assign
  BLUE_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(BLUE_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(BLUE_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(BLUE_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(BLUE_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --BLUE_s1_allgrants all slave grants, which is an e_mux
  BLUE_s1_allgrants <= BLUE_s1_grant_vector;
  --BLUE_s1_end_xfer assignment, which is an e_assign
  BLUE_s1_end_xfer <= NOT ((BLUE_s1_waits_for_read OR BLUE_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_BLUE_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_BLUE_s1 <= BLUE_s1_end_xfer AND (((NOT BLUE_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --BLUE_s1_arb_share_counter arbitration counter enable, which is an e_assign
  BLUE_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_BLUE_s1 AND BLUE_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_BLUE_s1 AND NOT BLUE_s1_non_bursting_master_requests));
  --BLUE_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      BLUE_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(BLUE_s1_arb_counter_enable) = '1' then 
        BLUE_s1_arb_share_counter <= BLUE_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --BLUE_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      BLUE_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((BLUE_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_BLUE_s1)) OR ((end_xfer_arb_share_counter_term_BLUE_s1 AND NOT BLUE_s1_non_bursting_master_requests)))) = '1' then 
        BLUE_s1_slavearbiterlockenable <= BLUE_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master BLUE/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= BLUE_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --BLUE_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  BLUE_s1_slavearbiterlockenable2 <= BLUE_s1_arb_share_counter_next_value;
  --cpu_0/data_master BLUE/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= BLUE_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --BLUE_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  BLUE_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_BLUE_s1 <= internal_cpu_0_data_master_requests_BLUE_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_BLUE_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_BLUE_s1 <= (internal_cpu_0_data_master_granted_BLUE_s1 AND cpu_0_data_master_read) AND NOT BLUE_s1_waits_for_read;
  --BLUE_s1_writedata mux, which is an e_mux
  BLUE_s1_writedata <= cpu_0_data_master_writedata (11 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_BLUE_s1 <= internal_cpu_0_data_master_qualified_request_BLUE_s1;
  --cpu_0/data_master saved-grant BLUE/s1, which is an e_assign
  cpu_0_data_master_saved_grant_BLUE_s1 <= internal_cpu_0_data_master_requests_BLUE_s1;
  --allow new arb cycle for BLUE/s1, which is an e_assign
  BLUE_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  BLUE_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  BLUE_s1_master_qreq_vector <= std_logic'('1');
  --BLUE_s1_reset_n assignment, which is an e_assign
  BLUE_s1_reset_n <= reset_n;
  BLUE_s1_chipselect <= internal_cpu_0_data_master_granted_BLUE_s1;
  --BLUE_s1_firsttransfer first transaction, which is an e_assign
  BLUE_s1_firsttransfer <= A_WE_StdLogic((std_logic'(BLUE_s1_begins_xfer) = '1'), BLUE_s1_unreg_firsttransfer, BLUE_s1_reg_firsttransfer);
  --BLUE_s1_unreg_firsttransfer first transaction, which is an e_assign
  BLUE_s1_unreg_firsttransfer <= NOT ((BLUE_s1_slavearbiterlockenable AND BLUE_s1_any_continuerequest));
  --BLUE_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      BLUE_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(BLUE_s1_begins_xfer) = '1' then 
        BLUE_s1_reg_firsttransfer <= BLUE_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --BLUE_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  BLUE_s1_beginbursttransfer_internal <= BLUE_s1_begins_xfer;
  --~BLUE_s1_write_n assignment, which is an e_mux
  BLUE_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_BLUE_s1 AND cpu_0_data_master_write));
  shifted_address_to_BLUE_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --BLUE_s1_address mux, which is an e_mux
  BLUE_s1_address <= A_EXT (A_SRL(shifted_address_to_BLUE_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_BLUE_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_BLUE_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_BLUE_s1_end_xfer <= BLUE_s1_end_xfer;
    end if;

  end process;

  --BLUE_s1_waits_for_read in a cycle, which is an e_mux
  BLUE_s1_waits_for_read <= BLUE_s1_in_a_read_cycle AND BLUE_s1_begins_xfer;
  --BLUE_s1_in_a_read_cycle assignment, which is an e_assign
  BLUE_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_BLUE_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= BLUE_s1_in_a_read_cycle;
  --BLUE_s1_waits_for_write in a cycle, which is an e_mux
  BLUE_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(BLUE_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --BLUE_s1_in_a_write_cycle assignment, which is an e_assign
  BLUE_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_BLUE_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= BLUE_s1_in_a_write_cycle;
  wait_for_BLUE_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_BLUE_s1 <= internal_cpu_0_data_master_granted_BLUE_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_BLUE_s1 <= internal_cpu_0_data_master_qualified_request_BLUE_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_BLUE_s1 <= internal_cpu_0_data_master_requests_BLUE_s1;
--synthesis translate_off
    --BLUE/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity CCD_XY_s1_arbitrator is 
        port (
              -- inputs:
                 signal CCD_XY_s1_irq : IN STD_LOGIC;
                 signal CCD_XY_s1_readdata : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal CCD_XY_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal CCD_XY_s1_chipselect : OUT STD_LOGIC;
                 signal CCD_XY_s1_irq_from_sa : OUT STD_LOGIC;
                 signal CCD_XY_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal CCD_XY_s1_reset_n : OUT STD_LOGIC;
                 signal CCD_XY_s1_write_n : OUT STD_LOGIC;
                 signal CCD_XY_s1_writedata : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_0_data_master_granted_CCD_XY_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_CCD_XY_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_CCD_XY_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_CCD_XY_s1 : OUT STD_LOGIC;
                 signal d1_CCD_XY_s1_end_xfer : OUT STD_LOGIC
              );
end entity CCD_XY_s1_arbitrator;


architecture europa of CCD_XY_s1_arbitrator is
                signal CCD_XY_s1_allgrants :  STD_LOGIC;
                signal CCD_XY_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal CCD_XY_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal CCD_XY_s1_any_continuerequest :  STD_LOGIC;
                signal CCD_XY_s1_arb_counter_enable :  STD_LOGIC;
                signal CCD_XY_s1_arb_share_counter :  STD_LOGIC;
                signal CCD_XY_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal CCD_XY_s1_arb_share_set_values :  STD_LOGIC;
                signal CCD_XY_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal CCD_XY_s1_begins_xfer :  STD_LOGIC;
                signal CCD_XY_s1_end_xfer :  STD_LOGIC;
                signal CCD_XY_s1_firsttransfer :  STD_LOGIC;
                signal CCD_XY_s1_grant_vector :  STD_LOGIC;
                signal CCD_XY_s1_in_a_read_cycle :  STD_LOGIC;
                signal CCD_XY_s1_in_a_write_cycle :  STD_LOGIC;
                signal CCD_XY_s1_master_qreq_vector :  STD_LOGIC;
                signal CCD_XY_s1_non_bursting_master_requests :  STD_LOGIC;
                signal CCD_XY_s1_reg_firsttransfer :  STD_LOGIC;
                signal CCD_XY_s1_slavearbiterlockenable :  STD_LOGIC;
                signal CCD_XY_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal CCD_XY_s1_unreg_firsttransfer :  STD_LOGIC;
                signal CCD_XY_s1_waits_for_read :  STD_LOGIC;
                signal CCD_XY_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_CCD_XY_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_CCD_XY_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_CCD_XY_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_CCD_XY_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_CCD_XY_s1 :  STD_LOGIC;
                signal shifted_address_to_CCD_XY_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_CCD_XY_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT CCD_XY_s1_end_xfer;
    end if;

  end process;

  CCD_XY_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_CCD_XY_s1);
  --assign CCD_XY_s1_readdata_from_sa = CCD_XY_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  CCD_XY_s1_readdata_from_sa <= CCD_XY_s1_readdata;
  internal_cpu_0_data_master_requests_CCD_XY_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000011010000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --CCD_XY_s1_arb_share_counter set values, which is an e_mux
  CCD_XY_s1_arb_share_set_values <= std_logic'('1');
  --CCD_XY_s1_non_bursting_master_requests mux, which is an e_mux
  CCD_XY_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_CCD_XY_s1;
  --CCD_XY_s1_any_bursting_master_saved_grant mux, which is an e_mux
  CCD_XY_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --CCD_XY_s1_arb_share_counter_next_value assignment, which is an e_assign
  CCD_XY_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(CCD_XY_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(CCD_XY_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(CCD_XY_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(CCD_XY_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --CCD_XY_s1_allgrants all slave grants, which is an e_mux
  CCD_XY_s1_allgrants <= CCD_XY_s1_grant_vector;
  --CCD_XY_s1_end_xfer assignment, which is an e_assign
  CCD_XY_s1_end_xfer <= NOT ((CCD_XY_s1_waits_for_read OR CCD_XY_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_CCD_XY_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_CCD_XY_s1 <= CCD_XY_s1_end_xfer AND (((NOT CCD_XY_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --CCD_XY_s1_arb_share_counter arbitration counter enable, which is an e_assign
  CCD_XY_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_CCD_XY_s1 AND CCD_XY_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_CCD_XY_s1 AND NOT CCD_XY_s1_non_bursting_master_requests));
  --CCD_XY_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      CCD_XY_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(CCD_XY_s1_arb_counter_enable) = '1' then 
        CCD_XY_s1_arb_share_counter <= CCD_XY_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --CCD_XY_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      CCD_XY_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((CCD_XY_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_CCD_XY_s1)) OR ((end_xfer_arb_share_counter_term_CCD_XY_s1 AND NOT CCD_XY_s1_non_bursting_master_requests)))) = '1' then 
        CCD_XY_s1_slavearbiterlockenable <= CCD_XY_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master CCD_XY/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= CCD_XY_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --CCD_XY_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  CCD_XY_s1_slavearbiterlockenable2 <= CCD_XY_s1_arb_share_counter_next_value;
  --cpu_0/data_master CCD_XY/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= CCD_XY_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --CCD_XY_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  CCD_XY_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_CCD_XY_s1 <= internal_cpu_0_data_master_requests_CCD_XY_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_CCD_XY_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_CCD_XY_s1 <= (internal_cpu_0_data_master_granted_CCD_XY_s1 AND cpu_0_data_master_read) AND NOT CCD_XY_s1_waits_for_read;
  --CCD_XY_s1_writedata mux, which is an e_mux
  CCD_XY_s1_writedata <= cpu_0_data_master_writedata (1 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_CCD_XY_s1 <= internal_cpu_0_data_master_qualified_request_CCD_XY_s1;
  --cpu_0/data_master saved-grant CCD_XY/s1, which is an e_assign
  cpu_0_data_master_saved_grant_CCD_XY_s1 <= internal_cpu_0_data_master_requests_CCD_XY_s1;
  --allow new arb cycle for CCD_XY/s1, which is an e_assign
  CCD_XY_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  CCD_XY_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  CCD_XY_s1_master_qreq_vector <= std_logic'('1');
  --CCD_XY_s1_reset_n assignment, which is an e_assign
  CCD_XY_s1_reset_n <= reset_n;
  CCD_XY_s1_chipselect <= internal_cpu_0_data_master_granted_CCD_XY_s1;
  --CCD_XY_s1_firsttransfer first transaction, which is an e_assign
  CCD_XY_s1_firsttransfer <= A_WE_StdLogic((std_logic'(CCD_XY_s1_begins_xfer) = '1'), CCD_XY_s1_unreg_firsttransfer, CCD_XY_s1_reg_firsttransfer);
  --CCD_XY_s1_unreg_firsttransfer first transaction, which is an e_assign
  CCD_XY_s1_unreg_firsttransfer <= NOT ((CCD_XY_s1_slavearbiterlockenable AND CCD_XY_s1_any_continuerequest));
  --CCD_XY_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      CCD_XY_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(CCD_XY_s1_begins_xfer) = '1' then 
        CCD_XY_s1_reg_firsttransfer <= CCD_XY_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --CCD_XY_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  CCD_XY_s1_beginbursttransfer_internal <= CCD_XY_s1_begins_xfer;
  --~CCD_XY_s1_write_n assignment, which is an e_mux
  CCD_XY_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_CCD_XY_s1 AND cpu_0_data_master_write));
  shifted_address_to_CCD_XY_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --CCD_XY_s1_address mux, which is an e_mux
  CCD_XY_s1_address <= A_EXT (A_SRL(shifted_address_to_CCD_XY_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_CCD_XY_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_CCD_XY_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_CCD_XY_s1_end_xfer <= CCD_XY_s1_end_xfer;
    end if;

  end process;

  --CCD_XY_s1_waits_for_read in a cycle, which is an e_mux
  CCD_XY_s1_waits_for_read <= CCD_XY_s1_in_a_read_cycle AND CCD_XY_s1_begins_xfer;
  --CCD_XY_s1_in_a_read_cycle assignment, which is an e_assign
  CCD_XY_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_CCD_XY_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= CCD_XY_s1_in_a_read_cycle;
  --CCD_XY_s1_waits_for_write in a cycle, which is an e_mux
  CCD_XY_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(CCD_XY_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --CCD_XY_s1_in_a_write_cycle assignment, which is an e_assign
  CCD_XY_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_CCD_XY_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= CCD_XY_s1_in_a_write_cycle;
  wait_for_CCD_XY_s1_counter <= std_logic'('0');
  --assign CCD_XY_s1_irq_from_sa = CCD_XY_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  CCD_XY_s1_irq_from_sa <= CCD_XY_s1_irq;
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_CCD_XY_s1 <= internal_cpu_0_data_master_granted_CCD_XY_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_CCD_XY_s1 <= internal_cpu_0_data_master_qualified_request_CCD_XY_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_CCD_XY_s1 <= internal_cpu_0_data_master_requests_CCD_XY_s1;
--synthesis translate_off
    --CCD_XY/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity DVAL_s1_arbitrator is 
        port (
              -- inputs:
                 signal DVAL_s1_readdata : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal DVAL_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal DVAL_s1_chipselect : OUT STD_LOGIC;
                 signal DVAL_s1_readdata_from_sa : OUT STD_LOGIC;
                 signal DVAL_s1_reset_n : OUT STD_LOGIC;
                 signal DVAL_s1_write_n : OUT STD_LOGIC;
                 signal DVAL_s1_writedata : OUT STD_LOGIC;
                 signal cpu_0_data_master_granted_DVAL_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_DVAL_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_DVAL_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_DVAL_s1 : OUT STD_LOGIC;
                 signal d1_DVAL_s1_end_xfer : OUT STD_LOGIC
              );
end entity DVAL_s1_arbitrator;


architecture europa of DVAL_s1_arbitrator is
                signal DVAL_s1_allgrants :  STD_LOGIC;
                signal DVAL_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal DVAL_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal DVAL_s1_any_continuerequest :  STD_LOGIC;
                signal DVAL_s1_arb_counter_enable :  STD_LOGIC;
                signal DVAL_s1_arb_share_counter :  STD_LOGIC;
                signal DVAL_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal DVAL_s1_arb_share_set_values :  STD_LOGIC;
                signal DVAL_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal DVAL_s1_begins_xfer :  STD_LOGIC;
                signal DVAL_s1_end_xfer :  STD_LOGIC;
                signal DVAL_s1_firsttransfer :  STD_LOGIC;
                signal DVAL_s1_grant_vector :  STD_LOGIC;
                signal DVAL_s1_in_a_read_cycle :  STD_LOGIC;
                signal DVAL_s1_in_a_write_cycle :  STD_LOGIC;
                signal DVAL_s1_master_qreq_vector :  STD_LOGIC;
                signal DVAL_s1_non_bursting_master_requests :  STD_LOGIC;
                signal DVAL_s1_reg_firsttransfer :  STD_LOGIC;
                signal DVAL_s1_slavearbiterlockenable :  STD_LOGIC;
                signal DVAL_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal DVAL_s1_unreg_firsttransfer :  STD_LOGIC;
                signal DVAL_s1_waits_for_read :  STD_LOGIC;
                signal DVAL_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_DVAL_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_DVAL_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_DVAL_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_DVAL_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_DVAL_s1 :  STD_LOGIC;
                signal shifted_address_to_DVAL_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_DVAL_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT DVAL_s1_end_xfer;
    end if;

  end process;

  DVAL_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_DVAL_s1);
  --assign DVAL_s1_readdata_from_sa = DVAL_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  DVAL_s1_readdata_from_sa <= DVAL_s1_readdata;
  internal_cpu_0_data_master_requests_DVAL_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000101010000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --DVAL_s1_arb_share_counter set values, which is an e_mux
  DVAL_s1_arb_share_set_values <= std_logic'('1');
  --DVAL_s1_non_bursting_master_requests mux, which is an e_mux
  DVAL_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_DVAL_s1;
  --DVAL_s1_any_bursting_master_saved_grant mux, which is an e_mux
  DVAL_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --DVAL_s1_arb_share_counter_next_value assignment, which is an e_assign
  DVAL_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(DVAL_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(DVAL_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(DVAL_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(DVAL_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --DVAL_s1_allgrants all slave grants, which is an e_mux
  DVAL_s1_allgrants <= DVAL_s1_grant_vector;
  --DVAL_s1_end_xfer assignment, which is an e_assign
  DVAL_s1_end_xfer <= NOT ((DVAL_s1_waits_for_read OR DVAL_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_DVAL_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_DVAL_s1 <= DVAL_s1_end_xfer AND (((NOT DVAL_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --DVAL_s1_arb_share_counter arbitration counter enable, which is an e_assign
  DVAL_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_DVAL_s1 AND DVAL_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_DVAL_s1 AND NOT DVAL_s1_non_bursting_master_requests));
  --DVAL_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      DVAL_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(DVAL_s1_arb_counter_enable) = '1' then 
        DVAL_s1_arb_share_counter <= DVAL_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --DVAL_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      DVAL_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((DVAL_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_DVAL_s1)) OR ((end_xfer_arb_share_counter_term_DVAL_s1 AND NOT DVAL_s1_non_bursting_master_requests)))) = '1' then 
        DVAL_s1_slavearbiterlockenable <= DVAL_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master DVAL/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= DVAL_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --DVAL_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  DVAL_s1_slavearbiterlockenable2 <= DVAL_s1_arb_share_counter_next_value;
  --cpu_0/data_master DVAL/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= DVAL_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --DVAL_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  DVAL_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_DVAL_s1 <= internal_cpu_0_data_master_requests_DVAL_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_DVAL_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_DVAL_s1 <= (internal_cpu_0_data_master_granted_DVAL_s1 AND cpu_0_data_master_read) AND NOT DVAL_s1_waits_for_read;
  --DVAL_s1_writedata mux, which is an e_mux
  DVAL_s1_writedata <= cpu_0_data_master_writedata(0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_DVAL_s1 <= internal_cpu_0_data_master_qualified_request_DVAL_s1;
  --cpu_0/data_master saved-grant DVAL/s1, which is an e_assign
  cpu_0_data_master_saved_grant_DVAL_s1 <= internal_cpu_0_data_master_requests_DVAL_s1;
  --allow new arb cycle for DVAL/s1, which is an e_assign
  DVAL_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  DVAL_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  DVAL_s1_master_qreq_vector <= std_logic'('1');
  --DVAL_s1_reset_n assignment, which is an e_assign
  DVAL_s1_reset_n <= reset_n;
  DVAL_s1_chipselect <= internal_cpu_0_data_master_granted_DVAL_s1;
  --DVAL_s1_firsttransfer first transaction, which is an e_assign
  DVAL_s1_firsttransfer <= A_WE_StdLogic((std_logic'(DVAL_s1_begins_xfer) = '1'), DVAL_s1_unreg_firsttransfer, DVAL_s1_reg_firsttransfer);
  --DVAL_s1_unreg_firsttransfer first transaction, which is an e_assign
  DVAL_s1_unreg_firsttransfer <= NOT ((DVAL_s1_slavearbiterlockenable AND DVAL_s1_any_continuerequest));
  --DVAL_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      DVAL_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(DVAL_s1_begins_xfer) = '1' then 
        DVAL_s1_reg_firsttransfer <= DVAL_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --DVAL_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  DVAL_s1_beginbursttransfer_internal <= DVAL_s1_begins_xfer;
  --~DVAL_s1_write_n assignment, which is an e_mux
  DVAL_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_DVAL_s1 AND cpu_0_data_master_write));
  shifted_address_to_DVAL_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --DVAL_s1_address mux, which is an e_mux
  DVAL_s1_address <= A_EXT (A_SRL(shifted_address_to_DVAL_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_DVAL_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_DVAL_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_DVAL_s1_end_xfer <= DVAL_s1_end_xfer;
    end if;

  end process;

  --DVAL_s1_waits_for_read in a cycle, which is an e_mux
  DVAL_s1_waits_for_read <= DVAL_s1_in_a_read_cycle AND DVAL_s1_begins_xfer;
  --DVAL_s1_in_a_read_cycle assignment, which is an e_assign
  DVAL_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_DVAL_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= DVAL_s1_in_a_read_cycle;
  --DVAL_s1_waits_for_write in a cycle, which is an e_mux
  DVAL_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(DVAL_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --DVAL_s1_in_a_write_cycle assignment, which is an e_assign
  DVAL_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_DVAL_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= DVAL_s1_in_a_write_cycle;
  wait_for_DVAL_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_DVAL_s1 <= internal_cpu_0_data_master_granted_DVAL_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_DVAL_s1 <= internal_cpu_0_data_master_qualified_request_DVAL_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_DVAL_s1 <= internal_cpu_0_data_master_requests_DVAL_s1;
--synthesis translate_off
    --DVAL/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity GREEN_s1_arbitrator is 
        port (
              -- inputs:
                 signal GREEN_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal GREEN_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal GREEN_s1_chipselect : OUT STD_LOGIC;
                 signal GREEN_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal GREEN_s1_reset_n : OUT STD_LOGIC;
                 signal GREEN_s1_write_n : OUT STD_LOGIC;
                 signal GREEN_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal cpu_0_data_master_granted_GREEN_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_GREEN_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_GREEN_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_GREEN_s1 : OUT STD_LOGIC;
                 signal d1_GREEN_s1_end_xfer : OUT STD_LOGIC
              );
end entity GREEN_s1_arbitrator;


architecture europa of GREEN_s1_arbitrator is
                signal GREEN_s1_allgrants :  STD_LOGIC;
                signal GREEN_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal GREEN_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal GREEN_s1_any_continuerequest :  STD_LOGIC;
                signal GREEN_s1_arb_counter_enable :  STD_LOGIC;
                signal GREEN_s1_arb_share_counter :  STD_LOGIC;
                signal GREEN_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal GREEN_s1_arb_share_set_values :  STD_LOGIC;
                signal GREEN_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal GREEN_s1_begins_xfer :  STD_LOGIC;
                signal GREEN_s1_end_xfer :  STD_LOGIC;
                signal GREEN_s1_firsttransfer :  STD_LOGIC;
                signal GREEN_s1_grant_vector :  STD_LOGIC;
                signal GREEN_s1_in_a_read_cycle :  STD_LOGIC;
                signal GREEN_s1_in_a_write_cycle :  STD_LOGIC;
                signal GREEN_s1_master_qreq_vector :  STD_LOGIC;
                signal GREEN_s1_non_bursting_master_requests :  STD_LOGIC;
                signal GREEN_s1_reg_firsttransfer :  STD_LOGIC;
                signal GREEN_s1_slavearbiterlockenable :  STD_LOGIC;
                signal GREEN_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal GREEN_s1_unreg_firsttransfer :  STD_LOGIC;
                signal GREEN_s1_waits_for_read :  STD_LOGIC;
                signal GREEN_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_GREEN_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_GREEN_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_GREEN_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_GREEN_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_GREEN_s1 :  STD_LOGIC;
                signal shifted_address_to_GREEN_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_GREEN_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT GREEN_s1_end_xfer;
    end if;

  end process;

  GREEN_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_GREEN_s1);
  --assign GREEN_s1_readdata_from_sa = GREEN_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  GREEN_s1_readdata_from_sa <= GREEN_s1_readdata;
  internal_cpu_0_data_master_requests_GREEN_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000101000000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --GREEN_s1_arb_share_counter set values, which is an e_mux
  GREEN_s1_arb_share_set_values <= std_logic'('1');
  --GREEN_s1_non_bursting_master_requests mux, which is an e_mux
  GREEN_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_GREEN_s1;
  --GREEN_s1_any_bursting_master_saved_grant mux, which is an e_mux
  GREEN_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --GREEN_s1_arb_share_counter_next_value assignment, which is an e_assign
  GREEN_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(GREEN_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(GREEN_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(GREEN_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(GREEN_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --GREEN_s1_allgrants all slave grants, which is an e_mux
  GREEN_s1_allgrants <= GREEN_s1_grant_vector;
  --GREEN_s1_end_xfer assignment, which is an e_assign
  GREEN_s1_end_xfer <= NOT ((GREEN_s1_waits_for_read OR GREEN_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_GREEN_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_GREEN_s1 <= GREEN_s1_end_xfer AND (((NOT GREEN_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --GREEN_s1_arb_share_counter arbitration counter enable, which is an e_assign
  GREEN_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_GREEN_s1 AND GREEN_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_GREEN_s1 AND NOT GREEN_s1_non_bursting_master_requests));
  --GREEN_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      GREEN_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(GREEN_s1_arb_counter_enable) = '1' then 
        GREEN_s1_arb_share_counter <= GREEN_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --GREEN_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      GREEN_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((GREEN_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_GREEN_s1)) OR ((end_xfer_arb_share_counter_term_GREEN_s1 AND NOT GREEN_s1_non_bursting_master_requests)))) = '1' then 
        GREEN_s1_slavearbiterlockenable <= GREEN_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master GREEN/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= GREEN_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --GREEN_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  GREEN_s1_slavearbiterlockenable2 <= GREEN_s1_arb_share_counter_next_value;
  --cpu_0/data_master GREEN/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= GREEN_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --GREEN_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  GREEN_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_GREEN_s1 <= internal_cpu_0_data_master_requests_GREEN_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_GREEN_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_GREEN_s1 <= (internal_cpu_0_data_master_granted_GREEN_s1 AND cpu_0_data_master_read) AND NOT GREEN_s1_waits_for_read;
  --GREEN_s1_writedata mux, which is an e_mux
  GREEN_s1_writedata <= cpu_0_data_master_writedata (11 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_GREEN_s1 <= internal_cpu_0_data_master_qualified_request_GREEN_s1;
  --cpu_0/data_master saved-grant GREEN/s1, which is an e_assign
  cpu_0_data_master_saved_grant_GREEN_s1 <= internal_cpu_0_data_master_requests_GREEN_s1;
  --allow new arb cycle for GREEN/s1, which is an e_assign
  GREEN_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  GREEN_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  GREEN_s1_master_qreq_vector <= std_logic'('1');
  --GREEN_s1_reset_n assignment, which is an e_assign
  GREEN_s1_reset_n <= reset_n;
  GREEN_s1_chipselect <= internal_cpu_0_data_master_granted_GREEN_s1;
  --GREEN_s1_firsttransfer first transaction, which is an e_assign
  GREEN_s1_firsttransfer <= A_WE_StdLogic((std_logic'(GREEN_s1_begins_xfer) = '1'), GREEN_s1_unreg_firsttransfer, GREEN_s1_reg_firsttransfer);
  --GREEN_s1_unreg_firsttransfer first transaction, which is an e_assign
  GREEN_s1_unreg_firsttransfer <= NOT ((GREEN_s1_slavearbiterlockenable AND GREEN_s1_any_continuerequest));
  --GREEN_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      GREEN_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(GREEN_s1_begins_xfer) = '1' then 
        GREEN_s1_reg_firsttransfer <= GREEN_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --GREEN_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  GREEN_s1_beginbursttransfer_internal <= GREEN_s1_begins_xfer;
  --~GREEN_s1_write_n assignment, which is an e_mux
  GREEN_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_GREEN_s1 AND cpu_0_data_master_write));
  shifted_address_to_GREEN_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --GREEN_s1_address mux, which is an e_mux
  GREEN_s1_address <= A_EXT (A_SRL(shifted_address_to_GREEN_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_GREEN_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_GREEN_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_GREEN_s1_end_xfer <= GREEN_s1_end_xfer;
    end if;

  end process;

  --GREEN_s1_waits_for_read in a cycle, which is an e_mux
  GREEN_s1_waits_for_read <= GREEN_s1_in_a_read_cycle AND GREEN_s1_begins_xfer;
  --GREEN_s1_in_a_read_cycle assignment, which is an e_assign
  GREEN_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_GREEN_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= GREEN_s1_in_a_read_cycle;
  --GREEN_s1_waits_for_write in a cycle, which is an e_mux
  GREEN_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(GREEN_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --GREEN_s1_in_a_write_cycle assignment, which is an e_assign
  GREEN_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_GREEN_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= GREEN_s1_in_a_write_cycle;
  wait_for_GREEN_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_GREEN_s1 <= internal_cpu_0_data_master_granted_GREEN_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_GREEN_s1 <= internal_cpu_0_data_master_qualified_request_GREEN_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_GREEN_s1 <= internal_cpu_0_data_master_requests_GREEN_s1;
--synthesis translate_off
    --GREEN/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity IN_mDATA_0_s1_arbitrator is 
        port (
              -- inputs:
                 signal IN_mDATA_0_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal IN_mDATA_0_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal IN_mDATA_0_s1_chipselect : OUT STD_LOGIC;
                 signal IN_mDATA_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal IN_mDATA_0_s1_reset_n : OUT STD_LOGIC;
                 signal IN_mDATA_0_s1_write_n : OUT STD_LOGIC;
                 signal IN_mDATA_0_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal cpu_0_data_master_granted_IN_mDATA_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_IN_mDATA_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_IN_mDATA_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_IN_mDATA_0_s1 : OUT STD_LOGIC;
                 signal d1_IN_mDATA_0_s1_end_xfer : OUT STD_LOGIC
              );
end entity IN_mDATA_0_s1_arbitrator;


architecture europa of IN_mDATA_0_s1_arbitrator is
                signal IN_mDATA_0_s1_allgrants :  STD_LOGIC;
                signal IN_mDATA_0_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal IN_mDATA_0_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal IN_mDATA_0_s1_any_continuerequest :  STD_LOGIC;
                signal IN_mDATA_0_s1_arb_counter_enable :  STD_LOGIC;
                signal IN_mDATA_0_s1_arb_share_counter :  STD_LOGIC;
                signal IN_mDATA_0_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal IN_mDATA_0_s1_arb_share_set_values :  STD_LOGIC;
                signal IN_mDATA_0_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal IN_mDATA_0_s1_begins_xfer :  STD_LOGIC;
                signal IN_mDATA_0_s1_end_xfer :  STD_LOGIC;
                signal IN_mDATA_0_s1_firsttransfer :  STD_LOGIC;
                signal IN_mDATA_0_s1_grant_vector :  STD_LOGIC;
                signal IN_mDATA_0_s1_in_a_read_cycle :  STD_LOGIC;
                signal IN_mDATA_0_s1_in_a_write_cycle :  STD_LOGIC;
                signal IN_mDATA_0_s1_master_qreq_vector :  STD_LOGIC;
                signal IN_mDATA_0_s1_non_bursting_master_requests :  STD_LOGIC;
                signal IN_mDATA_0_s1_reg_firsttransfer :  STD_LOGIC;
                signal IN_mDATA_0_s1_slavearbiterlockenable :  STD_LOGIC;
                signal IN_mDATA_0_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal IN_mDATA_0_s1_unreg_firsttransfer :  STD_LOGIC;
                signal IN_mDATA_0_s1_waits_for_read :  STD_LOGIC;
                signal IN_mDATA_0_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_IN_mDATA_0_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_IN_mDATA_0_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_IN_mDATA_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_IN_mDATA_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_IN_mDATA_0_s1 :  STD_LOGIC;
                signal shifted_address_to_IN_mDATA_0_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_IN_mDATA_0_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT IN_mDATA_0_s1_end_xfer;
    end if;

  end process;

  IN_mDATA_0_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_IN_mDATA_0_s1);
  --assign IN_mDATA_0_s1_readdata_from_sa = IN_mDATA_0_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  IN_mDATA_0_s1_readdata_from_sa <= IN_mDATA_0_s1_readdata;
  internal_cpu_0_data_master_requests_IN_mDATA_0_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000100010000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --IN_mDATA_0_s1_arb_share_counter set values, which is an e_mux
  IN_mDATA_0_s1_arb_share_set_values <= std_logic'('1');
  --IN_mDATA_0_s1_non_bursting_master_requests mux, which is an e_mux
  IN_mDATA_0_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_IN_mDATA_0_s1;
  --IN_mDATA_0_s1_any_bursting_master_saved_grant mux, which is an e_mux
  IN_mDATA_0_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --IN_mDATA_0_s1_arb_share_counter_next_value assignment, which is an e_assign
  IN_mDATA_0_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(IN_mDATA_0_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATA_0_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(IN_mDATA_0_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATA_0_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --IN_mDATA_0_s1_allgrants all slave grants, which is an e_mux
  IN_mDATA_0_s1_allgrants <= IN_mDATA_0_s1_grant_vector;
  --IN_mDATA_0_s1_end_xfer assignment, which is an e_assign
  IN_mDATA_0_s1_end_xfer <= NOT ((IN_mDATA_0_s1_waits_for_read OR IN_mDATA_0_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_IN_mDATA_0_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_IN_mDATA_0_s1 <= IN_mDATA_0_s1_end_xfer AND (((NOT IN_mDATA_0_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --IN_mDATA_0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  IN_mDATA_0_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_IN_mDATA_0_s1 AND IN_mDATA_0_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_IN_mDATA_0_s1 AND NOT IN_mDATA_0_s1_non_bursting_master_requests));
  --IN_mDATA_0_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATA_0_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(IN_mDATA_0_s1_arb_counter_enable) = '1' then 
        IN_mDATA_0_s1_arb_share_counter <= IN_mDATA_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --IN_mDATA_0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATA_0_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((IN_mDATA_0_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_IN_mDATA_0_s1)) OR ((end_xfer_arb_share_counter_term_IN_mDATA_0_s1 AND NOT IN_mDATA_0_s1_non_bursting_master_requests)))) = '1' then 
        IN_mDATA_0_s1_slavearbiterlockenable <= IN_mDATA_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master IN_mDATA_0/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= IN_mDATA_0_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --IN_mDATA_0_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  IN_mDATA_0_s1_slavearbiterlockenable2 <= IN_mDATA_0_s1_arb_share_counter_next_value;
  --cpu_0/data_master IN_mDATA_0/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= IN_mDATA_0_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --IN_mDATA_0_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  IN_mDATA_0_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_IN_mDATA_0_s1 <= internal_cpu_0_data_master_requests_IN_mDATA_0_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_IN_mDATA_0_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_IN_mDATA_0_s1 <= (internal_cpu_0_data_master_granted_IN_mDATA_0_s1 AND cpu_0_data_master_read) AND NOT IN_mDATA_0_s1_waits_for_read;
  --IN_mDATA_0_s1_writedata mux, which is an e_mux
  IN_mDATA_0_s1_writedata <= cpu_0_data_master_writedata (11 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_IN_mDATA_0_s1 <= internal_cpu_0_data_master_qualified_request_IN_mDATA_0_s1;
  --cpu_0/data_master saved-grant IN_mDATA_0/s1, which is an e_assign
  cpu_0_data_master_saved_grant_IN_mDATA_0_s1 <= internal_cpu_0_data_master_requests_IN_mDATA_0_s1;
  --allow new arb cycle for IN_mDATA_0/s1, which is an e_assign
  IN_mDATA_0_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  IN_mDATA_0_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  IN_mDATA_0_s1_master_qreq_vector <= std_logic'('1');
  --IN_mDATA_0_s1_reset_n assignment, which is an e_assign
  IN_mDATA_0_s1_reset_n <= reset_n;
  IN_mDATA_0_s1_chipselect <= internal_cpu_0_data_master_granted_IN_mDATA_0_s1;
  --IN_mDATA_0_s1_firsttransfer first transaction, which is an e_assign
  IN_mDATA_0_s1_firsttransfer <= A_WE_StdLogic((std_logic'(IN_mDATA_0_s1_begins_xfer) = '1'), IN_mDATA_0_s1_unreg_firsttransfer, IN_mDATA_0_s1_reg_firsttransfer);
  --IN_mDATA_0_s1_unreg_firsttransfer first transaction, which is an e_assign
  IN_mDATA_0_s1_unreg_firsttransfer <= NOT ((IN_mDATA_0_s1_slavearbiterlockenable AND IN_mDATA_0_s1_any_continuerequest));
  --IN_mDATA_0_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATA_0_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(IN_mDATA_0_s1_begins_xfer) = '1' then 
        IN_mDATA_0_s1_reg_firsttransfer <= IN_mDATA_0_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --IN_mDATA_0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  IN_mDATA_0_s1_beginbursttransfer_internal <= IN_mDATA_0_s1_begins_xfer;
  --~IN_mDATA_0_s1_write_n assignment, which is an e_mux
  IN_mDATA_0_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_IN_mDATA_0_s1 AND cpu_0_data_master_write));
  shifted_address_to_IN_mDATA_0_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --IN_mDATA_0_s1_address mux, which is an e_mux
  IN_mDATA_0_s1_address <= A_EXT (A_SRL(shifted_address_to_IN_mDATA_0_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_IN_mDATA_0_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_IN_mDATA_0_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_IN_mDATA_0_s1_end_xfer <= IN_mDATA_0_s1_end_xfer;
    end if;

  end process;

  --IN_mDATA_0_s1_waits_for_read in a cycle, which is an e_mux
  IN_mDATA_0_s1_waits_for_read <= IN_mDATA_0_s1_in_a_read_cycle AND IN_mDATA_0_s1_begins_xfer;
  --IN_mDATA_0_s1_in_a_read_cycle assignment, which is an e_assign
  IN_mDATA_0_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_IN_mDATA_0_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= IN_mDATA_0_s1_in_a_read_cycle;
  --IN_mDATA_0_s1_waits_for_write in a cycle, which is an e_mux
  IN_mDATA_0_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATA_0_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --IN_mDATA_0_s1_in_a_write_cycle assignment, which is an e_assign
  IN_mDATA_0_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_IN_mDATA_0_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= IN_mDATA_0_s1_in_a_write_cycle;
  wait_for_IN_mDATA_0_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_IN_mDATA_0_s1 <= internal_cpu_0_data_master_granted_IN_mDATA_0_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_IN_mDATA_0_s1 <= internal_cpu_0_data_master_qualified_request_IN_mDATA_0_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_IN_mDATA_0_s1 <= internal_cpu_0_data_master_requests_IN_mDATA_0_s1;
--synthesis translate_off
    --IN_mDATA_0/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity IN_mDATA_1_s1_arbitrator is 
        port (
              -- inputs:
                 signal IN_mDATA_1_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal IN_mDATA_1_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal IN_mDATA_1_s1_chipselect : OUT STD_LOGIC;
                 signal IN_mDATA_1_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal IN_mDATA_1_s1_reset_n : OUT STD_LOGIC;
                 signal IN_mDATA_1_s1_write_n : OUT STD_LOGIC;
                 signal IN_mDATA_1_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal cpu_0_data_master_granted_IN_mDATA_1_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_IN_mDATA_1_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_IN_mDATA_1_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_IN_mDATA_1_s1 : OUT STD_LOGIC;
                 signal d1_IN_mDATA_1_s1_end_xfer : OUT STD_LOGIC
              );
end entity IN_mDATA_1_s1_arbitrator;


architecture europa of IN_mDATA_1_s1_arbitrator is
                signal IN_mDATA_1_s1_allgrants :  STD_LOGIC;
                signal IN_mDATA_1_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal IN_mDATA_1_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal IN_mDATA_1_s1_any_continuerequest :  STD_LOGIC;
                signal IN_mDATA_1_s1_arb_counter_enable :  STD_LOGIC;
                signal IN_mDATA_1_s1_arb_share_counter :  STD_LOGIC;
                signal IN_mDATA_1_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal IN_mDATA_1_s1_arb_share_set_values :  STD_LOGIC;
                signal IN_mDATA_1_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal IN_mDATA_1_s1_begins_xfer :  STD_LOGIC;
                signal IN_mDATA_1_s1_end_xfer :  STD_LOGIC;
                signal IN_mDATA_1_s1_firsttransfer :  STD_LOGIC;
                signal IN_mDATA_1_s1_grant_vector :  STD_LOGIC;
                signal IN_mDATA_1_s1_in_a_read_cycle :  STD_LOGIC;
                signal IN_mDATA_1_s1_in_a_write_cycle :  STD_LOGIC;
                signal IN_mDATA_1_s1_master_qreq_vector :  STD_LOGIC;
                signal IN_mDATA_1_s1_non_bursting_master_requests :  STD_LOGIC;
                signal IN_mDATA_1_s1_reg_firsttransfer :  STD_LOGIC;
                signal IN_mDATA_1_s1_slavearbiterlockenable :  STD_LOGIC;
                signal IN_mDATA_1_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal IN_mDATA_1_s1_unreg_firsttransfer :  STD_LOGIC;
                signal IN_mDATA_1_s1_waits_for_read :  STD_LOGIC;
                signal IN_mDATA_1_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_IN_mDATA_1_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_IN_mDATA_1_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_IN_mDATA_1_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_IN_mDATA_1_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_IN_mDATA_1_s1 :  STD_LOGIC;
                signal shifted_address_to_IN_mDATA_1_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_IN_mDATA_1_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT IN_mDATA_1_s1_end_xfer;
    end if;

  end process;

  IN_mDATA_1_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_IN_mDATA_1_s1);
  --assign IN_mDATA_1_s1_readdata_from_sa = IN_mDATA_1_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  IN_mDATA_1_s1_readdata_from_sa <= IN_mDATA_1_s1_readdata;
  internal_cpu_0_data_master_requests_IN_mDATA_1_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000100100000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --IN_mDATA_1_s1_arb_share_counter set values, which is an e_mux
  IN_mDATA_1_s1_arb_share_set_values <= std_logic'('1');
  --IN_mDATA_1_s1_non_bursting_master_requests mux, which is an e_mux
  IN_mDATA_1_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_IN_mDATA_1_s1;
  --IN_mDATA_1_s1_any_bursting_master_saved_grant mux, which is an e_mux
  IN_mDATA_1_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --IN_mDATA_1_s1_arb_share_counter_next_value assignment, which is an e_assign
  IN_mDATA_1_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(IN_mDATA_1_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATA_1_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(IN_mDATA_1_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATA_1_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --IN_mDATA_1_s1_allgrants all slave grants, which is an e_mux
  IN_mDATA_1_s1_allgrants <= IN_mDATA_1_s1_grant_vector;
  --IN_mDATA_1_s1_end_xfer assignment, which is an e_assign
  IN_mDATA_1_s1_end_xfer <= NOT ((IN_mDATA_1_s1_waits_for_read OR IN_mDATA_1_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_IN_mDATA_1_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_IN_mDATA_1_s1 <= IN_mDATA_1_s1_end_xfer AND (((NOT IN_mDATA_1_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --IN_mDATA_1_s1_arb_share_counter arbitration counter enable, which is an e_assign
  IN_mDATA_1_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_IN_mDATA_1_s1 AND IN_mDATA_1_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_IN_mDATA_1_s1 AND NOT IN_mDATA_1_s1_non_bursting_master_requests));
  --IN_mDATA_1_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATA_1_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(IN_mDATA_1_s1_arb_counter_enable) = '1' then 
        IN_mDATA_1_s1_arb_share_counter <= IN_mDATA_1_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --IN_mDATA_1_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATA_1_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((IN_mDATA_1_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_IN_mDATA_1_s1)) OR ((end_xfer_arb_share_counter_term_IN_mDATA_1_s1 AND NOT IN_mDATA_1_s1_non_bursting_master_requests)))) = '1' then 
        IN_mDATA_1_s1_slavearbiterlockenable <= IN_mDATA_1_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master IN_mDATA_1/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= IN_mDATA_1_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --IN_mDATA_1_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  IN_mDATA_1_s1_slavearbiterlockenable2 <= IN_mDATA_1_s1_arb_share_counter_next_value;
  --cpu_0/data_master IN_mDATA_1/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= IN_mDATA_1_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --IN_mDATA_1_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  IN_mDATA_1_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_IN_mDATA_1_s1 <= internal_cpu_0_data_master_requests_IN_mDATA_1_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_IN_mDATA_1_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_IN_mDATA_1_s1 <= (internal_cpu_0_data_master_granted_IN_mDATA_1_s1 AND cpu_0_data_master_read) AND NOT IN_mDATA_1_s1_waits_for_read;
  --IN_mDATA_1_s1_writedata mux, which is an e_mux
  IN_mDATA_1_s1_writedata <= cpu_0_data_master_writedata (11 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_IN_mDATA_1_s1 <= internal_cpu_0_data_master_qualified_request_IN_mDATA_1_s1;
  --cpu_0/data_master saved-grant IN_mDATA_1/s1, which is an e_assign
  cpu_0_data_master_saved_grant_IN_mDATA_1_s1 <= internal_cpu_0_data_master_requests_IN_mDATA_1_s1;
  --allow new arb cycle for IN_mDATA_1/s1, which is an e_assign
  IN_mDATA_1_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  IN_mDATA_1_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  IN_mDATA_1_s1_master_qreq_vector <= std_logic'('1');
  --IN_mDATA_1_s1_reset_n assignment, which is an e_assign
  IN_mDATA_1_s1_reset_n <= reset_n;
  IN_mDATA_1_s1_chipselect <= internal_cpu_0_data_master_granted_IN_mDATA_1_s1;
  --IN_mDATA_1_s1_firsttransfer first transaction, which is an e_assign
  IN_mDATA_1_s1_firsttransfer <= A_WE_StdLogic((std_logic'(IN_mDATA_1_s1_begins_xfer) = '1'), IN_mDATA_1_s1_unreg_firsttransfer, IN_mDATA_1_s1_reg_firsttransfer);
  --IN_mDATA_1_s1_unreg_firsttransfer first transaction, which is an e_assign
  IN_mDATA_1_s1_unreg_firsttransfer <= NOT ((IN_mDATA_1_s1_slavearbiterlockenable AND IN_mDATA_1_s1_any_continuerequest));
  --IN_mDATA_1_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATA_1_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(IN_mDATA_1_s1_begins_xfer) = '1' then 
        IN_mDATA_1_s1_reg_firsttransfer <= IN_mDATA_1_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --IN_mDATA_1_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  IN_mDATA_1_s1_beginbursttransfer_internal <= IN_mDATA_1_s1_begins_xfer;
  --~IN_mDATA_1_s1_write_n assignment, which is an e_mux
  IN_mDATA_1_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_IN_mDATA_1_s1 AND cpu_0_data_master_write));
  shifted_address_to_IN_mDATA_1_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --IN_mDATA_1_s1_address mux, which is an e_mux
  IN_mDATA_1_s1_address <= A_EXT (A_SRL(shifted_address_to_IN_mDATA_1_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_IN_mDATA_1_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_IN_mDATA_1_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_IN_mDATA_1_s1_end_xfer <= IN_mDATA_1_s1_end_xfer;
    end if;

  end process;

  --IN_mDATA_1_s1_waits_for_read in a cycle, which is an e_mux
  IN_mDATA_1_s1_waits_for_read <= IN_mDATA_1_s1_in_a_read_cycle AND IN_mDATA_1_s1_begins_xfer;
  --IN_mDATA_1_s1_in_a_read_cycle assignment, which is an e_assign
  IN_mDATA_1_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_IN_mDATA_1_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= IN_mDATA_1_s1_in_a_read_cycle;
  --IN_mDATA_1_s1_waits_for_write in a cycle, which is an e_mux
  IN_mDATA_1_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATA_1_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --IN_mDATA_1_s1_in_a_write_cycle assignment, which is an e_assign
  IN_mDATA_1_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_IN_mDATA_1_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= IN_mDATA_1_s1_in_a_write_cycle;
  wait_for_IN_mDATA_1_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_IN_mDATA_1_s1 <= internal_cpu_0_data_master_granted_IN_mDATA_1_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_IN_mDATA_1_s1 <= internal_cpu_0_data_master_qualified_request_IN_mDATA_1_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_IN_mDATA_1_s1 <= internal_cpu_0_data_master_requests_IN_mDATA_1_s1;
--synthesis translate_off
    --IN_mDATA_1/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity IN_mDATAd_0_s1_arbitrator is 
        port (
              -- inputs:
                 signal IN_mDATAd_0_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal IN_mDATAd_0_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal IN_mDATAd_0_s1_chipselect : OUT STD_LOGIC;
                 signal IN_mDATAd_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal IN_mDATAd_0_s1_reset_n : OUT STD_LOGIC;
                 signal IN_mDATAd_0_s1_write_n : OUT STD_LOGIC;
                 signal IN_mDATAd_0_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal cpu_0_data_master_granted_IN_mDATAd_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_IN_mDATAd_0_s1 : OUT STD_LOGIC;
                 signal d1_IN_mDATAd_0_s1_end_xfer : OUT STD_LOGIC
              );
end entity IN_mDATAd_0_s1_arbitrator;


architecture europa of IN_mDATAd_0_s1_arbitrator is
                signal IN_mDATAd_0_s1_allgrants :  STD_LOGIC;
                signal IN_mDATAd_0_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal IN_mDATAd_0_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal IN_mDATAd_0_s1_any_continuerequest :  STD_LOGIC;
                signal IN_mDATAd_0_s1_arb_counter_enable :  STD_LOGIC;
                signal IN_mDATAd_0_s1_arb_share_counter :  STD_LOGIC;
                signal IN_mDATAd_0_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal IN_mDATAd_0_s1_arb_share_set_values :  STD_LOGIC;
                signal IN_mDATAd_0_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal IN_mDATAd_0_s1_begins_xfer :  STD_LOGIC;
                signal IN_mDATAd_0_s1_end_xfer :  STD_LOGIC;
                signal IN_mDATAd_0_s1_firsttransfer :  STD_LOGIC;
                signal IN_mDATAd_0_s1_grant_vector :  STD_LOGIC;
                signal IN_mDATAd_0_s1_in_a_read_cycle :  STD_LOGIC;
                signal IN_mDATAd_0_s1_in_a_write_cycle :  STD_LOGIC;
                signal IN_mDATAd_0_s1_master_qreq_vector :  STD_LOGIC;
                signal IN_mDATAd_0_s1_non_bursting_master_requests :  STD_LOGIC;
                signal IN_mDATAd_0_s1_reg_firsttransfer :  STD_LOGIC;
                signal IN_mDATAd_0_s1_slavearbiterlockenable :  STD_LOGIC;
                signal IN_mDATAd_0_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal IN_mDATAd_0_s1_unreg_firsttransfer :  STD_LOGIC;
                signal IN_mDATAd_0_s1_waits_for_read :  STD_LOGIC;
                signal IN_mDATAd_0_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_IN_mDATAd_0_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_IN_mDATAd_0_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_IN_mDATAd_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_IN_mDATAd_0_s1 :  STD_LOGIC;
                signal shifted_address_to_IN_mDATAd_0_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_IN_mDATAd_0_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT IN_mDATAd_0_s1_end_xfer;
    end if;

  end process;

  IN_mDATAd_0_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_IN_mDATAd_0_s1);
  --assign IN_mDATAd_0_s1_readdata_from_sa = IN_mDATAd_0_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  IN_mDATAd_0_s1_readdata_from_sa <= IN_mDATAd_0_s1_readdata;
  internal_cpu_0_data_master_requests_IN_mDATAd_0_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000101100000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --IN_mDATAd_0_s1_arb_share_counter set values, which is an e_mux
  IN_mDATAd_0_s1_arb_share_set_values <= std_logic'('1');
  --IN_mDATAd_0_s1_non_bursting_master_requests mux, which is an e_mux
  IN_mDATAd_0_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_IN_mDATAd_0_s1;
  --IN_mDATAd_0_s1_any_bursting_master_saved_grant mux, which is an e_mux
  IN_mDATAd_0_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --IN_mDATAd_0_s1_arb_share_counter_next_value assignment, which is an e_assign
  IN_mDATAd_0_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(IN_mDATAd_0_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATAd_0_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(IN_mDATAd_0_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATAd_0_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --IN_mDATAd_0_s1_allgrants all slave grants, which is an e_mux
  IN_mDATAd_0_s1_allgrants <= IN_mDATAd_0_s1_grant_vector;
  --IN_mDATAd_0_s1_end_xfer assignment, which is an e_assign
  IN_mDATAd_0_s1_end_xfer <= NOT ((IN_mDATAd_0_s1_waits_for_read OR IN_mDATAd_0_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_IN_mDATAd_0_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_IN_mDATAd_0_s1 <= IN_mDATAd_0_s1_end_xfer AND (((NOT IN_mDATAd_0_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --IN_mDATAd_0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  IN_mDATAd_0_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_IN_mDATAd_0_s1 AND IN_mDATAd_0_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_IN_mDATAd_0_s1 AND NOT IN_mDATAd_0_s1_non_bursting_master_requests));
  --IN_mDATAd_0_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATAd_0_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(IN_mDATAd_0_s1_arb_counter_enable) = '1' then 
        IN_mDATAd_0_s1_arb_share_counter <= IN_mDATAd_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --IN_mDATAd_0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATAd_0_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((IN_mDATAd_0_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_IN_mDATAd_0_s1)) OR ((end_xfer_arb_share_counter_term_IN_mDATAd_0_s1 AND NOT IN_mDATAd_0_s1_non_bursting_master_requests)))) = '1' then 
        IN_mDATAd_0_s1_slavearbiterlockenable <= IN_mDATAd_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master IN_mDATAd_0/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= IN_mDATAd_0_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --IN_mDATAd_0_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  IN_mDATAd_0_s1_slavearbiterlockenable2 <= IN_mDATAd_0_s1_arb_share_counter_next_value;
  --cpu_0/data_master IN_mDATAd_0/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= IN_mDATAd_0_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --IN_mDATAd_0_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  IN_mDATAd_0_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 <= internal_cpu_0_data_master_requests_IN_mDATAd_0_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1 <= (internal_cpu_0_data_master_granted_IN_mDATAd_0_s1 AND cpu_0_data_master_read) AND NOT IN_mDATAd_0_s1_waits_for_read;
  --IN_mDATAd_0_s1_writedata mux, which is an e_mux
  IN_mDATAd_0_s1_writedata <= cpu_0_data_master_writedata (11 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_IN_mDATAd_0_s1 <= internal_cpu_0_data_master_qualified_request_IN_mDATAd_0_s1;
  --cpu_0/data_master saved-grant IN_mDATAd_0/s1, which is an e_assign
  cpu_0_data_master_saved_grant_IN_mDATAd_0_s1 <= internal_cpu_0_data_master_requests_IN_mDATAd_0_s1;
  --allow new arb cycle for IN_mDATAd_0/s1, which is an e_assign
  IN_mDATAd_0_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  IN_mDATAd_0_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  IN_mDATAd_0_s1_master_qreq_vector <= std_logic'('1');
  --IN_mDATAd_0_s1_reset_n assignment, which is an e_assign
  IN_mDATAd_0_s1_reset_n <= reset_n;
  IN_mDATAd_0_s1_chipselect <= internal_cpu_0_data_master_granted_IN_mDATAd_0_s1;
  --IN_mDATAd_0_s1_firsttransfer first transaction, which is an e_assign
  IN_mDATAd_0_s1_firsttransfer <= A_WE_StdLogic((std_logic'(IN_mDATAd_0_s1_begins_xfer) = '1'), IN_mDATAd_0_s1_unreg_firsttransfer, IN_mDATAd_0_s1_reg_firsttransfer);
  --IN_mDATAd_0_s1_unreg_firsttransfer first transaction, which is an e_assign
  IN_mDATAd_0_s1_unreg_firsttransfer <= NOT ((IN_mDATAd_0_s1_slavearbiterlockenable AND IN_mDATAd_0_s1_any_continuerequest));
  --IN_mDATAd_0_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATAd_0_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(IN_mDATAd_0_s1_begins_xfer) = '1' then 
        IN_mDATAd_0_s1_reg_firsttransfer <= IN_mDATAd_0_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --IN_mDATAd_0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  IN_mDATAd_0_s1_beginbursttransfer_internal <= IN_mDATAd_0_s1_begins_xfer;
  --~IN_mDATAd_0_s1_write_n assignment, which is an e_mux
  IN_mDATAd_0_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_IN_mDATAd_0_s1 AND cpu_0_data_master_write));
  shifted_address_to_IN_mDATAd_0_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --IN_mDATAd_0_s1_address mux, which is an e_mux
  IN_mDATAd_0_s1_address <= A_EXT (A_SRL(shifted_address_to_IN_mDATAd_0_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_IN_mDATAd_0_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_IN_mDATAd_0_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_IN_mDATAd_0_s1_end_xfer <= IN_mDATAd_0_s1_end_xfer;
    end if;

  end process;

  --IN_mDATAd_0_s1_waits_for_read in a cycle, which is an e_mux
  IN_mDATAd_0_s1_waits_for_read <= IN_mDATAd_0_s1_in_a_read_cycle AND IN_mDATAd_0_s1_begins_xfer;
  --IN_mDATAd_0_s1_in_a_read_cycle assignment, which is an e_assign
  IN_mDATAd_0_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_IN_mDATAd_0_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= IN_mDATAd_0_s1_in_a_read_cycle;
  --IN_mDATAd_0_s1_waits_for_write in a cycle, which is an e_mux
  IN_mDATAd_0_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATAd_0_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --IN_mDATAd_0_s1_in_a_write_cycle assignment, which is an e_assign
  IN_mDATAd_0_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_IN_mDATAd_0_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= IN_mDATAd_0_s1_in_a_write_cycle;
  wait_for_IN_mDATAd_0_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_IN_mDATAd_0_s1 <= internal_cpu_0_data_master_granted_IN_mDATAd_0_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 <= internal_cpu_0_data_master_qualified_request_IN_mDATAd_0_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_IN_mDATAd_0_s1 <= internal_cpu_0_data_master_requests_IN_mDATAd_0_s1;
--synthesis translate_off
    --IN_mDATAd_0/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity IN_mDATAd_1_s1_arbitrator is 
        port (
              -- inputs:
                 signal IN_mDATAd_1_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal IN_mDATAd_1_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal IN_mDATAd_1_s1_chipselect : OUT STD_LOGIC;
                 signal IN_mDATAd_1_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal IN_mDATAd_1_s1_reset_n : OUT STD_LOGIC;
                 signal IN_mDATAd_1_s1_write_n : OUT STD_LOGIC;
                 signal IN_mDATAd_1_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal cpu_0_data_master_granted_IN_mDATAd_1_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_IN_mDATAd_1_s1 : OUT STD_LOGIC;
                 signal d1_IN_mDATAd_1_s1_end_xfer : OUT STD_LOGIC
              );
end entity IN_mDATAd_1_s1_arbitrator;


architecture europa of IN_mDATAd_1_s1_arbitrator is
                signal IN_mDATAd_1_s1_allgrants :  STD_LOGIC;
                signal IN_mDATAd_1_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal IN_mDATAd_1_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal IN_mDATAd_1_s1_any_continuerequest :  STD_LOGIC;
                signal IN_mDATAd_1_s1_arb_counter_enable :  STD_LOGIC;
                signal IN_mDATAd_1_s1_arb_share_counter :  STD_LOGIC;
                signal IN_mDATAd_1_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal IN_mDATAd_1_s1_arb_share_set_values :  STD_LOGIC;
                signal IN_mDATAd_1_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal IN_mDATAd_1_s1_begins_xfer :  STD_LOGIC;
                signal IN_mDATAd_1_s1_end_xfer :  STD_LOGIC;
                signal IN_mDATAd_1_s1_firsttransfer :  STD_LOGIC;
                signal IN_mDATAd_1_s1_grant_vector :  STD_LOGIC;
                signal IN_mDATAd_1_s1_in_a_read_cycle :  STD_LOGIC;
                signal IN_mDATAd_1_s1_in_a_write_cycle :  STD_LOGIC;
                signal IN_mDATAd_1_s1_master_qreq_vector :  STD_LOGIC;
                signal IN_mDATAd_1_s1_non_bursting_master_requests :  STD_LOGIC;
                signal IN_mDATAd_1_s1_reg_firsttransfer :  STD_LOGIC;
                signal IN_mDATAd_1_s1_slavearbiterlockenable :  STD_LOGIC;
                signal IN_mDATAd_1_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal IN_mDATAd_1_s1_unreg_firsttransfer :  STD_LOGIC;
                signal IN_mDATAd_1_s1_waits_for_read :  STD_LOGIC;
                signal IN_mDATAd_1_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_IN_mDATAd_1_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_IN_mDATAd_1_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_IN_mDATAd_1_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_IN_mDATAd_1_s1 :  STD_LOGIC;
                signal shifted_address_to_IN_mDATAd_1_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_IN_mDATAd_1_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT IN_mDATAd_1_s1_end_xfer;
    end if;

  end process;

  IN_mDATAd_1_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_IN_mDATAd_1_s1);
  --assign IN_mDATAd_1_s1_readdata_from_sa = IN_mDATAd_1_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  IN_mDATAd_1_s1_readdata_from_sa <= IN_mDATAd_1_s1_readdata;
  internal_cpu_0_data_master_requests_IN_mDATAd_1_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000101110000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --IN_mDATAd_1_s1_arb_share_counter set values, which is an e_mux
  IN_mDATAd_1_s1_arb_share_set_values <= std_logic'('1');
  --IN_mDATAd_1_s1_non_bursting_master_requests mux, which is an e_mux
  IN_mDATAd_1_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_IN_mDATAd_1_s1;
  --IN_mDATAd_1_s1_any_bursting_master_saved_grant mux, which is an e_mux
  IN_mDATAd_1_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --IN_mDATAd_1_s1_arb_share_counter_next_value assignment, which is an e_assign
  IN_mDATAd_1_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(IN_mDATAd_1_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATAd_1_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(IN_mDATAd_1_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATAd_1_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --IN_mDATAd_1_s1_allgrants all slave grants, which is an e_mux
  IN_mDATAd_1_s1_allgrants <= IN_mDATAd_1_s1_grant_vector;
  --IN_mDATAd_1_s1_end_xfer assignment, which is an e_assign
  IN_mDATAd_1_s1_end_xfer <= NOT ((IN_mDATAd_1_s1_waits_for_read OR IN_mDATAd_1_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_IN_mDATAd_1_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_IN_mDATAd_1_s1 <= IN_mDATAd_1_s1_end_xfer AND (((NOT IN_mDATAd_1_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --IN_mDATAd_1_s1_arb_share_counter arbitration counter enable, which is an e_assign
  IN_mDATAd_1_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_IN_mDATAd_1_s1 AND IN_mDATAd_1_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_IN_mDATAd_1_s1 AND NOT IN_mDATAd_1_s1_non_bursting_master_requests));
  --IN_mDATAd_1_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATAd_1_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(IN_mDATAd_1_s1_arb_counter_enable) = '1' then 
        IN_mDATAd_1_s1_arb_share_counter <= IN_mDATAd_1_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --IN_mDATAd_1_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATAd_1_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((IN_mDATAd_1_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_IN_mDATAd_1_s1)) OR ((end_xfer_arb_share_counter_term_IN_mDATAd_1_s1 AND NOT IN_mDATAd_1_s1_non_bursting_master_requests)))) = '1' then 
        IN_mDATAd_1_s1_slavearbiterlockenable <= IN_mDATAd_1_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master IN_mDATAd_1/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= IN_mDATAd_1_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --IN_mDATAd_1_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  IN_mDATAd_1_s1_slavearbiterlockenable2 <= IN_mDATAd_1_s1_arb_share_counter_next_value;
  --cpu_0/data_master IN_mDATAd_1/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= IN_mDATAd_1_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --IN_mDATAd_1_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  IN_mDATAd_1_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 <= internal_cpu_0_data_master_requests_IN_mDATAd_1_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1 <= (internal_cpu_0_data_master_granted_IN_mDATAd_1_s1 AND cpu_0_data_master_read) AND NOT IN_mDATAd_1_s1_waits_for_read;
  --IN_mDATAd_1_s1_writedata mux, which is an e_mux
  IN_mDATAd_1_s1_writedata <= cpu_0_data_master_writedata (11 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_IN_mDATAd_1_s1 <= internal_cpu_0_data_master_qualified_request_IN_mDATAd_1_s1;
  --cpu_0/data_master saved-grant IN_mDATAd_1/s1, which is an e_assign
  cpu_0_data_master_saved_grant_IN_mDATAd_1_s1 <= internal_cpu_0_data_master_requests_IN_mDATAd_1_s1;
  --allow new arb cycle for IN_mDATAd_1/s1, which is an e_assign
  IN_mDATAd_1_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  IN_mDATAd_1_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  IN_mDATAd_1_s1_master_qreq_vector <= std_logic'('1');
  --IN_mDATAd_1_s1_reset_n assignment, which is an e_assign
  IN_mDATAd_1_s1_reset_n <= reset_n;
  IN_mDATAd_1_s1_chipselect <= internal_cpu_0_data_master_granted_IN_mDATAd_1_s1;
  --IN_mDATAd_1_s1_firsttransfer first transaction, which is an e_assign
  IN_mDATAd_1_s1_firsttransfer <= A_WE_StdLogic((std_logic'(IN_mDATAd_1_s1_begins_xfer) = '1'), IN_mDATAd_1_s1_unreg_firsttransfer, IN_mDATAd_1_s1_reg_firsttransfer);
  --IN_mDATAd_1_s1_unreg_firsttransfer first transaction, which is an e_assign
  IN_mDATAd_1_s1_unreg_firsttransfer <= NOT ((IN_mDATAd_1_s1_slavearbiterlockenable AND IN_mDATAd_1_s1_any_continuerequest));
  --IN_mDATAd_1_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      IN_mDATAd_1_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(IN_mDATAd_1_s1_begins_xfer) = '1' then 
        IN_mDATAd_1_s1_reg_firsttransfer <= IN_mDATAd_1_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --IN_mDATAd_1_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  IN_mDATAd_1_s1_beginbursttransfer_internal <= IN_mDATAd_1_s1_begins_xfer;
  --~IN_mDATAd_1_s1_write_n assignment, which is an e_mux
  IN_mDATAd_1_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_IN_mDATAd_1_s1 AND cpu_0_data_master_write));
  shifted_address_to_IN_mDATAd_1_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --IN_mDATAd_1_s1_address mux, which is an e_mux
  IN_mDATAd_1_s1_address <= A_EXT (A_SRL(shifted_address_to_IN_mDATAd_1_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_IN_mDATAd_1_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_IN_mDATAd_1_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_IN_mDATAd_1_s1_end_xfer <= IN_mDATAd_1_s1_end_xfer;
    end if;

  end process;

  --IN_mDATAd_1_s1_waits_for_read in a cycle, which is an e_mux
  IN_mDATAd_1_s1_waits_for_read <= IN_mDATAd_1_s1_in_a_read_cycle AND IN_mDATAd_1_s1_begins_xfer;
  --IN_mDATAd_1_s1_in_a_read_cycle assignment, which is an e_assign
  IN_mDATAd_1_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_IN_mDATAd_1_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= IN_mDATAd_1_s1_in_a_read_cycle;
  --IN_mDATAd_1_s1_waits_for_write in a cycle, which is an e_mux
  IN_mDATAd_1_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(IN_mDATAd_1_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --IN_mDATAd_1_s1_in_a_write_cycle assignment, which is an e_assign
  IN_mDATAd_1_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_IN_mDATAd_1_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= IN_mDATAd_1_s1_in_a_write_cycle;
  wait_for_IN_mDATAd_1_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_IN_mDATAd_1_s1 <= internal_cpu_0_data_master_granted_IN_mDATAd_1_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 <= internal_cpu_0_data_master_qualified_request_IN_mDATAd_1_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_IN_mDATAd_1_s1 <= internal_cpu_0_data_master_requests_IN_mDATAd_1_s1;
--synthesis translate_off
    --IN_mDATAd_1/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity LCD_0_control_slave_arbitrator is 
        port (
              -- inputs:
                 signal LCD_0_control_slave_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal LCD_0_control_slave_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal LCD_0_control_slave_begintransfer : OUT STD_LOGIC;
                 signal LCD_0_control_slave_read : OUT STD_LOGIC;
                 signal LCD_0_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal LCD_0_control_slave_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal LCD_0_control_slave_write : OUT STD_LOGIC;
                 signal LCD_0_control_slave_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_0_data_master_granted_LCD_0_control_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_LCD_0_control_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_LCD_0_control_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_LCD_0_control_slave : OUT STD_LOGIC;
                 signal d1_LCD_0_control_slave_end_xfer : OUT STD_LOGIC
              );
end entity LCD_0_control_slave_arbitrator;


architecture europa of LCD_0_control_slave_arbitrator is
                signal LCD_0_control_slave_allgrants :  STD_LOGIC;
                signal LCD_0_control_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal LCD_0_control_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal LCD_0_control_slave_any_continuerequest :  STD_LOGIC;
                signal LCD_0_control_slave_arb_counter_enable :  STD_LOGIC;
                signal LCD_0_control_slave_arb_share_counter :  STD_LOGIC;
                signal LCD_0_control_slave_arb_share_counter_next_value :  STD_LOGIC;
                signal LCD_0_control_slave_arb_share_set_values :  STD_LOGIC;
                signal LCD_0_control_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal LCD_0_control_slave_begins_xfer :  STD_LOGIC;
                signal LCD_0_control_slave_counter_load_value :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal LCD_0_control_slave_end_xfer :  STD_LOGIC;
                signal LCD_0_control_slave_firsttransfer :  STD_LOGIC;
                signal LCD_0_control_slave_grant_vector :  STD_LOGIC;
                signal LCD_0_control_slave_in_a_read_cycle :  STD_LOGIC;
                signal LCD_0_control_slave_in_a_write_cycle :  STD_LOGIC;
                signal LCD_0_control_slave_master_qreq_vector :  STD_LOGIC;
                signal LCD_0_control_slave_non_bursting_master_requests :  STD_LOGIC;
                signal LCD_0_control_slave_pretend_byte_enable :  STD_LOGIC;
                signal LCD_0_control_slave_reg_firsttransfer :  STD_LOGIC;
                signal LCD_0_control_slave_slavearbiterlockenable :  STD_LOGIC;
                signal LCD_0_control_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal LCD_0_control_slave_unreg_firsttransfer :  STD_LOGIC;
                signal LCD_0_control_slave_wait_counter :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal LCD_0_control_slave_waits_for_read :  STD_LOGIC;
                signal LCD_0_control_slave_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_LCD_0_control_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_LCD_0_control_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_LCD_0_control_slave_wait_counter_eq_0 :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_LCD_0_control_slave :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_LCD_0_control_slave :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_LCD_0_control_slave :  STD_LOGIC;
                signal shifted_address_to_LCD_0_control_slave_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_LCD_0_control_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT LCD_0_control_slave_end_xfer;
    end if;

  end process;

  LCD_0_control_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_LCD_0_control_slave);
  --assign LCD_0_control_slave_readdata_from_sa = LCD_0_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  LCD_0_control_slave_readdata_from_sa <= LCD_0_control_slave_readdata;
  internal_cpu_0_data_master_requests_LCD_0_control_slave <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000100110000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --LCD_0_control_slave_arb_share_counter set values, which is an e_mux
  LCD_0_control_slave_arb_share_set_values <= std_logic'('1');
  --LCD_0_control_slave_non_bursting_master_requests mux, which is an e_mux
  LCD_0_control_slave_non_bursting_master_requests <= internal_cpu_0_data_master_requests_LCD_0_control_slave;
  --LCD_0_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  LCD_0_control_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --LCD_0_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  LCD_0_control_slave_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(LCD_0_control_slave_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LCD_0_control_slave_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(LCD_0_control_slave_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LCD_0_control_slave_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --LCD_0_control_slave_allgrants all slave grants, which is an e_mux
  LCD_0_control_slave_allgrants <= LCD_0_control_slave_grant_vector;
  --LCD_0_control_slave_end_xfer assignment, which is an e_assign
  LCD_0_control_slave_end_xfer <= NOT ((LCD_0_control_slave_waits_for_read OR LCD_0_control_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_LCD_0_control_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_LCD_0_control_slave <= LCD_0_control_slave_end_xfer AND (((NOT LCD_0_control_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --LCD_0_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  LCD_0_control_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_LCD_0_control_slave AND LCD_0_control_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_LCD_0_control_slave AND NOT LCD_0_control_slave_non_bursting_master_requests));
  --LCD_0_control_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LCD_0_control_slave_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(LCD_0_control_slave_arb_counter_enable) = '1' then 
        LCD_0_control_slave_arb_share_counter <= LCD_0_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --LCD_0_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LCD_0_control_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((LCD_0_control_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_LCD_0_control_slave)) OR ((end_xfer_arb_share_counter_term_LCD_0_control_slave AND NOT LCD_0_control_slave_non_bursting_master_requests)))) = '1' then 
        LCD_0_control_slave_slavearbiterlockenable <= LCD_0_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master LCD_0/control_slave arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= LCD_0_control_slave_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --LCD_0_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  LCD_0_control_slave_slavearbiterlockenable2 <= LCD_0_control_slave_arb_share_counter_next_value;
  --cpu_0/data_master LCD_0/control_slave arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= LCD_0_control_slave_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --LCD_0_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  LCD_0_control_slave_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_LCD_0_control_slave <= internal_cpu_0_data_master_requests_LCD_0_control_slave AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_LCD_0_control_slave, which is an e_mux
  cpu_0_data_master_read_data_valid_LCD_0_control_slave <= (internal_cpu_0_data_master_granted_LCD_0_control_slave AND cpu_0_data_master_read) AND NOT LCD_0_control_slave_waits_for_read;
  --LCD_0_control_slave_writedata mux, which is an e_mux
  LCD_0_control_slave_writedata <= cpu_0_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_LCD_0_control_slave <= internal_cpu_0_data_master_qualified_request_LCD_0_control_slave;
  --cpu_0/data_master saved-grant LCD_0/control_slave, which is an e_assign
  cpu_0_data_master_saved_grant_LCD_0_control_slave <= internal_cpu_0_data_master_requests_LCD_0_control_slave;
  --allow new arb cycle for LCD_0/control_slave, which is an e_assign
  LCD_0_control_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  LCD_0_control_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  LCD_0_control_slave_master_qreq_vector <= std_logic'('1');
  LCD_0_control_slave_begintransfer <= LCD_0_control_slave_begins_xfer;
  --LCD_0_control_slave_firsttransfer first transaction, which is an e_assign
  LCD_0_control_slave_firsttransfer <= A_WE_StdLogic((std_logic'(LCD_0_control_slave_begins_xfer) = '1'), LCD_0_control_slave_unreg_firsttransfer, LCD_0_control_slave_reg_firsttransfer);
  --LCD_0_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  LCD_0_control_slave_unreg_firsttransfer <= NOT ((LCD_0_control_slave_slavearbiterlockenable AND LCD_0_control_slave_any_continuerequest));
  --LCD_0_control_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LCD_0_control_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(LCD_0_control_slave_begins_xfer) = '1' then 
        LCD_0_control_slave_reg_firsttransfer <= LCD_0_control_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --LCD_0_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  LCD_0_control_slave_beginbursttransfer_internal <= LCD_0_control_slave_begins_xfer;
  --LCD_0_control_slave_read assignment, which is an e_mux
  LCD_0_control_slave_read <= (((internal_cpu_0_data_master_granted_LCD_0_control_slave AND cpu_0_data_master_read)) AND NOT LCD_0_control_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000") & (LCD_0_control_slave_wait_counter))<std_logic_vector'("00000000000000000000000000100110"))));
  --LCD_0_control_slave_write assignment, which is an e_mux
  LCD_0_control_slave_write <= (((((internal_cpu_0_data_master_granted_LCD_0_control_slave AND cpu_0_data_master_write)) AND NOT LCD_0_control_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("0000000000000000000000000") & (LCD_0_control_slave_wait_counter))>=std_logic_vector'("00000000000000000000000000100110"))))) AND to_std_logic((((std_logic_vector'("0000000000000000000000000") & (LCD_0_control_slave_wait_counter))<std_logic_vector'("00000000000000000000000001001100"))))) AND LCD_0_control_slave_pretend_byte_enable;
  shifted_address_to_LCD_0_control_slave_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --LCD_0_control_slave_address mux, which is an e_mux
  LCD_0_control_slave_address <= A_EXT (A_SRL(shifted_address_to_LCD_0_control_slave_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_LCD_0_control_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_LCD_0_control_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_LCD_0_control_slave_end_xfer <= LCD_0_control_slave_end_xfer;
    end if;

  end process;

  --LCD_0_control_slave_waits_for_read in a cycle, which is an e_mux
  LCD_0_control_slave_waits_for_read <= LCD_0_control_slave_in_a_read_cycle AND wait_for_LCD_0_control_slave_counter;
  --LCD_0_control_slave_in_a_read_cycle assignment, which is an e_assign
  LCD_0_control_slave_in_a_read_cycle <= internal_cpu_0_data_master_granted_LCD_0_control_slave AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= LCD_0_control_slave_in_a_read_cycle;
  --LCD_0_control_slave_waits_for_write in a cycle, which is an e_mux
  LCD_0_control_slave_waits_for_write <= LCD_0_control_slave_in_a_write_cycle AND wait_for_LCD_0_control_slave_counter;
  --LCD_0_control_slave_in_a_write_cycle assignment, which is an e_assign
  LCD_0_control_slave_in_a_write_cycle <= internal_cpu_0_data_master_granted_LCD_0_control_slave AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= LCD_0_control_slave_in_a_write_cycle;
  internal_LCD_0_control_slave_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("0000000000000000000000000") & (LCD_0_control_slave_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LCD_0_control_slave_wait_counter <= std_logic_vector'("0000000");
    elsif clk'event and clk = '1' then
      LCD_0_control_slave_wait_counter <= LCD_0_control_slave_counter_load_value;
    end if;

  end process;

  LCD_0_control_slave_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((LCD_0_control_slave_in_a_read_cycle AND LCD_0_control_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000001001010"), A_WE_StdLogicVector((std_logic'(((LCD_0_control_slave_in_a_write_cycle AND LCD_0_control_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000001110000"), A_WE_StdLogicVector((std_logic'((NOT internal_LCD_0_control_slave_wait_counter_eq_0)) = '1'), ((std_logic_vector'("00000000000000000000000000") & (LCD_0_control_slave_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 7);
  wait_for_LCD_0_control_slave_counter <= LCD_0_control_slave_begins_xfer OR NOT internal_LCD_0_control_slave_wait_counter_eq_0;
  --LCD_0_control_slave_pretend_byte_enable byte enable port mux, which is an e_mux
  LCD_0_control_slave_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_granted_LCD_0_control_slave)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_0_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --vhdl renameroo for output signals
  LCD_0_control_slave_wait_counter_eq_0 <= internal_LCD_0_control_slave_wait_counter_eq_0;
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_LCD_0_control_slave <= internal_cpu_0_data_master_granted_LCD_0_control_slave;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_LCD_0_control_slave <= internal_cpu_0_data_master_qualified_request_LCD_0_control_slave;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_LCD_0_control_slave <= internal_cpu_0_data_master_requests_LCD_0_control_slave;
--synthesis translate_off
    --LCD_0/control_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity LEDs_s1_arbitrator is 
        port (
              -- inputs:
                 signal LEDs_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal LEDs_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal LEDs_s1_chipselect : OUT STD_LOGIC;
                 signal LEDs_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal LEDs_s1_reset_n : OUT STD_LOGIC;
                 signal LEDs_s1_write_n : OUT STD_LOGIC;
                 signal LEDs_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_0_data_master_granted_LEDs_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_LEDs_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_LEDs_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_LEDs_s1 : OUT STD_LOGIC;
                 signal d1_LEDs_s1_end_xfer : OUT STD_LOGIC
              );
end entity LEDs_s1_arbitrator;


architecture europa of LEDs_s1_arbitrator is
                signal LEDs_s1_allgrants :  STD_LOGIC;
                signal LEDs_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal LEDs_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal LEDs_s1_any_continuerequest :  STD_LOGIC;
                signal LEDs_s1_arb_counter_enable :  STD_LOGIC;
                signal LEDs_s1_arb_share_counter :  STD_LOGIC;
                signal LEDs_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal LEDs_s1_arb_share_set_values :  STD_LOGIC;
                signal LEDs_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal LEDs_s1_begins_xfer :  STD_LOGIC;
                signal LEDs_s1_end_xfer :  STD_LOGIC;
                signal LEDs_s1_firsttransfer :  STD_LOGIC;
                signal LEDs_s1_grant_vector :  STD_LOGIC;
                signal LEDs_s1_in_a_read_cycle :  STD_LOGIC;
                signal LEDs_s1_in_a_write_cycle :  STD_LOGIC;
                signal LEDs_s1_master_qreq_vector :  STD_LOGIC;
                signal LEDs_s1_non_bursting_master_requests :  STD_LOGIC;
                signal LEDs_s1_pretend_byte_enable :  STD_LOGIC;
                signal LEDs_s1_reg_firsttransfer :  STD_LOGIC;
                signal LEDs_s1_slavearbiterlockenable :  STD_LOGIC;
                signal LEDs_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal LEDs_s1_unreg_firsttransfer :  STD_LOGIC;
                signal LEDs_s1_waits_for_read :  STD_LOGIC;
                signal LEDs_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_LEDs_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_LEDs_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_LEDs_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_LEDs_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_LEDs_s1 :  STD_LOGIC;
                signal shifted_address_to_LEDs_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_LEDs_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT LEDs_s1_end_xfer;
    end if;

  end process;

  LEDs_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_LEDs_s1);
  --assign LEDs_s1_readdata_from_sa = LEDs_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  LEDs_s1_readdata_from_sa <= LEDs_s1_readdata;
  internal_cpu_0_data_master_requests_LEDs_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000010000000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --LEDs_s1_arb_share_counter set values, which is an e_mux
  LEDs_s1_arb_share_set_values <= std_logic'('1');
  --LEDs_s1_non_bursting_master_requests mux, which is an e_mux
  LEDs_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_LEDs_s1;
  --LEDs_s1_any_bursting_master_saved_grant mux, which is an e_mux
  LEDs_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --LEDs_s1_arb_share_counter_next_value assignment, which is an e_assign
  LEDs_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(LEDs_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LEDs_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(LEDs_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LEDs_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --LEDs_s1_allgrants all slave grants, which is an e_mux
  LEDs_s1_allgrants <= LEDs_s1_grant_vector;
  --LEDs_s1_end_xfer assignment, which is an e_assign
  LEDs_s1_end_xfer <= NOT ((LEDs_s1_waits_for_read OR LEDs_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_LEDs_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_LEDs_s1 <= LEDs_s1_end_xfer AND (((NOT LEDs_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --LEDs_s1_arb_share_counter arbitration counter enable, which is an e_assign
  LEDs_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_LEDs_s1 AND LEDs_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_LEDs_s1 AND NOT LEDs_s1_non_bursting_master_requests));
  --LEDs_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LEDs_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(LEDs_s1_arb_counter_enable) = '1' then 
        LEDs_s1_arb_share_counter <= LEDs_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --LEDs_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LEDs_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((LEDs_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_LEDs_s1)) OR ((end_xfer_arb_share_counter_term_LEDs_s1 AND NOT LEDs_s1_non_bursting_master_requests)))) = '1' then 
        LEDs_s1_slavearbiterlockenable <= LEDs_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master LEDs/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= LEDs_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --LEDs_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  LEDs_s1_slavearbiterlockenable2 <= LEDs_s1_arb_share_counter_next_value;
  --cpu_0/data_master LEDs/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= LEDs_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --LEDs_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  LEDs_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_LEDs_s1 <= internal_cpu_0_data_master_requests_LEDs_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_LEDs_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_LEDs_s1 <= (internal_cpu_0_data_master_granted_LEDs_s1 AND cpu_0_data_master_read) AND NOT LEDs_s1_waits_for_read;
  --LEDs_s1_writedata mux, which is an e_mux
  LEDs_s1_writedata <= cpu_0_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_LEDs_s1 <= internal_cpu_0_data_master_qualified_request_LEDs_s1;
  --cpu_0/data_master saved-grant LEDs/s1, which is an e_assign
  cpu_0_data_master_saved_grant_LEDs_s1 <= internal_cpu_0_data_master_requests_LEDs_s1;
  --allow new arb cycle for LEDs/s1, which is an e_assign
  LEDs_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  LEDs_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  LEDs_s1_master_qreq_vector <= std_logic'('1');
  --LEDs_s1_reset_n assignment, which is an e_assign
  LEDs_s1_reset_n <= reset_n;
  LEDs_s1_chipselect <= internal_cpu_0_data_master_granted_LEDs_s1;
  --LEDs_s1_firsttransfer first transaction, which is an e_assign
  LEDs_s1_firsttransfer <= A_WE_StdLogic((std_logic'(LEDs_s1_begins_xfer) = '1'), LEDs_s1_unreg_firsttransfer, LEDs_s1_reg_firsttransfer);
  --LEDs_s1_unreg_firsttransfer first transaction, which is an e_assign
  LEDs_s1_unreg_firsttransfer <= NOT ((LEDs_s1_slavearbiterlockenable AND LEDs_s1_any_continuerequest));
  --LEDs_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LEDs_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(LEDs_s1_begins_xfer) = '1' then 
        LEDs_s1_reg_firsttransfer <= LEDs_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --LEDs_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  LEDs_s1_beginbursttransfer_internal <= LEDs_s1_begins_xfer;
  --~LEDs_s1_write_n assignment, which is an e_mux
  LEDs_s1_write_n <= NOT ((((internal_cpu_0_data_master_granted_LEDs_s1 AND cpu_0_data_master_write)) AND LEDs_s1_pretend_byte_enable));
  shifted_address_to_LEDs_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --LEDs_s1_address mux, which is an e_mux
  LEDs_s1_address <= A_EXT (A_SRL(shifted_address_to_LEDs_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_LEDs_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_LEDs_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_LEDs_s1_end_xfer <= LEDs_s1_end_xfer;
    end if;

  end process;

  --LEDs_s1_waits_for_read in a cycle, which is an e_mux
  LEDs_s1_waits_for_read <= LEDs_s1_in_a_read_cycle AND LEDs_s1_begins_xfer;
  --LEDs_s1_in_a_read_cycle assignment, which is an e_assign
  LEDs_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_LEDs_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= LEDs_s1_in_a_read_cycle;
  --LEDs_s1_waits_for_write in a cycle, which is an e_mux
  LEDs_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LEDs_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --LEDs_s1_in_a_write_cycle assignment, which is an e_assign
  LEDs_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_LEDs_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= LEDs_s1_in_a_write_cycle;
  wait_for_LEDs_s1_counter <= std_logic'('0');
  --LEDs_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  LEDs_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_granted_LEDs_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_0_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_LEDs_s1 <= internal_cpu_0_data_master_granted_LEDs_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_LEDs_s1 <= internal_cpu_0_data_master_qualified_request_LEDs_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_LEDs_s1 <= internal_cpu_0_data_master_requests_LEDs_s1;
--synthesis translate_off
    --LEDs/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity LUT_DATA_s1_arbitrator is 
        port (
              -- inputs:
                 signal LUT_DATA_s1_readdata : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal LUT_DATA_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal LUT_DATA_s1_chipselect : OUT STD_LOGIC;
                 signal LUT_DATA_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal LUT_DATA_s1_reset_n : OUT STD_LOGIC;
                 signal LUT_DATA_s1_write_n : OUT STD_LOGIC;
                 signal LUT_DATA_s1_writedata : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal cpu_0_data_master_granted_LUT_DATA_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_LUT_DATA_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_LUT_DATA_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_LUT_DATA_s1 : OUT STD_LOGIC;
                 signal d1_LUT_DATA_s1_end_xfer : OUT STD_LOGIC
              );
end entity LUT_DATA_s1_arbitrator;


architecture europa of LUT_DATA_s1_arbitrator is
                signal LUT_DATA_s1_allgrants :  STD_LOGIC;
                signal LUT_DATA_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal LUT_DATA_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal LUT_DATA_s1_any_continuerequest :  STD_LOGIC;
                signal LUT_DATA_s1_arb_counter_enable :  STD_LOGIC;
                signal LUT_DATA_s1_arb_share_counter :  STD_LOGIC;
                signal LUT_DATA_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal LUT_DATA_s1_arb_share_set_values :  STD_LOGIC;
                signal LUT_DATA_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal LUT_DATA_s1_begins_xfer :  STD_LOGIC;
                signal LUT_DATA_s1_end_xfer :  STD_LOGIC;
                signal LUT_DATA_s1_firsttransfer :  STD_LOGIC;
                signal LUT_DATA_s1_grant_vector :  STD_LOGIC;
                signal LUT_DATA_s1_in_a_read_cycle :  STD_LOGIC;
                signal LUT_DATA_s1_in_a_write_cycle :  STD_LOGIC;
                signal LUT_DATA_s1_master_qreq_vector :  STD_LOGIC;
                signal LUT_DATA_s1_non_bursting_master_requests :  STD_LOGIC;
                signal LUT_DATA_s1_reg_firsttransfer :  STD_LOGIC;
                signal LUT_DATA_s1_slavearbiterlockenable :  STD_LOGIC;
                signal LUT_DATA_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal LUT_DATA_s1_unreg_firsttransfer :  STD_LOGIC;
                signal LUT_DATA_s1_waits_for_read :  STD_LOGIC;
                signal LUT_DATA_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_LUT_DATA_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_LUT_DATA_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_LUT_DATA_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_LUT_DATA_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_LUT_DATA_s1 :  STD_LOGIC;
                signal shifted_address_to_LUT_DATA_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_LUT_DATA_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT LUT_DATA_s1_end_xfer;
    end if;

  end process;

  LUT_DATA_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_LUT_DATA_s1);
  --assign LUT_DATA_s1_readdata_from_sa = LUT_DATA_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  LUT_DATA_s1_readdata_from_sa <= LUT_DATA_s1_readdata;
  internal_cpu_0_data_master_requests_LUT_DATA_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000011000000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --LUT_DATA_s1_arb_share_counter set values, which is an e_mux
  LUT_DATA_s1_arb_share_set_values <= std_logic'('1');
  --LUT_DATA_s1_non_bursting_master_requests mux, which is an e_mux
  LUT_DATA_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_LUT_DATA_s1;
  --LUT_DATA_s1_any_bursting_master_saved_grant mux, which is an e_mux
  LUT_DATA_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --LUT_DATA_s1_arb_share_counter_next_value assignment, which is an e_assign
  LUT_DATA_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(LUT_DATA_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LUT_DATA_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(LUT_DATA_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LUT_DATA_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --LUT_DATA_s1_allgrants all slave grants, which is an e_mux
  LUT_DATA_s1_allgrants <= LUT_DATA_s1_grant_vector;
  --LUT_DATA_s1_end_xfer assignment, which is an e_assign
  LUT_DATA_s1_end_xfer <= NOT ((LUT_DATA_s1_waits_for_read OR LUT_DATA_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_LUT_DATA_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_LUT_DATA_s1 <= LUT_DATA_s1_end_xfer AND (((NOT LUT_DATA_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --LUT_DATA_s1_arb_share_counter arbitration counter enable, which is an e_assign
  LUT_DATA_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_LUT_DATA_s1 AND LUT_DATA_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_LUT_DATA_s1 AND NOT LUT_DATA_s1_non_bursting_master_requests));
  --LUT_DATA_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LUT_DATA_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(LUT_DATA_s1_arb_counter_enable) = '1' then 
        LUT_DATA_s1_arb_share_counter <= LUT_DATA_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --LUT_DATA_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LUT_DATA_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((LUT_DATA_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_LUT_DATA_s1)) OR ((end_xfer_arb_share_counter_term_LUT_DATA_s1 AND NOT LUT_DATA_s1_non_bursting_master_requests)))) = '1' then 
        LUT_DATA_s1_slavearbiterlockenable <= LUT_DATA_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master LUT_DATA/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= LUT_DATA_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --LUT_DATA_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  LUT_DATA_s1_slavearbiterlockenable2 <= LUT_DATA_s1_arb_share_counter_next_value;
  --cpu_0/data_master LUT_DATA/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= LUT_DATA_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --LUT_DATA_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  LUT_DATA_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_LUT_DATA_s1 <= internal_cpu_0_data_master_requests_LUT_DATA_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_LUT_DATA_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_LUT_DATA_s1 <= (internal_cpu_0_data_master_granted_LUT_DATA_s1 AND cpu_0_data_master_read) AND NOT LUT_DATA_s1_waits_for_read;
  --LUT_DATA_s1_writedata mux, which is an e_mux
  LUT_DATA_s1_writedata <= cpu_0_data_master_writedata (23 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_LUT_DATA_s1 <= internal_cpu_0_data_master_qualified_request_LUT_DATA_s1;
  --cpu_0/data_master saved-grant LUT_DATA/s1, which is an e_assign
  cpu_0_data_master_saved_grant_LUT_DATA_s1 <= internal_cpu_0_data_master_requests_LUT_DATA_s1;
  --allow new arb cycle for LUT_DATA/s1, which is an e_assign
  LUT_DATA_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  LUT_DATA_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  LUT_DATA_s1_master_qreq_vector <= std_logic'('1');
  --LUT_DATA_s1_reset_n assignment, which is an e_assign
  LUT_DATA_s1_reset_n <= reset_n;
  LUT_DATA_s1_chipselect <= internal_cpu_0_data_master_granted_LUT_DATA_s1;
  --LUT_DATA_s1_firsttransfer first transaction, which is an e_assign
  LUT_DATA_s1_firsttransfer <= A_WE_StdLogic((std_logic'(LUT_DATA_s1_begins_xfer) = '1'), LUT_DATA_s1_unreg_firsttransfer, LUT_DATA_s1_reg_firsttransfer);
  --LUT_DATA_s1_unreg_firsttransfer first transaction, which is an e_assign
  LUT_DATA_s1_unreg_firsttransfer <= NOT ((LUT_DATA_s1_slavearbiterlockenable AND LUT_DATA_s1_any_continuerequest));
  --LUT_DATA_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LUT_DATA_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(LUT_DATA_s1_begins_xfer) = '1' then 
        LUT_DATA_s1_reg_firsttransfer <= LUT_DATA_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --LUT_DATA_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  LUT_DATA_s1_beginbursttransfer_internal <= LUT_DATA_s1_begins_xfer;
  --~LUT_DATA_s1_write_n assignment, which is an e_mux
  LUT_DATA_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_LUT_DATA_s1 AND cpu_0_data_master_write));
  shifted_address_to_LUT_DATA_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --LUT_DATA_s1_address mux, which is an e_mux
  LUT_DATA_s1_address <= A_EXT (A_SRL(shifted_address_to_LUT_DATA_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_LUT_DATA_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_LUT_DATA_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_LUT_DATA_s1_end_xfer <= LUT_DATA_s1_end_xfer;
    end if;

  end process;

  --LUT_DATA_s1_waits_for_read in a cycle, which is an e_mux
  LUT_DATA_s1_waits_for_read <= LUT_DATA_s1_in_a_read_cycle AND LUT_DATA_s1_begins_xfer;
  --LUT_DATA_s1_in_a_read_cycle assignment, which is an e_assign
  LUT_DATA_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_LUT_DATA_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= LUT_DATA_s1_in_a_read_cycle;
  --LUT_DATA_s1_waits_for_write in a cycle, which is an e_mux
  LUT_DATA_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LUT_DATA_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --LUT_DATA_s1_in_a_write_cycle assignment, which is an e_assign
  LUT_DATA_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_LUT_DATA_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= LUT_DATA_s1_in_a_write_cycle;
  wait_for_LUT_DATA_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_LUT_DATA_s1 <= internal_cpu_0_data_master_granted_LUT_DATA_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_LUT_DATA_s1 <= internal_cpu_0_data_master_qualified_request_LUT_DATA_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_LUT_DATA_s1 <= internal_cpu_0_data_master_requests_LUT_DATA_s1;
--synthesis translate_off
    --LUT_DATA/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity LUT_INDEX_s1_arbitrator is 
        port (
              -- inputs:
                 signal LUT_INDEX_s1_irq : IN STD_LOGIC;
                 signal LUT_INDEX_s1_readdata : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal LUT_INDEX_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal LUT_INDEX_s1_chipselect : OUT STD_LOGIC;
                 signal LUT_INDEX_s1_irq_from_sa : OUT STD_LOGIC;
                 signal LUT_INDEX_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal LUT_INDEX_s1_reset_n : OUT STD_LOGIC;
                 signal LUT_INDEX_s1_write_n : OUT STD_LOGIC;
                 signal LUT_INDEX_s1_writedata : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal cpu_0_data_master_granted_LUT_INDEX_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_LUT_INDEX_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_LUT_INDEX_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_LUT_INDEX_s1 : OUT STD_LOGIC;
                 signal d1_LUT_INDEX_s1_end_xfer : OUT STD_LOGIC
              );
end entity LUT_INDEX_s1_arbitrator;


architecture europa of LUT_INDEX_s1_arbitrator is
                signal LUT_INDEX_s1_allgrants :  STD_LOGIC;
                signal LUT_INDEX_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal LUT_INDEX_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal LUT_INDEX_s1_any_continuerequest :  STD_LOGIC;
                signal LUT_INDEX_s1_arb_counter_enable :  STD_LOGIC;
                signal LUT_INDEX_s1_arb_share_counter :  STD_LOGIC;
                signal LUT_INDEX_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal LUT_INDEX_s1_arb_share_set_values :  STD_LOGIC;
                signal LUT_INDEX_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal LUT_INDEX_s1_begins_xfer :  STD_LOGIC;
                signal LUT_INDEX_s1_end_xfer :  STD_LOGIC;
                signal LUT_INDEX_s1_firsttransfer :  STD_LOGIC;
                signal LUT_INDEX_s1_grant_vector :  STD_LOGIC;
                signal LUT_INDEX_s1_in_a_read_cycle :  STD_LOGIC;
                signal LUT_INDEX_s1_in_a_write_cycle :  STD_LOGIC;
                signal LUT_INDEX_s1_master_qreq_vector :  STD_LOGIC;
                signal LUT_INDEX_s1_non_bursting_master_requests :  STD_LOGIC;
                signal LUT_INDEX_s1_reg_firsttransfer :  STD_LOGIC;
                signal LUT_INDEX_s1_slavearbiterlockenable :  STD_LOGIC;
                signal LUT_INDEX_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal LUT_INDEX_s1_unreg_firsttransfer :  STD_LOGIC;
                signal LUT_INDEX_s1_waits_for_read :  STD_LOGIC;
                signal LUT_INDEX_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_LUT_INDEX_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_LUT_INDEX_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_LUT_INDEX_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_LUT_INDEX_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_LUT_INDEX_s1 :  STD_LOGIC;
                signal shifted_address_to_LUT_INDEX_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_LUT_INDEX_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT LUT_INDEX_s1_end_xfer;
    end if;

  end process;

  LUT_INDEX_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_LUT_INDEX_s1);
  --assign LUT_INDEX_s1_readdata_from_sa = LUT_INDEX_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  LUT_INDEX_s1_readdata_from_sa <= LUT_INDEX_s1_readdata;
  internal_cpu_0_data_master_requests_LUT_INDEX_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000010110000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --LUT_INDEX_s1_arb_share_counter set values, which is an e_mux
  LUT_INDEX_s1_arb_share_set_values <= std_logic'('1');
  --LUT_INDEX_s1_non_bursting_master_requests mux, which is an e_mux
  LUT_INDEX_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_LUT_INDEX_s1;
  --LUT_INDEX_s1_any_bursting_master_saved_grant mux, which is an e_mux
  LUT_INDEX_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --LUT_INDEX_s1_arb_share_counter_next_value assignment, which is an e_assign
  LUT_INDEX_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(LUT_INDEX_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LUT_INDEX_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(LUT_INDEX_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LUT_INDEX_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --LUT_INDEX_s1_allgrants all slave grants, which is an e_mux
  LUT_INDEX_s1_allgrants <= LUT_INDEX_s1_grant_vector;
  --LUT_INDEX_s1_end_xfer assignment, which is an e_assign
  LUT_INDEX_s1_end_xfer <= NOT ((LUT_INDEX_s1_waits_for_read OR LUT_INDEX_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_LUT_INDEX_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_LUT_INDEX_s1 <= LUT_INDEX_s1_end_xfer AND (((NOT LUT_INDEX_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --LUT_INDEX_s1_arb_share_counter arbitration counter enable, which is an e_assign
  LUT_INDEX_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_LUT_INDEX_s1 AND LUT_INDEX_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_LUT_INDEX_s1 AND NOT LUT_INDEX_s1_non_bursting_master_requests));
  --LUT_INDEX_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LUT_INDEX_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(LUT_INDEX_s1_arb_counter_enable) = '1' then 
        LUT_INDEX_s1_arb_share_counter <= LUT_INDEX_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --LUT_INDEX_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LUT_INDEX_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((LUT_INDEX_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_LUT_INDEX_s1)) OR ((end_xfer_arb_share_counter_term_LUT_INDEX_s1 AND NOT LUT_INDEX_s1_non_bursting_master_requests)))) = '1' then 
        LUT_INDEX_s1_slavearbiterlockenable <= LUT_INDEX_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master LUT_INDEX/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= LUT_INDEX_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --LUT_INDEX_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  LUT_INDEX_s1_slavearbiterlockenable2 <= LUT_INDEX_s1_arb_share_counter_next_value;
  --cpu_0/data_master LUT_INDEX/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= LUT_INDEX_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --LUT_INDEX_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  LUT_INDEX_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_LUT_INDEX_s1 <= internal_cpu_0_data_master_requests_LUT_INDEX_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_LUT_INDEX_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_LUT_INDEX_s1 <= (internal_cpu_0_data_master_granted_LUT_INDEX_s1 AND cpu_0_data_master_read) AND NOT LUT_INDEX_s1_waits_for_read;
  --LUT_INDEX_s1_writedata mux, which is an e_mux
  LUT_INDEX_s1_writedata <= cpu_0_data_master_writedata (5 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_LUT_INDEX_s1 <= internal_cpu_0_data_master_qualified_request_LUT_INDEX_s1;
  --cpu_0/data_master saved-grant LUT_INDEX/s1, which is an e_assign
  cpu_0_data_master_saved_grant_LUT_INDEX_s1 <= internal_cpu_0_data_master_requests_LUT_INDEX_s1;
  --allow new arb cycle for LUT_INDEX/s1, which is an e_assign
  LUT_INDEX_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  LUT_INDEX_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  LUT_INDEX_s1_master_qreq_vector <= std_logic'('1');
  --LUT_INDEX_s1_reset_n assignment, which is an e_assign
  LUT_INDEX_s1_reset_n <= reset_n;
  LUT_INDEX_s1_chipselect <= internal_cpu_0_data_master_granted_LUT_INDEX_s1;
  --LUT_INDEX_s1_firsttransfer first transaction, which is an e_assign
  LUT_INDEX_s1_firsttransfer <= A_WE_StdLogic((std_logic'(LUT_INDEX_s1_begins_xfer) = '1'), LUT_INDEX_s1_unreg_firsttransfer, LUT_INDEX_s1_reg_firsttransfer);
  --LUT_INDEX_s1_unreg_firsttransfer first transaction, which is an e_assign
  LUT_INDEX_s1_unreg_firsttransfer <= NOT ((LUT_INDEX_s1_slavearbiterlockenable AND LUT_INDEX_s1_any_continuerequest));
  --LUT_INDEX_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      LUT_INDEX_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(LUT_INDEX_s1_begins_xfer) = '1' then 
        LUT_INDEX_s1_reg_firsttransfer <= LUT_INDEX_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --LUT_INDEX_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  LUT_INDEX_s1_beginbursttransfer_internal <= LUT_INDEX_s1_begins_xfer;
  --~LUT_INDEX_s1_write_n assignment, which is an e_mux
  LUT_INDEX_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_LUT_INDEX_s1 AND cpu_0_data_master_write));
  shifted_address_to_LUT_INDEX_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --LUT_INDEX_s1_address mux, which is an e_mux
  LUT_INDEX_s1_address <= A_EXT (A_SRL(shifted_address_to_LUT_INDEX_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_LUT_INDEX_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_LUT_INDEX_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_LUT_INDEX_s1_end_xfer <= LUT_INDEX_s1_end_xfer;
    end if;

  end process;

  --LUT_INDEX_s1_waits_for_read in a cycle, which is an e_mux
  LUT_INDEX_s1_waits_for_read <= LUT_INDEX_s1_in_a_read_cycle AND LUT_INDEX_s1_begins_xfer;
  --LUT_INDEX_s1_in_a_read_cycle assignment, which is an e_assign
  LUT_INDEX_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_LUT_INDEX_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= LUT_INDEX_s1_in_a_read_cycle;
  --LUT_INDEX_s1_waits_for_write in a cycle, which is an e_mux
  LUT_INDEX_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(LUT_INDEX_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --LUT_INDEX_s1_in_a_write_cycle assignment, which is an e_assign
  LUT_INDEX_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_LUT_INDEX_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= LUT_INDEX_s1_in_a_write_cycle;
  wait_for_LUT_INDEX_s1_counter <= std_logic'('0');
  --assign LUT_INDEX_s1_irq_from_sa = LUT_INDEX_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  LUT_INDEX_s1_irq_from_sa <= LUT_INDEX_s1_irq;
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_LUT_INDEX_s1 <= internal_cpu_0_data_master_granted_LUT_INDEX_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_LUT_INDEX_s1 <= internal_cpu_0_data_master_qualified_request_LUT_INDEX_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_LUT_INDEX_s1 <= internal_cpu_0_data_master_requests_LUT_INDEX_s1;
--synthesis translate_off
    --LUT_INDEX/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity PIX_VALCLK_s1_arbitrator is 
        port (
              -- inputs:
                 signal PIX_VALCLK_s1_irq : IN STD_LOGIC;
                 signal PIX_VALCLK_s1_readdata : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal PIX_VALCLK_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal PIX_VALCLK_s1_chipselect : OUT STD_LOGIC;
                 signal PIX_VALCLK_s1_irq_from_sa : OUT STD_LOGIC;
                 signal PIX_VALCLK_s1_readdata_from_sa : OUT STD_LOGIC;
                 signal PIX_VALCLK_s1_reset_n : OUT STD_LOGIC;
                 signal PIX_VALCLK_s1_write_n : OUT STD_LOGIC;
                 signal PIX_VALCLK_s1_writedata : OUT STD_LOGIC;
                 signal cpu_0_data_master_granted_PIX_VALCLK_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_PIX_VALCLK_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_PIX_VALCLK_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_PIX_VALCLK_s1 : OUT STD_LOGIC;
                 signal d1_PIX_VALCLK_s1_end_xfer : OUT STD_LOGIC
              );
end entity PIX_VALCLK_s1_arbitrator;


architecture europa of PIX_VALCLK_s1_arbitrator is
                signal PIX_VALCLK_s1_allgrants :  STD_LOGIC;
                signal PIX_VALCLK_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal PIX_VALCLK_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal PIX_VALCLK_s1_any_continuerequest :  STD_LOGIC;
                signal PIX_VALCLK_s1_arb_counter_enable :  STD_LOGIC;
                signal PIX_VALCLK_s1_arb_share_counter :  STD_LOGIC;
                signal PIX_VALCLK_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal PIX_VALCLK_s1_arb_share_set_values :  STD_LOGIC;
                signal PIX_VALCLK_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal PIX_VALCLK_s1_begins_xfer :  STD_LOGIC;
                signal PIX_VALCLK_s1_end_xfer :  STD_LOGIC;
                signal PIX_VALCLK_s1_firsttransfer :  STD_LOGIC;
                signal PIX_VALCLK_s1_grant_vector :  STD_LOGIC;
                signal PIX_VALCLK_s1_in_a_read_cycle :  STD_LOGIC;
                signal PIX_VALCLK_s1_in_a_write_cycle :  STD_LOGIC;
                signal PIX_VALCLK_s1_master_qreq_vector :  STD_LOGIC;
                signal PIX_VALCLK_s1_non_bursting_master_requests :  STD_LOGIC;
                signal PIX_VALCLK_s1_reg_firsttransfer :  STD_LOGIC;
                signal PIX_VALCLK_s1_slavearbiterlockenable :  STD_LOGIC;
                signal PIX_VALCLK_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal PIX_VALCLK_s1_unreg_firsttransfer :  STD_LOGIC;
                signal PIX_VALCLK_s1_waits_for_read :  STD_LOGIC;
                signal PIX_VALCLK_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_PIX_VALCLK_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_PIX_VALCLK_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_PIX_VALCLK_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_PIX_VALCLK_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_PIX_VALCLK_s1 :  STD_LOGIC;
                signal shifted_address_to_PIX_VALCLK_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_PIX_VALCLK_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT PIX_VALCLK_s1_end_xfer;
    end if;

  end process;

  PIX_VALCLK_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_PIX_VALCLK_s1);
  --assign PIX_VALCLK_s1_readdata_from_sa = PIX_VALCLK_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  PIX_VALCLK_s1_readdata_from_sa <= PIX_VALCLK_s1_readdata;
  internal_cpu_0_data_master_requests_PIX_VALCLK_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000110000000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --PIX_VALCLK_s1_arb_share_counter set values, which is an e_mux
  PIX_VALCLK_s1_arb_share_set_values <= std_logic'('1');
  --PIX_VALCLK_s1_non_bursting_master_requests mux, which is an e_mux
  PIX_VALCLK_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_PIX_VALCLK_s1;
  --PIX_VALCLK_s1_any_bursting_master_saved_grant mux, which is an e_mux
  PIX_VALCLK_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --PIX_VALCLK_s1_arb_share_counter_next_value assignment, which is an e_assign
  PIX_VALCLK_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(PIX_VALCLK_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(PIX_VALCLK_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(PIX_VALCLK_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(PIX_VALCLK_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --PIX_VALCLK_s1_allgrants all slave grants, which is an e_mux
  PIX_VALCLK_s1_allgrants <= PIX_VALCLK_s1_grant_vector;
  --PIX_VALCLK_s1_end_xfer assignment, which is an e_assign
  PIX_VALCLK_s1_end_xfer <= NOT ((PIX_VALCLK_s1_waits_for_read OR PIX_VALCLK_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_PIX_VALCLK_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_PIX_VALCLK_s1 <= PIX_VALCLK_s1_end_xfer AND (((NOT PIX_VALCLK_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --PIX_VALCLK_s1_arb_share_counter arbitration counter enable, which is an e_assign
  PIX_VALCLK_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_PIX_VALCLK_s1 AND PIX_VALCLK_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_PIX_VALCLK_s1 AND NOT PIX_VALCLK_s1_non_bursting_master_requests));
  --PIX_VALCLK_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      PIX_VALCLK_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(PIX_VALCLK_s1_arb_counter_enable) = '1' then 
        PIX_VALCLK_s1_arb_share_counter <= PIX_VALCLK_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --PIX_VALCLK_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      PIX_VALCLK_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((PIX_VALCLK_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_PIX_VALCLK_s1)) OR ((end_xfer_arb_share_counter_term_PIX_VALCLK_s1 AND NOT PIX_VALCLK_s1_non_bursting_master_requests)))) = '1' then 
        PIX_VALCLK_s1_slavearbiterlockenable <= PIX_VALCLK_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master PIX_VALCLK/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= PIX_VALCLK_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --PIX_VALCLK_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  PIX_VALCLK_s1_slavearbiterlockenable2 <= PIX_VALCLK_s1_arb_share_counter_next_value;
  --cpu_0/data_master PIX_VALCLK/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= PIX_VALCLK_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --PIX_VALCLK_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  PIX_VALCLK_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_PIX_VALCLK_s1 <= internal_cpu_0_data_master_requests_PIX_VALCLK_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_PIX_VALCLK_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_PIX_VALCLK_s1 <= (internal_cpu_0_data_master_granted_PIX_VALCLK_s1 AND cpu_0_data_master_read) AND NOT PIX_VALCLK_s1_waits_for_read;
  --PIX_VALCLK_s1_writedata mux, which is an e_mux
  PIX_VALCLK_s1_writedata <= cpu_0_data_master_writedata(0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_PIX_VALCLK_s1 <= internal_cpu_0_data_master_qualified_request_PIX_VALCLK_s1;
  --cpu_0/data_master saved-grant PIX_VALCLK/s1, which is an e_assign
  cpu_0_data_master_saved_grant_PIX_VALCLK_s1 <= internal_cpu_0_data_master_requests_PIX_VALCLK_s1;
  --allow new arb cycle for PIX_VALCLK/s1, which is an e_assign
  PIX_VALCLK_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  PIX_VALCLK_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  PIX_VALCLK_s1_master_qreq_vector <= std_logic'('1');
  --PIX_VALCLK_s1_reset_n assignment, which is an e_assign
  PIX_VALCLK_s1_reset_n <= reset_n;
  PIX_VALCLK_s1_chipselect <= internal_cpu_0_data_master_granted_PIX_VALCLK_s1;
  --PIX_VALCLK_s1_firsttransfer first transaction, which is an e_assign
  PIX_VALCLK_s1_firsttransfer <= A_WE_StdLogic((std_logic'(PIX_VALCLK_s1_begins_xfer) = '1'), PIX_VALCLK_s1_unreg_firsttransfer, PIX_VALCLK_s1_reg_firsttransfer);
  --PIX_VALCLK_s1_unreg_firsttransfer first transaction, which is an e_assign
  PIX_VALCLK_s1_unreg_firsttransfer <= NOT ((PIX_VALCLK_s1_slavearbiterlockenable AND PIX_VALCLK_s1_any_continuerequest));
  --PIX_VALCLK_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      PIX_VALCLK_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(PIX_VALCLK_s1_begins_xfer) = '1' then 
        PIX_VALCLK_s1_reg_firsttransfer <= PIX_VALCLK_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --PIX_VALCLK_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  PIX_VALCLK_s1_beginbursttransfer_internal <= PIX_VALCLK_s1_begins_xfer;
  --~PIX_VALCLK_s1_write_n assignment, which is an e_mux
  PIX_VALCLK_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_PIX_VALCLK_s1 AND cpu_0_data_master_write));
  shifted_address_to_PIX_VALCLK_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --PIX_VALCLK_s1_address mux, which is an e_mux
  PIX_VALCLK_s1_address <= A_EXT (A_SRL(shifted_address_to_PIX_VALCLK_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_PIX_VALCLK_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_PIX_VALCLK_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_PIX_VALCLK_s1_end_xfer <= PIX_VALCLK_s1_end_xfer;
    end if;

  end process;

  --PIX_VALCLK_s1_waits_for_read in a cycle, which is an e_mux
  PIX_VALCLK_s1_waits_for_read <= PIX_VALCLK_s1_in_a_read_cycle AND PIX_VALCLK_s1_begins_xfer;
  --PIX_VALCLK_s1_in_a_read_cycle assignment, which is an e_assign
  PIX_VALCLK_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_PIX_VALCLK_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= PIX_VALCLK_s1_in_a_read_cycle;
  --PIX_VALCLK_s1_waits_for_write in a cycle, which is an e_mux
  PIX_VALCLK_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(PIX_VALCLK_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --PIX_VALCLK_s1_in_a_write_cycle assignment, which is an e_assign
  PIX_VALCLK_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_PIX_VALCLK_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= PIX_VALCLK_s1_in_a_write_cycle;
  wait_for_PIX_VALCLK_s1_counter <= std_logic'('0');
  --assign PIX_VALCLK_s1_irq_from_sa = PIX_VALCLK_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  PIX_VALCLK_s1_irq_from_sa <= PIX_VALCLK_s1_irq;
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_PIX_VALCLK_s1 <= internal_cpu_0_data_master_granted_PIX_VALCLK_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_PIX_VALCLK_s1 <= internal_cpu_0_data_master_qualified_request_PIX_VALCLK_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_PIX_VALCLK_s1 <= internal_cpu_0_data_master_requests_PIX_VALCLK_s1;
--synthesis translate_off
    --PIX_VALCLK/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity RAW2RGB_CONTROL_OUT_s1_arbitrator is 
        port (
              -- inputs:
                 signal RAW2RGB_CONTROL_OUT_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal RAW2RGB_CONTROL_OUT_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal RAW2RGB_CONTROL_OUT_s1_chipselect : OUT STD_LOGIC;
                 signal RAW2RGB_CONTROL_OUT_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal RAW2RGB_CONTROL_OUT_s1_reset_n : OUT STD_LOGIC;
                 signal RAW2RGB_CONTROL_OUT_s1_write_n : OUT STD_LOGIC;
                 signal RAW2RGB_CONTROL_OUT_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 : OUT STD_LOGIC;
                 signal d1_RAW2RGB_CONTROL_OUT_s1_end_xfer : OUT STD_LOGIC
              );
end entity RAW2RGB_CONTROL_OUT_s1_arbitrator;


architecture europa of RAW2RGB_CONTROL_OUT_s1_arbitrator is
                signal RAW2RGB_CONTROL_OUT_s1_allgrants :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_any_continuerequest :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_arb_counter_enable :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_arb_share_counter :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_arb_share_set_values :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_begins_xfer :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_end_xfer :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_firsttransfer :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_grant_vector :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_in_a_read_cycle :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_in_a_write_cycle :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_master_qreq_vector :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_non_bursting_master_requests :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_reg_firsttransfer :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_unreg_firsttransfer :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_waits_for_read :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_RAW2RGB_CONTROL_OUT_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_RAW2RGB_CONTROL_OUT_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 :  STD_LOGIC;
                signal shifted_address_to_RAW2RGB_CONTROL_OUT_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_RAW2RGB_CONTROL_OUT_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT RAW2RGB_CONTROL_OUT_s1_end_xfer;
    end if;

  end process;

  RAW2RGB_CONTROL_OUT_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1);
  --assign RAW2RGB_CONTROL_OUT_s1_readdata_from_sa = RAW2RGB_CONTROL_OUT_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_readdata_from_sa <= RAW2RGB_CONTROL_OUT_s1_readdata;
  internal_cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("10001000001100000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --RAW2RGB_CONTROL_OUT_s1_arb_share_counter set values, which is an e_mux
  RAW2RGB_CONTROL_OUT_s1_arb_share_set_values <= std_logic'('1');
  --RAW2RGB_CONTROL_OUT_s1_non_bursting_master_requests mux, which is an e_mux
  RAW2RGB_CONTROL_OUT_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1;
  --RAW2RGB_CONTROL_OUT_s1_any_bursting_master_saved_grant mux, which is an e_mux
  RAW2RGB_CONTROL_OUT_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --RAW2RGB_CONTROL_OUT_s1_arb_share_counter_next_value assignment, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(RAW2RGB_CONTROL_OUT_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RAW2RGB_CONTROL_OUT_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(RAW2RGB_CONTROL_OUT_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RAW2RGB_CONTROL_OUT_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --RAW2RGB_CONTROL_OUT_s1_allgrants all slave grants, which is an e_mux
  RAW2RGB_CONTROL_OUT_s1_allgrants <= RAW2RGB_CONTROL_OUT_s1_grant_vector;
  --RAW2RGB_CONTROL_OUT_s1_end_xfer assignment, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_end_xfer <= NOT ((RAW2RGB_CONTROL_OUT_s1_waits_for_read OR RAW2RGB_CONTROL_OUT_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_RAW2RGB_CONTROL_OUT_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_RAW2RGB_CONTROL_OUT_s1 <= RAW2RGB_CONTROL_OUT_s1_end_xfer AND (((NOT RAW2RGB_CONTROL_OUT_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --RAW2RGB_CONTROL_OUT_s1_arb_share_counter arbitration counter enable, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_RAW2RGB_CONTROL_OUT_s1 AND RAW2RGB_CONTROL_OUT_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_RAW2RGB_CONTROL_OUT_s1 AND NOT RAW2RGB_CONTROL_OUT_s1_non_bursting_master_requests));
  --RAW2RGB_CONTROL_OUT_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      RAW2RGB_CONTROL_OUT_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(RAW2RGB_CONTROL_OUT_s1_arb_counter_enable) = '1' then 
        RAW2RGB_CONTROL_OUT_s1_arb_share_counter <= RAW2RGB_CONTROL_OUT_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((RAW2RGB_CONTROL_OUT_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_RAW2RGB_CONTROL_OUT_s1)) OR ((end_xfer_arb_share_counter_term_RAW2RGB_CONTROL_OUT_s1 AND NOT RAW2RGB_CONTROL_OUT_s1_non_bursting_master_requests)))) = '1' then 
        RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable <= RAW2RGB_CONTROL_OUT_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master RAW2RGB_CONTROL_OUT/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable2 <= RAW2RGB_CONTROL_OUT_s1_arb_share_counter_next_value;
  --cpu_0/data_master RAW2RGB_CONTROL_OUT/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --RAW2RGB_CONTROL_OUT_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 <= internal_cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1 <= (internal_cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 AND cpu_0_data_master_read) AND NOT RAW2RGB_CONTROL_OUT_s1_waits_for_read;
  --RAW2RGB_CONTROL_OUT_s1_writedata mux, which is an e_mux
  RAW2RGB_CONTROL_OUT_s1_writedata <= cpu_0_data_master_writedata (3 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 <= internal_cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1;
  --cpu_0/data_master saved-grant RAW2RGB_CONTROL_OUT/s1, which is an e_assign
  cpu_0_data_master_saved_grant_RAW2RGB_CONTROL_OUT_s1 <= internal_cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1;
  --allow new arb cycle for RAW2RGB_CONTROL_OUT/s1, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  RAW2RGB_CONTROL_OUT_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  RAW2RGB_CONTROL_OUT_s1_master_qreq_vector <= std_logic'('1');
  --RAW2RGB_CONTROL_OUT_s1_reset_n assignment, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_reset_n <= reset_n;
  RAW2RGB_CONTROL_OUT_s1_chipselect <= internal_cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1;
  --RAW2RGB_CONTROL_OUT_s1_firsttransfer first transaction, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_firsttransfer <= A_WE_StdLogic((std_logic'(RAW2RGB_CONTROL_OUT_s1_begins_xfer) = '1'), RAW2RGB_CONTROL_OUT_s1_unreg_firsttransfer, RAW2RGB_CONTROL_OUT_s1_reg_firsttransfer);
  --RAW2RGB_CONTROL_OUT_s1_unreg_firsttransfer first transaction, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_unreg_firsttransfer <= NOT ((RAW2RGB_CONTROL_OUT_s1_slavearbiterlockenable AND RAW2RGB_CONTROL_OUT_s1_any_continuerequest));
  --RAW2RGB_CONTROL_OUT_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      RAW2RGB_CONTROL_OUT_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(RAW2RGB_CONTROL_OUT_s1_begins_xfer) = '1' then 
        RAW2RGB_CONTROL_OUT_s1_reg_firsttransfer <= RAW2RGB_CONTROL_OUT_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --RAW2RGB_CONTROL_OUT_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_beginbursttransfer_internal <= RAW2RGB_CONTROL_OUT_s1_begins_xfer;
  --~RAW2RGB_CONTROL_OUT_s1_write_n assignment, which is an e_mux
  RAW2RGB_CONTROL_OUT_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 AND cpu_0_data_master_write));
  shifted_address_to_RAW2RGB_CONTROL_OUT_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --RAW2RGB_CONTROL_OUT_s1_address mux, which is an e_mux
  RAW2RGB_CONTROL_OUT_s1_address <= A_EXT (A_SRL(shifted_address_to_RAW2RGB_CONTROL_OUT_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_RAW2RGB_CONTROL_OUT_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_RAW2RGB_CONTROL_OUT_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_RAW2RGB_CONTROL_OUT_s1_end_xfer <= RAW2RGB_CONTROL_OUT_s1_end_xfer;
    end if;

  end process;

  --RAW2RGB_CONTROL_OUT_s1_waits_for_read in a cycle, which is an e_mux
  RAW2RGB_CONTROL_OUT_s1_waits_for_read <= RAW2RGB_CONTROL_OUT_s1_in_a_read_cycle AND RAW2RGB_CONTROL_OUT_s1_begins_xfer;
  --RAW2RGB_CONTROL_OUT_s1_in_a_read_cycle assignment, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= RAW2RGB_CONTROL_OUT_s1_in_a_read_cycle;
  --RAW2RGB_CONTROL_OUT_s1_waits_for_write in a cycle, which is an e_mux
  RAW2RGB_CONTROL_OUT_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RAW2RGB_CONTROL_OUT_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --RAW2RGB_CONTROL_OUT_s1_in_a_write_cycle assignment, which is an e_assign
  RAW2RGB_CONTROL_OUT_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= RAW2RGB_CONTROL_OUT_s1_in_a_write_cycle;
  wait_for_RAW2RGB_CONTROL_OUT_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 <= internal_cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 <= internal_cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 <= internal_cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1;
--synthesis translate_off
    --RAW2RGB_CONTROL_OUT/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity RED_s1_arbitrator is 
        port (
              -- inputs:
                 signal RED_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal RED_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal RED_s1_chipselect : OUT STD_LOGIC;
                 signal RED_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal RED_s1_reset_n : OUT STD_LOGIC;
                 signal RED_s1_write_n : OUT STD_LOGIC;
                 signal RED_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal cpu_0_data_master_granted_RED_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_RED_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_RED_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_RED_s1 : OUT STD_LOGIC;
                 signal d1_RED_s1_end_xfer : OUT STD_LOGIC
              );
end entity RED_s1_arbitrator;


architecture europa of RED_s1_arbitrator is
                signal RED_s1_allgrants :  STD_LOGIC;
                signal RED_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal RED_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal RED_s1_any_continuerequest :  STD_LOGIC;
                signal RED_s1_arb_counter_enable :  STD_LOGIC;
                signal RED_s1_arb_share_counter :  STD_LOGIC;
                signal RED_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal RED_s1_arb_share_set_values :  STD_LOGIC;
                signal RED_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal RED_s1_begins_xfer :  STD_LOGIC;
                signal RED_s1_end_xfer :  STD_LOGIC;
                signal RED_s1_firsttransfer :  STD_LOGIC;
                signal RED_s1_grant_vector :  STD_LOGIC;
                signal RED_s1_in_a_read_cycle :  STD_LOGIC;
                signal RED_s1_in_a_write_cycle :  STD_LOGIC;
                signal RED_s1_master_qreq_vector :  STD_LOGIC;
                signal RED_s1_non_bursting_master_requests :  STD_LOGIC;
                signal RED_s1_reg_firsttransfer :  STD_LOGIC;
                signal RED_s1_slavearbiterlockenable :  STD_LOGIC;
                signal RED_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal RED_s1_unreg_firsttransfer :  STD_LOGIC;
                signal RED_s1_waits_for_read :  STD_LOGIC;
                signal RED_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_RED_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_RED_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_RED_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_RED_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_RED_s1 :  STD_LOGIC;
                signal shifted_address_to_RED_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_RED_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT RED_s1_end_xfer;
    end if;

  end process;

  RED_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_RED_s1);
  --assign RED_s1_readdata_from_sa = RED_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  RED_s1_readdata_from_sa <= RED_s1_readdata;
  internal_cpu_0_data_master_requests_RED_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000011100000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --RED_s1_arb_share_counter set values, which is an e_mux
  RED_s1_arb_share_set_values <= std_logic'('1');
  --RED_s1_non_bursting_master_requests mux, which is an e_mux
  RED_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_RED_s1;
  --RED_s1_any_bursting_master_saved_grant mux, which is an e_mux
  RED_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --RED_s1_arb_share_counter_next_value assignment, which is an e_assign
  RED_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(RED_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RED_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(RED_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RED_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --RED_s1_allgrants all slave grants, which is an e_mux
  RED_s1_allgrants <= RED_s1_grant_vector;
  --RED_s1_end_xfer assignment, which is an e_assign
  RED_s1_end_xfer <= NOT ((RED_s1_waits_for_read OR RED_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_RED_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_RED_s1 <= RED_s1_end_xfer AND (((NOT RED_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --RED_s1_arb_share_counter arbitration counter enable, which is an e_assign
  RED_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_RED_s1 AND RED_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_RED_s1 AND NOT RED_s1_non_bursting_master_requests));
  --RED_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      RED_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(RED_s1_arb_counter_enable) = '1' then 
        RED_s1_arb_share_counter <= RED_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --RED_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      RED_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((RED_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_RED_s1)) OR ((end_xfer_arb_share_counter_term_RED_s1 AND NOT RED_s1_non_bursting_master_requests)))) = '1' then 
        RED_s1_slavearbiterlockenable <= RED_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master RED/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= RED_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --RED_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  RED_s1_slavearbiterlockenable2 <= RED_s1_arb_share_counter_next_value;
  --cpu_0/data_master RED/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= RED_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --RED_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  RED_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_RED_s1 <= internal_cpu_0_data_master_requests_RED_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_RED_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_RED_s1 <= (internal_cpu_0_data_master_granted_RED_s1 AND cpu_0_data_master_read) AND NOT RED_s1_waits_for_read;
  --RED_s1_writedata mux, which is an e_mux
  RED_s1_writedata <= cpu_0_data_master_writedata (11 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_RED_s1 <= internal_cpu_0_data_master_qualified_request_RED_s1;
  --cpu_0/data_master saved-grant RED/s1, which is an e_assign
  cpu_0_data_master_saved_grant_RED_s1 <= internal_cpu_0_data_master_requests_RED_s1;
  --allow new arb cycle for RED/s1, which is an e_assign
  RED_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  RED_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  RED_s1_master_qreq_vector <= std_logic'('1');
  --RED_s1_reset_n assignment, which is an e_assign
  RED_s1_reset_n <= reset_n;
  RED_s1_chipselect <= internal_cpu_0_data_master_granted_RED_s1;
  --RED_s1_firsttransfer first transaction, which is an e_assign
  RED_s1_firsttransfer <= A_WE_StdLogic((std_logic'(RED_s1_begins_xfer) = '1'), RED_s1_unreg_firsttransfer, RED_s1_reg_firsttransfer);
  --RED_s1_unreg_firsttransfer first transaction, which is an e_assign
  RED_s1_unreg_firsttransfer <= NOT ((RED_s1_slavearbiterlockenable AND RED_s1_any_continuerequest));
  --RED_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      RED_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(RED_s1_begins_xfer) = '1' then 
        RED_s1_reg_firsttransfer <= RED_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --RED_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  RED_s1_beginbursttransfer_internal <= RED_s1_begins_xfer;
  --~RED_s1_write_n assignment, which is an e_mux
  RED_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_RED_s1 AND cpu_0_data_master_write));
  shifted_address_to_RED_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --RED_s1_address mux, which is an e_mux
  RED_s1_address <= A_EXT (A_SRL(shifted_address_to_RED_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_RED_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_RED_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_RED_s1_end_xfer <= RED_s1_end_xfer;
    end if;

  end process;

  --RED_s1_waits_for_read in a cycle, which is an e_mux
  RED_s1_waits_for_read <= RED_s1_in_a_read_cycle AND RED_s1_begins_xfer;
  --RED_s1_in_a_read_cycle assignment, which is an e_assign
  RED_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_RED_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= RED_s1_in_a_read_cycle;
  --RED_s1_waits_for_write in a cycle, which is an e_mux
  RED_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RED_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --RED_s1_in_a_write_cycle assignment, which is an e_assign
  RED_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_RED_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= RED_s1_in_a_write_cycle;
  wait_for_RED_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_RED_s1 <= internal_cpu_0_data_master_granted_RED_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_RED_s1 <= internal_cpu_0_data_master_qualified_request_RED_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_RED_s1 <= internal_cpu_0_data_master_requests_RED_s1;
--synthesis translate_off
    --RED/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity RESET_OUT_s1_arbitrator is 
        port (
              -- inputs:
                 signal RESET_OUT_s1_readdata : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal RESET_OUT_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal RESET_OUT_s1_chipselect : OUT STD_LOGIC;
                 signal RESET_OUT_s1_readdata_from_sa : OUT STD_LOGIC;
                 signal RESET_OUT_s1_reset_n : OUT STD_LOGIC;
                 signal RESET_OUT_s1_write_n : OUT STD_LOGIC;
                 signal RESET_OUT_s1_writedata : OUT STD_LOGIC;
                 signal cpu_0_data_master_granted_RESET_OUT_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_RESET_OUT_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_RESET_OUT_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_RESET_OUT_s1 : OUT STD_LOGIC;
                 signal d1_RESET_OUT_s1_end_xfer : OUT STD_LOGIC
              );
end entity RESET_OUT_s1_arbitrator;


architecture europa of RESET_OUT_s1_arbitrator is
                signal RESET_OUT_s1_allgrants :  STD_LOGIC;
                signal RESET_OUT_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal RESET_OUT_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal RESET_OUT_s1_any_continuerequest :  STD_LOGIC;
                signal RESET_OUT_s1_arb_counter_enable :  STD_LOGIC;
                signal RESET_OUT_s1_arb_share_counter :  STD_LOGIC;
                signal RESET_OUT_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal RESET_OUT_s1_arb_share_set_values :  STD_LOGIC;
                signal RESET_OUT_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal RESET_OUT_s1_begins_xfer :  STD_LOGIC;
                signal RESET_OUT_s1_end_xfer :  STD_LOGIC;
                signal RESET_OUT_s1_firsttransfer :  STD_LOGIC;
                signal RESET_OUT_s1_grant_vector :  STD_LOGIC;
                signal RESET_OUT_s1_in_a_read_cycle :  STD_LOGIC;
                signal RESET_OUT_s1_in_a_write_cycle :  STD_LOGIC;
                signal RESET_OUT_s1_master_qreq_vector :  STD_LOGIC;
                signal RESET_OUT_s1_non_bursting_master_requests :  STD_LOGIC;
                signal RESET_OUT_s1_reg_firsttransfer :  STD_LOGIC;
                signal RESET_OUT_s1_slavearbiterlockenable :  STD_LOGIC;
                signal RESET_OUT_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal RESET_OUT_s1_unreg_firsttransfer :  STD_LOGIC;
                signal RESET_OUT_s1_waits_for_read :  STD_LOGIC;
                signal RESET_OUT_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_RESET_OUT_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_RESET_OUT_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_RESET_OUT_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_RESET_OUT_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_RESET_OUT_s1 :  STD_LOGIC;
                signal shifted_address_to_RESET_OUT_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_RESET_OUT_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT RESET_OUT_s1_end_xfer;
    end if;

  end process;

  RESET_OUT_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_RESET_OUT_s1);
  --assign RESET_OUT_s1_readdata_from_sa = RESET_OUT_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  RESET_OUT_s1_readdata_from_sa <= RESET_OUT_s1_readdata;
  internal_cpu_0_data_master_requests_RESET_OUT_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000100000000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --RESET_OUT_s1_arb_share_counter set values, which is an e_mux
  RESET_OUT_s1_arb_share_set_values <= std_logic'('1');
  --RESET_OUT_s1_non_bursting_master_requests mux, which is an e_mux
  RESET_OUT_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_RESET_OUT_s1;
  --RESET_OUT_s1_any_bursting_master_saved_grant mux, which is an e_mux
  RESET_OUT_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --RESET_OUT_s1_arb_share_counter_next_value assignment, which is an e_assign
  RESET_OUT_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(RESET_OUT_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RESET_OUT_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(RESET_OUT_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RESET_OUT_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --RESET_OUT_s1_allgrants all slave grants, which is an e_mux
  RESET_OUT_s1_allgrants <= RESET_OUT_s1_grant_vector;
  --RESET_OUT_s1_end_xfer assignment, which is an e_assign
  RESET_OUT_s1_end_xfer <= NOT ((RESET_OUT_s1_waits_for_read OR RESET_OUT_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_RESET_OUT_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_RESET_OUT_s1 <= RESET_OUT_s1_end_xfer AND (((NOT RESET_OUT_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --RESET_OUT_s1_arb_share_counter arbitration counter enable, which is an e_assign
  RESET_OUT_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_RESET_OUT_s1 AND RESET_OUT_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_RESET_OUT_s1 AND NOT RESET_OUT_s1_non_bursting_master_requests));
  --RESET_OUT_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      RESET_OUT_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(RESET_OUT_s1_arb_counter_enable) = '1' then 
        RESET_OUT_s1_arb_share_counter <= RESET_OUT_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --RESET_OUT_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      RESET_OUT_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((RESET_OUT_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_RESET_OUT_s1)) OR ((end_xfer_arb_share_counter_term_RESET_OUT_s1 AND NOT RESET_OUT_s1_non_bursting_master_requests)))) = '1' then 
        RESET_OUT_s1_slavearbiterlockenable <= RESET_OUT_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master RESET_OUT/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= RESET_OUT_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --RESET_OUT_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  RESET_OUT_s1_slavearbiterlockenable2 <= RESET_OUT_s1_arb_share_counter_next_value;
  --cpu_0/data_master RESET_OUT/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= RESET_OUT_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --RESET_OUT_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  RESET_OUT_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_RESET_OUT_s1 <= internal_cpu_0_data_master_requests_RESET_OUT_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_RESET_OUT_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_RESET_OUT_s1 <= (internal_cpu_0_data_master_granted_RESET_OUT_s1 AND cpu_0_data_master_read) AND NOT RESET_OUT_s1_waits_for_read;
  --RESET_OUT_s1_writedata mux, which is an e_mux
  RESET_OUT_s1_writedata <= cpu_0_data_master_writedata(0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_RESET_OUT_s1 <= internal_cpu_0_data_master_qualified_request_RESET_OUT_s1;
  --cpu_0/data_master saved-grant RESET_OUT/s1, which is an e_assign
  cpu_0_data_master_saved_grant_RESET_OUT_s1 <= internal_cpu_0_data_master_requests_RESET_OUT_s1;
  --allow new arb cycle for RESET_OUT/s1, which is an e_assign
  RESET_OUT_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  RESET_OUT_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  RESET_OUT_s1_master_qreq_vector <= std_logic'('1');
  --RESET_OUT_s1_reset_n assignment, which is an e_assign
  RESET_OUT_s1_reset_n <= reset_n;
  RESET_OUT_s1_chipselect <= internal_cpu_0_data_master_granted_RESET_OUT_s1;
  --RESET_OUT_s1_firsttransfer first transaction, which is an e_assign
  RESET_OUT_s1_firsttransfer <= A_WE_StdLogic((std_logic'(RESET_OUT_s1_begins_xfer) = '1'), RESET_OUT_s1_unreg_firsttransfer, RESET_OUT_s1_reg_firsttransfer);
  --RESET_OUT_s1_unreg_firsttransfer first transaction, which is an e_assign
  RESET_OUT_s1_unreg_firsttransfer <= NOT ((RESET_OUT_s1_slavearbiterlockenable AND RESET_OUT_s1_any_continuerequest));
  --RESET_OUT_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      RESET_OUT_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(RESET_OUT_s1_begins_xfer) = '1' then 
        RESET_OUT_s1_reg_firsttransfer <= RESET_OUT_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --RESET_OUT_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  RESET_OUT_s1_beginbursttransfer_internal <= RESET_OUT_s1_begins_xfer;
  --~RESET_OUT_s1_write_n assignment, which is an e_mux
  RESET_OUT_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_RESET_OUT_s1 AND cpu_0_data_master_write));
  shifted_address_to_RESET_OUT_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --RESET_OUT_s1_address mux, which is an e_mux
  RESET_OUT_s1_address <= A_EXT (A_SRL(shifted_address_to_RESET_OUT_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_RESET_OUT_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_RESET_OUT_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_RESET_OUT_s1_end_xfer <= RESET_OUT_s1_end_xfer;
    end if;

  end process;

  --RESET_OUT_s1_waits_for_read in a cycle, which is an e_mux
  RESET_OUT_s1_waits_for_read <= RESET_OUT_s1_in_a_read_cycle AND RESET_OUT_s1_begins_xfer;
  --RESET_OUT_s1_in_a_read_cycle assignment, which is an e_assign
  RESET_OUT_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_RESET_OUT_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= RESET_OUT_s1_in_a_read_cycle;
  --RESET_OUT_s1_waits_for_write in a cycle, which is an e_mux
  RESET_OUT_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RESET_OUT_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --RESET_OUT_s1_in_a_write_cycle assignment, which is an e_assign
  RESET_OUT_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_RESET_OUT_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= RESET_OUT_s1_in_a_write_cycle;
  wait_for_RESET_OUT_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_RESET_OUT_s1 <= internal_cpu_0_data_master_granted_RESET_OUT_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_RESET_OUT_s1 <= internal_cpu_0_data_master_qualified_request_RESET_OUT_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_RESET_OUT_s1 <= internal_cpu_0_data_master_requests_RESET_OUT_s1;
--synthesis translate_off
    --RESET_OUT/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity SWint_s1_arbitrator is 
        port (
              -- inputs:
                 signal SWint_s1_irq : IN STD_LOGIC;
                 signal SWint_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal SWint_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal SWint_s1_chipselect : OUT STD_LOGIC;
                 signal SWint_s1_irq_from_sa : OUT STD_LOGIC;
                 signal SWint_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal SWint_s1_reset_n : OUT STD_LOGIC;
                 signal SWint_s1_write_n : OUT STD_LOGIC;
                 signal SWint_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_0_data_master_granted_SWint_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_SWint_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_SWint_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_SWint_s1 : OUT STD_LOGIC;
                 signal d1_SWint_s1_end_xfer : OUT STD_LOGIC
              );
end entity SWint_s1_arbitrator;


architecture europa of SWint_s1_arbitrator is
                signal SWint_s1_allgrants :  STD_LOGIC;
                signal SWint_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal SWint_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal SWint_s1_any_continuerequest :  STD_LOGIC;
                signal SWint_s1_arb_counter_enable :  STD_LOGIC;
                signal SWint_s1_arb_share_counter :  STD_LOGIC;
                signal SWint_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal SWint_s1_arb_share_set_values :  STD_LOGIC;
                signal SWint_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal SWint_s1_begins_xfer :  STD_LOGIC;
                signal SWint_s1_end_xfer :  STD_LOGIC;
                signal SWint_s1_firsttransfer :  STD_LOGIC;
                signal SWint_s1_grant_vector :  STD_LOGIC;
                signal SWint_s1_in_a_read_cycle :  STD_LOGIC;
                signal SWint_s1_in_a_write_cycle :  STD_LOGIC;
                signal SWint_s1_master_qreq_vector :  STD_LOGIC;
                signal SWint_s1_non_bursting_master_requests :  STD_LOGIC;
                signal SWint_s1_pretend_byte_enable :  STD_LOGIC;
                signal SWint_s1_reg_firsttransfer :  STD_LOGIC;
                signal SWint_s1_slavearbiterlockenable :  STD_LOGIC;
                signal SWint_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal SWint_s1_unreg_firsttransfer :  STD_LOGIC;
                signal SWint_s1_waits_for_read :  STD_LOGIC;
                signal SWint_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_SWint_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_SWint_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_SWint_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_SWint_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_SWint_s1 :  STD_LOGIC;
                signal shifted_address_to_SWint_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_SWint_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT SWint_s1_end_xfer;
    end if;

  end process;

  SWint_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_SWint_s1);
  --assign SWint_s1_readdata_from_sa = SWint_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  SWint_s1_readdata_from_sa <= SWint_s1_readdata;
  internal_cpu_0_data_master_requests_SWint_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000010010000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --SWint_s1_arb_share_counter set values, which is an e_mux
  SWint_s1_arb_share_set_values <= std_logic'('1');
  --SWint_s1_non_bursting_master_requests mux, which is an e_mux
  SWint_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_SWint_s1;
  --SWint_s1_any_bursting_master_saved_grant mux, which is an e_mux
  SWint_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --SWint_s1_arb_share_counter_next_value assignment, which is an e_assign
  SWint_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(SWint_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SWint_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(SWint_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SWint_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --SWint_s1_allgrants all slave grants, which is an e_mux
  SWint_s1_allgrants <= SWint_s1_grant_vector;
  --SWint_s1_end_xfer assignment, which is an e_assign
  SWint_s1_end_xfer <= NOT ((SWint_s1_waits_for_read OR SWint_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_SWint_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_SWint_s1 <= SWint_s1_end_xfer AND (((NOT SWint_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --SWint_s1_arb_share_counter arbitration counter enable, which is an e_assign
  SWint_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_SWint_s1 AND SWint_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_SWint_s1 AND NOT SWint_s1_non_bursting_master_requests));
  --SWint_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SWint_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(SWint_s1_arb_counter_enable) = '1' then 
        SWint_s1_arb_share_counter <= SWint_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --SWint_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SWint_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((SWint_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_SWint_s1)) OR ((end_xfer_arb_share_counter_term_SWint_s1 AND NOT SWint_s1_non_bursting_master_requests)))) = '1' then 
        SWint_s1_slavearbiterlockenable <= SWint_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master SWint/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= SWint_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --SWint_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  SWint_s1_slavearbiterlockenable2 <= SWint_s1_arb_share_counter_next_value;
  --cpu_0/data_master SWint/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= SWint_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --SWint_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  SWint_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_SWint_s1 <= internal_cpu_0_data_master_requests_SWint_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_SWint_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_SWint_s1 <= (internal_cpu_0_data_master_granted_SWint_s1 AND cpu_0_data_master_read) AND NOT SWint_s1_waits_for_read;
  --SWint_s1_writedata mux, which is an e_mux
  SWint_s1_writedata <= cpu_0_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_SWint_s1 <= internal_cpu_0_data_master_qualified_request_SWint_s1;
  --cpu_0/data_master saved-grant SWint/s1, which is an e_assign
  cpu_0_data_master_saved_grant_SWint_s1 <= internal_cpu_0_data_master_requests_SWint_s1;
  --allow new arb cycle for SWint/s1, which is an e_assign
  SWint_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  SWint_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  SWint_s1_master_qreq_vector <= std_logic'('1');
  --SWint_s1_reset_n assignment, which is an e_assign
  SWint_s1_reset_n <= reset_n;
  SWint_s1_chipselect <= internal_cpu_0_data_master_granted_SWint_s1;
  --SWint_s1_firsttransfer first transaction, which is an e_assign
  SWint_s1_firsttransfer <= A_WE_StdLogic((std_logic'(SWint_s1_begins_xfer) = '1'), SWint_s1_unreg_firsttransfer, SWint_s1_reg_firsttransfer);
  --SWint_s1_unreg_firsttransfer first transaction, which is an e_assign
  SWint_s1_unreg_firsttransfer <= NOT ((SWint_s1_slavearbiterlockenable AND SWint_s1_any_continuerequest));
  --SWint_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SWint_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(SWint_s1_begins_xfer) = '1' then 
        SWint_s1_reg_firsttransfer <= SWint_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --SWint_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  SWint_s1_beginbursttransfer_internal <= SWint_s1_begins_xfer;
  --~SWint_s1_write_n assignment, which is an e_mux
  SWint_s1_write_n <= NOT ((((internal_cpu_0_data_master_granted_SWint_s1 AND cpu_0_data_master_write)) AND SWint_s1_pretend_byte_enable));
  shifted_address_to_SWint_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --SWint_s1_address mux, which is an e_mux
  SWint_s1_address <= A_EXT (A_SRL(shifted_address_to_SWint_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_SWint_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_SWint_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_SWint_s1_end_xfer <= SWint_s1_end_xfer;
    end if;

  end process;

  --SWint_s1_waits_for_read in a cycle, which is an e_mux
  SWint_s1_waits_for_read <= SWint_s1_in_a_read_cycle AND SWint_s1_begins_xfer;
  --SWint_s1_in_a_read_cycle assignment, which is an e_assign
  SWint_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_SWint_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= SWint_s1_in_a_read_cycle;
  --SWint_s1_waits_for_write in a cycle, which is an e_mux
  SWint_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SWint_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --SWint_s1_in_a_write_cycle assignment, which is an e_assign
  SWint_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_SWint_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= SWint_s1_in_a_write_cycle;
  wait_for_SWint_s1_counter <= std_logic'('0');
  --SWint_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  SWint_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_granted_SWint_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_0_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --assign SWint_s1_irq_from_sa = SWint_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  SWint_s1_irq_from_sa <= SWint_s1_irq;
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_SWint_s1 <= internal_cpu_0_data_master_granted_SWint_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_SWint_s1 <= internal_cpu_0_data_master_qualified_request_SWint_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_SWint_s1 <= internal_cpu_0_data_master_requests_SWint_s1;
--synthesis translate_off
    --SWint/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity SWint2_s1_arbitrator is 
        port (
              -- inputs:
                 signal SWint2_s1_irq : IN STD_LOGIC;
                 signal SWint2_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal SWint2_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal SWint2_s1_chipselect : OUT STD_LOGIC;
                 signal SWint2_s1_irq_from_sa : OUT STD_LOGIC;
                 signal SWint2_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal SWint2_s1_reset_n : OUT STD_LOGIC;
                 signal SWint2_s1_write_n : OUT STD_LOGIC;
                 signal SWint2_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_0_data_master_granted_SWint2_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_SWint2_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_SWint2_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_SWint2_s1 : OUT STD_LOGIC;
                 signal d1_SWint2_s1_end_xfer : OUT STD_LOGIC
              );
end entity SWint2_s1_arbitrator;


architecture europa of SWint2_s1_arbitrator is
                signal SWint2_s1_allgrants :  STD_LOGIC;
                signal SWint2_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal SWint2_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal SWint2_s1_any_continuerequest :  STD_LOGIC;
                signal SWint2_s1_arb_counter_enable :  STD_LOGIC;
                signal SWint2_s1_arb_share_counter :  STD_LOGIC;
                signal SWint2_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal SWint2_s1_arb_share_set_values :  STD_LOGIC;
                signal SWint2_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal SWint2_s1_begins_xfer :  STD_LOGIC;
                signal SWint2_s1_end_xfer :  STD_LOGIC;
                signal SWint2_s1_firsttransfer :  STD_LOGIC;
                signal SWint2_s1_grant_vector :  STD_LOGIC;
                signal SWint2_s1_in_a_read_cycle :  STD_LOGIC;
                signal SWint2_s1_in_a_write_cycle :  STD_LOGIC;
                signal SWint2_s1_master_qreq_vector :  STD_LOGIC;
                signal SWint2_s1_non_bursting_master_requests :  STD_LOGIC;
                signal SWint2_s1_pretend_byte_enable :  STD_LOGIC;
                signal SWint2_s1_reg_firsttransfer :  STD_LOGIC;
                signal SWint2_s1_slavearbiterlockenable :  STD_LOGIC;
                signal SWint2_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal SWint2_s1_unreg_firsttransfer :  STD_LOGIC;
                signal SWint2_s1_waits_for_read :  STD_LOGIC;
                signal SWint2_s1_waits_for_write :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_SWint2_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_SWint2_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_SWint2_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_SWint2_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_SWint2_s1 :  STD_LOGIC;
                signal shifted_address_to_SWint2_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_SWint2_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT SWint2_s1_end_xfer;
    end if;

  end process;

  SWint2_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_SWint2_s1);
  --assign SWint2_s1_readdata_from_sa = SWint2_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  SWint2_s1_readdata_from_sa <= SWint2_s1_readdata;
  internal_cpu_0_data_master_requests_SWint2_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000010100000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --SWint2_s1_arb_share_counter set values, which is an e_mux
  SWint2_s1_arb_share_set_values <= std_logic'('1');
  --SWint2_s1_non_bursting_master_requests mux, which is an e_mux
  SWint2_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_SWint2_s1;
  --SWint2_s1_any_bursting_master_saved_grant mux, which is an e_mux
  SWint2_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --SWint2_s1_arb_share_counter_next_value assignment, which is an e_assign
  SWint2_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(SWint2_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SWint2_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(SWint2_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SWint2_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --SWint2_s1_allgrants all slave grants, which is an e_mux
  SWint2_s1_allgrants <= SWint2_s1_grant_vector;
  --SWint2_s1_end_xfer assignment, which is an e_assign
  SWint2_s1_end_xfer <= NOT ((SWint2_s1_waits_for_read OR SWint2_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_SWint2_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_SWint2_s1 <= SWint2_s1_end_xfer AND (((NOT SWint2_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --SWint2_s1_arb_share_counter arbitration counter enable, which is an e_assign
  SWint2_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_SWint2_s1 AND SWint2_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_SWint2_s1 AND NOT SWint2_s1_non_bursting_master_requests));
  --SWint2_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SWint2_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(SWint2_s1_arb_counter_enable) = '1' then 
        SWint2_s1_arb_share_counter <= SWint2_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --SWint2_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SWint2_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((SWint2_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_SWint2_s1)) OR ((end_xfer_arb_share_counter_term_SWint2_s1 AND NOT SWint2_s1_non_bursting_master_requests)))) = '1' then 
        SWint2_s1_slavearbiterlockenable <= SWint2_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master SWint2/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= SWint2_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --SWint2_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  SWint2_s1_slavearbiterlockenable2 <= SWint2_s1_arb_share_counter_next_value;
  --cpu_0/data_master SWint2/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= SWint2_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --SWint2_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  SWint2_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_SWint2_s1 <= internal_cpu_0_data_master_requests_SWint2_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_SWint2_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_SWint2_s1 <= (internal_cpu_0_data_master_granted_SWint2_s1 AND cpu_0_data_master_read) AND NOT SWint2_s1_waits_for_read;
  --SWint2_s1_writedata mux, which is an e_mux
  SWint2_s1_writedata <= cpu_0_data_master_writedata (7 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_SWint2_s1 <= internal_cpu_0_data_master_qualified_request_SWint2_s1;
  --cpu_0/data_master saved-grant SWint2/s1, which is an e_assign
  cpu_0_data_master_saved_grant_SWint2_s1 <= internal_cpu_0_data_master_requests_SWint2_s1;
  --allow new arb cycle for SWint2/s1, which is an e_assign
  SWint2_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  SWint2_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  SWint2_s1_master_qreq_vector <= std_logic'('1');
  --SWint2_s1_reset_n assignment, which is an e_assign
  SWint2_s1_reset_n <= reset_n;
  SWint2_s1_chipselect <= internal_cpu_0_data_master_granted_SWint2_s1;
  --SWint2_s1_firsttransfer first transaction, which is an e_assign
  SWint2_s1_firsttransfer <= A_WE_StdLogic((std_logic'(SWint2_s1_begins_xfer) = '1'), SWint2_s1_unreg_firsttransfer, SWint2_s1_reg_firsttransfer);
  --SWint2_s1_unreg_firsttransfer first transaction, which is an e_assign
  SWint2_s1_unreg_firsttransfer <= NOT ((SWint2_s1_slavearbiterlockenable AND SWint2_s1_any_continuerequest));
  --SWint2_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      SWint2_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(SWint2_s1_begins_xfer) = '1' then 
        SWint2_s1_reg_firsttransfer <= SWint2_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --SWint2_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  SWint2_s1_beginbursttransfer_internal <= SWint2_s1_begins_xfer;
  --~SWint2_s1_write_n assignment, which is an e_mux
  SWint2_s1_write_n <= NOT ((((internal_cpu_0_data_master_granted_SWint2_s1 AND cpu_0_data_master_write)) AND SWint2_s1_pretend_byte_enable));
  shifted_address_to_SWint2_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --SWint2_s1_address mux, which is an e_mux
  SWint2_s1_address <= A_EXT (A_SRL(shifted_address_to_SWint2_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_SWint2_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_SWint2_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_SWint2_s1_end_xfer <= SWint2_s1_end_xfer;
    end if;

  end process;

  --SWint2_s1_waits_for_read in a cycle, which is an e_mux
  SWint2_s1_waits_for_read <= SWint2_s1_in_a_read_cycle AND SWint2_s1_begins_xfer;
  --SWint2_s1_in_a_read_cycle assignment, which is an e_assign
  SWint2_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_SWint2_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= SWint2_s1_in_a_read_cycle;
  --SWint2_s1_waits_for_write in a cycle, which is an e_mux
  SWint2_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(SWint2_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --SWint2_s1_in_a_write_cycle assignment, which is an e_assign
  SWint2_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_SWint2_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= SWint2_s1_in_a_write_cycle;
  wait_for_SWint2_s1_counter <= std_logic'('0');
  --SWint2_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  SWint2_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_granted_SWint2_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_0_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  --assign SWint2_s1_irq_from_sa = SWint2_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  SWint2_s1_irq_from_sa <= SWint2_s1_irq;
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_SWint2_s1 <= internal_cpu_0_data_master_granted_SWint2_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_SWint2_s1 <= internal_cpu_0_data_master_qualified_request_SWint2_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_SWint2_s1 <= internal_cpu_0_data_master_requests_SWint2_s1;
--synthesis translate_off
    --SWint2/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_0_jtag_debug_module_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_0_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_instruction_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_instruction_master_read : IN STD_LOGIC;
                 signal cpu_0_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_jtag_debug_module_resetrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_0_data_master_granted_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_granted_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_requests_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_0_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal cpu_0_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                 signal cpu_0_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_0_jtag_debug_module_chipselect : OUT STD_LOGIC;
                 signal cpu_0_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                 signal cpu_0_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                 signal cpu_0_jtag_debug_module_write : OUT STD_LOGIC;
                 signal cpu_0_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_0_jtag_debug_module_end_xfer : OUT STD_LOGIC
              );
end entity cpu_0_jtag_debug_module_arbitrator;


architecture europa of cpu_0_jtag_debug_module_arbitrator is
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_instruction_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_0_instruction_master_saved_grant_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_allgrants :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_allow_new_arb_cycle :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_any_bursting_master_saved_grant :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_any_continuerequest :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_0_jtag_debug_module_arb_counter_enable :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_arb_share_counter :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_arb_share_counter_next_value :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_arb_share_set_values :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_0_jtag_debug_module_arbitration_holdoff_internal :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_beginbursttransfer_internal :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_begins_xfer :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_0_jtag_debug_module_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_0_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_firsttransfer :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_0_jtag_debug_module_in_a_read_cycle :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_in_a_write_cycle :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_0_jtag_debug_module_non_bursting_master_requests :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_reg_firsttransfer :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_0_jtag_debug_module_slavearbiterlockenable :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_slavearbiterlockenable2 :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_unreg_firsttransfer :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_waits_for_read :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_waits_for_write :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_0_instruction_master_granted_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_0_instruction_master_requests_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_instruction_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_cpu_0_jtag_debug_module_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT cpu_0_jtag_debug_module_end_xfer;
    end if;

  end process;

  cpu_0_jtag_debug_module_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module OR internal_cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module));
  --assign cpu_0_jtag_debug_module_readdata_from_sa = cpu_0_jtag_debug_module_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_0_jtag_debug_module_readdata_from_sa <= cpu_0_jtag_debug_module_readdata;
  internal_cpu_0_data_master_requests_cpu_0_jtag_debug_module <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("10000100000000000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --cpu_0_jtag_debug_module_arb_share_counter set values, which is an e_mux
  cpu_0_jtag_debug_module_arb_share_set_values <= std_logic'('1');
  --cpu_0_jtag_debug_module_non_bursting_master_requests mux, which is an e_mux
  cpu_0_jtag_debug_module_non_bursting_master_requests <= ((internal_cpu_0_data_master_requests_cpu_0_jtag_debug_module OR internal_cpu_0_instruction_master_requests_cpu_0_jtag_debug_module) OR internal_cpu_0_data_master_requests_cpu_0_jtag_debug_module) OR internal_cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;
  --cpu_0_jtag_debug_module_any_bursting_master_saved_grant mux, which is an e_mux
  cpu_0_jtag_debug_module_any_bursting_master_saved_grant <= std_logic'('0');
  --cpu_0_jtag_debug_module_arb_share_counter_next_value assignment, which is an e_assign
  cpu_0_jtag_debug_module_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_0_jtag_debug_module_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_jtag_debug_module_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(cpu_0_jtag_debug_module_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_jtag_debug_module_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --cpu_0_jtag_debug_module_allgrants all slave grants, which is an e_mux
  cpu_0_jtag_debug_module_allgrants <= (((or_reduce(cpu_0_jtag_debug_module_grant_vector)) OR (or_reduce(cpu_0_jtag_debug_module_grant_vector))) OR (or_reduce(cpu_0_jtag_debug_module_grant_vector))) OR (or_reduce(cpu_0_jtag_debug_module_grant_vector));
  --cpu_0_jtag_debug_module_end_xfer assignment, which is an e_assign
  cpu_0_jtag_debug_module_end_xfer <= NOT ((cpu_0_jtag_debug_module_waits_for_read OR cpu_0_jtag_debug_module_waits_for_write));
  --end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module <= cpu_0_jtag_debug_module_end_xfer AND (((NOT cpu_0_jtag_debug_module_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --cpu_0_jtag_debug_module_arb_share_counter arbitration counter enable, which is an e_assign
  cpu_0_jtag_debug_module_arb_counter_enable <= ((end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module AND cpu_0_jtag_debug_module_allgrants)) OR ((end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module AND NOT cpu_0_jtag_debug_module_non_bursting_master_requests));
  --cpu_0_jtag_debug_module_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_jtag_debug_module_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_0_jtag_debug_module_arb_counter_enable) = '1' then 
        cpu_0_jtag_debug_module_arb_share_counter <= cpu_0_jtag_debug_module_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0_jtag_debug_module_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_jtag_debug_module_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((or_reduce(cpu_0_jtag_debug_module_master_qreq_vector) AND end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module)) OR ((end_xfer_arb_share_counter_term_cpu_0_jtag_debug_module AND NOT cpu_0_jtag_debug_module_non_bursting_master_requests)))) = '1' then 
        cpu_0_jtag_debug_module_slavearbiterlockenable <= cpu_0_jtag_debug_module_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master cpu_0/jtag_debug_module arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= cpu_0_jtag_debug_module_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --cpu_0_jtag_debug_module_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  cpu_0_jtag_debug_module_slavearbiterlockenable2 <= cpu_0_jtag_debug_module_arb_share_counter_next_value;
  --cpu_0/data_master cpu_0/jtag_debug_module arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= cpu_0_jtag_debug_module_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --cpu_0/instruction_master cpu_0/jtag_debug_module arbiterlock, which is an e_assign
  cpu_0_instruction_master_arbiterlock <= cpu_0_jtag_debug_module_slavearbiterlockenable AND cpu_0_instruction_master_continuerequest;
  --cpu_0/instruction_master cpu_0/jtag_debug_module arbiterlock2, which is an e_assign
  cpu_0_instruction_master_arbiterlock2 <= cpu_0_jtag_debug_module_slavearbiterlockenable2 AND cpu_0_instruction_master_continuerequest;
  --cpu_0/instruction_master granted cpu_0/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_0_instruction_master_saved_grant_cpu_0_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_0_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_0_instruction_master_requests_cpu_0_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module))))));
    end if;

  end process;

  --cpu_0_instruction_master_continuerequest continued request, which is an e_mux
  cpu_0_instruction_master_continuerequest <= last_cycle_cpu_0_instruction_master_granted_slave_cpu_0_jtag_debug_module AND internal_cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;
  --cpu_0_jtag_debug_module_any_continuerequest at least one master continues requesting, which is an e_mux
  cpu_0_jtag_debug_module_any_continuerequest <= cpu_0_instruction_master_continuerequest OR cpu_0_data_master_continuerequest;
  internal_cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module <= internal_cpu_0_data_master_requests_cpu_0_jtag_debug_module AND NOT ((((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000")))))) OR cpu_0_instruction_master_arbiterlock));
  --local readdatavalid cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module, which is an e_mux
  cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module <= (internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module AND cpu_0_data_master_read) AND NOT cpu_0_jtag_debug_module_waits_for_read;
  --cpu_0_jtag_debug_module_writedata mux, which is an e_mux
  cpu_0_jtag_debug_module_writedata <= cpu_0_data_master_writedata;
  internal_cpu_0_instruction_master_requests_cpu_0_jtag_debug_module <= ((to_std_logic(((Std_Logic_Vector'(cpu_0_instruction_master_address_to_slave(16 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("10000100000000000")))) AND (cpu_0_instruction_master_read))) AND cpu_0_instruction_master_read;
  --cpu_0/data_master granted cpu_0/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_0_data_master_saved_grant_cpu_0_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_0_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_0_data_master_requests_cpu_0_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module))))));
    end if;

  end process;

  --cpu_0_data_master_continuerequest continued request, which is an e_mux
  cpu_0_data_master_continuerequest <= last_cycle_cpu_0_data_master_granted_slave_cpu_0_jtag_debug_module AND internal_cpu_0_data_master_requests_cpu_0_jtag_debug_module;
  internal_cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module <= internal_cpu_0_instruction_master_requests_cpu_0_jtag_debug_module AND NOT ((((cpu_0_instruction_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_instruction_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000")))))) OR cpu_0_data_master_arbiterlock));
  --local readdatavalid cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module, which is an e_mux
  cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module <= (internal_cpu_0_instruction_master_granted_cpu_0_jtag_debug_module AND cpu_0_instruction_master_read) AND NOT cpu_0_jtag_debug_module_waits_for_read;
  --allow new arb cycle for cpu_0/jtag_debug_module, which is an e_assign
  cpu_0_jtag_debug_module_allow_new_arb_cycle <= NOT cpu_0_data_master_arbiterlock AND NOT cpu_0_instruction_master_arbiterlock;
  --cpu_0/instruction_master assignment into master qualified-requests vector for cpu_0/jtag_debug_module, which is an e_assign
  cpu_0_jtag_debug_module_master_qreq_vector(0) <= internal_cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module;
  --cpu_0/instruction_master grant cpu_0/jtag_debug_module, which is an e_assign
  internal_cpu_0_instruction_master_granted_cpu_0_jtag_debug_module <= cpu_0_jtag_debug_module_grant_vector(0);
  --cpu_0/instruction_master saved-grant cpu_0/jtag_debug_module, which is an e_assign
  cpu_0_instruction_master_saved_grant_cpu_0_jtag_debug_module <= cpu_0_jtag_debug_module_arb_winner(0) AND internal_cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;
  --cpu_0/data_master assignment into master qualified-requests vector for cpu_0/jtag_debug_module, which is an e_assign
  cpu_0_jtag_debug_module_master_qreq_vector(1) <= internal_cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module;
  --cpu_0/data_master grant cpu_0/jtag_debug_module, which is an e_assign
  internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module <= cpu_0_jtag_debug_module_grant_vector(1);
  --cpu_0/data_master saved-grant cpu_0/jtag_debug_module, which is an e_assign
  cpu_0_data_master_saved_grant_cpu_0_jtag_debug_module <= cpu_0_jtag_debug_module_arb_winner(1) AND internal_cpu_0_data_master_requests_cpu_0_jtag_debug_module;
  --cpu_0/jtag_debug_module chosen-master double-vector, which is an e_assign
  cpu_0_jtag_debug_module_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((cpu_0_jtag_debug_module_master_qreq_vector & cpu_0_jtag_debug_module_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT cpu_0_jtag_debug_module_master_qreq_vector & NOT cpu_0_jtag_debug_module_master_qreq_vector))) + (std_logic_vector'("000") & (cpu_0_jtag_debug_module_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  cpu_0_jtag_debug_module_arb_winner <= A_WE_StdLogicVector((std_logic'(((cpu_0_jtag_debug_module_allow_new_arb_cycle AND or_reduce(cpu_0_jtag_debug_module_grant_vector)))) = '1'), cpu_0_jtag_debug_module_grant_vector, cpu_0_jtag_debug_module_saved_chosen_master_vector);
  --saved cpu_0_jtag_debug_module_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_jtag_debug_module_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_0_jtag_debug_module_allow_new_arb_cycle) = '1' then 
        cpu_0_jtag_debug_module_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(cpu_0_jtag_debug_module_grant_vector)) = '1'), cpu_0_jtag_debug_module_grant_vector, cpu_0_jtag_debug_module_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  cpu_0_jtag_debug_module_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((cpu_0_jtag_debug_module_chosen_master_double_vector(1) OR cpu_0_jtag_debug_module_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((cpu_0_jtag_debug_module_chosen_master_double_vector(0) OR cpu_0_jtag_debug_module_chosen_master_double_vector(2)))));
  --cpu_0/jtag_debug_module chosen master rotated left, which is an e_assign
  cpu_0_jtag_debug_module_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(cpu_0_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(cpu_0_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --cpu_0/jtag_debug_module's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_jtag_debug_module_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(cpu_0_jtag_debug_module_grant_vector)) = '1' then 
        cpu_0_jtag_debug_module_arb_addend <= A_WE_StdLogicVector((std_logic'(cpu_0_jtag_debug_module_end_xfer) = '1'), cpu_0_jtag_debug_module_chosen_master_rot_left, cpu_0_jtag_debug_module_grant_vector);
      end if;
    end if;

  end process;

  cpu_0_jtag_debug_module_begintransfer <= cpu_0_jtag_debug_module_begins_xfer;
  --assign cpu_0_jtag_debug_module_resetrequest_from_sa = cpu_0_jtag_debug_module_resetrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_0_jtag_debug_module_resetrequest_from_sa <= cpu_0_jtag_debug_module_resetrequest;
  cpu_0_jtag_debug_module_chipselect <= internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module OR internal_cpu_0_instruction_master_granted_cpu_0_jtag_debug_module;
  --cpu_0_jtag_debug_module_firsttransfer first transaction, which is an e_assign
  cpu_0_jtag_debug_module_firsttransfer <= A_WE_StdLogic((std_logic'(cpu_0_jtag_debug_module_begins_xfer) = '1'), cpu_0_jtag_debug_module_unreg_firsttransfer, cpu_0_jtag_debug_module_reg_firsttransfer);
  --cpu_0_jtag_debug_module_unreg_firsttransfer first transaction, which is an e_assign
  cpu_0_jtag_debug_module_unreg_firsttransfer <= NOT ((cpu_0_jtag_debug_module_slavearbiterlockenable AND cpu_0_jtag_debug_module_any_continuerequest));
  --cpu_0_jtag_debug_module_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_jtag_debug_module_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_0_jtag_debug_module_begins_xfer) = '1' then 
        cpu_0_jtag_debug_module_reg_firsttransfer <= cpu_0_jtag_debug_module_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --cpu_0_jtag_debug_module_beginbursttransfer_internal begin burst transfer, which is an e_assign
  cpu_0_jtag_debug_module_beginbursttransfer_internal <= cpu_0_jtag_debug_module_begins_xfer;
  --cpu_0_jtag_debug_module_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  cpu_0_jtag_debug_module_arbitration_holdoff_internal <= cpu_0_jtag_debug_module_begins_xfer AND cpu_0_jtag_debug_module_firsttransfer;
  --cpu_0_jtag_debug_module_write assignment, which is an e_mux
  cpu_0_jtag_debug_module_write <= internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module AND cpu_0_data_master_write;
  shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --cpu_0_jtag_debug_module_address mux, which is an e_mux
  cpu_0_jtag_debug_module_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module)) = '1'), (A_SRL(shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_instruction_master,std_logic_vector'("00000000000000000000000000000010")))), 9);
  shifted_address_to_cpu_0_jtag_debug_module_from_cpu_0_instruction_master <= cpu_0_instruction_master_address_to_slave;
  --d1_cpu_0_jtag_debug_module_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_cpu_0_jtag_debug_module_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_cpu_0_jtag_debug_module_end_xfer <= cpu_0_jtag_debug_module_end_xfer;
    end if;

  end process;

  --cpu_0_jtag_debug_module_waits_for_read in a cycle, which is an e_mux
  cpu_0_jtag_debug_module_waits_for_read <= cpu_0_jtag_debug_module_in_a_read_cycle AND cpu_0_jtag_debug_module_begins_xfer;
  --cpu_0_jtag_debug_module_in_a_read_cycle assignment, which is an e_assign
  cpu_0_jtag_debug_module_in_a_read_cycle <= ((internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module AND cpu_0_data_master_read)) OR ((internal_cpu_0_instruction_master_granted_cpu_0_jtag_debug_module AND cpu_0_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= cpu_0_jtag_debug_module_in_a_read_cycle;
  --cpu_0_jtag_debug_module_waits_for_write in a cycle, which is an e_mux
  cpu_0_jtag_debug_module_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_jtag_debug_module_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --cpu_0_jtag_debug_module_in_a_write_cycle assignment, which is an e_assign
  cpu_0_jtag_debug_module_in_a_write_cycle <= internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= cpu_0_jtag_debug_module_in_a_write_cycle;
  wait_for_cpu_0_jtag_debug_module_counter <= std_logic'('0');
  --cpu_0_jtag_debug_module_byteenable byte enable port mux, which is an e_mux
  cpu_0_jtag_debug_module_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_0_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --debugaccess mux, which is an e_mux
  cpu_0_jtag_debug_module_debugaccess <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module)) = '1'), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_debugaccess))), std_logic_vector'("00000000000000000000000000000000")));
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_cpu_0_jtag_debug_module <= internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module <= internal_cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_cpu_0_jtag_debug_module <= internal_cpu_0_data_master_requests_cpu_0_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_0_instruction_master_granted_cpu_0_jtag_debug_module <= internal_cpu_0_instruction_master_granted_cpu_0_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module <= internal_cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_0_instruction_master_requests_cpu_0_jtag_debug_module <= internal_cpu_0_instruction_master_requests_cpu_0_jtag_debug_module;
--synthesis translate_off
    --cpu_0/jtag_debug_module enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_0_data_master_granted_cpu_0_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_0_instruction_master_granted_cpu_0_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line, now);
          write(write_line, string'(": "));
          write(write_line, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line.all);
          deallocate (write_line);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line1 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_saved_grant_cpu_0_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_0_instruction_master_saved_grant_cpu_0_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line1, now);
          write(write_line1, string'(": "));
          write(write_line1, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line1.all);
          deallocate (write_line1);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity cpu_0_custom_instruction_master_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_custom_instruction_master_multi_start : IN STD_LOGIC;
                 signal cpu_0_fpoint_s1_done_from_sa : IN STD_LOGIC;
                 signal cpu_0_fpoint_s1_result_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_0_custom_instruction_master_multi_done : OUT STD_LOGIC;
                 signal cpu_0_custom_instruction_master_multi_result : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_custom_instruction_master_reset_n : OUT STD_LOGIC;
                 signal cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 : OUT STD_LOGIC;
                 signal cpu_0_fpoint_s1_select : OUT STD_LOGIC
              );
end entity cpu_0_custom_instruction_master_arbitrator;


architecture europa of cpu_0_custom_instruction_master_arbitrator is
                signal internal_cpu_0_fpoint_s1_select :  STD_LOGIC;

begin

  internal_cpu_0_fpoint_s1_select <= std_logic'('1');
  cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 <= internal_cpu_0_fpoint_s1_select AND cpu_0_custom_instruction_master_multi_start;
  --cpu_0_custom_instruction_master_multi_result mux, which is an e_mux
  cpu_0_custom_instruction_master_multi_result <= A_REP(internal_cpu_0_fpoint_s1_select, 32) AND cpu_0_fpoint_s1_result_from_sa;
  --multi_done mux, which is an e_mux
  cpu_0_custom_instruction_master_multi_done <= internal_cpu_0_fpoint_s1_select AND cpu_0_fpoint_s1_done_from_sa;
  --cpu_0_custom_instruction_master_reset_n local reset_n, which is an e_assign
  cpu_0_custom_instruction_master_reset_n <= reset_n;
  --vhdl renameroo for output signals
  cpu_0_fpoint_s1_select <= internal_cpu_0_fpoint_s1_select;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_0_data_master_arbitrator is 
        port (
              -- inputs:
                 signal BLUE_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal CCD_XY_s1_irq_from_sa : IN STD_LOGIC;
                 signal CCD_XY_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal DVAL_s1_readdata_from_sa : IN STD_LOGIC;
                 signal GREEN_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal IN_mDATA_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal IN_mDATA_1_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal IN_mDATAd_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal IN_mDATAd_1_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal LCD_0_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal LCD_0_control_slave_wait_counter_eq_0 : IN STD_LOGIC;
                 signal LEDs_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal LUT_DATA_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal LUT_INDEX_s1_irq_from_sa : IN STD_LOGIC;
                 signal LUT_INDEX_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal PIX_VALCLK_s1_irq_from_sa : IN STD_LOGIC;
                 signal PIX_VALCLK_s1_readdata_from_sa : IN STD_LOGIC;
                 signal RAW2RGB_CONTROL_OUT_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal RED_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal RESET_OUT_s1_readdata_from_sa : IN STD_LOGIC;
                 signal SWint2_s1_irq_from_sa : IN STD_LOGIC;
                 signal SWint2_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal SWint_s1_irq_from_sa : IN STD_LOGIC;
                 signal SWint_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_0_data_master_granted_BLUE_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_CCD_XY_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_DVAL_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_GREEN_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_IN_mDATA_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_IN_mDATA_1_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_IN_mDATAd_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_IN_mDATAd_1_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_LCD_0_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_LEDs_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_LUT_DATA_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_LUT_INDEX_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_PIX_VALCLK_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_RED_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_RESET_OUT_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_SWint2_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_SWint_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_cpu_0_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_performance_counter_0_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_granted_timer_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_BLUE_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_CCD_XY_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_DVAL_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_GREEN_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_IN_mDATA_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_IN_mDATA_1_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_LCD_0_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_LEDs_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_LUT_DATA_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_LUT_INDEX_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_PIX_VALCLK_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_RED_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_RESET_OUT_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_SWint2_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_SWint_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_performance_counter_0_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_timer_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_BLUE_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_CCD_XY_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_DVAL_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_GREEN_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_IN_mDATA_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_IN_mDATA_1_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_LCD_0_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_LEDs_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_LUT_DATA_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_LUT_INDEX_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_PIX_VALCLK_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_RED_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_RESET_OUT_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_SWint2_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_SWint_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_performance_counter_0_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_timer_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_BLUE_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_CCD_XY_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_DVAL_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_GREEN_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_IN_mDATA_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_IN_mDATA_1_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_IN_mDATAd_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_IN_mDATAd_1_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_LCD_0_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_LEDs_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_LUT_DATA_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_LUT_INDEX_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_PIX_VALCLK_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_RED_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_RESET_OUT_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_SWint2_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_SWint_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_cpu_0_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_performance_counter_0_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_0_data_master_requests_timer_0_s1 : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_BLUE_s1_end_xfer : IN STD_LOGIC;
                 signal d1_CCD_XY_s1_end_xfer : IN STD_LOGIC;
                 signal d1_DVAL_s1_end_xfer : IN STD_LOGIC;
                 signal d1_GREEN_s1_end_xfer : IN STD_LOGIC;
                 signal d1_IN_mDATA_0_s1_end_xfer : IN STD_LOGIC;
                 signal d1_IN_mDATA_1_s1_end_xfer : IN STD_LOGIC;
                 signal d1_IN_mDATAd_0_s1_end_xfer : IN STD_LOGIC;
                 signal d1_IN_mDATAd_1_s1_end_xfer : IN STD_LOGIC;
                 signal d1_LCD_0_control_slave_end_xfer : IN STD_LOGIC;
                 signal d1_LEDs_s1_end_xfer : IN STD_LOGIC;
                 signal d1_LUT_DATA_s1_end_xfer : IN STD_LOGIC;
                 signal d1_LUT_INDEX_s1_end_xfer : IN STD_LOGIC;
                 signal d1_PIX_VALCLK_s1_end_xfer : IN STD_LOGIC;
                 signal d1_RAW2RGB_CONTROL_OUT_s1_end_xfer : IN STD_LOGIC;
                 signal d1_RED_s1_end_xfer : IN STD_LOGIC;
                 signal d1_RESET_OUT_s1_end_xfer : IN STD_LOGIC;
                 signal d1_SWint2_s1_end_xfer : IN STD_LOGIC;
                 signal d1_SWint_s1_end_xfer : IN STD_LOGIC;
                 signal d1_cpu_0_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_memory2_0_s1_end_xfer : IN STD_LOGIC;
                 signal d1_performance_counter_0_control_slave_end_xfer : IN STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                 signal d1_timer_0_s1_end_xfer : IN STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                 signal onchip_memory2_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal performance_counter_0_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal timer_0_s1_irq_from_sa : IN STD_LOGIC;
                 signal timer_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_0_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : OUT STD_LOGIC;
                 signal cpu_0_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_data_master_readdatavalid : OUT STD_LOGIC;
                 signal cpu_0_data_master_waitrequest : OUT STD_LOGIC
              );
end entity cpu_0_data_master_arbitrator;


architecture europa of cpu_0_data_master_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_0_data_master_address_last_time :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal cpu_0_data_master_byteenable_last_time :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_0_data_master_is_granted_some_slave :  STD_LOGIC;
                signal cpu_0_data_master_read_but_no_slave_selected :  STD_LOGIC;
                signal cpu_0_data_master_read_last_time :  STD_LOGIC;
                signal cpu_0_data_master_run :  STD_LOGIC;
                signal cpu_0_data_master_write_last_time :  STD_LOGIC;
                signal cpu_0_data_master_writedata_last_time :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_cpu_0_data_master_address_to_slave :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal internal_cpu_0_data_master_latency_counter :  STD_LOGIC;
                signal internal_cpu_0_data_master_waitrequest :  STD_LOGIC;
                signal latency_load_value :  STD_LOGIC;
                signal p1_cpu_0_data_master_latency_counter :  STD_LOGIC;
                signal pre_flush_cpu_0_data_master_readdatavalid :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;
                signal r_3 :  STD_LOGIC;
                signal r_4 :  STD_LOGIC;

begin

  --r_0 master_run cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_BLUE_s1 OR NOT cpu_0_data_master_requests_BLUE_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_BLUE_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_BLUE_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_BLUE_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_CCD_XY_s1 OR NOT cpu_0_data_master_requests_CCD_XY_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_CCD_XY_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_CCD_XY_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_CCD_XY_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_DVAL_s1 OR NOT cpu_0_data_master_requests_DVAL_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_DVAL_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_DVAL_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_DVAL_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_GREEN_s1 OR NOT cpu_0_data_master_requests_GREEN_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_GREEN_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_GREEN_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_GREEN_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_IN_mDATA_0_s1 OR NOT cpu_0_data_master_requests_IN_mDATA_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_IN_mDATA_0_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_IN_mDATA_0_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_IN_mDATA_0_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))));
  --cascaded wait assignment, which is an e_assign
  cpu_0_data_master_run <= (((r_0 AND r_1) AND r_2) AND r_3) AND r_4;
  --r_1 master_run cascaded wait assignment, which is an e_assign
  r_1 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_IN_mDATA_1_s1 OR NOT cpu_0_data_master_requests_IN_mDATA_1_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_IN_mDATA_1_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_IN_mDATA_1_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_IN_mDATA_1_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 OR NOT cpu_0_data_master_requests_IN_mDATAd_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_IN_mDATAd_0_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 OR NOT cpu_0_data_master_requests_IN_mDATAd_1_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_IN_mDATAd_1_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_LCD_0_control_slave OR NOT cpu_0_data_master_requests_LCD_0_control_slave)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_LCD_0_control_slave OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((LCD_0_control_slave_wait_counter_eq_0 AND NOT d1_LCD_0_control_slave_end_xfer)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_LCD_0_control_slave OR NOT cpu_0_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((LCD_0_control_slave_wait_counter_eq_0 AND NOT d1_LCD_0_control_slave_end_xfer)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_LEDs_s1 OR NOT cpu_0_data_master_requests_LEDs_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_LEDs_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_LEDs_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_LEDs_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))));
  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_LUT_DATA_s1 OR NOT cpu_0_data_master_requests_LUT_DATA_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_LUT_DATA_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_LUT_DATA_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_LUT_DATA_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_LUT_INDEX_s1 OR NOT cpu_0_data_master_requests_LUT_INDEX_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_LUT_INDEX_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_LUT_INDEX_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_LUT_INDEX_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_PIX_VALCLK_s1 OR NOT cpu_0_data_master_requests_PIX_VALCLK_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_PIX_VALCLK_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_PIX_VALCLK_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_PIX_VALCLK_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 OR NOT cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_RAW2RGB_CONTROL_OUT_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_RED_s1 OR NOT cpu_0_data_master_requests_RED_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_RED_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_RED_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_RED_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))));
  --r_3 master_run cascaded wait assignment, which is an e_assign
  r_3 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_RESET_OUT_s1 OR NOT cpu_0_data_master_requests_RESET_OUT_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_RESET_OUT_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_RESET_OUT_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_RESET_OUT_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_SWint_s1 OR NOT cpu_0_data_master_requests_SWint_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_SWint_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_SWint_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_SWint_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_SWint2_s1 OR NOT cpu_0_data_master_requests_SWint2_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_SWint2_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_SWint2_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_SWint2_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module OR NOT cpu_0_data_master_requests_cpu_0_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_granted_cpu_0_jtag_debug_module OR NOT cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_cpu_0_jtag_debug_module_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave OR NOT cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave OR NOT ((cpu_0_data_master_read OR cpu_0_data_master_write)))))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_read OR cpu_0_data_master_write)))))))))));
  --r_4 master_run cascaded wait assignment, which is an e_assign
  r_4 <= Vector_To_Std_Logic(((((((((((((((((((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave OR NOT ((cpu_0_data_master_read OR cpu_0_data_master_write)))))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_read OR cpu_0_data_master_write))))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_onchip_memory2_0_s1 OR NOT cpu_0_data_master_requests_onchip_memory2_0_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_granted_onchip_memory2_0_s1 OR NOT cpu_0_data_master_qualified_request_onchip_memory2_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_onchip_memory2_0_s1 OR NOT ((cpu_0_data_master_read OR cpu_0_data_master_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_read OR cpu_0_data_master_write)))))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_onchip_memory2_0_s1 OR NOT ((cpu_0_data_master_read OR cpu_0_data_master_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_read OR cpu_0_data_master_write)))))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_performance_counter_0_control_slave OR NOT cpu_0_data_master_requests_performance_counter_0_control_slave)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_performance_counter_0_control_slave OR NOT ((cpu_0_data_master_read OR cpu_0_data_master_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_read OR cpu_0_data_master_write)))))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_performance_counter_0_control_slave OR NOT ((cpu_0_data_master_read OR cpu_0_data_master_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_read OR cpu_0_data_master_write)))))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_sysid_control_slave OR NOT cpu_0_data_master_requests_sysid_control_slave)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_sysid_control_slave OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_sysid_control_slave_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_sysid_control_slave OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_data_master_qualified_request_timer_0_s1 OR NOT cpu_0_data_master_requests_timer_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_timer_0_s1 OR NOT cpu_0_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_timer_0_s1_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_data_master_qualified_request_timer_0_s1 OR NOT cpu_0_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_write)))))))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_0_data_master_address_to_slave <= cpu_0_data_master_address(16 DOWNTO 0);
  --cpu_0_data_master_read_but_no_slave_selected assignment, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_data_master_read_but_no_slave_selected <= std_logic'('0');
    elsif clk'event and clk = '1' then
      cpu_0_data_master_read_but_no_slave_selected <= (cpu_0_data_master_read AND cpu_0_data_master_run) AND NOT cpu_0_data_master_is_granted_some_slave;
    end if;

  end process;

  --some slave is getting selected, which is an e_mux
  cpu_0_data_master_is_granted_some_slave <= ((((((((((((((((((((((cpu_0_data_master_granted_BLUE_s1 OR cpu_0_data_master_granted_CCD_XY_s1) OR cpu_0_data_master_granted_DVAL_s1) OR cpu_0_data_master_granted_GREEN_s1) OR cpu_0_data_master_granted_IN_mDATA_0_s1) OR cpu_0_data_master_granted_IN_mDATA_1_s1) OR cpu_0_data_master_granted_IN_mDATAd_0_s1) OR cpu_0_data_master_granted_IN_mDATAd_1_s1) OR cpu_0_data_master_granted_LCD_0_control_slave) OR cpu_0_data_master_granted_LEDs_s1) OR cpu_0_data_master_granted_LUT_DATA_s1) OR cpu_0_data_master_granted_LUT_INDEX_s1) OR cpu_0_data_master_granted_PIX_VALCLK_s1) OR cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1) OR cpu_0_data_master_granted_RED_s1) OR cpu_0_data_master_granted_RESET_OUT_s1) OR cpu_0_data_master_granted_SWint_s1) OR cpu_0_data_master_granted_SWint2_s1) OR cpu_0_data_master_granted_cpu_0_jtag_debug_module) OR cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave) OR cpu_0_data_master_granted_onchip_memory2_0_s1) OR cpu_0_data_master_granted_performance_counter_0_control_slave) OR cpu_0_data_master_granted_sysid_control_slave) OR cpu_0_data_master_granted_timer_0_s1;
  --latent slave read data valids which may be flushed, which is an e_mux
  pre_flush_cpu_0_data_master_readdatavalid <= cpu_0_data_master_read_data_valid_onchip_memory2_0_s1 OR cpu_0_data_master_read_data_valid_performance_counter_0_control_slave;
  --latent slave read data valid which is not flushed, which is an e_mux
  cpu_0_data_master_readdatavalid <= ((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((cpu_0_data_master_read_but_no_slave_selected OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_BLUE_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_CCD_XY_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_DVAL_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_GREEN_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_IN_mDATA_0_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_IN_mDATA_1_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_LCD_0_control_slave) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_LEDs_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_LUT_DATA_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_LUT_INDEX_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_PIX_VALCLK_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_RED_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_RESET_OUT_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_SWint_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_SWint2_s1) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_sysid_control_slave) OR cpu_0_data_master_read_but_no_slave_selected) OR pre_flush_cpu_0_data_master_readdatavalid) OR cpu_0_data_master_read_data_valid_timer_0_s1;
  --cpu_0/data_master readdata mux, which is an e_mux
  cpu_0_data_master_readdata <= ((((((((((((((((((((((((A_REP(NOT ((cpu_0_data_master_qualified_request_BLUE_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("00000000000000000000") & (BLUE_s1_readdata_from_sa)))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_CCD_XY_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000000000") & (CCD_XY_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_DVAL_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(DVAL_s1_readdata_from_sa)))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_GREEN_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("00000000000000000000") & (GREEN_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_IN_mDATA_0_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("00000000000000000000") & (IN_mDATA_0_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_IN_mDATA_1_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("00000000000000000000") & (IN_mDATA_1_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("00000000000000000000") & (IN_mDATAd_0_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("00000000000000000000") & (IN_mDATAd_1_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_LCD_0_control_slave AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (LCD_0_control_slave_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_LEDs_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (LEDs_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_LUT_DATA_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("00000000") & (LUT_DATA_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_LUT_INDEX_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("00000000000000000000000000") & (LUT_INDEX_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_PIX_VALCLK_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(PIX_VALCLK_s1_readdata_from_sa)))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("0000000000000000000000000000") & (RAW2RGB_CONTROL_OUT_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_RED_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("00000000000000000000") & (RED_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_RESET_OUT_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(RESET_OUT_s1_readdata_from_sa)))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_SWint_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (SWint_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_SWint2_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("000000000000000000000000") & (SWint2_s1_readdata_from_sa))))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module AND cpu_0_data_master_read)) , 32) OR cpu_0_jtag_debug_module_readdata_from_sa))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave AND cpu_0_data_master_read)) , 32) OR jtag_uart_0_avalon_jtag_slave_readdata_from_sa))) AND ((A_REP(NOT cpu_0_data_master_read_data_valid_onchip_memory2_0_s1, 32) OR onchip_memory2_0_s1_readdata_from_sa))) AND ((A_REP(NOT cpu_0_data_master_read_data_valid_performance_counter_0_control_slave, 32) OR performance_counter_0_control_slave_readdata_from_sa))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_sysid_control_slave AND cpu_0_data_master_read)) , 32) OR sysid_control_slave_readdata_from_sa))) AND ((A_REP(NOT ((cpu_0_data_master_qualified_request_timer_0_s1 AND cpu_0_data_master_read)) , 32) OR (std_logic_vector'("0000000000000000") & (timer_0_s1_readdata_from_sa))));
  --actual waitrequest port, which is an e_assign
  internal_cpu_0_data_master_waitrequest <= NOT cpu_0_data_master_run;
  --latent max counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_0_data_master_latency_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      internal_cpu_0_data_master_latency_counter <= p1_cpu_0_data_master_latency_counter;
    end if;

  end process;

  --latency counter load mux, which is an e_mux
  p1_cpu_0_data_master_latency_counter <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(((cpu_0_data_master_run AND cpu_0_data_master_read))) = '1'), (std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(latency_load_value))), A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_latency_counter)) = '1'), ((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(internal_cpu_0_data_master_latency_counter))) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000"))));
  --read latency load values, which is an e_mux
  latency_load_value <= Vector_To_Std_Logic(((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_requests_onchip_memory2_0_s1))) AND std_logic_vector'("00000000000000000000000000000001"))) OR (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_requests_performance_counter_0_control_slave))) AND std_logic_vector'("00000000000000000000000000000001")))));
  --irq assign, which is an e_assign
  cpu_0_data_master_irq <= Std_Logic_Vector'(A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(timer_0_s1_irq_from_sa) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(SWint2_s1_irq_from_sa) & A_ToStdLogicVector(SWint_s1_irq_from_sa) & A_ToStdLogicVector(jtag_uart_0_avalon_jtag_slave_irq_from_sa) & A_ToStdLogicVector(CCD_XY_s1_irq_from_sa) & A_ToStdLogicVector(LUT_INDEX_s1_irq_from_sa) & A_ToStdLogicVector(PIX_VALCLK_s1_irq_from_sa));
  --vhdl renameroo for output signals
  cpu_0_data_master_address_to_slave <= internal_cpu_0_data_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_0_data_master_latency_counter <= internal_cpu_0_data_master_latency_counter;
  --vhdl renameroo for output signals
  cpu_0_data_master_waitrequest <= internal_cpu_0_data_master_waitrequest;
--synthesis translate_off
    --cpu_0_data_master_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_0_data_master_address_last_time <= std_logic_vector'("00000000000000000");
      elsif clk'event and clk = '1' then
        cpu_0_data_master_address_last_time <= cpu_0_data_master_address;
      end if;

    end process;

    --cpu_0/data_master waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        active_and_waiting_last_time <= internal_cpu_0_data_master_waitrequest AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
      end if;

    end process;

    --cpu_0_data_master_address matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line2 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_0_data_master_address /= cpu_0_data_master_address_last_time))))) = '1' then 
          write(write_line2, now);
          write(write_line2, string'(": "));
          write(write_line2, string'("cpu_0_data_master_address did not heed wait!!!"));
          write(output, write_line2.all);
          deallocate (write_line2);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_0_data_master_byteenable check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_0_data_master_byteenable_last_time <= std_logic_vector'("0000");
      elsif clk'event and clk = '1' then
        cpu_0_data_master_byteenable_last_time <= cpu_0_data_master_byteenable;
      end if;

    end process;

    --cpu_0_data_master_byteenable matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line3 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_0_data_master_byteenable /= cpu_0_data_master_byteenable_last_time))))) = '1' then 
          write(write_line3, now);
          write(write_line3, string'(": "));
          write(write_line3, string'("cpu_0_data_master_byteenable did not heed wait!!!"));
          write(output, write_line3.all);
          deallocate (write_line3);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_0_data_master_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_0_data_master_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        cpu_0_data_master_read_last_time <= cpu_0_data_master_read;
      end if;

    end process;

    --cpu_0_data_master_read matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line4 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_0_data_master_read) /= std_logic'(cpu_0_data_master_read_last_time)))))) = '1' then 
          write(write_line4, now);
          write(write_line4, string'(": "));
          write(write_line4, string'("cpu_0_data_master_read did not heed wait!!!"));
          write(output, write_line4.all);
          deallocate (write_line4);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_0_data_master_write check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_0_data_master_write_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        cpu_0_data_master_write_last_time <= cpu_0_data_master_write;
      end if;

    end process;

    --cpu_0_data_master_write matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line5 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_0_data_master_write) /= std_logic'(cpu_0_data_master_write_last_time)))))) = '1' then 
          write(write_line5, now);
          write(write_line5, string'(": "));
          write(write_line5, string'("cpu_0_data_master_write did not heed wait!!!"));
          write(output, write_line5.all);
          deallocate (write_line5);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_0_data_master_writedata check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_0_data_master_writedata_last_time <= std_logic_vector'("00000000000000000000000000000000");
      elsif clk'event and clk = '1' then
        cpu_0_data_master_writedata_last_time <= cpu_0_data_master_writedata;
      end if;

    end process;

    --cpu_0_data_master_writedata matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line6 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'(((active_and_waiting_last_time AND to_std_logic(((cpu_0_data_master_writedata /= cpu_0_data_master_writedata_last_time)))) AND cpu_0_data_master_write)) = '1' then 
          write(write_line6, now);
          write(write_line6, string'(": "));
          write(write_line6, string'("cpu_0_data_master_writedata did not heed wait!!!"));
          write(output, write_line6.all);
          deallocate (write_line6);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_0_instruction_master_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_instruction_master_address : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_instruction_master_granted_cpu_0_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_0_instruction_master_granted_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_0_instruction_master_read : IN STD_LOGIC;
                 signal cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_0_instruction_master_requests_cpu_0_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_0_instruction_master_requests_onchip_memory2_0_s1 : IN STD_LOGIC;
                 signal cpu_0_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_0_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_memory2_0_s1_end_xfer : IN STD_LOGIC;
                 signal onchip_memory2_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_0_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_instruction_master_latency_counter : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_instruction_master_readdatavalid : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_waitrequest : OUT STD_LOGIC
              );
end entity cpu_0_instruction_master_arbitrator;


architecture europa of cpu_0_instruction_master_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_0_instruction_master_address_last_time :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal cpu_0_instruction_master_is_granted_some_slave :  STD_LOGIC;
                signal cpu_0_instruction_master_read_but_no_slave_selected :  STD_LOGIC;
                signal cpu_0_instruction_master_read_last_time :  STD_LOGIC;
                signal cpu_0_instruction_master_run :  STD_LOGIC;
                signal internal_cpu_0_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal internal_cpu_0_instruction_master_latency_counter :  STD_LOGIC;
                signal internal_cpu_0_instruction_master_waitrequest :  STD_LOGIC;
                signal latency_load_value :  STD_LOGIC;
                signal p1_cpu_0_instruction_master_latency_counter :  STD_LOGIC;
                signal pre_flush_cpu_0_instruction_master_readdatavalid :  STD_LOGIC;
                signal r_3 :  STD_LOGIC;
                signal r_4 :  STD_LOGIC;

begin

  --r_3 master_run cascaded wait assignment, which is an e_assign
  r_3 <= Vector_To_Std_Logic((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module OR NOT cpu_0_instruction_master_requests_cpu_0_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_instruction_master_granted_cpu_0_jtag_debug_module OR NOT cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module OR NOT cpu_0_instruction_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_cpu_0_jtag_debug_module_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_instruction_master_read)))))))));
  --cascaded wait assignment, which is an e_assign
  cpu_0_instruction_master_run <= r_3 AND r_4;
  --r_4 master_run cascaded wait assignment, which is an e_assign
  r_4 <= Vector_To_Std_Logic((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 OR NOT cpu_0_instruction_master_requests_onchip_memory2_0_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_0_instruction_master_granted_onchip_memory2_0_s1 OR NOT cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 OR NOT (cpu_0_instruction_master_read))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_0_instruction_master_read))))))))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_0_instruction_master_address_to_slave <= cpu_0_instruction_master_address(16 DOWNTO 0);
  --cpu_0_instruction_master_read_but_no_slave_selected assignment, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_instruction_master_read_but_no_slave_selected <= std_logic'('0');
    elsif clk'event and clk = '1' then
      cpu_0_instruction_master_read_but_no_slave_selected <= (cpu_0_instruction_master_read AND cpu_0_instruction_master_run) AND NOT cpu_0_instruction_master_is_granted_some_slave;
    end if;

  end process;

  --some slave is getting selected, which is an e_mux
  cpu_0_instruction_master_is_granted_some_slave <= cpu_0_instruction_master_granted_cpu_0_jtag_debug_module OR cpu_0_instruction_master_granted_onchip_memory2_0_s1;
  --latent slave read data valids which may be flushed, which is an e_mux
  pre_flush_cpu_0_instruction_master_readdatavalid <= cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1;
  --latent slave read data valid which is not flushed, which is an e_mux
  cpu_0_instruction_master_readdatavalid <= (((cpu_0_instruction_master_read_but_no_slave_selected OR pre_flush_cpu_0_instruction_master_readdatavalid) OR cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module) OR cpu_0_instruction_master_read_but_no_slave_selected) OR pre_flush_cpu_0_instruction_master_readdatavalid;
  --cpu_0/instruction_master readdata mux, which is an e_mux
  cpu_0_instruction_master_readdata <= ((A_REP(NOT ((cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module AND cpu_0_instruction_master_read)) , 32) OR cpu_0_jtag_debug_module_readdata_from_sa)) AND ((A_REP(NOT cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1, 32) OR onchip_memory2_0_s1_readdata_from_sa));
  --actual waitrequest port, which is an e_assign
  internal_cpu_0_instruction_master_waitrequest <= NOT cpu_0_instruction_master_run;
  --latent max counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_0_instruction_master_latency_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      internal_cpu_0_instruction_master_latency_counter <= p1_cpu_0_instruction_master_latency_counter;
    end if;

  end process;

  --latency counter load mux, which is an e_mux
  p1_cpu_0_instruction_master_latency_counter <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(((cpu_0_instruction_master_run AND cpu_0_instruction_master_read))) = '1'), (std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(latency_load_value))), A_WE_StdLogicVector((std_logic'((internal_cpu_0_instruction_master_latency_counter)) = '1'), ((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(internal_cpu_0_instruction_master_latency_counter))) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000"))));
  --read latency load values, which is an e_mux
  latency_load_value <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_instruction_master_requests_onchip_memory2_0_s1))) AND std_logic_vector'("00000000000000000000000000000001")));
  --vhdl renameroo for output signals
  cpu_0_instruction_master_address_to_slave <= internal_cpu_0_instruction_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_0_instruction_master_latency_counter <= internal_cpu_0_instruction_master_latency_counter;
  --vhdl renameroo for output signals
  cpu_0_instruction_master_waitrequest <= internal_cpu_0_instruction_master_waitrequest;
--synthesis translate_off
    --cpu_0_instruction_master_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_0_instruction_master_address_last_time <= std_logic_vector'("00000000000000000");
      elsif clk'event and clk = '1' then
        cpu_0_instruction_master_address_last_time <= cpu_0_instruction_master_address;
      end if;

    end process;

    --cpu_0/instruction_master waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        active_and_waiting_last_time <= internal_cpu_0_instruction_master_waitrequest AND (cpu_0_instruction_master_read);
      end if;

    end process;

    --cpu_0_instruction_master_address matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line7 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_0_instruction_master_address /= cpu_0_instruction_master_address_last_time))))) = '1' then 
          write(write_line7, now);
          write(write_line7, string'(": "));
          write(write_line7, string'("cpu_0_instruction_master_address did not heed wait!!!"));
          write(output, write_line7.all);
          deallocate (write_line7);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --cpu_0_instruction_master_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_0_instruction_master_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        cpu_0_instruction_master_read_last_time <= cpu_0_instruction_master_read;
      end if;

    end process;

    --cpu_0_instruction_master_read matches last port_name, which is an e_process
    process (clk)
    VARIABLE write_line8 : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_0_instruction_master_read) /= std_logic'(cpu_0_instruction_master_read_last_time)))))) = '1' then 
          write(write_line8, now);
          write(write_line8, string'(": "));
          write(write_line8, string'("cpu_0_instruction_master_read did not heed wait!!!"));
          write(output, write_line8.all);
          deallocate (write_line8);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity cpu_0_fpoint_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_custom_instruction_master_multi_clk_en : IN STD_LOGIC;
                 signal cpu_0_custom_instruction_master_multi_dataa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_custom_instruction_master_multi_datab : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_custom_instruction_master_multi_n : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 : IN STD_LOGIC;
                 signal cpu_0_fpoint_s1_done : IN STD_LOGIC;
                 signal cpu_0_fpoint_s1_result : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_fpoint_s1_select : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_0_fpoint_s1_clk_en : OUT STD_LOGIC;
                 signal cpu_0_fpoint_s1_dataa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_fpoint_s1_datab : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_fpoint_s1_done_from_sa : OUT STD_LOGIC;
                 signal cpu_0_fpoint_s1_n : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_0_fpoint_s1_reset : OUT STD_LOGIC;
                 signal cpu_0_fpoint_s1_result_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_fpoint_s1_start : OUT STD_LOGIC
              );
end entity cpu_0_fpoint_s1_arbitrator;


architecture europa of cpu_0_fpoint_s1_arbitrator is

begin

  cpu_0_fpoint_s1_clk_en <= cpu_0_custom_instruction_master_multi_clk_en;
  cpu_0_fpoint_s1_dataa <= cpu_0_custom_instruction_master_multi_dataa;
  cpu_0_fpoint_s1_datab <= cpu_0_custom_instruction_master_multi_datab;
  cpu_0_fpoint_s1_n <= cpu_0_custom_instruction_master_multi_n (1 DOWNTO 0);
  cpu_0_fpoint_s1_start <= cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1;
  --assign cpu_0_fpoint_s1_result_from_sa = cpu_0_fpoint_s1_result so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_0_fpoint_s1_result_from_sa <= cpu_0_fpoint_s1_result;
  --assign cpu_0_fpoint_s1_done_from_sa = cpu_0_fpoint_s1_done so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_0_fpoint_s1_done_from_sa <= cpu_0_fpoint_s1_done;
  --cpu_0_fpoint/s1 local reset_n, which is an e_assign
  cpu_0_fpoint_s1_reset <= NOT reset_n;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity jtag_uart_0_avalon_jtag_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_0_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_irq : IN STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_0_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                 signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_address : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                 signal jtag_uart_0_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity jtag_uart_0_avalon_jtag_slave_arbitrator;


architecture europa of jtag_uart_0_avalon_jtag_slave_arbitrator is
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_allgrants :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_any_continuerequest :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_arb_counter_enable :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_arb_share_counter :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_arb_share_set_values :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_begins_xfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_firsttransfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_grant_vector :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_in_a_read_cycle :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_in_a_write_cycle :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_master_qreq_vector :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_reg_firsttransfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_waits_for_read :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_jtag_uart_0_avalon_jtag_slave_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_jtag_uart_0_avalon_jtag_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT jtag_uart_0_avalon_jtag_slave_end_xfer;
    end if;

  end process;

  jtag_uart_0_avalon_jtag_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave);
  --assign jtag_uart_0_avalon_jtag_slave_readdata_from_sa = jtag_uart_0_avalon_jtag_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_readdata_from_sa <= jtag_uart_0_avalon_jtag_slave_readdata;
  internal_cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("10001000110010000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --assign jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa = jtag_uart_0_avalon_jtag_slave_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa <= jtag_uart_0_avalon_jtag_slave_dataavailable;
  --assign jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa = jtag_uart_0_avalon_jtag_slave_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa <= jtag_uart_0_avalon_jtag_slave_readyfordata;
  --assign jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa = jtag_uart_0_avalon_jtag_slave_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa <= jtag_uart_0_avalon_jtag_slave_waitrequest;
  --jtag_uart_0_avalon_jtag_slave_arb_share_counter set values, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_arb_share_set_values <= std_logic'('1');
  --jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests mux, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests <= internal_cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave;
  --jtag_uart_0_avalon_jtag_slave_any_bursting_master_saved_grant mux, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(jtag_uart_0_avalon_jtag_slave_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(jtag_uart_0_avalon_jtag_slave_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(jtag_uart_0_avalon_jtag_slave_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(jtag_uart_0_avalon_jtag_slave_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --jtag_uart_0_avalon_jtag_slave_allgrants all slave grants, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_allgrants <= jtag_uart_0_avalon_jtag_slave_grant_vector;
  --jtag_uart_0_avalon_jtag_slave_end_xfer assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_end_xfer <= NOT ((jtag_uart_0_avalon_jtag_slave_waits_for_read OR jtag_uart_0_avalon_jtag_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave <= jtag_uart_0_avalon_jtag_slave_end_xfer AND (((NOT jtag_uart_0_avalon_jtag_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --jtag_uart_0_avalon_jtag_slave_arb_share_counter arbitration counter enable, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave AND jtag_uart_0_avalon_jtag_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave AND NOT jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests));
  --jtag_uart_0_avalon_jtag_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_0_avalon_jtag_slave_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(jtag_uart_0_avalon_jtag_slave_arb_counter_enable) = '1' then 
        jtag_uart_0_avalon_jtag_slave_arb_share_counter <= jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((jtag_uart_0_avalon_jtag_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave)) OR ((end_xfer_arb_share_counter_term_jtag_uart_0_avalon_jtag_slave AND NOT jtag_uart_0_avalon_jtag_slave_non_bursting_master_requests)))) = '1' then 
        jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable <= jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master jtag_uart_0/avalon_jtag_slave arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable2 <= jtag_uart_0_avalon_jtag_slave_arb_share_counter_next_value;
  --cpu_0/data_master jtag_uart_0/avalon_jtag_slave arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --jtag_uart_0_avalon_jtag_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave <= internal_cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave, which is an e_mux
  cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave <= (internal_cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_0_data_master_read) AND NOT jtag_uart_0_avalon_jtag_slave_waits_for_read;
  --jtag_uart_0_avalon_jtag_slave_writedata mux, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_writedata <= cpu_0_data_master_writedata;
  --master is always granted when requested
  internal_cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave <= internal_cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave;
  --cpu_0/data_master saved-grant jtag_uart_0/avalon_jtag_slave, which is an e_assign
  cpu_0_data_master_saved_grant_jtag_uart_0_avalon_jtag_slave <= internal_cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave;
  --allow new arb cycle for jtag_uart_0/avalon_jtag_slave, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  jtag_uart_0_avalon_jtag_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  jtag_uart_0_avalon_jtag_slave_master_qreq_vector <= std_logic'('1');
  --jtag_uart_0_avalon_jtag_slave_reset_n assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_reset_n <= reset_n;
  jtag_uart_0_avalon_jtag_slave_chipselect <= internal_cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave;
  --jtag_uart_0_avalon_jtag_slave_firsttransfer first transaction, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_firsttransfer <= A_WE_StdLogic((std_logic'(jtag_uart_0_avalon_jtag_slave_begins_xfer) = '1'), jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer, jtag_uart_0_avalon_jtag_slave_reg_firsttransfer);
  --jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer first transaction, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer <= NOT ((jtag_uart_0_avalon_jtag_slave_slavearbiterlockenable AND jtag_uart_0_avalon_jtag_slave_any_continuerequest));
  --jtag_uart_0_avalon_jtag_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_0_avalon_jtag_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(jtag_uart_0_avalon_jtag_slave_begins_xfer) = '1' then 
        jtag_uart_0_avalon_jtag_slave_reg_firsttransfer <= jtag_uart_0_avalon_jtag_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --jtag_uart_0_avalon_jtag_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_beginbursttransfer_internal <= jtag_uart_0_avalon_jtag_slave_begins_xfer;
  --~jtag_uart_0_avalon_jtag_slave_read_n assignment, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_read_n <= NOT ((internal_cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_0_data_master_read));
  --~jtag_uart_0_avalon_jtag_slave_write_n assignment, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_write_n <= NOT ((internal_cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_0_data_master_write));
  shifted_address_to_jtag_uart_0_avalon_jtag_slave_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --jtag_uart_0_avalon_jtag_slave_address mux, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_address <= Vector_To_Std_Logic(A_SRL(shifted_address_to_jtag_uart_0_avalon_jtag_slave_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")));
  --d1_jtag_uart_0_avalon_jtag_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_jtag_uart_0_avalon_jtag_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_jtag_uart_0_avalon_jtag_slave_end_xfer <= jtag_uart_0_avalon_jtag_slave_end_xfer;
    end if;

  end process;

  --jtag_uart_0_avalon_jtag_slave_waits_for_read in a cycle, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_waits_for_read <= jtag_uart_0_avalon_jtag_slave_in_a_read_cycle AND internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_uart_0_avalon_jtag_slave_in_a_read_cycle assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_in_a_read_cycle <= internal_cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= jtag_uart_0_avalon_jtag_slave_in_a_read_cycle;
  --jtag_uart_0_avalon_jtag_slave_waits_for_write in a cycle, which is an e_mux
  jtag_uart_0_avalon_jtag_slave_waits_for_write <= jtag_uart_0_avalon_jtag_slave_in_a_write_cycle AND internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_uart_0_avalon_jtag_slave_in_a_write_cycle assignment, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_in_a_write_cycle <= internal_cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= jtag_uart_0_avalon_jtag_slave_in_a_write_cycle;
  wait_for_jtag_uart_0_avalon_jtag_slave_counter <= std_logic'('0');
  --assign jtag_uart_0_avalon_jtag_slave_irq_from_sa = jtag_uart_0_avalon_jtag_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_0_avalon_jtag_slave_irq_from_sa <= jtag_uart_0_avalon_jtag_slave_irq;
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave <= internal_cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave <= internal_cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave <= internal_cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave;
  --vhdl renameroo for output signals
  jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa <= internal_jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa;
--synthesis translate_off
    --jtag_uart_0/avalon_jtag_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity onchip_memory2_0_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_0_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_instruction_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_instruction_master_read : IN STD_LOGIC;
                 signal onchip_memory2_0_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_0_data_master_granted_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_granted_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_instruction_master_requests_onchip_memory2_0_s1 : OUT STD_LOGIC;
                 signal d1_onchip_memory2_0_s1_end_xfer : OUT STD_LOGIC;
                 signal onchip_memory2_0_s1_address : OUT STD_LOGIC_VECTOR (12 DOWNTO 0);
                 signal onchip_memory2_0_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal onchip_memory2_0_s1_chipselect : OUT STD_LOGIC;
                 signal onchip_memory2_0_s1_clken : OUT STD_LOGIC;
                 signal onchip_memory2_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_memory2_0_s1_write : OUT STD_LOGIC;
                 signal onchip_memory2_0_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity onchip_memory2_0_s1_arbitrator;


architecture europa of onchip_memory2_0_s1_arbitrator is
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register_in :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_0_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_instruction_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register :  STD_LOGIC;
                signal cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register_in :  STD_LOGIC;
                signal cpu_0_instruction_master_saved_grant_onchip_memory2_0_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_onchip_memory2_0_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_instruction_master_granted_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_instruction_master_requests_onchip_memory2_0_s1 :  STD_LOGIC;
                signal last_cycle_cpu_0_data_master_granted_slave_onchip_memory2_0_s1 :  STD_LOGIC;
                signal last_cycle_cpu_0_instruction_master_granted_slave_onchip_memory2_0_s1 :  STD_LOGIC;
                signal onchip_memory2_0_s1_allgrants :  STD_LOGIC;
                signal onchip_memory2_0_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal onchip_memory2_0_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal onchip_memory2_0_s1_any_continuerequest :  STD_LOGIC;
                signal onchip_memory2_0_s1_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_arb_counter_enable :  STD_LOGIC;
                signal onchip_memory2_0_s1_arb_share_counter :  STD_LOGIC;
                signal onchip_memory2_0_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal onchip_memory2_0_s1_arb_share_set_values :  STD_LOGIC;
                signal onchip_memory2_0_s1_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_arbitration_holdoff_internal :  STD_LOGIC;
                signal onchip_memory2_0_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal onchip_memory2_0_s1_begins_xfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_memory2_0_s1_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_end_xfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_firsttransfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_in_a_read_cycle :  STD_LOGIC;
                signal onchip_memory2_0_s1_in_a_write_cycle :  STD_LOGIC;
                signal onchip_memory2_0_s1_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_non_bursting_master_requests :  STD_LOGIC;
                signal onchip_memory2_0_s1_reg_firsttransfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal onchip_memory2_0_s1_slavearbiterlockenable :  STD_LOGIC;
                signal onchip_memory2_0_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal onchip_memory2_0_s1_unreg_firsttransfer :  STD_LOGIC;
                signal onchip_memory2_0_s1_waits_for_read :  STD_LOGIC;
                signal onchip_memory2_0_s1_waits_for_write :  STD_LOGIC;
                signal p1_cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register :  STD_LOGIC;
                signal p1_cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register :  STD_LOGIC;
                signal shifted_address_to_onchip_memory2_0_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal shifted_address_to_onchip_memory2_0_s1_from_cpu_0_instruction_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_onchip_memory2_0_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT onchip_memory2_0_s1_end_xfer;
    end if;

  end process;

  onchip_memory2_0_s1_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_0_data_master_qualified_request_onchip_memory2_0_s1 OR internal_cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1));
  --assign onchip_memory2_0_s1_readdata_from_sa = onchip_memory2_0_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  onchip_memory2_0_s1_readdata_from_sa <= onchip_memory2_0_s1_readdata;
  internal_cpu_0_data_master_requests_onchip_memory2_0_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 15) & std_logic_vector'("000000000000000")) = std_logic_vector'("01000000000000000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --onchip_memory2_0_s1_arb_share_counter set values, which is an e_mux
  onchip_memory2_0_s1_arb_share_set_values <= std_logic'('1');
  --onchip_memory2_0_s1_non_bursting_master_requests mux, which is an e_mux
  onchip_memory2_0_s1_non_bursting_master_requests <= ((internal_cpu_0_data_master_requests_onchip_memory2_0_s1 OR internal_cpu_0_instruction_master_requests_onchip_memory2_0_s1) OR internal_cpu_0_data_master_requests_onchip_memory2_0_s1) OR internal_cpu_0_instruction_master_requests_onchip_memory2_0_s1;
  --onchip_memory2_0_s1_any_bursting_master_saved_grant mux, which is an e_mux
  onchip_memory2_0_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --onchip_memory2_0_s1_arb_share_counter_next_value assignment, which is an e_assign
  onchip_memory2_0_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(onchip_memory2_0_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_memory2_0_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(onchip_memory2_0_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_memory2_0_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --onchip_memory2_0_s1_allgrants all slave grants, which is an e_mux
  onchip_memory2_0_s1_allgrants <= (((or_reduce(onchip_memory2_0_s1_grant_vector)) OR (or_reduce(onchip_memory2_0_s1_grant_vector))) OR (or_reduce(onchip_memory2_0_s1_grant_vector))) OR (or_reduce(onchip_memory2_0_s1_grant_vector));
  --onchip_memory2_0_s1_end_xfer assignment, which is an e_assign
  onchip_memory2_0_s1_end_xfer <= NOT ((onchip_memory2_0_s1_waits_for_read OR onchip_memory2_0_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_onchip_memory2_0_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_onchip_memory2_0_s1 <= onchip_memory2_0_s1_end_xfer AND (((NOT onchip_memory2_0_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --onchip_memory2_0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  onchip_memory2_0_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_onchip_memory2_0_s1 AND onchip_memory2_0_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_onchip_memory2_0_s1 AND NOT onchip_memory2_0_s1_non_bursting_master_requests));
  --onchip_memory2_0_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_memory2_0_s1_arb_counter_enable) = '1' then 
        onchip_memory2_0_s1_arb_share_counter <= onchip_memory2_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --onchip_memory2_0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((or_reduce(onchip_memory2_0_s1_master_qreq_vector) AND end_xfer_arb_share_counter_term_onchip_memory2_0_s1)) OR ((end_xfer_arb_share_counter_term_onchip_memory2_0_s1 AND NOT onchip_memory2_0_s1_non_bursting_master_requests)))) = '1' then 
        onchip_memory2_0_s1_slavearbiterlockenable <= onchip_memory2_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master onchip_memory2_0/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= onchip_memory2_0_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --onchip_memory2_0_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  onchip_memory2_0_s1_slavearbiterlockenable2 <= onchip_memory2_0_s1_arb_share_counter_next_value;
  --cpu_0/data_master onchip_memory2_0/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= onchip_memory2_0_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --cpu_0/instruction_master onchip_memory2_0/s1 arbiterlock, which is an e_assign
  cpu_0_instruction_master_arbiterlock <= onchip_memory2_0_s1_slavearbiterlockenable AND cpu_0_instruction_master_continuerequest;
  --cpu_0/instruction_master onchip_memory2_0/s1 arbiterlock2, which is an e_assign
  cpu_0_instruction_master_arbiterlock2 <= onchip_memory2_0_s1_slavearbiterlockenable2 AND cpu_0_instruction_master_continuerequest;
  --cpu_0/instruction_master granted onchip_memory2_0/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_0_instruction_master_granted_slave_onchip_memory2_0_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_0_instruction_master_granted_slave_onchip_memory2_0_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_0_instruction_master_saved_grant_onchip_memory2_0_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((onchip_memory2_0_s1_arbitration_holdoff_internal OR NOT internal_cpu_0_instruction_master_requests_onchip_memory2_0_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_0_instruction_master_granted_slave_onchip_memory2_0_s1))))));
    end if;

  end process;

  --cpu_0_instruction_master_continuerequest continued request, which is an e_mux
  cpu_0_instruction_master_continuerequest <= last_cycle_cpu_0_instruction_master_granted_slave_onchip_memory2_0_s1 AND internal_cpu_0_instruction_master_requests_onchip_memory2_0_s1;
  --onchip_memory2_0_s1_any_continuerequest at least one master continues requesting, which is an e_mux
  onchip_memory2_0_s1_any_continuerequest <= cpu_0_instruction_master_continuerequest OR cpu_0_data_master_continuerequest;
  internal_cpu_0_data_master_qualified_request_onchip_memory2_0_s1 <= internal_cpu_0_data_master_requests_onchip_memory2_0_s1 AND NOT ((((cpu_0_data_master_read AND to_std_logic(((std_logic_vector'("00000000000000000000000000000001")<(std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter)))))))) OR cpu_0_instruction_master_arbiterlock));
  --cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register_in <= (internal_cpu_0_data_master_granted_onchip_memory2_0_s1 AND cpu_0_data_master_read) AND NOT onchip_memory2_0_s1_waits_for_read;
  --shift register p1 cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register) & A_ToStdLogicVector(cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register_in)));
  --cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register <= p1_cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register;
    end if;

  end process;

  --local readdatavalid cpu_0_data_master_read_data_valid_onchip_memory2_0_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_onchip_memory2_0_s1 <= cpu_0_data_master_read_data_valid_onchip_memory2_0_s1_shift_register;
  --onchip_memory2_0_s1_writedata mux, which is an e_mux
  onchip_memory2_0_s1_writedata <= cpu_0_data_master_writedata;
  --mux onchip_memory2_0_s1_clken, which is an e_mux
  onchip_memory2_0_s1_clken <= std_logic'('1');
  internal_cpu_0_instruction_master_requests_onchip_memory2_0_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_0_instruction_master_address_to_slave(16 DOWNTO 15) & std_logic_vector'("000000000000000")) = std_logic_vector'("01000000000000000")))) AND (cpu_0_instruction_master_read))) AND cpu_0_instruction_master_read;
  --cpu_0/data_master granted onchip_memory2_0/s1 last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_0_data_master_granted_slave_onchip_memory2_0_s1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      last_cycle_cpu_0_data_master_granted_slave_onchip_memory2_0_s1 <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_0_data_master_saved_grant_onchip_memory2_0_s1) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((onchip_memory2_0_s1_arbitration_holdoff_internal OR NOT internal_cpu_0_data_master_requests_onchip_memory2_0_s1))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_0_data_master_granted_slave_onchip_memory2_0_s1))))));
    end if;

  end process;

  --cpu_0_data_master_continuerequest continued request, which is an e_mux
  cpu_0_data_master_continuerequest <= last_cycle_cpu_0_data_master_granted_slave_onchip_memory2_0_s1 AND internal_cpu_0_data_master_requests_onchip_memory2_0_s1;
  internal_cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 <= internal_cpu_0_instruction_master_requests_onchip_memory2_0_s1 AND NOT ((((cpu_0_instruction_master_read AND to_std_logic(((std_logic_vector'("00000000000000000000000000000001")<(std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_instruction_master_latency_counter)))))))) OR cpu_0_data_master_arbiterlock));
  --cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register_in <= (internal_cpu_0_instruction_master_granted_onchip_memory2_0_s1 AND cpu_0_instruction_master_read) AND NOT onchip_memory2_0_s1_waits_for_read;
  --shift register p1 cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register) & A_ToStdLogicVector(cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register_in)));
  --cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register <= p1_cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register;
    end if;

  end process;

  --local readdatavalid cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1, which is an e_mux
  cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1 <= cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1_shift_register;
  --allow new arb cycle for onchip_memory2_0/s1, which is an e_assign
  onchip_memory2_0_s1_allow_new_arb_cycle <= NOT cpu_0_data_master_arbiterlock AND NOT cpu_0_instruction_master_arbiterlock;
  --cpu_0/instruction_master assignment into master qualified-requests vector for onchip_memory2_0/s1, which is an e_assign
  onchip_memory2_0_s1_master_qreq_vector(0) <= internal_cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1;
  --cpu_0/instruction_master grant onchip_memory2_0/s1, which is an e_assign
  internal_cpu_0_instruction_master_granted_onchip_memory2_0_s1 <= onchip_memory2_0_s1_grant_vector(0);
  --cpu_0/instruction_master saved-grant onchip_memory2_0/s1, which is an e_assign
  cpu_0_instruction_master_saved_grant_onchip_memory2_0_s1 <= onchip_memory2_0_s1_arb_winner(0) AND internal_cpu_0_instruction_master_requests_onchip_memory2_0_s1;
  --cpu_0/data_master assignment into master qualified-requests vector for onchip_memory2_0/s1, which is an e_assign
  onchip_memory2_0_s1_master_qreq_vector(1) <= internal_cpu_0_data_master_qualified_request_onchip_memory2_0_s1;
  --cpu_0/data_master grant onchip_memory2_0/s1, which is an e_assign
  internal_cpu_0_data_master_granted_onchip_memory2_0_s1 <= onchip_memory2_0_s1_grant_vector(1);
  --cpu_0/data_master saved-grant onchip_memory2_0/s1, which is an e_assign
  cpu_0_data_master_saved_grant_onchip_memory2_0_s1 <= onchip_memory2_0_s1_arb_winner(1) AND internal_cpu_0_data_master_requests_onchip_memory2_0_s1;
  --onchip_memory2_0/s1 chosen-master double-vector, which is an e_assign
  onchip_memory2_0_s1_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((onchip_memory2_0_s1_master_qreq_vector & onchip_memory2_0_s1_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT onchip_memory2_0_s1_master_qreq_vector & NOT onchip_memory2_0_s1_master_qreq_vector))) + (std_logic_vector'("000") & (onchip_memory2_0_s1_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  onchip_memory2_0_s1_arb_winner <= A_WE_StdLogicVector((std_logic'(((onchip_memory2_0_s1_allow_new_arb_cycle AND or_reduce(onchip_memory2_0_s1_grant_vector)))) = '1'), onchip_memory2_0_s1_grant_vector, onchip_memory2_0_s1_saved_chosen_master_vector);
  --saved onchip_memory2_0_s1_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_memory2_0_s1_allow_new_arb_cycle) = '1' then 
        onchip_memory2_0_s1_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(onchip_memory2_0_s1_grant_vector)) = '1'), onchip_memory2_0_s1_grant_vector, onchip_memory2_0_s1_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  onchip_memory2_0_s1_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((onchip_memory2_0_s1_chosen_master_double_vector(1) OR onchip_memory2_0_s1_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((onchip_memory2_0_s1_chosen_master_double_vector(0) OR onchip_memory2_0_s1_chosen_master_double_vector(2)))));
  --onchip_memory2_0/s1 chosen master rotated left, which is an e_assign
  onchip_memory2_0_s1_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(onchip_memory2_0_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(onchip_memory2_0_s1_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --onchip_memory2_0/s1's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(onchip_memory2_0_s1_grant_vector)) = '1' then 
        onchip_memory2_0_s1_arb_addend <= A_WE_StdLogicVector((std_logic'(onchip_memory2_0_s1_end_xfer) = '1'), onchip_memory2_0_s1_chosen_master_rot_left, onchip_memory2_0_s1_grant_vector);
      end if;
    end if;

  end process;

  onchip_memory2_0_s1_chipselect <= internal_cpu_0_data_master_granted_onchip_memory2_0_s1 OR internal_cpu_0_instruction_master_granted_onchip_memory2_0_s1;
  --onchip_memory2_0_s1_firsttransfer first transaction, which is an e_assign
  onchip_memory2_0_s1_firsttransfer <= A_WE_StdLogic((std_logic'(onchip_memory2_0_s1_begins_xfer) = '1'), onchip_memory2_0_s1_unreg_firsttransfer, onchip_memory2_0_s1_reg_firsttransfer);
  --onchip_memory2_0_s1_unreg_firsttransfer first transaction, which is an e_assign
  onchip_memory2_0_s1_unreg_firsttransfer <= NOT ((onchip_memory2_0_s1_slavearbiterlockenable AND onchip_memory2_0_s1_any_continuerequest));
  --onchip_memory2_0_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory2_0_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_memory2_0_s1_begins_xfer) = '1' then 
        onchip_memory2_0_s1_reg_firsttransfer <= onchip_memory2_0_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --onchip_memory2_0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  onchip_memory2_0_s1_beginbursttransfer_internal <= onchip_memory2_0_s1_begins_xfer;
  --onchip_memory2_0_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  onchip_memory2_0_s1_arbitration_holdoff_internal <= onchip_memory2_0_s1_begins_xfer AND onchip_memory2_0_s1_firsttransfer;
  --onchip_memory2_0_s1_write assignment, which is an e_mux
  onchip_memory2_0_s1_write <= internal_cpu_0_data_master_granted_onchip_memory2_0_s1 AND cpu_0_data_master_write;
  shifted_address_to_onchip_memory2_0_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --onchip_memory2_0_s1_address mux, which is an e_mux
  onchip_memory2_0_s1_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_granted_onchip_memory2_0_s1)) = '1'), (A_SRL(shifted_address_to_onchip_memory2_0_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(shifted_address_to_onchip_memory2_0_s1_from_cpu_0_instruction_master,std_logic_vector'("00000000000000000000000000000010")))), 13);
  shifted_address_to_onchip_memory2_0_s1_from_cpu_0_instruction_master <= cpu_0_instruction_master_address_to_slave;
  --d1_onchip_memory2_0_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_onchip_memory2_0_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_onchip_memory2_0_s1_end_xfer <= onchip_memory2_0_s1_end_xfer;
    end if;

  end process;

  --onchip_memory2_0_s1_waits_for_read in a cycle, which is an e_mux
  onchip_memory2_0_s1_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_memory2_0_s1_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_memory2_0_s1_in_a_read_cycle assignment, which is an e_assign
  onchip_memory2_0_s1_in_a_read_cycle <= ((internal_cpu_0_data_master_granted_onchip_memory2_0_s1 AND cpu_0_data_master_read)) OR ((internal_cpu_0_instruction_master_granted_onchip_memory2_0_s1 AND cpu_0_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= onchip_memory2_0_s1_in_a_read_cycle;
  --onchip_memory2_0_s1_waits_for_write in a cycle, which is an e_mux
  onchip_memory2_0_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_memory2_0_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_memory2_0_s1_in_a_write_cycle assignment, which is an e_assign
  onchip_memory2_0_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_onchip_memory2_0_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= onchip_memory2_0_s1_in_a_write_cycle;
  wait_for_onchip_memory2_0_s1_counter <= std_logic'('0');
  --onchip_memory2_0_s1_byteenable byte enable port mux, which is an e_mux
  onchip_memory2_0_s1_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_0_data_master_granted_onchip_memory2_0_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_0_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_onchip_memory2_0_s1 <= internal_cpu_0_data_master_granted_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_onchip_memory2_0_s1 <= internal_cpu_0_data_master_qualified_request_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_onchip_memory2_0_s1 <= internal_cpu_0_data_master_requests_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_0_instruction_master_granted_onchip_memory2_0_s1 <= internal_cpu_0_instruction_master_granted_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 <= internal_cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1;
  --vhdl renameroo for output signals
  cpu_0_instruction_master_requests_onchip_memory2_0_s1 <= internal_cpu_0_instruction_master_requests_onchip_memory2_0_s1;
--synthesis translate_off
    --onchip_memory2_0/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line9 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_0_data_master_granted_onchip_memory2_0_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_0_instruction_master_granted_onchip_memory2_0_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line9, now);
          write(write_line9, string'(": "));
          write(write_line9, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line9.all);
          deallocate (write_line9);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line10 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_saved_grant_onchip_memory2_0_s1))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_0_instruction_master_saved_grant_onchip_memory2_0_s1))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line10, now);
          write(write_line10, string'(": "));
          write(write_line10, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line10.all);
          deallocate (write_line10);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity performance_counter_0_control_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal performance_counter_0_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_0_data_master_granted_performance_counter_0_control_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_performance_counter_0_control_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_performance_counter_0_control_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_performance_counter_0_control_slave : OUT STD_LOGIC;
                 signal d1_performance_counter_0_control_slave_end_xfer : OUT STD_LOGIC;
                 signal performance_counter_0_control_slave_address : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal performance_counter_0_control_slave_begintransfer : OUT STD_LOGIC;
                 signal performance_counter_0_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal performance_counter_0_control_slave_reset_n : OUT STD_LOGIC;
                 signal performance_counter_0_control_slave_write : OUT STD_LOGIC;
                 signal performance_counter_0_control_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity performance_counter_0_control_slave_arbitrator;


architecture europa of performance_counter_0_control_slave_arbitrator is
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register_in :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_performance_counter_0_control_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_performance_counter_0_control_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_performance_counter_0_control_slave :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_performance_counter_0_control_slave :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_performance_counter_0_control_slave :  STD_LOGIC;
                signal p1_cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register :  STD_LOGIC;
                signal performance_counter_0_control_slave_allgrants :  STD_LOGIC;
                signal performance_counter_0_control_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal performance_counter_0_control_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal performance_counter_0_control_slave_any_continuerequest :  STD_LOGIC;
                signal performance_counter_0_control_slave_arb_counter_enable :  STD_LOGIC;
                signal performance_counter_0_control_slave_arb_share_counter :  STD_LOGIC;
                signal performance_counter_0_control_slave_arb_share_counter_next_value :  STD_LOGIC;
                signal performance_counter_0_control_slave_arb_share_set_values :  STD_LOGIC;
                signal performance_counter_0_control_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal performance_counter_0_control_slave_begins_xfer :  STD_LOGIC;
                signal performance_counter_0_control_slave_end_xfer :  STD_LOGIC;
                signal performance_counter_0_control_slave_firsttransfer :  STD_LOGIC;
                signal performance_counter_0_control_slave_grant_vector :  STD_LOGIC;
                signal performance_counter_0_control_slave_in_a_read_cycle :  STD_LOGIC;
                signal performance_counter_0_control_slave_in_a_write_cycle :  STD_LOGIC;
                signal performance_counter_0_control_slave_master_qreq_vector :  STD_LOGIC;
                signal performance_counter_0_control_slave_non_bursting_master_requests :  STD_LOGIC;
                signal performance_counter_0_control_slave_reg_firsttransfer :  STD_LOGIC;
                signal performance_counter_0_control_slave_slavearbiterlockenable :  STD_LOGIC;
                signal performance_counter_0_control_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal performance_counter_0_control_slave_unreg_firsttransfer :  STD_LOGIC;
                signal performance_counter_0_control_slave_waits_for_read :  STD_LOGIC;
                signal performance_counter_0_control_slave_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_performance_counter_0_control_slave_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal wait_for_performance_counter_0_control_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT performance_counter_0_control_slave_end_xfer;
    end if;

  end process;

  performance_counter_0_control_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_performance_counter_0_control_slave);
  --assign performance_counter_0_control_slave_readdata_from_sa = performance_counter_0_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  performance_counter_0_control_slave_readdata_from_sa <= performance_counter_0_control_slave_readdata;
  internal_cpu_0_data_master_requests_performance_counter_0_control_slave <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 6) & std_logic_vector'("000000")) = std_logic_vector'("10001000000000000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --performance_counter_0_control_slave_arb_share_counter set values, which is an e_mux
  performance_counter_0_control_slave_arb_share_set_values <= std_logic'('1');
  --performance_counter_0_control_slave_non_bursting_master_requests mux, which is an e_mux
  performance_counter_0_control_slave_non_bursting_master_requests <= internal_cpu_0_data_master_requests_performance_counter_0_control_slave;
  --performance_counter_0_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  performance_counter_0_control_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --performance_counter_0_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  performance_counter_0_control_slave_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(performance_counter_0_control_slave_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(performance_counter_0_control_slave_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(performance_counter_0_control_slave_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(performance_counter_0_control_slave_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --performance_counter_0_control_slave_allgrants all slave grants, which is an e_mux
  performance_counter_0_control_slave_allgrants <= performance_counter_0_control_slave_grant_vector;
  --performance_counter_0_control_slave_end_xfer assignment, which is an e_assign
  performance_counter_0_control_slave_end_xfer <= NOT ((performance_counter_0_control_slave_waits_for_read OR performance_counter_0_control_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_performance_counter_0_control_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_performance_counter_0_control_slave <= performance_counter_0_control_slave_end_xfer AND (((NOT performance_counter_0_control_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --performance_counter_0_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  performance_counter_0_control_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_performance_counter_0_control_slave AND performance_counter_0_control_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_performance_counter_0_control_slave AND NOT performance_counter_0_control_slave_non_bursting_master_requests));
  --performance_counter_0_control_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      performance_counter_0_control_slave_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(performance_counter_0_control_slave_arb_counter_enable) = '1' then 
        performance_counter_0_control_slave_arb_share_counter <= performance_counter_0_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --performance_counter_0_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      performance_counter_0_control_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((performance_counter_0_control_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_performance_counter_0_control_slave)) OR ((end_xfer_arb_share_counter_term_performance_counter_0_control_slave AND NOT performance_counter_0_control_slave_non_bursting_master_requests)))) = '1' then 
        performance_counter_0_control_slave_slavearbiterlockenable <= performance_counter_0_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master performance_counter_0/control_slave arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= performance_counter_0_control_slave_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --performance_counter_0_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  performance_counter_0_control_slave_slavearbiterlockenable2 <= performance_counter_0_control_slave_arb_share_counter_next_value;
  --cpu_0/data_master performance_counter_0/control_slave arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= performance_counter_0_control_slave_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --performance_counter_0_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  performance_counter_0_control_slave_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_performance_counter_0_control_slave <= internal_cpu_0_data_master_requests_performance_counter_0_control_slave AND NOT ((cpu_0_data_master_read AND to_std_logic(((std_logic_vector'("00000000000000000000000000000001")<(std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))))))));
  --cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register_in <= (internal_cpu_0_data_master_granted_performance_counter_0_control_slave AND cpu_0_data_master_read) AND NOT performance_counter_0_control_slave_waits_for_read;
  --shift register p1 cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register) & A_ToStdLogicVector(cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register_in)));
  --cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register <= p1_cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register;
    end if;

  end process;

  --local readdatavalid cpu_0_data_master_read_data_valid_performance_counter_0_control_slave, which is an e_mux
  cpu_0_data_master_read_data_valid_performance_counter_0_control_slave <= cpu_0_data_master_read_data_valid_performance_counter_0_control_slave_shift_register;
  --performance_counter_0_control_slave_writedata mux, which is an e_mux
  performance_counter_0_control_slave_writedata <= cpu_0_data_master_writedata;
  --master is always granted when requested
  internal_cpu_0_data_master_granted_performance_counter_0_control_slave <= internal_cpu_0_data_master_qualified_request_performance_counter_0_control_slave;
  --cpu_0/data_master saved-grant performance_counter_0/control_slave, which is an e_assign
  cpu_0_data_master_saved_grant_performance_counter_0_control_slave <= internal_cpu_0_data_master_requests_performance_counter_0_control_slave;
  --allow new arb cycle for performance_counter_0/control_slave, which is an e_assign
  performance_counter_0_control_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  performance_counter_0_control_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  performance_counter_0_control_slave_master_qreq_vector <= std_logic'('1');
  performance_counter_0_control_slave_begintransfer <= performance_counter_0_control_slave_begins_xfer;
  --performance_counter_0_control_slave_reset_n assignment, which is an e_assign
  performance_counter_0_control_slave_reset_n <= reset_n;
  --performance_counter_0_control_slave_firsttransfer first transaction, which is an e_assign
  performance_counter_0_control_slave_firsttransfer <= A_WE_StdLogic((std_logic'(performance_counter_0_control_slave_begins_xfer) = '1'), performance_counter_0_control_slave_unreg_firsttransfer, performance_counter_0_control_slave_reg_firsttransfer);
  --performance_counter_0_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  performance_counter_0_control_slave_unreg_firsttransfer <= NOT ((performance_counter_0_control_slave_slavearbiterlockenable AND performance_counter_0_control_slave_any_continuerequest));
  --performance_counter_0_control_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      performance_counter_0_control_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(performance_counter_0_control_slave_begins_xfer) = '1' then 
        performance_counter_0_control_slave_reg_firsttransfer <= performance_counter_0_control_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --performance_counter_0_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  performance_counter_0_control_slave_beginbursttransfer_internal <= performance_counter_0_control_slave_begins_xfer;
  --performance_counter_0_control_slave_write assignment, which is an e_mux
  performance_counter_0_control_slave_write <= internal_cpu_0_data_master_granted_performance_counter_0_control_slave AND cpu_0_data_master_write;
  shifted_address_to_performance_counter_0_control_slave_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --performance_counter_0_control_slave_address mux, which is an e_mux
  performance_counter_0_control_slave_address <= A_EXT (A_SRL(shifted_address_to_performance_counter_0_control_slave_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 4);
  --d1_performance_counter_0_control_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_performance_counter_0_control_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_performance_counter_0_control_slave_end_xfer <= performance_counter_0_control_slave_end_xfer;
    end if;

  end process;

  --performance_counter_0_control_slave_waits_for_read in a cycle, which is an e_mux
  performance_counter_0_control_slave_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(performance_counter_0_control_slave_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --performance_counter_0_control_slave_in_a_read_cycle assignment, which is an e_assign
  performance_counter_0_control_slave_in_a_read_cycle <= internal_cpu_0_data_master_granted_performance_counter_0_control_slave AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= performance_counter_0_control_slave_in_a_read_cycle;
  --performance_counter_0_control_slave_waits_for_write in a cycle, which is an e_mux
  performance_counter_0_control_slave_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(performance_counter_0_control_slave_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --performance_counter_0_control_slave_in_a_write_cycle assignment, which is an e_assign
  performance_counter_0_control_slave_in_a_write_cycle <= internal_cpu_0_data_master_granted_performance_counter_0_control_slave AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= performance_counter_0_control_slave_in_a_write_cycle;
  wait_for_performance_counter_0_control_slave_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_performance_counter_0_control_slave <= internal_cpu_0_data_master_granted_performance_counter_0_control_slave;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_performance_counter_0_control_slave <= internal_cpu_0_data_master_qualified_request_performance_counter_0_control_slave;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_performance_counter_0_control_slave <= internal_cpu_0_data_master_requests_performance_counter_0_control_slave;
--synthesis translate_off
    --performance_counter_0/control_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sysid_control_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_0_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                 signal sysid_control_slave_address : OUT STD_LOGIC;
                 signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity sysid_control_slave_arbitrator;


architecture europa of sysid_control_slave_arbitrator is
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_sysid_control_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_sysid_control_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal shifted_address_to_sysid_control_slave_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal sysid_control_slave_allgrants :  STD_LOGIC;
                signal sysid_control_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal sysid_control_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal sysid_control_slave_any_continuerequest :  STD_LOGIC;
                signal sysid_control_slave_arb_counter_enable :  STD_LOGIC;
                signal sysid_control_slave_arb_share_counter :  STD_LOGIC;
                signal sysid_control_slave_arb_share_counter_next_value :  STD_LOGIC;
                signal sysid_control_slave_arb_share_set_values :  STD_LOGIC;
                signal sysid_control_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal sysid_control_slave_begins_xfer :  STD_LOGIC;
                signal sysid_control_slave_end_xfer :  STD_LOGIC;
                signal sysid_control_slave_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_grant_vector :  STD_LOGIC;
                signal sysid_control_slave_in_a_read_cycle :  STD_LOGIC;
                signal sysid_control_slave_in_a_write_cycle :  STD_LOGIC;
                signal sysid_control_slave_master_qreq_vector :  STD_LOGIC;
                signal sysid_control_slave_non_bursting_master_requests :  STD_LOGIC;
                signal sysid_control_slave_reg_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_slavearbiterlockenable :  STD_LOGIC;
                signal sysid_control_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal sysid_control_slave_unreg_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_waits_for_read :  STD_LOGIC;
                signal sysid_control_slave_waits_for_write :  STD_LOGIC;
                signal wait_for_sysid_control_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT sysid_control_slave_end_xfer;
    end if;

  end process;

  sysid_control_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_sysid_control_slave);
  --assign sysid_control_slave_readdata_from_sa = sysid_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sysid_control_slave_readdata_from_sa <= sysid_control_slave_readdata;
  internal_cpu_0_data_master_requests_sysid_control_slave <= ((to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("10001000110011000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write)))) AND cpu_0_data_master_read;
  --sysid_control_slave_arb_share_counter set values, which is an e_mux
  sysid_control_slave_arb_share_set_values <= std_logic'('1');
  --sysid_control_slave_non_bursting_master_requests mux, which is an e_mux
  sysid_control_slave_non_bursting_master_requests <= internal_cpu_0_data_master_requests_sysid_control_slave;
  --sysid_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  sysid_control_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --sysid_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  sysid_control_slave_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(sysid_control_slave_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sysid_control_slave_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(sysid_control_slave_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sysid_control_slave_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --sysid_control_slave_allgrants all slave grants, which is an e_mux
  sysid_control_slave_allgrants <= sysid_control_slave_grant_vector;
  --sysid_control_slave_end_xfer assignment, which is an e_assign
  sysid_control_slave_end_xfer <= NOT ((sysid_control_slave_waits_for_read OR sysid_control_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_sysid_control_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_sysid_control_slave <= sysid_control_slave_end_xfer AND (((NOT sysid_control_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --sysid_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  sysid_control_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_sysid_control_slave AND sysid_control_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_sysid_control_slave AND NOT sysid_control_slave_non_bursting_master_requests));
  --sysid_control_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(sysid_control_slave_arb_counter_enable) = '1' then 
        sysid_control_slave_arb_share_counter <= sysid_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sysid_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((sysid_control_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_sysid_control_slave)) OR ((end_xfer_arb_share_counter_term_sysid_control_slave AND NOT sysid_control_slave_non_bursting_master_requests)))) = '1' then 
        sysid_control_slave_slavearbiterlockenable <= sysid_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master sysid/control_slave arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= sysid_control_slave_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --sysid_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  sysid_control_slave_slavearbiterlockenable2 <= sysid_control_slave_arb_share_counter_next_value;
  --cpu_0/data_master sysid/control_slave arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= sysid_control_slave_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --sysid_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  sysid_control_slave_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_sysid_control_slave <= internal_cpu_0_data_master_requests_sysid_control_slave AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_sysid_control_slave, which is an e_mux
  cpu_0_data_master_read_data_valid_sysid_control_slave <= (internal_cpu_0_data_master_granted_sysid_control_slave AND cpu_0_data_master_read) AND NOT sysid_control_slave_waits_for_read;
  --master is always granted when requested
  internal_cpu_0_data_master_granted_sysid_control_slave <= internal_cpu_0_data_master_qualified_request_sysid_control_slave;
  --cpu_0/data_master saved-grant sysid/control_slave, which is an e_assign
  cpu_0_data_master_saved_grant_sysid_control_slave <= internal_cpu_0_data_master_requests_sysid_control_slave;
  --allow new arb cycle for sysid/control_slave, which is an e_assign
  sysid_control_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  sysid_control_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  sysid_control_slave_master_qreq_vector <= std_logic'('1');
  --sysid_control_slave_firsttransfer first transaction, which is an e_assign
  sysid_control_slave_firsttransfer <= A_WE_StdLogic((std_logic'(sysid_control_slave_begins_xfer) = '1'), sysid_control_slave_unreg_firsttransfer, sysid_control_slave_reg_firsttransfer);
  --sysid_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  sysid_control_slave_unreg_firsttransfer <= NOT ((sysid_control_slave_slavearbiterlockenable AND sysid_control_slave_any_continuerequest));
  --sysid_control_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(sysid_control_slave_begins_xfer) = '1' then 
        sysid_control_slave_reg_firsttransfer <= sysid_control_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --sysid_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sysid_control_slave_beginbursttransfer_internal <= sysid_control_slave_begins_xfer;
  shifted_address_to_sysid_control_slave_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --sysid_control_slave_address mux, which is an e_mux
  sysid_control_slave_address <= Vector_To_Std_Logic(A_SRL(shifted_address_to_sysid_control_slave_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")));
  --d1_sysid_control_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sysid_control_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_sysid_control_slave_end_xfer <= sysid_control_slave_end_xfer;
    end if;

  end process;

  --sysid_control_slave_waits_for_read in a cycle, which is an e_mux
  sysid_control_slave_waits_for_read <= sysid_control_slave_in_a_read_cycle AND sysid_control_slave_begins_xfer;
  --sysid_control_slave_in_a_read_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_read_cycle <= internal_cpu_0_data_master_granted_sysid_control_slave AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sysid_control_slave_in_a_read_cycle;
  --sysid_control_slave_waits_for_write in a cycle, which is an e_mux
  sysid_control_slave_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sysid_control_slave_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --sysid_control_slave_in_a_write_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_write_cycle <= internal_cpu_0_data_master_granted_sysid_control_slave AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sysid_control_slave_in_a_write_cycle;
  wait_for_sysid_control_slave_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_sysid_control_slave <= internal_cpu_0_data_master_granted_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_sysid_control_slave <= internal_cpu_0_data_master_qualified_request_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_sysid_control_slave <= internal_cpu_0_data_master_requests_sysid_control_slave;
--synthesis translate_off
    --sysid/control_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity timer_0_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                 signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                 signal cpu_0_data_master_read : IN STD_LOGIC;
                 signal cpu_0_data_master_write : IN STD_LOGIC;
                 signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal timer_0_s1_irq : IN STD_LOGIC;
                 signal timer_0_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_0_data_master_granted_timer_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_qualified_request_timer_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_read_data_valid_timer_0_s1 : OUT STD_LOGIC;
                 signal cpu_0_data_master_requests_timer_0_s1 : OUT STD_LOGIC;
                 signal d1_timer_0_s1_end_xfer : OUT STD_LOGIC;
                 signal timer_0_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal timer_0_s1_chipselect : OUT STD_LOGIC;
                 signal timer_0_s1_irq_from_sa : OUT STD_LOGIC;
                 signal timer_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal timer_0_s1_reset_n : OUT STD_LOGIC;
                 signal timer_0_s1_write_n : OUT STD_LOGIC;
                 signal timer_0_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
end entity timer_0_s1_arbitrator;


architecture europa of timer_0_s1_arbitrator is
                signal cpu_0_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_0_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_0_data_master_continuerequest :  STD_LOGIC;
                signal cpu_0_data_master_saved_grant_timer_0_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_timer_0_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_0_data_master_granted_timer_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_qualified_request_timer_0_s1 :  STD_LOGIC;
                signal internal_cpu_0_data_master_requests_timer_0_s1 :  STD_LOGIC;
                signal shifted_address_to_timer_0_s1_from_cpu_0_data_master :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal timer_0_s1_allgrants :  STD_LOGIC;
                signal timer_0_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal timer_0_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal timer_0_s1_any_continuerequest :  STD_LOGIC;
                signal timer_0_s1_arb_counter_enable :  STD_LOGIC;
                signal timer_0_s1_arb_share_counter :  STD_LOGIC;
                signal timer_0_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal timer_0_s1_arb_share_set_values :  STD_LOGIC;
                signal timer_0_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal timer_0_s1_begins_xfer :  STD_LOGIC;
                signal timer_0_s1_end_xfer :  STD_LOGIC;
                signal timer_0_s1_firsttransfer :  STD_LOGIC;
                signal timer_0_s1_grant_vector :  STD_LOGIC;
                signal timer_0_s1_in_a_read_cycle :  STD_LOGIC;
                signal timer_0_s1_in_a_write_cycle :  STD_LOGIC;
                signal timer_0_s1_master_qreq_vector :  STD_LOGIC;
                signal timer_0_s1_non_bursting_master_requests :  STD_LOGIC;
                signal timer_0_s1_reg_firsttransfer :  STD_LOGIC;
                signal timer_0_s1_slavearbiterlockenable :  STD_LOGIC;
                signal timer_0_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal timer_0_s1_unreg_firsttransfer :  STD_LOGIC;
                signal timer_0_s1_waits_for_read :  STD_LOGIC;
                signal timer_0_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_timer_0_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      d1_reasons_to_wait <= NOT timer_0_s1_end_xfer;
    end if;

  end process;

  timer_0_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_0_data_master_qualified_request_timer_0_s1);
  --assign timer_0_s1_readdata_from_sa = timer_0_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer_0_s1_readdata_from_sa <= timer_0_s1_readdata;
  internal_cpu_0_data_master_requests_timer_0_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_0_data_master_address_to_slave(16 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("10001000001000000")))) AND ((cpu_0_data_master_read OR cpu_0_data_master_write));
  --timer_0_s1_arb_share_counter set values, which is an e_mux
  timer_0_s1_arb_share_set_values <= std_logic'('1');
  --timer_0_s1_non_bursting_master_requests mux, which is an e_mux
  timer_0_s1_non_bursting_master_requests <= internal_cpu_0_data_master_requests_timer_0_s1;
  --timer_0_s1_any_bursting_master_saved_grant mux, which is an e_mux
  timer_0_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --timer_0_s1_arb_share_counter_next_value assignment, which is an e_assign
  timer_0_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(timer_0_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(timer_0_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(timer_0_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(timer_0_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --timer_0_s1_allgrants all slave grants, which is an e_mux
  timer_0_s1_allgrants <= timer_0_s1_grant_vector;
  --timer_0_s1_end_xfer assignment, which is an e_assign
  timer_0_s1_end_xfer <= NOT ((timer_0_s1_waits_for_read OR timer_0_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_timer_0_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_timer_0_s1 <= timer_0_s1_end_xfer AND (((NOT timer_0_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --timer_0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  timer_0_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_timer_0_s1 AND timer_0_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_timer_0_s1 AND NOT timer_0_s1_non_bursting_master_requests));
  --timer_0_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer_0_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(timer_0_s1_arb_counter_enable) = '1' then 
        timer_0_s1_arb_share_counter <= timer_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --timer_0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer_0_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((timer_0_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_timer_0_s1)) OR ((end_xfer_arb_share_counter_term_timer_0_s1 AND NOT timer_0_s1_non_bursting_master_requests)))) = '1' then 
        timer_0_s1_slavearbiterlockenable <= timer_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_0/data_master timer_0/s1 arbiterlock, which is an e_assign
  cpu_0_data_master_arbiterlock <= timer_0_s1_slavearbiterlockenable AND cpu_0_data_master_continuerequest;
  --timer_0_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  timer_0_s1_slavearbiterlockenable2 <= timer_0_s1_arb_share_counter_next_value;
  --cpu_0/data_master timer_0/s1 arbiterlock2, which is an e_assign
  cpu_0_data_master_arbiterlock2 <= timer_0_s1_slavearbiterlockenable2 AND cpu_0_data_master_continuerequest;
  --timer_0_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  timer_0_s1_any_continuerequest <= std_logic'('1');
  --cpu_0_data_master_continuerequest continued request, which is an e_assign
  cpu_0_data_master_continuerequest <= std_logic'('1');
  internal_cpu_0_data_master_qualified_request_timer_0_s1 <= internal_cpu_0_data_master_requests_timer_0_s1 AND NOT ((cpu_0_data_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_data_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000"))))));
  --local readdatavalid cpu_0_data_master_read_data_valid_timer_0_s1, which is an e_mux
  cpu_0_data_master_read_data_valid_timer_0_s1 <= (internal_cpu_0_data_master_granted_timer_0_s1 AND cpu_0_data_master_read) AND NOT timer_0_s1_waits_for_read;
  --timer_0_s1_writedata mux, which is an e_mux
  timer_0_s1_writedata <= cpu_0_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_0_data_master_granted_timer_0_s1 <= internal_cpu_0_data_master_qualified_request_timer_0_s1;
  --cpu_0/data_master saved-grant timer_0/s1, which is an e_assign
  cpu_0_data_master_saved_grant_timer_0_s1 <= internal_cpu_0_data_master_requests_timer_0_s1;
  --allow new arb cycle for timer_0/s1, which is an e_assign
  timer_0_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  timer_0_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  timer_0_s1_master_qreq_vector <= std_logic'('1');
  --timer_0_s1_reset_n assignment, which is an e_assign
  timer_0_s1_reset_n <= reset_n;
  timer_0_s1_chipselect <= internal_cpu_0_data_master_granted_timer_0_s1;
  --timer_0_s1_firsttransfer first transaction, which is an e_assign
  timer_0_s1_firsttransfer <= A_WE_StdLogic((std_logic'(timer_0_s1_begins_xfer) = '1'), timer_0_s1_unreg_firsttransfer, timer_0_s1_reg_firsttransfer);
  --timer_0_s1_unreg_firsttransfer first transaction, which is an e_assign
  timer_0_s1_unreg_firsttransfer <= NOT ((timer_0_s1_slavearbiterlockenable AND timer_0_s1_any_continuerequest));
  --timer_0_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer_0_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(timer_0_s1_begins_xfer) = '1' then 
        timer_0_s1_reg_firsttransfer <= timer_0_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --timer_0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  timer_0_s1_beginbursttransfer_internal <= timer_0_s1_begins_xfer;
  --~timer_0_s1_write_n assignment, which is an e_mux
  timer_0_s1_write_n <= NOT ((internal_cpu_0_data_master_granted_timer_0_s1 AND cpu_0_data_master_write));
  shifted_address_to_timer_0_s1_from_cpu_0_data_master <= cpu_0_data_master_address_to_slave;
  --timer_0_s1_address mux, which is an e_mux
  timer_0_s1_address <= A_EXT (A_SRL(shifted_address_to_timer_0_s1_from_cpu_0_data_master,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_timer_0_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_timer_0_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      d1_timer_0_s1_end_xfer <= timer_0_s1_end_xfer;
    end if;

  end process;

  --timer_0_s1_waits_for_read in a cycle, which is an e_mux
  timer_0_s1_waits_for_read <= timer_0_s1_in_a_read_cycle AND timer_0_s1_begins_xfer;
  --timer_0_s1_in_a_read_cycle assignment, which is an e_assign
  timer_0_s1_in_a_read_cycle <= internal_cpu_0_data_master_granted_timer_0_s1 AND cpu_0_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= timer_0_s1_in_a_read_cycle;
  --timer_0_s1_waits_for_write in a cycle, which is an e_mux
  timer_0_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(timer_0_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --timer_0_s1_in_a_write_cycle assignment, which is an e_assign
  timer_0_s1_in_a_write_cycle <= internal_cpu_0_data_master_granted_timer_0_s1 AND cpu_0_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= timer_0_s1_in_a_write_cycle;
  wait_for_timer_0_s1_counter <= std_logic'('0');
  --assign timer_0_s1_irq_from_sa = timer_0_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer_0_s1_irq_from_sa <= timer_0_s1_irq;
  --vhdl renameroo for output signals
  cpu_0_data_master_granted_timer_0_s1 <= internal_cpu_0_data_master_granted_timer_0_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_qualified_request_timer_0_s1 <= internal_cpu_0_data_master_qualified_request_timer_0_s1;
  --vhdl renameroo for output signals
  cpu_0_data_master_requests_timer_0_s1 <= internal_cpu_0_data_master_requests_timer_0_s1;
--synthesis translate_off
    --timer_0/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        enable_nonzero_assertions <= std_logic'('1');
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity niosii_reset_clk_domain_synch_module is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal data_in : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal data_out : OUT STD_LOGIC
              );
end entity niosii_reset_clk_domain_synch_module;


architecture europa of niosii_reset_clk_domain_synch_module is
                signal data_in_d1 :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of data_in_d1 : signal is "{-from ""*""} CUT=ON ; PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101";
attribute ALTERA_ATTRIBUTE of data_out : signal is "PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_in_d1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      data_in_d1 <= data_in;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_out <= std_logic'('0');
    elsif clk'event and clk = '1' then
      data_out <= data_in_d1;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity niosii is 
        port (
              -- 1) global signals:
                 signal clk : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- the_BLUE
                 signal out_port_from_the_BLUE : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);

              -- the_CCD_XY
                 signal in_port_to_the_CCD_XY : IN STD_LOGIC_VECTOR (1 DOWNTO 0);

              -- the_DVAL
                 signal out_port_from_the_DVAL : OUT STD_LOGIC;

              -- the_GREEN
                 signal out_port_from_the_GREEN : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);

              -- the_IN_mDATA_0
                 signal in_port_to_the_IN_mDATA_0 : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

              -- the_IN_mDATA_1
                 signal in_port_to_the_IN_mDATA_1 : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

              -- the_IN_mDATAd_0
                 signal in_port_to_the_IN_mDATAd_0 : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

              -- the_IN_mDATAd_1
                 signal in_port_to_the_IN_mDATAd_1 : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

              -- the_LCD_0
                 signal LCD_E_from_the_LCD_0 : OUT STD_LOGIC;
                 signal LCD_RS_from_the_LCD_0 : OUT STD_LOGIC;
                 signal LCD_RW_from_the_LCD_0 : OUT STD_LOGIC;
                 signal LCD_data_to_and_from_the_LCD_0 : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_LEDs
                 signal out_port_from_the_LEDs : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_LUT_DATA
                 signal out_port_from_the_LUT_DATA : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);

              -- the_LUT_INDEX
                 signal in_port_to_the_LUT_INDEX : IN STD_LOGIC_VECTOR (5 DOWNTO 0);

              -- the_PIX_VALCLK
                 signal in_port_to_the_PIX_VALCLK : IN STD_LOGIC;

              -- the_RAW2RGB_CONTROL_OUT
                 signal out_port_from_the_RAW2RGB_CONTROL_OUT : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);

              -- the_RED
                 signal out_port_from_the_RED : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);

              -- the_RESET_OUT
                 signal out_port_from_the_RESET_OUT : OUT STD_LOGIC;

              -- the_SWint
                 signal in_port_to_the_SWint : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

              -- the_SWint2
                 signal in_port_to_the_SWint2 : IN STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity niosii;


architecture europa of niosii is
component BLUE_s1_arbitrator is 
           port (
                 -- inputs:
                    signal BLUE_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal BLUE_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal BLUE_s1_chipselect : OUT STD_LOGIC;
                    signal BLUE_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal BLUE_s1_reset_n : OUT STD_LOGIC;
                    signal BLUE_s1_write_n : OUT STD_LOGIC;
                    signal BLUE_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal cpu_0_data_master_granted_BLUE_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_BLUE_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_BLUE_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_BLUE_s1 : OUT STD_LOGIC;
                    signal d1_BLUE_s1_end_xfer : OUT STD_LOGIC
                 );
end component BLUE_s1_arbitrator;

component BLUE is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
                 );
end component BLUE;

component CCD_XY_s1_arbitrator is 
           port (
                 -- inputs:
                    signal CCD_XY_s1_irq : IN STD_LOGIC;
                    signal CCD_XY_s1_readdata : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal CCD_XY_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal CCD_XY_s1_chipselect : OUT STD_LOGIC;
                    signal CCD_XY_s1_irq_from_sa : OUT STD_LOGIC;
                    signal CCD_XY_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal CCD_XY_s1_reset_n : OUT STD_LOGIC;
                    signal CCD_XY_s1_write_n : OUT STD_LOGIC;
                    signal CCD_XY_s1_writedata : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_0_data_master_granted_CCD_XY_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_CCD_XY_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_CCD_XY_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_CCD_XY_s1 : OUT STD_LOGIC;
                    signal d1_CCD_XY_s1_end_xfer : OUT STD_LOGIC
                 );
end component CCD_XY_s1_arbitrator;

component CCD_XY is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (1 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (1 DOWNTO 0)
                 );
end component CCD_XY;

component DVAL_s1_arbitrator is 
           port (
                 -- inputs:
                    signal DVAL_s1_readdata : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal DVAL_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal DVAL_s1_chipselect : OUT STD_LOGIC;
                    signal DVAL_s1_readdata_from_sa : OUT STD_LOGIC;
                    signal DVAL_s1_reset_n : OUT STD_LOGIC;
                    signal DVAL_s1_write_n : OUT STD_LOGIC;
                    signal DVAL_s1_writedata : OUT STD_LOGIC;
                    signal cpu_0_data_master_granted_DVAL_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_DVAL_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_DVAL_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_DVAL_s1 : OUT STD_LOGIC;
                    signal d1_DVAL_s1_end_xfer : OUT STD_LOGIC
                 );
end component DVAL_s1_arbitrator;

component DVAL is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC;

                 -- outputs:
                    signal out_port : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC
                 );
end component DVAL;

component GREEN_s1_arbitrator is 
           port (
                 -- inputs:
                    signal GREEN_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal GREEN_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal GREEN_s1_chipselect : OUT STD_LOGIC;
                    signal GREEN_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal GREEN_s1_reset_n : OUT STD_LOGIC;
                    signal GREEN_s1_write_n : OUT STD_LOGIC;
                    signal GREEN_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal cpu_0_data_master_granted_GREEN_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_GREEN_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_GREEN_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_GREEN_s1 : OUT STD_LOGIC;
                    signal d1_GREEN_s1_end_xfer : OUT STD_LOGIC
                 );
end component GREEN_s1_arbitrator;

component GREEN is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
                 );
end component GREEN;

component IN_mDATA_0_s1_arbitrator is 
           port (
                 -- inputs:
                    signal IN_mDATA_0_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal IN_mDATA_0_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal IN_mDATA_0_s1_chipselect : OUT STD_LOGIC;
                    signal IN_mDATA_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal IN_mDATA_0_s1_reset_n : OUT STD_LOGIC;
                    signal IN_mDATA_0_s1_write_n : OUT STD_LOGIC;
                    signal IN_mDATA_0_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal cpu_0_data_master_granted_IN_mDATA_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_IN_mDATA_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_IN_mDATA_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_IN_mDATA_0_s1 : OUT STD_LOGIC;
                    signal d1_IN_mDATA_0_s1_end_xfer : OUT STD_LOGIC
                 );
end component IN_mDATA_0_s1_arbitrator;

component IN_mDATA_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
                 );
end component IN_mDATA_0;

component IN_mDATA_1_s1_arbitrator is 
           port (
                 -- inputs:
                    signal IN_mDATA_1_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal IN_mDATA_1_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal IN_mDATA_1_s1_chipselect : OUT STD_LOGIC;
                    signal IN_mDATA_1_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal IN_mDATA_1_s1_reset_n : OUT STD_LOGIC;
                    signal IN_mDATA_1_s1_write_n : OUT STD_LOGIC;
                    signal IN_mDATA_1_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal cpu_0_data_master_granted_IN_mDATA_1_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_IN_mDATA_1_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_IN_mDATA_1_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_IN_mDATA_1_s1 : OUT STD_LOGIC;
                    signal d1_IN_mDATA_1_s1_end_xfer : OUT STD_LOGIC
                 );
end component IN_mDATA_1_s1_arbitrator;

component IN_mDATA_1 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
                 );
end component IN_mDATA_1;

component IN_mDATAd_0_s1_arbitrator is 
           port (
                 -- inputs:
                    signal IN_mDATAd_0_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal IN_mDATAd_0_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal IN_mDATAd_0_s1_chipselect : OUT STD_LOGIC;
                    signal IN_mDATAd_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal IN_mDATAd_0_s1_reset_n : OUT STD_LOGIC;
                    signal IN_mDATAd_0_s1_write_n : OUT STD_LOGIC;
                    signal IN_mDATAd_0_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal cpu_0_data_master_granted_IN_mDATAd_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_IN_mDATAd_0_s1 : OUT STD_LOGIC;
                    signal d1_IN_mDATAd_0_s1_end_xfer : OUT STD_LOGIC
                 );
end component IN_mDATAd_0_s1_arbitrator;

component IN_mDATAd_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
                 );
end component IN_mDATAd_0;

component IN_mDATAd_1_s1_arbitrator is 
           port (
                 -- inputs:
                    signal IN_mDATAd_1_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal IN_mDATAd_1_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal IN_mDATAd_1_s1_chipselect : OUT STD_LOGIC;
                    signal IN_mDATAd_1_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal IN_mDATAd_1_s1_reset_n : OUT STD_LOGIC;
                    signal IN_mDATAd_1_s1_write_n : OUT STD_LOGIC;
                    signal IN_mDATAd_1_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal cpu_0_data_master_granted_IN_mDATAd_1_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_IN_mDATAd_1_s1 : OUT STD_LOGIC;
                    signal d1_IN_mDATAd_1_s1_end_xfer : OUT STD_LOGIC
                 );
end component IN_mDATAd_1_s1_arbitrator;

component IN_mDATAd_1 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
                 );
end component IN_mDATAd_1;

component LCD_0_control_slave_arbitrator is 
           port (
                 -- inputs:
                    signal LCD_0_control_slave_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal LCD_0_control_slave_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal LCD_0_control_slave_begintransfer : OUT STD_LOGIC;
                    signal LCD_0_control_slave_read : OUT STD_LOGIC;
                    signal LCD_0_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal LCD_0_control_slave_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal LCD_0_control_slave_write : OUT STD_LOGIC;
                    signal LCD_0_control_slave_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_0_data_master_granted_LCD_0_control_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_LCD_0_control_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_LCD_0_control_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_LCD_0_control_slave : OUT STD_LOGIC;
                    signal d1_LCD_0_control_slave_end_xfer : OUT STD_LOGIC
                 );
end component LCD_0_control_slave_arbitrator;

component LCD_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal begintransfer : IN STD_LOGIC;
                    signal read : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal LCD_E : OUT STD_LOGIC;
                    signal LCD_RS : OUT STD_LOGIC;
                    signal LCD_RW : OUT STD_LOGIC;
                    signal LCD_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component LCD_0;

component LEDs_s1_arbitrator is 
           port (
                 -- inputs:
                    signal LEDs_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal LEDs_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal LEDs_s1_chipselect : OUT STD_LOGIC;
                    signal LEDs_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal LEDs_s1_reset_n : OUT STD_LOGIC;
                    signal LEDs_s1_write_n : OUT STD_LOGIC;
                    signal LEDs_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_0_data_master_granted_LEDs_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_LEDs_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_LEDs_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_LEDs_s1 : OUT STD_LOGIC;
                    signal d1_LEDs_s1_end_xfer : OUT STD_LOGIC
                 );
end component LEDs_s1_arbitrator;

component LEDs is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component LEDs;

component LUT_DATA_s1_arbitrator is 
           port (
                 -- inputs:
                    signal LUT_DATA_s1_readdata : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal LUT_DATA_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal LUT_DATA_s1_chipselect : OUT STD_LOGIC;
                    signal LUT_DATA_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal LUT_DATA_s1_reset_n : OUT STD_LOGIC;
                    signal LUT_DATA_s1_write_n : OUT STD_LOGIC;
                    signal LUT_DATA_s1_writedata : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal cpu_0_data_master_granted_LUT_DATA_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_LUT_DATA_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_LUT_DATA_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_LUT_DATA_s1 : OUT STD_LOGIC;
                    signal d1_LUT_DATA_s1_end_xfer : OUT STD_LOGIC
                 );
end component LUT_DATA_s1_arbitrator;

component LUT_DATA is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (23 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (23 DOWNTO 0)
                 );
end component LUT_DATA;

component LUT_INDEX_s1_arbitrator is 
           port (
                 -- inputs:
                    signal LUT_INDEX_s1_irq : IN STD_LOGIC;
                    signal LUT_INDEX_s1_readdata : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal LUT_INDEX_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal LUT_INDEX_s1_chipselect : OUT STD_LOGIC;
                    signal LUT_INDEX_s1_irq_from_sa : OUT STD_LOGIC;
                    signal LUT_INDEX_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal LUT_INDEX_s1_reset_n : OUT STD_LOGIC;
                    signal LUT_INDEX_s1_write_n : OUT STD_LOGIC;
                    signal LUT_INDEX_s1_writedata : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal cpu_0_data_master_granted_LUT_INDEX_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_LUT_INDEX_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_LUT_INDEX_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_LUT_INDEX_s1 : OUT STD_LOGIC;
                    signal d1_LUT_INDEX_s1_end_xfer : OUT STD_LOGIC
                 );
end component LUT_INDEX_s1_arbitrator;

component LUT_INDEX is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (5 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (5 DOWNTO 0)
                 );
end component LUT_INDEX;

component PIX_VALCLK_s1_arbitrator is 
           port (
                 -- inputs:
                    signal PIX_VALCLK_s1_irq : IN STD_LOGIC;
                    signal PIX_VALCLK_s1_readdata : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal PIX_VALCLK_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal PIX_VALCLK_s1_chipselect : OUT STD_LOGIC;
                    signal PIX_VALCLK_s1_irq_from_sa : OUT STD_LOGIC;
                    signal PIX_VALCLK_s1_readdata_from_sa : OUT STD_LOGIC;
                    signal PIX_VALCLK_s1_reset_n : OUT STD_LOGIC;
                    signal PIX_VALCLK_s1_write_n : OUT STD_LOGIC;
                    signal PIX_VALCLK_s1_writedata : OUT STD_LOGIC;
                    signal cpu_0_data_master_granted_PIX_VALCLK_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_PIX_VALCLK_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_PIX_VALCLK_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_PIX_VALCLK_s1 : OUT STD_LOGIC;
                    signal d1_PIX_VALCLK_s1_end_xfer : OUT STD_LOGIC
                 );
end component PIX_VALCLK_s1_arbitrator;

component PIX_VALCLK is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC;

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC
                 );
end component PIX_VALCLK;

component RAW2RGB_CONTROL_OUT_s1_arbitrator is 
           port (
                 -- inputs:
                    signal RAW2RGB_CONTROL_OUT_s1_readdata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal RAW2RGB_CONTROL_OUT_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal RAW2RGB_CONTROL_OUT_s1_chipselect : OUT STD_LOGIC;
                    signal RAW2RGB_CONTROL_OUT_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal RAW2RGB_CONTROL_OUT_s1_reset_n : OUT STD_LOGIC;
                    signal RAW2RGB_CONTROL_OUT_s1_write_n : OUT STD_LOGIC;
                    signal RAW2RGB_CONTROL_OUT_s1_writedata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 : OUT STD_LOGIC;
                    signal d1_RAW2RGB_CONTROL_OUT_s1_end_xfer : OUT STD_LOGIC
                 );
end component RAW2RGB_CONTROL_OUT_s1_arbitrator;

component RAW2RGB_CONTROL_OUT is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
                 );
end component RAW2RGB_CONTROL_OUT;

component RED_s1_arbitrator is 
           port (
                 -- inputs:
                    signal RED_s1_readdata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal RED_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal RED_s1_chipselect : OUT STD_LOGIC;
                    signal RED_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal RED_s1_reset_n : OUT STD_LOGIC;
                    signal RED_s1_write_n : OUT STD_LOGIC;
                    signal RED_s1_writedata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal cpu_0_data_master_granted_RED_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_RED_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_RED_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_RED_s1 : OUT STD_LOGIC;
                    signal d1_RED_s1_end_xfer : OUT STD_LOGIC
                 );
end component RED_s1_arbitrator;

component RED is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal readdata : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
                 );
end component RED;

component RESET_OUT_s1_arbitrator is 
           port (
                 -- inputs:
                    signal RESET_OUT_s1_readdata : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal RESET_OUT_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal RESET_OUT_s1_chipselect : OUT STD_LOGIC;
                    signal RESET_OUT_s1_readdata_from_sa : OUT STD_LOGIC;
                    signal RESET_OUT_s1_reset_n : OUT STD_LOGIC;
                    signal RESET_OUT_s1_write_n : OUT STD_LOGIC;
                    signal RESET_OUT_s1_writedata : OUT STD_LOGIC;
                    signal cpu_0_data_master_granted_RESET_OUT_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_RESET_OUT_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_RESET_OUT_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_RESET_OUT_s1 : OUT STD_LOGIC;
                    signal d1_RESET_OUT_s1_end_xfer : OUT STD_LOGIC
                 );
end component RESET_OUT_s1_arbitrator;

component RESET_OUT is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC;

                 -- outputs:
                    signal out_port : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC
                 );
end component RESET_OUT;

component SWint_s1_arbitrator is 
           port (
                 -- inputs:
                    signal SWint_s1_irq : IN STD_LOGIC;
                    signal SWint_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal SWint_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal SWint_s1_chipselect : OUT STD_LOGIC;
                    signal SWint_s1_irq_from_sa : OUT STD_LOGIC;
                    signal SWint_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal SWint_s1_reset_n : OUT STD_LOGIC;
                    signal SWint_s1_write_n : OUT STD_LOGIC;
                    signal SWint_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_0_data_master_granted_SWint_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_SWint_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_SWint_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_SWint_s1 : OUT STD_LOGIC;
                    signal d1_SWint_s1_end_xfer : OUT STD_LOGIC
                 );
end component SWint_s1_arbitrator;

component SWint is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component SWint;

component SWint2_s1_arbitrator is 
           port (
                 -- inputs:
                    signal SWint2_s1_irq : IN STD_LOGIC;
                    signal SWint2_s1_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal SWint2_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal SWint2_s1_chipselect : OUT STD_LOGIC;
                    signal SWint2_s1_irq_from_sa : OUT STD_LOGIC;
                    signal SWint2_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal SWint2_s1_reset_n : OUT STD_LOGIC;
                    signal SWint2_s1_write_n : OUT STD_LOGIC;
                    signal SWint2_s1_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_0_data_master_granted_SWint2_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_SWint2_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_SWint2_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_SWint2_s1 : OUT STD_LOGIC;
                    signal d1_SWint2_s1_end_xfer : OUT STD_LOGIC
                 );
end component SWint2_s1_arbitrator;

component SWint2 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal in_port : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component SWint2;

component cpu_0_jtag_debug_module_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_0_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_instruction_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_instruction_master_read : IN STD_LOGIC;
                    signal cpu_0_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_jtag_debug_module_resetrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_0_data_master_granted_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_granted_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_requests_cpu_0_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_0_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal cpu_0_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                    signal cpu_0_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_0_jtag_debug_module_chipselect : OUT STD_LOGIC;
                    signal cpu_0_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                    signal cpu_0_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                    signal cpu_0_jtag_debug_module_write : OUT STD_LOGIC;
                    signal cpu_0_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_0_jtag_debug_module_end_xfer : OUT STD_LOGIC
                 );
end component cpu_0_jtag_debug_module_arbitrator;

component cpu_0_custom_instruction_master_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_custom_instruction_master_multi_start : IN STD_LOGIC;
                    signal cpu_0_fpoint_s1_done_from_sa : IN STD_LOGIC;
                    signal cpu_0_fpoint_s1_result_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_0_custom_instruction_master_multi_done : OUT STD_LOGIC;
                    signal cpu_0_custom_instruction_master_multi_result : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_custom_instruction_master_reset_n : OUT STD_LOGIC;
                    signal cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 : OUT STD_LOGIC;
                    signal cpu_0_fpoint_s1_select : OUT STD_LOGIC
                 );
end component cpu_0_custom_instruction_master_arbitrator;

component cpu_0_data_master_arbitrator is 
           port (
                 -- inputs:
                    signal BLUE_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal CCD_XY_s1_irq_from_sa : IN STD_LOGIC;
                    signal CCD_XY_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal DVAL_s1_readdata_from_sa : IN STD_LOGIC;
                    signal GREEN_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal IN_mDATA_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal IN_mDATA_1_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal IN_mDATAd_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal IN_mDATAd_1_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal LCD_0_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal LCD_0_control_slave_wait_counter_eq_0 : IN STD_LOGIC;
                    signal LEDs_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal LUT_DATA_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal LUT_INDEX_s1_irq_from_sa : IN STD_LOGIC;
                    signal LUT_INDEX_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal PIX_VALCLK_s1_irq_from_sa : IN STD_LOGIC;
                    signal PIX_VALCLK_s1_readdata_from_sa : IN STD_LOGIC;
                    signal RAW2RGB_CONTROL_OUT_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal RED_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal RESET_OUT_s1_readdata_from_sa : IN STD_LOGIC;
                    signal SWint2_s1_irq_from_sa : IN STD_LOGIC;
                    signal SWint2_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal SWint_s1_irq_from_sa : IN STD_LOGIC;
                    signal SWint_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_0_data_master_granted_BLUE_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_CCD_XY_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_DVAL_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_GREEN_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_IN_mDATA_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_IN_mDATA_1_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_IN_mDATAd_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_IN_mDATAd_1_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_LCD_0_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_LEDs_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_LUT_DATA_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_LUT_INDEX_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_PIX_VALCLK_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_RED_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_RESET_OUT_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_SWint2_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_SWint_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_cpu_0_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_performance_counter_0_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_granted_timer_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_BLUE_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_CCD_XY_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_DVAL_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_GREEN_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_IN_mDATA_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_IN_mDATA_1_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_LCD_0_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_LEDs_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_LUT_DATA_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_LUT_INDEX_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_PIX_VALCLK_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_RED_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_RESET_OUT_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_SWint2_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_SWint_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_performance_counter_0_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_timer_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_BLUE_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_CCD_XY_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_DVAL_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_GREEN_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_IN_mDATA_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_IN_mDATA_1_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_LCD_0_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_LEDs_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_LUT_DATA_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_LUT_INDEX_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_PIX_VALCLK_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_RED_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_RESET_OUT_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_SWint2_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_SWint_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_performance_counter_0_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_timer_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_BLUE_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_CCD_XY_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_DVAL_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_GREEN_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_IN_mDATA_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_IN_mDATA_1_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_IN_mDATAd_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_IN_mDATAd_1_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_LCD_0_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_LEDs_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_LUT_DATA_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_LUT_INDEX_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_PIX_VALCLK_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_RED_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_RESET_OUT_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_SWint2_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_SWint_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_cpu_0_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_performance_counter_0_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_0_data_master_requests_timer_0_s1 : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_BLUE_s1_end_xfer : IN STD_LOGIC;
                    signal d1_CCD_XY_s1_end_xfer : IN STD_LOGIC;
                    signal d1_DVAL_s1_end_xfer : IN STD_LOGIC;
                    signal d1_GREEN_s1_end_xfer : IN STD_LOGIC;
                    signal d1_IN_mDATA_0_s1_end_xfer : IN STD_LOGIC;
                    signal d1_IN_mDATA_1_s1_end_xfer : IN STD_LOGIC;
                    signal d1_IN_mDATAd_0_s1_end_xfer : IN STD_LOGIC;
                    signal d1_IN_mDATAd_1_s1_end_xfer : IN STD_LOGIC;
                    signal d1_LCD_0_control_slave_end_xfer : IN STD_LOGIC;
                    signal d1_LEDs_s1_end_xfer : IN STD_LOGIC;
                    signal d1_LUT_DATA_s1_end_xfer : IN STD_LOGIC;
                    signal d1_LUT_INDEX_s1_end_xfer : IN STD_LOGIC;
                    signal d1_PIX_VALCLK_s1_end_xfer : IN STD_LOGIC;
                    signal d1_RAW2RGB_CONTROL_OUT_s1_end_xfer : IN STD_LOGIC;
                    signal d1_RED_s1_end_xfer : IN STD_LOGIC;
                    signal d1_RESET_OUT_s1_end_xfer : IN STD_LOGIC;
                    signal d1_SWint2_s1_end_xfer : IN STD_LOGIC;
                    signal d1_SWint_s1_end_xfer : IN STD_LOGIC;
                    signal d1_cpu_0_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_memory2_0_s1_end_xfer : IN STD_LOGIC;
                    signal d1_performance_counter_0_control_slave_end_xfer : IN STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                    signal d1_timer_0_s1_end_xfer : IN STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                    signal onchip_memory2_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal performance_counter_0_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal timer_0_s1_irq_from_sa : IN STD_LOGIC;
                    signal timer_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_0_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : OUT STD_LOGIC;
                    signal cpu_0_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_data_master_readdatavalid : OUT STD_LOGIC;
                    signal cpu_0_data_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_0_data_master_arbitrator;

component cpu_0_instruction_master_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_instruction_master_address : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_instruction_master_granted_cpu_0_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_0_instruction_master_granted_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_0_instruction_master_read : IN STD_LOGIC;
                    signal cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_0_instruction_master_requests_cpu_0_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_0_instruction_master_requests_onchip_memory2_0_s1 : IN STD_LOGIC;
                    signal cpu_0_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_0_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_memory2_0_s1_end_xfer : IN STD_LOGIC;
                    signal onchip_memory2_0_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_0_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_instruction_master_latency_counter : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_instruction_master_readdatavalid : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_0_instruction_master_arbitrator;

component cpu_0 is 
           port (
                 -- inputs:
                    signal A_ci_multi_done : IN STD_LOGIC;
                    signal A_ci_multi_result : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal d_irq : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_readdatavalid : IN STD_LOGIC;
                    signal d_waitrequest : IN STD_LOGIC;
                    signal i_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_readdatavalid : IN STD_LOGIC;
                    signal i_waitrequest : IN STD_LOGIC;
                    signal jtag_debug_module_address : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal jtag_debug_module_begintransfer : IN STD_LOGIC;
                    signal jtag_debug_module_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal jtag_debug_module_debugaccess : IN STD_LOGIC;
                    signal jtag_debug_module_select : IN STD_LOGIC;
                    signal jtag_debug_module_write : IN STD_LOGIC;
                    signal jtag_debug_module_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal A_ci_multi_a : OUT STD_LOGIC_VECTOR (4 DOWNTO 0);
                    signal A_ci_multi_b : OUT STD_LOGIC_VECTOR (4 DOWNTO 0);
                    signal A_ci_multi_c : OUT STD_LOGIC_VECTOR (4 DOWNTO 0);
                    signal A_ci_multi_clk_en : OUT STD_LOGIC;
                    signal A_ci_multi_dataa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal A_ci_multi_datab : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal A_ci_multi_estatus : OUT STD_LOGIC;
                    signal A_ci_multi_ipending : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal A_ci_multi_n : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal A_ci_multi_readra : OUT STD_LOGIC;
                    signal A_ci_multi_readrb : OUT STD_LOGIC;
                    signal A_ci_multi_start : OUT STD_LOGIC;
                    signal A_ci_multi_status : OUT STD_LOGIC;
                    signal A_ci_multi_writerc : OUT STD_LOGIC;
                    signal d_address : OUT STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal d_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal d_read : OUT STD_LOGIC;
                    signal d_write : OUT STD_LOGIC;
                    signal d_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_address : OUT STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal i_read : OUT STD_LOGIC;
                    signal jtag_debug_module_debugaccess_to_roms : OUT STD_LOGIC;
                    signal jtag_debug_module_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_debug_module_resetrequest : OUT STD_LOGIC
                 );
end component cpu_0;

component cpu_0_fpoint_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_custom_instruction_master_multi_clk_en : IN STD_LOGIC;
                    signal cpu_0_custom_instruction_master_multi_dataa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_custom_instruction_master_multi_datab : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_custom_instruction_master_multi_n : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 : IN STD_LOGIC;
                    signal cpu_0_fpoint_s1_done : IN STD_LOGIC;
                    signal cpu_0_fpoint_s1_result : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_fpoint_s1_select : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_0_fpoint_s1_clk_en : OUT STD_LOGIC;
                    signal cpu_0_fpoint_s1_dataa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_fpoint_s1_datab : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_fpoint_s1_done_from_sa : OUT STD_LOGIC;
                    signal cpu_0_fpoint_s1_n : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_0_fpoint_s1_reset : OUT STD_LOGIC;
                    signal cpu_0_fpoint_s1_result_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_fpoint_s1_start : OUT STD_LOGIC
                 );
end component cpu_0_fpoint_s1_arbitrator;

component cpu_0_fpoint is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal clk_en : IN STD_LOGIC;
                    signal dataa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal datab : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal n : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal reset : IN STD_LOGIC;
                    signal start : IN STD_LOGIC;

                 -- outputs:
                    signal done : OUT STD_LOGIC;
                    signal result : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component cpu_0_fpoint;

component jtag_uart_0_avalon_jtag_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_0_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_irq : IN STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_0_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave : OUT STD_LOGIC;
                    signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_address : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                    signal jtag_uart_0_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component jtag_uart_0_avalon_jtag_slave_arbitrator;

component jtag_uart_0 is 
           port (
                 -- inputs:
                    signal av_address : IN STD_LOGIC;
                    signal av_chipselect : IN STD_LOGIC;
                    signal av_read_n : IN STD_LOGIC;
                    signal av_write_n : IN STD_LOGIC;
                    signal av_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal rst_n : IN STD_LOGIC;

                 -- outputs:
                    signal av_irq : OUT STD_LOGIC;
                    signal av_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal av_waitrequest : OUT STD_LOGIC;
                    signal dataavailable : OUT STD_LOGIC;
                    signal readyfordata : OUT STD_LOGIC
                 );
end component jtag_uart_0;

component onchip_memory2_0_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_0_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_instruction_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_instruction_master_read : IN STD_LOGIC;
                    signal onchip_memory2_0_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_0_data_master_granted_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_granted_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_instruction_master_requests_onchip_memory2_0_s1 : OUT STD_LOGIC;
                    signal d1_onchip_memory2_0_s1_end_xfer : OUT STD_LOGIC;
                    signal onchip_memory2_0_s1_address : OUT STD_LOGIC_VECTOR (12 DOWNTO 0);
                    signal onchip_memory2_0_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal onchip_memory2_0_s1_chipselect : OUT STD_LOGIC;
                    signal onchip_memory2_0_s1_clken : OUT STD_LOGIC;
                    signal onchip_memory2_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_memory2_0_s1_write : OUT STD_LOGIC;
                    signal onchip_memory2_0_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component onchip_memory2_0_s1_arbitrator;

component onchip_memory2_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (12 DOWNTO 0);
                    signal byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal clken : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component onchip_memory2_0;

component performance_counter_0_control_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal performance_counter_0_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_0_data_master_granted_performance_counter_0_control_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_performance_counter_0_control_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_performance_counter_0_control_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_performance_counter_0_control_slave : OUT STD_LOGIC;
                    signal d1_performance_counter_0_control_slave_end_xfer : OUT STD_LOGIC;
                    signal performance_counter_0_control_slave_address : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal performance_counter_0_control_slave_begintransfer : OUT STD_LOGIC;
                    signal performance_counter_0_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal performance_counter_0_control_slave_reset_n : OUT STD_LOGIC;
                    signal performance_counter_0_control_slave_write : OUT STD_LOGIC;
                    signal performance_counter_0_control_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component performance_counter_0_control_slave_arbitrator;

component performance_counter_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal begintransfer : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component performance_counter_0;

component sysid_control_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_0_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                    signal sysid_control_slave_address : OUT STD_LOGIC;
                    signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid_control_slave_arbitrator;

component sysid is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC;

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid;

component timer_0_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_0_data_master_address_to_slave : IN STD_LOGIC_VECTOR (16 DOWNTO 0);
                    signal cpu_0_data_master_latency_counter : IN STD_LOGIC;
                    signal cpu_0_data_master_read : IN STD_LOGIC;
                    signal cpu_0_data_master_write : IN STD_LOGIC;
                    signal cpu_0_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal timer_0_s1_irq : IN STD_LOGIC;
                    signal timer_0_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_0_data_master_granted_timer_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_qualified_request_timer_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_read_data_valid_timer_0_s1 : OUT STD_LOGIC;
                    signal cpu_0_data_master_requests_timer_0_s1 : OUT STD_LOGIC;
                    signal d1_timer_0_s1_end_xfer : OUT STD_LOGIC;
                    signal timer_0_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal timer_0_s1_chipselect : OUT STD_LOGIC;
                    signal timer_0_s1_irq_from_sa : OUT STD_LOGIC;
                    signal timer_0_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal timer_0_s1_reset_n : OUT STD_LOGIC;
                    signal timer_0_s1_write_n : OUT STD_LOGIC;
                    signal timer_0_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer_0_s1_arbitrator;

component timer_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer_0;

component niosii_reset_clk_domain_synch_module is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal data_in : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal data_out : OUT STD_LOGIC
                 );
end component niosii_reset_clk_domain_synch_module;

                signal BLUE_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal BLUE_s1_chipselect :  STD_LOGIC;
                signal BLUE_s1_readdata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal BLUE_s1_readdata_from_sa :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal BLUE_s1_reset_n :  STD_LOGIC;
                signal BLUE_s1_write_n :  STD_LOGIC;
                signal BLUE_s1_writedata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal CCD_XY_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal CCD_XY_s1_chipselect :  STD_LOGIC;
                signal CCD_XY_s1_irq :  STD_LOGIC;
                signal CCD_XY_s1_irq_from_sa :  STD_LOGIC;
                signal CCD_XY_s1_readdata :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal CCD_XY_s1_readdata_from_sa :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal CCD_XY_s1_reset_n :  STD_LOGIC;
                signal CCD_XY_s1_write_n :  STD_LOGIC;
                signal CCD_XY_s1_writedata :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal DVAL_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal DVAL_s1_chipselect :  STD_LOGIC;
                signal DVAL_s1_readdata :  STD_LOGIC;
                signal DVAL_s1_readdata_from_sa :  STD_LOGIC;
                signal DVAL_s1_reset_n :  STD_LOGIC;
                signal DVAL_s1_write_n :  STD_LOGIC;
                signal DVAL_s1_writedata :  STD_LOGIC;
                signal GREEN_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal GREEN_s1_chipselect :  STD_LOGIC;
                signal GREEN_s1_readdata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal GREEN_s1_readdata_from_sa :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal GREEN_s1_reset_n :  STD_LOGIC;
                signal GREEN_s1_write_n :  STD_LOGIC;
                signal GREEN_s1_writedata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATA_0_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal IN_mDATA_0_s1_chipselect :  STD_LOGIC;
                signal IN_mDATA_0_s1_readdata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATA_0_s1_readdata_from_sa :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATA_0_s1_reset_n :  STD_LOGIC;
                signal IN_mDATA_0_s1_write_n :  STD_LOGIC;
                signal IN_mDATA_0_s1_writedata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATA_1_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal IN_mDATA_1_s1_chipselect :  STD_LOGIC;
                signal IN_mDATA_1_s1_readdata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATA_1_s1_readdata_from_sa :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATA_1_s1_reset_n :  STD_LOGIC;
                signal IN_mDATA_1_s1_write_n :  STD_LOGIC;
                signal IN_mDATA_1_s1_writedata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATAd_0_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal IN_mDATAd_0_s1_chipselect :  STD_LOGIC;
                signal IN_mDATAd_0_s1_readdata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATAd_0_s1_readdata_from_sa :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATAd_0_s1_reset_n :  STD_LOGIC;
                signal IN_mDATAd_0_s1_write_n :  STD_LOGIC;
                signal IN_mDATAd_0_s1_writedata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATAd_1_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal IN_mDATAd_1_s1_chipselect :  STD_LOGIC;
                signal IN_mDATAd_1_s1_readdata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATAd_1_s1_readdata_from_sa :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal IN_mDATAd_1_s1_reset_n :  STD_LOGIC;
                signal IN_mDATAd_1_s1_write_n :  STD_LOGIC;
                signal IN_mDATAd_1_s1_writedata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal LCD_0_control_slave_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal LCD_0_control_slave_begintransfer :  STD_LOGIC;
                signal LCD_0_control_slave_read :  STD_LOGIC;
                signal LCD_0_control_slave_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LCD_0_control_slave_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LCD_0_control_slave_wait_counter_eq_0 :  STD_LOGIC;
                signal LCD_0_control_slave_write :  STD_LOGIC;
                signal LCD_0_control_slave_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LEDs_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal LEDs_s1_chipselect :  STD_LOGIC;
                signal LEDs_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LEDs_s1_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LEDs_s1_reset_n :  STD_LOGIC;
                signal LEDs_s1_write_n :  STD_LOGIC;
                signal LEDs_s1_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal LUT_DATA_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal LUT_DATA_s1_chipselect :  STD_LOGIC;
                signal LUT_DATA_s1_readdata :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal LUT_DATA_s1_readdata_from_sa :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal LUT_DATA_s1_reset_n :  STD_LOGIC;
                signal LUT_DATA_s1_write_n :  STD_LOGIC;
                signal LUT_DATA_s1_writedata :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal LUT_INDEX_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal LUT_INDEX_s1_chipselect :  STD_LOGIC;
                signal LUT_INDEX_s1_irq :  STD_LOGIC;
                signal LUT_INDEX_s1_irq_from_sa :  STD_LOGIC;
                signal LUT_INDEX_s1_readdata :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal LUT_INDEX_s1_readdata_from_sa :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal LUT_INDEX_s1_reset_n :  STD_LOGIC;
                signal LUT_INDEX_s1_write_n :  STD_LOGIC;
                signal LUT_INDEX_s1_writedata :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal PIX_VALCLK_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal PIX_VALCLK_s1_chipselect :  STD_LOGIC;
                signal PIX_VALCLK_s1_irq :  STD_LOGIC;
                signal PIX_VALCLK_s1_irq_from_sa :  STD_LOGIC;
                signal PIX_VALCLK_s1_readdata :  STD_LOGIC;
                signal PIX_VALCLK_s1_readdata_from_sa :  STD_LOGIC;
                signal PIX_VALCLK_s1_reset_n :  STD_LOGIC;
                signal PIX_VALCLK_s1_write_n :  STD_LOGIC;
                signal PIX_VALCLK_s1_writedata :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal RAW2RGB_CONTROL_OUT_s1_chipselect :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_readdata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal RAW2RGB_CONTROL_OUT_s1_readdata_from_sa :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal RAW2RGB_CONTROL_OUT_s1_reset_n :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_write_n :  STD_LOGIC;
                signal RAW2RGB_CONTROL_OUT_s1_writedata :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal RED_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal RED_s1_chipselect :  STD_LOGIC;
                signal RED_s1_readdata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal RED_s1_readdata_from_sa :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal RED_s1_reset_n :  STD_LOGIC;
                signal RED_s1_write_n :  STD_LOGIC;
                signal RED_s1_writedata :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal RESET_OUT_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal RESET_OUT_s1_chipselect :  STD_LOGIC;
                signal RESET_OUT_s1_readdata :  STD_LOGIC;
                signal RESET_OUT_s1_readdata_from_sa :  STD_LOGIC;
                signal RESET_OUT_s1_reset_n :  STD_LOGIC;
                signal RESET_OUT_s1_write_n :  STD_LOGIC;
                signal RESET_OUT_s1_writedata :  STD_LOGIC;
                signal SWint2_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal SWint2_s1_chipselect :  STD_LOGIC;
                signal SWint2_s1_irq :  STD_LOGIC;
                signal SWint2_s1_irq_from_sa :  STD_LOGIC;
                signal SWint2_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal SWint2_s1_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal SWint2_s1_reset_n :  STD_LOGIC;
                signal SWint2_s1_write_n :  STD_LOGIC;
                signal SWint2_s1_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal SWint_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal SWint_s1_chipselect :  STD_LOGIC;
                signal SWint_s1_irq :  STD_LOGIC;
                signal SWint_s1_irq_from_sa :  STD_LOGIC;
                signal SWint_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal SWint_s1_readdata_from_sa :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal SWint_s1_reset_n :  STD_LOGIC;
                signal SWint_s1_write_n :  STD_LOGIC;
                signal SWint_s1_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal clk_reset_n :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_a :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_b :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_c :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_clk_en :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_dataa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_datab :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_done :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_estatus :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_ipending :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_n :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_readra :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_readrb :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_result :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_start :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_status :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_writerc :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_reset_n :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 :  STD_LOGIC;
                signal cpu_0_data_master_address :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal cpu_0_data_master_address_to_slave :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal cpu_0_data_master_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_0_data_master_debugaccess :  STD_LOGIC;
                signal cpu_0_data_master_granted_BLUE_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_CCD_XY_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_DVAL_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_GREEN_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_IN_mDATA_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_IN_mDATA_1_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_IN_mDATAd_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_IN_mDATAd_1_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_LCD_0_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_granted_LEDs_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_LUT_DATA_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_LUT_INDEX_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_PIX_VALCLK_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_RED_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_RESET_OUT_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_SWint2_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_SWint_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_0_data_master_granted_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_granted_performance_counter_0_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_granted_timer_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_irq :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_data_master_latency_counter :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_BLUE_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_CCD_XY_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_DVAL_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_GREEN_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_IN_mDATA_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_IN_mDATA_1_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_LCD_0_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_LEDs_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_LUT_DATA_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_LUT_INDEX_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_PIX_VALCLK_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_RED_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_RESET_OUT_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_SWint2_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_SWint_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_performance_counter_0_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_qualified_request_timer_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_BLUE_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_CCD_XY_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_DVAL_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_GREEN_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_IN_mDATA_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_IN_mDATA_1_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_LCD_0_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_LEDs_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_LUT_DATA_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_LUT_INDEX_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_PIX_VALCLK_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_RED_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_RESET_OUT_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_SWint2_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_SWint_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_performance_counter_0_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_sysid_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_read_data_valid_timer_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_data_master_readdatavalid :  STD_LOGIC;
                signal cpu_0_data_master_requests_BLUE_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_CCD_XY_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_DVAL_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_GREEN_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_IN_mDATA_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_IN_mDATA_1_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_IN_mDATAd_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_IN_mDATAd_1_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_LCD_0_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_requests_LEDs_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_LUT_DATA_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_LUT_INDEX_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_PIX_VALCLK_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_RED_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_RESET_OUT_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_SWint2_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_SWint_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_0_data_master_requests_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_requests_performance_counter_0_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal cpu_0_data_master_requests_timer_0_s1 :  STD_LOGIC;
                signal cpu_0_data_master_waitrequest :  STD_LOGIC;
                signal cpu_0_data_master_write :  STD_LOGIC;
                signal cpu_0_data_master_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_fpoint_s1_clk_en :  STD_LOGIC;
                signal cpu_0_fpoint_s1_dataa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_fpoint_s1_datab :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_fpoint_s1_done :  STD_LOGIC;
                signal cpu_0_fpoint_s1_done_from_sa :  STD_LOGIC;
                signal cpu_0_fpoint_s1_n :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_0_fpoint_s1_reset :  STD_LOGIC;
                signal cpu_0_fpoint_s1_result :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_fpoint_s1_result_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_fpoint_s1_select :  STD_LOGIC;
                signal cpu_0_fpoint_s1_start :  STD_LOGIC;
                signal cpu_0_instruction_master_address :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal cpu_0_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (16 DOWNTO 0);
                signal cpu_0_instruction_master_granted_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_instruction_master_granted_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_0_instruction_master_latency_counter :  STD_LOGIC;
                signal cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_0_instruction_master_read :  STD_LOGIC;
                signal cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_0_instruction_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_instruction_master_readdatavalid :  STD_LOGIC;
                signal cpu_0_instruction_master_requests_cpu_0_jtag_debug_module :  STD_LOGIC;
                signal cpu_0_instruction_master_requests_onchip_memory2_0_s1 :  STD_LOGIC;
                signal cpu_0_instruction_master_waitrequest :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_address :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal cpu_0_jtag_debug_module_begintransfer :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_0_jtag_debug_module_chipselect :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_debugaccess :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_jtag_debug_module_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_jtag_debug_module_resetrequest :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_resetrequest_from_sa :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_write :  STD_LOGIC;
                signal cpu_0_jtag_debug_module_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal d1_BLUE_s1_end_xfer :  STD_LOGIC;
                signal d1_CCD_XY_s1_end_xfer :  STD_LOGIC;
                signal d1_DVAL_s1_end_xfer :  STD_LOGIC;
                signal d1_GREEN_s1_end_xfer :  STD_LOGIC;
                signal d1_IN_mDATA_0_s1_end_xfer :  STD_LOGIC;
                signal d1_IN_mDATA_1_s1_end_xfer :  STD_LOGIC;
                signal d1_IN_mDATAd_0_s1_end_xfer :  STD_LOGIC;
                signal d1_IN_mDATAd_1_s1_end_xfer :  STD_LOGIC;
                signal d1_LCD_0_control_slave_end_xfer :  STD_LOGIC;
                signal d1_LEDs_s1_end_xfer :  STD_LOGIC;
                signal d1_LUT_DATA_s1_end_xfer :  STD_LOGIC;
                signal d1_LUT_INDEX_s1_end_xfer :  STD_LOGIC;
                signal d1_PIX_VALCLK_s1_end_xfer :  STD_LOGIC;
                signal d1_RAW2RGB_CONTROL_OUT_s1_end_xfer :  STD_LOGIC;
                signal d1_RED_s1_end_xfer :  STD_LOGIC;
                signal d1_RESET_OUT_s1_end_xfer :  STD_LOGIC;
                signal d1_SWint2_s1_end_xfer :  STD_LOGIC;
                signal d1_SWint_s1_end_xfer :  STD_LOGIC;
                signal d1_cpu_0_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal d1_jtag_uart_0_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal d1_onchip_memory2_0_s1_end_xfer :  STD_LOGIC;
                signal d1_performance_counter_0_control_slave_end_xfer :  STD_LOGIC;
                signal d1_sysid_control_slave_end_xfer :  STD_LOGIC;
                signal d1_timer_0_s1_end_xfer :  STD_LOGIC;
                signal internal_LCD_E_from_the_LCD_0 :  STD_LOGIC;
                signal internal_LCD_RS_from_the_LCD_0 :  STD_LOGIC;
                signal internal_LCD_RW_from_the_LCD_0 :  STD_LOGIC;
                signal internal_out_port_from_the_BLUE :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal internal_out_port_from_the_DVAL :  STD_LOGIC;
                signal internal_out_port_from_the_GREEN :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal internal_out_port_from_the_LEDs :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_out_port_from_the_LUT_DATA :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal internal_out_port_from_the_RAW2RGB_CONTROL_OUT :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_out_port_from_the_RED :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal internal_out_port_from_the_RESET_OUT :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_address :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_chipselect :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_dataavailable :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_irq :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_irq_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_read_n :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_uart_0_avalon_jtag_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_uart_0_avalon_jtag_slave_readyfordata :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_reset_n :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_waitrequest :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_write_n :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal module_input :  STD_LOGIC;
                signal onchip_memory2_0_s1_address :  STD_LOGIC_VECTOR (12 DOWNTO 0);
                signal onchip_memory2_0_s1_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_memory2_0_s1_chipselect :  STD_LOGIC;
                signal onchip_memory2_0_s1_clken :  STD_LOGIC;
                signal onchip_memory2_0_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_memory2_0_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_memory2_0_s1_write :  STD_LOGIC;
                signal onchip_memory2_0_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal performance_counter_0_control_slave_address :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal performance_counter_0_control_slave_begintransfer :  STD_LOGIC;
                signal performance_counter_0_control_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal performance_counter_0_control_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal performance_counter_0_control_slave_reset_n :  STD_LOGIC;
                signal performance_counter_0_control_slave_write :  STD_LOGIC;
                signal performance_counter_0_control_slave_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal reset_n_sources :  STD_LOGIC;
                signal sysid_control_slave_address :  STD_LOGIC;
                signal sysid_control_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal sysid_control_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal timer_0_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer_0_s1_chipselect :  STD_LOGIC;
                signal timer_0_s1_irq :  STD_LOGIC;
                signal timer_0_s1_irq_from_sa :  STD_LOGIC;
                signal timer_0_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal timer_0_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal timer_0_s1_reset_n :  STD_LOGIC;
                signal timer_0_s1_write_n :  STD_LOGIC;
                signal timer_0_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);

begin

  --the_BLUE_s1, which is an e_instance
  the_BLUE_s1 : BLUE_s1_arbitrator
    port map(
      BLUE_s1_address => BLUE_s1_address,
      BLUE_s1_chipselect => BLUE_s1_chipselect,
      BLUE_s1_readdata_from_sa => BLUE_s1_readdata_from_sa,
      BLUE_s1_reset_n => BLUE_s1_reset_n,
      BLUE_s1_write_n => BLUE_s1_write_n,
      BLUE_s1_writedata => BLUE_s1_writedata,
      cpu_0_data_master_granted_BLUE_s1 => cpu_0_data_master_granted_BLUE_s1,
      cpu_0_data_master_qualified_request_BLUE_s1 => cpu_0_data_master_qualified_request_BLUE_s1,
      cpu_0_data_master_read_data_valid_BLUE_s1 => cpu_0_data_master_read_data_valid_BLUE_s1,
      cpu_0_data_master_requests_BLUE_s1 => cpu_0_data_master_requests_BLUE_s1,
      d1_BLUE_s1_end_xfer => d1_BLUE_s1_end_xfer,
      BLUE_s1_readdata => BLUE_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_BLUE, which is an e_ptf_instance
  the_BLUE : BLUE
    port map(
      out_port => internal_out_port_from_the_BLUE,
      readdata => BLUE_s1_readdata,
      address => BLUE_s1_address,
      chipselect => BLUE_s1_chipselect,
      clk => clk,
      reset_n => BLUE_s1_reset_n,
      write_n => BLUE_s1_write_n,
      writedata => BLUE_s1_writedata
    );


  --the_CCD_XY_s1, which is an e_instance
  the_CCD_XY_s1 : CCD_XY_s1_arbitrator
    port map(
      CCD_XY_s1_address => CCD_XY_s1_address,
      CCD_XY_s1_chipselect => CCD_XY_s1_chipselect,
      CCD_XY_s1_irq_from_sa => CCD_XY_s1_irq_from_sa,
      CCD_XY_s1_readdata_from_sa => CCD_XY_s1_readdata_from_sa,
      CCD_XY_s1_reset_n => CCD_XY_s1_reset_n,
      CCD_XY_s1_write_n => CCD_XY_s1_write_n,
      CCD_XY_s1_writedata => CCD_XY_s1_writedata,
      cpu_0_data_master_granted_CCD_XY_s1 => cpu_0_data_master_granted_CCD_XY_s1,
      cpu_0_data_master_qualified_request_CCD_XY_s1 => cpu_0_data_master_qualified_request_CCD_XY_s1,
      cpu_0_data_master_read_data_valid_CCD_XY_s1 => cpu_0_data_master_read_data_valid_CCD_XY_s1,
      cpu_0_data_master_requests_CCD_XY_s1 => cpu_0_data_master_requests_CCD_XY_s1,
      d1_CCD_XY_s1_end_xfer => d1_CCD_XY_s1_end_xfer,
      CCD_XY_s1_irq => CCD_XY_s1_irq,
      CCD_XY_s1_readdata => CCD_XY_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_CCD_XY, which is an e_ptf_instance
  the_CCD_XY : CCD_XY
    port map(
      irq => CCD_XY_s1_irq,
      readdata => CCD_XY_s1_readdata,
      address => CCD_XY_s1_address,
      chipselect => CCD_XY_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_CCD_XY,
      reset_n => CCD_XY_s1_reset_n,
      write_n => CCD_XY_s1_write_n,
      writedata => CCD_XY_s1_writedata
    );


  --the_DVAL_s1, which is an e_instance
  the_DVAL_s1 : DVAL_s1_arbitrator
    port map(
      DVAL_s1_address => DVAL_s1_address,
      DVAL_s1_chipselect => DVAL_s1_chipselect,
      DVAL_s1_readdata_from_sa => DVAL_s1_readdata_from_sa,
      DVAL_s1_reset_n => DVAL_s1_reset_n,
      DVAL_s1_write_n => DVAL_s1_write_n,
      DVAL_s1_writedata => DVAL_s1_writedata,
      cpu_0_data_master_granted_DVAL_s1 => cpu_0_data_master_granted_DVAL_s1,
      cpu_0_data_master_qualified_request_DVAL_s1 => cpu_0_data_master_qualified_request_DVAL_s1,
      cpu_0_data_master_read_data_valid_DVAL_s1 => cpu_0_data_master_read_data_valid_DVAL_s1,
      cpu_0_data_master_requests_DVAL_s1 => cpu_0_data_master_requests_DVAL_s1,
      d1_DVAL_s1_end_xfer => d1_DVAL_s1_end_xfer,
      DVAL_s1_readdata => DVAL_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_DVAL, which is an e_ptf_instance
  the_DVAL : DVAL
    port map(
      out_port => internal_out_port_from_the_DVAL,
      readdata => DVAL_s1_readdata,
      address => DVAL_s1_address,
      chipselect => DVAL_s1_chipselect,
      clk => clk,
      reset_n => DVAL_s1_reset_n,
      write_n => DVAL_s1_write_n,
      writedata => DVAL_s1_writedata
    );


  --the_GREEN_s1, which is an e_instance
  the_GREEN_s1 : GREEN_s1_arbitrator
    port map(
      GREEN_s1_address => GREEN_s1_address,
      GREEN_s1_chipselect => GREEN_s1_chipselect,
      GREEN_s1_readdata_from_sa => GREEN_s1_readdata_from_sa,
      GREEN_s1_reset_n => GREEN_s1_reset_n,
      GREEN_s1_write_n => GREEN_s1_write_n,
      GREEN_s1_writedata => GREEN_s1_writedata,
      cpu_0_data_master_granted_GREEN_s1 => cpu_0_data_master_granted_GREEN_s1,
      cpu_0_data_master_qualified_request_GREEN_s1 => cpu_0_data_master_qualified_request_GREEN_s1,
      cpu_0_data_master_read_data_valid_GREEN_s1 => cpu_0_data_master_read_data_valid_GREEN_s1,
      cpu_0_data_master_requests_GREEN_s1 => cpu_0_data_master_requests_GREEN_s1,
      d1_GREEN_s1_end_xfer => d1_GREEN_s1_end_xfer,
      GREEN_s1_readdata => GREEN_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_GREEN, which is an e_ptf_instance
  the_GREEN : GREEN
    port map(
      out_port => internal_out_port_from_the_GREEN,
      readdata => GREEN_s1_readdata,
      address => GREEN_s1_address,
      chipselect => GREEN_s1_chipselect,
      clk => clk,
      reset_n => GREEN_s1_reset_n,
      write_n => GREEN_s1_write_n,
      writedata => GREEN_s1_writedata
    );


  --the_IN_mDATA_0_s1, which is an e_instance
  the_IN_mDATA_0_s1 : IN_mDATA_0_s1_arbitrator
    port map(
      IN_mDATA_0_s1_address => IN_mDATA_0_s1_address,
      IN_mDATA_0_s1_chipselect => IN_mDATA_0_s1_chipselect,
      IN_mDATA_0_s1_readdata_from_sa => IN_mDATA_0_s1_readdata_from_sa,
      IN_mDATA_0_s1_reset_n => IN_mDATA_0_s1_reset_n,
      IN_mDATA_0_s1_write_n => IN_mDATA_0_s1_write_n,
      IN_mDATA_0_s1_writedata => IN_mDATA_0_s1_writedata,
      cpu_0_data_master_granted_IN_mDATA_0_s1 => cpu_0_data_master_granted_IN_mDATA_0_s1,
      cpu_0_data_master_qualified_request_IN_mDATA_0_s1 => cpu_0_data_master_qualified_request_IN_mDATA_0_s1,
      cpu_0_data_master_read_data_valid_IN_mDATA_0_s1 => cpu_0_data_master_read_data_valid_IN_mDATA_0_s1,
      cpu_0_data_master_requests_IN_mDATA_0_s1 => cpu_0_data_master_requests_IN_mDATA_0_s1,
      d1_IN_mDATA_0_s1_end_xfer => d1_IN_mDATA_0_s1_end_xfer,
      IN_mDATA_0_s1_readdata => IN_mDATA_0_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_IN_mDATA_0, which is an e_ptf_instance
  the_IN_mDATA_0 : IN_mDATA_0
    port map(
      readdata => IN_mDATA_0_s1_readdata,
      address => IN_mDATA_0_s1_address,
      chipselect => IN_mDATA_0_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_IN_mDATA_0,
      reset_n => IN_mDATA_0_s1_reset_n,
      write_n => IN_mDATA_0_s1_write_n,
      writedata => IN_mDATA_0_s1_writedata
    );


  --the_IN_mDATA_1_s1, which is an e_instance
  the_IN_mDATA_1_s1 : IN_mDATA_1_s1_arbitrator
    port map(
      IN_mDATA_1_s1_address => IN_mDATA_1_s1_address,
      IN_mDATA_1_s1_chipselect => IN_mDATA_1_s1_chipselect,
      IN_mDATA_1_s1_readdata_from_sa => IN_mDATA_1_s1_readdata_from_sa,
      IN_mDATA_1_s1_reset_n => IN_mDATA_1_s1_reset_n,
      IN_mDATA_1_s1_write_n => IN_mDATA_1_s1_write_n,
      IN_mDATA_1_s1_writedata => IN_mDATA_1_s1_writedata,
      cpu_0_data_master_granted_IN_mDATA_1_s1 => cpu_0_data_master_granted_IN_mDATA_1_s1,
      cpu_0_data_master_qualified_request_IN_mDATA_1_s1 => cpu_0_data_master_qualified_request_IN_mDATA_1_s1,
      cpu_0_data_master_read_data_valid_IN_mDATA_1_s1 => cpu_0_data_master_read_data_valid_IN_mDATA_1_s1,
      cpu_0_data_master_requests_IN_mDATA_1_s1 => cpu_0_data_master_requests_IN_mDATA_1_s1,
      d1_IN_mDATA_1_s1_end_xfer => d1_IN_mDATA_1_s1_end_xfer,
      IN_mDATA_1_s1_readdata => IN_mDATA_1_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_IN_mDATA_1, which is an e_ptf_instance
  the_IN_mDATA_1 : IN_mDATA_1
    port map(
      readdata => IN_mDATA_1_s1_readdata,
      address => IN_mDATA_1_s1_address,
      chipselect => IN_mDATA_1_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_IN_mDATA_1,
      reset_n => IN_mDATA_1_s1_reset_n,
      write_n => IN_mDATA_1_s1_write_n,
      writedata => IN_mDATA_1_s1_writedata
    );


  --the_IN_mDATAd_0_s1, which is an e_instance
  the_IN_mDATAd_0_s1 : IN_mDATAd_0_s1_arbitrator
    port map(
      IN_mDATAd_0_s1_address => IN_mDATAd_0_s1_address,
      IN_mDATAd_0_s1_chipselect => IN_mDATAd_0_s1_chipselect,
      IN_mDATAd_0_s1_readdata_from_sa => IN_mDATAd_0_s1_readdata_from_sa,
      IN_mDATAd_0_s1_reset_n => IN_mDATAd_0_s1_reset_n,
      IN_mDATAd_0_s1_write_n => IN_mDATAd_0_s1_write_n,
      IN_mDATAd_0_s1_writedata => IN_mDATAd_0_s1_writedata,
      cpu_0_data_master_granted_IN_mDATAd_0_s1 => cpu_0_data_master_granted_IN_mDATAd_0_s1,
      cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 => cpu_0_data_master_qualified_request_IN_mDATAd_0_s1,
      cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1 => cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1,
      cpu_0_data_master_requests_IN_mDATAd_0_s1 => cpu_0_data_master_requests_IN_mDATAd_0_s1,
      d1_IN_mDATAd_0_s1_end_xfer => d1_IN_mDATAd_0_s1_end_xfer,
      IN_mDATAd_0_s1_readdata => IN_mDATAd_0_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_IN_mDATAd_0, which is an e_ptf_instance
  the_IN_mDATAd_0 : IN_mDATAd_0
    port map(
      readdata => IN_mDATAd_0_s1_readdata,
      address => IN_mDATAd_0_s1_address,
      chipselect => IN_mDATAd_0_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_IN_mDATAd_0,
      reset_n => IN_mDATAd_0_s1_reset_n,
      write_n => IN_mDATAd_0_s1_write_n,
      writedata => IN_mDATAd_0_s1_writedata
    );


  --the_IN_mDATAd_1_s1, which is an e_instance
  the_IN_mDATAd_1_s1 : IN_mDATAd_1_s1_arbitrator
    port map(
      IN_mDATAd_1_s1_address => IN_mDATAd_1_s1_address,
      IN_mDATAd_1_s1_chipselect => IN_mDATAd_1_s1_chipselect,
      IN_mDATAd_1_s1_readdata_from_sa => IN_mDATAd_1_s1_readdata_from_sa,
      IN_mDATAd_1_s1_reset_n => IN_mDATAd_1_s1_reset_n,
      IN_mDATAd_1_s1_write_n => IN_mDATAd_1_s1_write_n,
      IN_mDATAd_1_s1_writedata => IN_mDATAd_1_s1_writedata,
      cpu_0_data_master_granted_IN_mDATAd_1_s1 => cpu_0_data_master_granted_IN_mDATAd_1_s1,
      cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 => cpu_0_data_master_qualified_request_IN_mDATAd_1_s1,
      cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1 => cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1,
      cpu_0_data_master_requests_IN_mDATAd_1_s1 => cpu_0_data_master_requests_IN_mDATAd_1_s1,
      d1_IN_mDATAd_1_s1_end_xfer => d1_IN_mDATAd_1_s1_end_xfer,
      IN_mDATAd_1_s1_readdata => IN_mDATAd_1_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_IN_mDATAd_1, which is an e_ptf_instance
  the_IN_mDATAd_1 : IN_mDATAd_1
    port map(
      readdata => IN_mDATAd_1_s1_readdata,
      address => IN_mDATAd_1_s1_address,
      chipselect => IN_mDATAd_1_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_IN_mDATAd_1,
      reset_n => IN_mDATAd_1_s1_reset_n,
      write_n => IN_mDATAd_1_s1_write_n,
      writedata => IN_mDATAd_1_s1_writedata
    );


  --the_LCD_0_control_slave, which is an e_instance
  the_LCD_0_control_slave : LCD_0_control_slave_arbitrator
    port map(
      LCD_0_control_slave_address => LCD_0_control_slave_address,
      LCD_0_control_slave_begintransfer => LCD_0_control_slave_begintransfer,
      LCD_0_control_slave_read => LCD_0_control_slave_read,
      LCD_0_control_slave_readdata_from_sa => LCD_0_control_slave_readdata_from_sa,
      LCD_0_control_slave_wait_counter_eq_0 => LCD_0_control_slave_wait_counter_eq_0,
      LCD_0_control_slave_write => LCD_0_control_slave_write,
      LCD_0_control_slave_writedata => LCD_0_control_slave_writedata,
      cpu_0_data_master_granted_LCD_0_control_slave => cpu_0_data_master_granted_LCD_0_control_slave,
      cpu_0_data_master_qualified_request_LCD_0_control_slave => cpu_0_data_master_qualified_request_LCD_0_control_slave,
      cpu_0_data_master_read_data_valid_LCD_0_control_slave => cpu_0_data_master_read_data_valid_LCD_0_control_slave,
      cpu_0_data_master_requests_LCD_0_control_slave => cpu_0_data_master_requests_LCD_0_control_slave,
      d1_LCD_0_control_slave_end_xfer => d1_LCD_0_control_slave_end_xfer,
      LCD_0_control_slave_readdata => LCD_0_control_slave_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_byteenable => cpu_0_data_master_byteenable,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_LCD_0, which is an e_ptf_instance
  the_LCD_0 : LCD_0
    port map(
      LCD_E => internal_LCD_E_from_the_LCD_0,
      LCD_RS => internal_LCD_RS_from_the_LCD_0,
      LCD_RW => internal_LCD_RW_from_the_LCD_0,
      LCD_data => LCD_data_to_and_from_the_LCD_0,
      readdata => LCD_0_control_slave_readdata,
      address => LCD_0_control_slave_address,
      begintransfer => LCD_0_control_slave_begintransfer,
      read => LCD_0_control_slave_read,
      write => LCD_0_control_slave_write,
      writedata => LCD_0_control_slave_writedata
    );


  --the_LEDs_s1, which is an e_instance
  the_LEDs_s1 : LEDs_s1_arbitrator
    port map(
      LEDs_s1_address => LEDs_s1_address,
      LEDs_s1_chipselect => LEDs_s1_chipselect,
      LEDs_s1_readdata_from_sa => LEDs_s1_readdata_from_sa,
      LEDs_s1_reset_n => LEDs_s1_reset_n,
      LEDs_s1_write_n => LEDs_s1_write_n,
      LEDs_s1_writedata => LEDs_s1_writedata,
      cpu_0_data_master_granted_LEDs_s1 => cpu_0_data_master_granted_LEDs_s1,
      cpu_0_data_master_qualified_request_LEDs_s1 => cpu_0_data_master_qualified_request_LEDs_s1,
      cpu_0_data_master_read_data_valid_LEDs_s1 => cpu_0_data_master_read_data_valid_LEDs_s1,
      cpu_0_data_master_requests_LEDs_s1 => cpu_0_data_master_requests_LEDs_s1,
      d1_LEDs_s1_end_xfer => d1_LEDs_s1_end_xfer,
      LEDs_s1_readdata => LEDs_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_byteenable => cpu_0_data_master_byteenable,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_LEDs, which is an e_ptf_instance
  the_LEDs : LEDs
    port map(
      out_port => internal_out_port_from_the_LEDs,
      readdata => LEDs_s1_readdata,
      address => LEDs_s1_address,
      chipselect => LEDs_s1_chipselect,
      clk => clk,
      reset_n => LEDs_s1_reset_n,
      write_n => LEDs_s1_write_n,
      writedata => LEDs_s1_writedata
    );


  --the_LUT_DATA_s1, which is an e_instance
  the_LUT_DATA_s1 : LUT_DATA_s1_arbitrator
    port map(
      LUT_DATA_s1_address => LUT_DATA_s1_address,
      LUT_DATA_s1_chipselect => LUT_DATA_s1_chipselect,
      LUT_DATA_s1_readdata_from_sa => LUT_DATA_s1_readdata_from_sa,
      LUT_DATA_s1_reset_n => LUT_DATA_s1_reset_n,
      LUT_DATA_s1_write_n => LUT_DATA_s1_write_n,
      LUT_DATA_s1_writedata => LUT_DATA_s1_writedata,
      cpu_0_data_master_granted_LUT_DATA_s1 => cpu_0_data_master_granted_LUT_DATA_s1,
      cpu_0_data_master_qualified_request_LUT_DATA_s1 => cpu_0_data_master_qualified_request_LUT_DATA_s1,
      cpu_0_data_master_read_data_valid_LUT_DATA_s1 => cpu_0_data_master_read_data_valid_LUT_DATA_s1,
      cpu_0_data_master_requests_LUT_DATA_s1 => cpu_0_data_master_requests_LUT_DATA_s1,
      d1_LUT_DATA_s1_end_xfer => d1_LUT_DATA_s1_end_xfer,
      LUT_DATA_s1_readdata => LUT_DATA_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_LUT_DATA, which is an e_ptf_instance
  the_LUT_DATA : LUT_DATA
    port map(
      out_port => internal_out_port_from_the_LUT_DATA,
      readdata => LUT_DATA_s1_readdata,
      address => LUT_DATA_s1_address,
      chipselect => LUT_DATA_s1_chipselect,
      clk => clk,
      reset_n => LUT_DATA_s1_reset_n,
      write_n => LUT_DATA_s1_write_n,
      writedata => LUT_DATA_s1_writedata
    );


  --the_LUT_INDEX_s1, which is an e_instance
  the_LUT_INDEX_s1 : LUT_INDEX_s1_arbitrator
    port map(
      LUT_INDEX_s1_address => LUT_INDEX_s1_address,
      LUT_INDEX_s1_chipselect => LUT_INDEX_s1_chipselect,
      LUT_INDEX_s1_irq_from_sa => LUT_INDEX_s1_irq_from_sa,
      LUT_INDEX_s1_readdata_from_sa => LUT_INDEX_s1_readdata_from_sa,
      LUT_INDEX_s1_reset_n => LUT_INDEX_s1_reset_n,
      LUT_INDEX_s1_write_n => LUT_INDEX_s1_write_n,
      LUT_INDEX_s1_writedata => LUT_INDEX_s1_writedata,
      cpu_0_data_master_granted_LUT_INDEX_s1 => cpu_0_data_master_granted_LUT_INDEX_s1,
      cpu_0_data_master_qualified_request_LUT_INDEX_s1 => cpu_0_data_master_qualified_request_LUT_INDEX_s1,
      cpu_0_data_master_read_data_valid_LUT_INDEX_s1 => cpu_0_data_master_read_data_valid_LUT_INDEX_s1,
      cpu_0_data_master_requests_LUT_INDEX_s1 => cpu_0_data_master_requests_LUT_INDEX_s1,
      d1_LUT_INDEX_s1_end_xfer => d1_LUT_INDEX_s1_end_xfer,
      LUT_INDEX_s1_irq => LUT_INDEX_s1_irq,
      LUT_INDEX_s1_readdata => LUT_INDEX_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_LUT_INDEX, which is an e_ptf_instance
  the_LUT_INDEX : LUT_INDEX
    port map(
      irq => LUT_INDEX_s1_irq,
      readdata => LUT_INDEX_s1_readdata,
      address => LUT_INDEX_s1_address,
      chipselect => LUT_INDEX_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_LUT_INDEX,
      reset_n => LUT_INDEX_s1_reset_n,
      write_n => LUT_INDEX_s1_write_n,
      writedata => LUT_INDEX_s1_writedata
    );


  --the_PIX_VALCLK_s1, which is an e_instance
  the_PIX_VALCLK_s1 : PIX_VALCLK_s1_arbitrator
    port map(
      PIX_VALCLK_s1_address => PIX_VALCLK_s1_address,
      PIX_VALCLK_s1_chipselect => PIX_VALCLK_s1_chipselect,
      PIX_VALCLK_s1_irq_from_sa => PIX_VALCLK_s1_irq_from_sa,
      PIX_VALCLK_s1_readdata_from_sa => PIX_VALCLK_s1_readdata_from_sa,
      PIX_VALCLK_s1_reset_n => PIX_VALCLK_s1_reset_n,
      PIX_VALCLK_s1_write_n => PIX_VALCLK_s1_write_n,
      PIX_VALCLK_s1_writedata => PIX_VALCLK_s1_writedata,
      cpu_0_data_master_granted_PIX_VALCLK_s1 => cpu_0_data_master_granted_PIX_VALCLK_s1,
      cpu_0_data_master_qualified_request_PIX_VALCLK_s1 => cpu_0_data_master_qualified_request_PIX_VALCLK_s1,
      cpu_0_data_master_read_data_valid_PIX_VALCLK_s1 => cpu_0_data_master_read_data_valid_PIX_VALCLK_s1,
      cpu_0_data_master_requests_PIX_VALCLK_s1 => cpu_0_data_master_requests_PIX_VALCLK_s1,
      d1_PIX_VALCLK_s1_end_xfer => d1_PIX_VALCLK_s1_end_xfer,
      PIX_VALCLK_s1_irq => PIX_VALCLK_s1_irq,
      PIX_VALCLK_s1_readdata => PIX_VALCLK_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_PIX_VALCLK, which is an e_ptf_instance
  the_PIX_VALCLK : PIX_VALCLK
    port map(
      irq => PIX_VALCLK_s1_irq,
      readdata => PIX_VALCLK_s1_readdata,
      address => PIX_VALCLK_s1_address,
      chipselect => PIX_VALCLK_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_PIX_VALCLK,
      reset_n => PIX_VALCLK_s1_reset_n,
      write_n => PIX_VALCLK_s1_write_n,
      writedata => PIX_VALCLK_s1_writedata
    );


  --the_RAW2RGB_CONTROL_OUT_s1, which is an e_instance
  the_RAW2RGB_CONTROL_OUT_s1 : RAW2RGB_CONTROL_OUT_s1_arbitrator
    port map(
      RAW2RGB_CONTROL_OUT_s1_address => RAW2RGB_CONTROL_OUT_s1_address,
      RAW2RGB_CONTROL_OUT_s1_chipselect => RAW2RGB_CONTROL_OUT_s1_chipselect,
      RAW2RGB_CONTROL_OUT_s1_readdata_from_sa => RAW2RGB_CONTROL_OUT_s1_readdata_from_sa,
      RAW2RGB_CONTROL_OUT_s1_reset_n => RAW2RGB_CONTROL_OUT_s1_reset_n,
      RAW2RGB_CONTROL_OUT_s1_write_n => RAW2RGB_CONTROL_OUT_s1_write_n,
      RAW2RGB_CONTROL_OUT_s1_writedata => RAW2RGB_CONTROL_OUT_s1_writedata,
      cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 => cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1,
      cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 => cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1,
      cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1 => cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1,
      cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 => cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1,
      d1_RAW2RGB_CONTROL_OUT_s1_end_xfer => d1_RAW2RGB_CONTROL_OUT_s1_end_xfer,
      RAW2RGB_CONTROL_OUT_s1_readdata => RAW2RGB_CONTROL_OUT_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_RAW2RGB_CONTROL_OUT, which is an e_ptf_instance
  the_RAW2RGB_CONTROL_OUT : RAW2RGB_CONTROL_OUT
    port map(
      out_port => internal_out_port_from_the_RAW2RGB_CONTROL_OUT,
      readdata => RAW2RGB_CONTROL_OUT_s1_readdata,
      address => RAW2RGB_CONTROL_OUT_s1_address,
      chipselect => RAW2RGB_CONTROL_OUT_s1_chipselect,
      clk => clk,
      reset_n => RAW2RGB_CONTROL_OUT_s1_reset_n,
      write_n => RAW2RGB_CONTROL_OUT_s1_write_n,
      writedata => RAW2RGB_CONTROL_OUT_s1_writedata
    );


  --the_RED_s1, which is an e_instance
  the_RED_s1 : RED_s1_arbitrator
    port map(
      RED_s1_address => RED_s1_address,
      RED_s1_chipselect => RED_s1_chipselect,
      RED_s1_readdata_from_sa => RED_s1_readdata_from_sa,
      RED_s1_reset_n => RED_s1_reset_n,
      RED_s1_write_n => RED_s1_write_n,
      RED_s1_writedata => RED_s1_writedata,
      cpu_0_data_master_granted_RED_s1 => cpu_0_data_master_granted_RED_s1,
      cpu_0_data_master_qualified_request_RED_s1 => cpu_0_data_master_qualified_request_RED_s1,
      cpu_0_data_master_read_data_valid_RED_s1 => cpu_0_data_master_read_data_valid_RED_s1,
      cpu_0_data_master_requests_RED_s1 => cpu_0_data_master_requests_RED_s1,
      d1_RED_s1_end_xfer => d1_RED_s1_end_xfer,
      RED_s1_readdata => RED_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_RED, which is an e_ptf_instance
  the_RED : RED
    port map(
      out_port => internal_out_port_from_the_RED,
      readdata => RED_s1_readdata,
      address => RED_s1_address,
      chipselect => RED_s1_chipselect,
      clk => clk,
      reset_n => RED_s1_reset_n,
      write_n => RED_s1_write_n,
      writedata => RED_s1_writedata
    );


  --the_RESET_OUT_s1, which is an e_instance
  the_RESET_OUT_s1 : RESET_OUT_s1_arbitrator
    port map(
      RESET_OUT_s1_address => RESET_OUT_s1_address,
      RESET_OUT_s1_chipselect => RESET_OUT_s1_chipselect,
      RESET_OUT_s1_readdata_from_sa => RESET_OUT_s1_readdata_from_sa,
      RESET_OUT_s1_reset_n => RESET_OUT_s1_reset_n,
      RESET_OUT_s1_write_n => RESET_OUT_s1_write_n,
      RESET_OUT_s1_writedata => RESET_OUT_s1_writedata,
      cpu_0_data_master_granted_RESET_OUT_s1 => cpu_0_data_master_granted_RESET_OUT_s1,
      cpu_0_data_master_qualified_request_RESET_OUT_s1 => cpu_0_data_master_qualified_request_RESET_OUT_s1,
      cpu_0_data_master_read_data_valid_RESET_OUT_s1 => cpu_0_data_master_read_data_valid_RESET_OUT_s1,
      cpu_0_data_master_requests_RESET_OUT_s1 => cpu_0_data_master_requests_RESET_OUT_s1,
      d1_RESET_OUT_s1_end_xfer => d1_RESET_OUT_s1_end_xfer,
      RESET_OUT_s1_readdata => RESET_OUT_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_RESET_OUT, which is an e_ptf_instance
  the_RESET_OUT : RESET_OUT
    port map(
      out_port => internal_out_port_from_the_RESET_OUT,
      readdata => RESET_OUT_s1_readdata,
      address => RESET_OUT_s1_address,
      chipselect => RESET_OUT_s1_chipselect,
      clk => clk,
      reset_n => RESET_OUT_s1_reset_n,
      write_n => RESET_OUT_s1_write_n,
      writedata => RESET_OUT_s1_writedata
    );


  --the_SWint_s1, which is an e_instance
  the_SWint_s1 : SWint_s1_arbitrator
    port map(
      SWint_s1_address => SWint_s1_address,
      SWint_s1_chipselect => SWint_s1_chipselect,
      SWint_s1_irq_from_sa => SWint_s1_irq_from_sa,
      SWint_s1_readdata_from_sa => SWint_s1_readdata_from_sa,
      SWint_s1_reset_n => SWint_s1_reset_n,
      SWint_s1_write_n => SWint_s1_write_n,
      SWint_s1_writedata => SWint_s1_writedata,
      cpu_0_data_master_granted_SWint_s1 => cpu_0_data_master_granted_SWint_s1,
      cpu_0_data_master_qualified_request_SWint_s1 => cpu_0_data_master_qualified_request_SWint_s1,
      cpu_0_data_master_read_data_valid_SWint_s1 => cpu_0_data_master_read_data_valid_SWint_s1,
      cpu_0_data_master_requests_SWint_s1 => cpu_0_data_master_requests_SWint_s1,
      d1_SWint_s1_end_xfer => d1_SWint_s1_end_xfer,
      SWint_s1_irq => SWint_s1_irq,
      SWint_s1_readdata => SWint_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_byteenable => cpu_0_data_master_byteenable,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_SWint, which is an e_ptf_instance
  the_SWint : SWint
    port map(
      irq => SWint_s1_irq,
      readdata => SWint_s1_readdata,
      address => SWint_s1_address,
      chipselect => SWint_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_SWint,
      reset_n => SWint_s1_reset_n,
      write_n => SWint_s1_write_n,
      writedata => SWint_s1_writedata
    );


  --the_SWint2_s1, which is an e_instance
  the_SWint2_s1 : SWint2_s1_arbitrator
    port map(
      SWint2_s1_address => SWint2_s1_address,
      SWint2_s1_chipselect => SWint2_s1_chipselect,
      SWint2_s1_irq_from_sa => SWint2_s1_irq_from_sa,
      SWint2_s1_readdata_from_sa => SWint2_s1_readdata_from_sa,
      SWint2_s1_reset_n => SWint2_s1_reset_n,
      SWint2_s1_write_n => SWint2_s1_write_n,
      SWint2_s1_writedata => SWint2_s1_writedata,
      cpu_0_data_master_granted_SWint2_s1 => cpu_0_data_master_granted_SWint2_s1,
      cpu_0_data_master_qualified_request_SWint2_s1 => cpu_0_data_master_qualified_request_SWint2_s1,
      cpu_0_data_master_read_data_valid_SWint2_s1 => cpu_0_data_master_read_data_valid_SWint2_s1,
      cpu_0_data_master_requests_SWint2_s1 => cpu_0_data_master_requests_SWint2_s1,
      d1_SWint2_s1_end_xfer => d1_SWint2_s1_end_xfer,
      SWint2_s1_irq => SWint2_s1_irq,
      SWint2_s1_readdata => SWint2_s1_readdata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_byteenable => cpu_0_data_master_byteenable,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_SWint2, which is an e_ptf_instance
  the_SWint2 : SWint2
    port map(
      irq => SWint2_s1_irq,
      readdata => SWint2_s1_readdata,
      address => SWint2_s1_address,
      chipselect => SWint2_s1_chipselect,
      clk => clk,
      in_port => in_port_to_the_SWint2,
      reset_n => SWint2_s1_reset_n,
      write_n => SWint2_s1_write_n,
      writedata => SWint2_s1_writedata
    );


  --the_cpu_0_jtag_debug_module, which is an e_instance
  the_cpu_0_jtag_debug_module : cpu_0_jtag_debug_module_arbitrator
    port map(
      cpu_0_data_master_granted_cpu_0_jtag_debug_module => cpu_0_data_master_granted_cpu_0_jtag_debug_module,
      cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module => cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module,
      cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module => cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module,
      cpu_0_data_master_requests_cpu_0_jtag_debug_module => cpu_0_data_master_requests_cpu_0_jtag_debug_module,
      cpu_0_instruction_master_granted_cpu_0_jtag_debug_module => cpu_0_instruction_master_granted_cpu_0_jtag_debug_module,
      cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module => cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module,
      cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module => cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module,
      cpu_0_instruction_master_requests_cpu_0_jtag_debug_module => cpu_0_instruction_master_requests_cpu_0_jtag_debug_module,
      cpu_0_jtag_debug_module_address => cpu_0_jtag_debug_module_address,
      cpu_0_jtag_debug_module_begintransfer => cpu_0_jtag_debug_module_begintransfer,
      cpu_0_jtag_debug_module_byteenable => cpu_0_jtag_debug_module_byteenable,
      cpu_0_jtag_debug_module_chipselect => cpu_0_jtag_debug_module_chipselect,
      cpu_0_jtag_debug_module_debugaccess => cpu_0_jtag_debug_module_debugaccess,
      cpu_0_jtag_debug_module_readdata_from_sa => cpu_0_jtag_debug_module_readdata_from_sa,
      cpu_0_jtag_debug_module_resetrequest_from_sa => cpu_0_jtag_debug_module_resetrequest_from_sa,
      cpu_0_jtag_debug_module_write => cpu_0_jtag_debug_module_write,
      cpu_0_jtag_debug_module_writedata => cpu_0_jtag_debug_module_writedata,
      d1_cpu_0_jtag_debug_module_end_xfer => d1_cpu_0_jtag_debug_module_end_xfer,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_byteenable => cpu_0_data_master_byteenable,
      cpu_0_data_master_debugaccess => cpu_0_data_master_debugaccess,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      cpu_0_instruction_master_address_to_slave => cpu_0_instruction_master_address_to_slave,
      cpu_0_instruction_master_latency_counter => cpu_0_instruction_master_latency_counter,
      cpu_0_instruction_master_read => cpu_0_instruction_master_read,
      cpu_0_jtag_debug_module_readdata => cpu_0_jtag_debug_module_readdata,
      cpu_0_jtag_debug_module_resetrequest => cpu_0_jtag_debug_module_resetrequest,
      reset_n => clk_reset_n
    );


  --the_cpu_0_custom_instruction_master, which is an e_instance
  the_cpu_0_custom_instruction_master : cpu_0_custom_instruction_master_arbitrator
    port map(
      cpu_0_custom_instruction_master_multi_done => cpu_0_custom_instruction_master_multi_done,
      cpu_0_custom_instruction_master_multi_result => cpu_0_custom_instruction_master_multi_result,
      cpu_0_custom_instruction_master_reset_n => cpu_0_custom_instruction_master_reset_n,
      cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 => cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1,
      cpu_0_fpoint_s1_select => cpu_0_fpoint_s1_select,
      clk => clk,
      cpu_0_custom_instruction_master_multi_start => cpu_0_custom_instruction_master_multi_start,
      cpu_0_fpoint_s1_done_from_sa => cpu_0_fpoint_s1_done_from_sa,
      cpu_0_fpoint_s1_result_from_sa => cpu_0_fpoint_s1_result_from_sa,
      reset_n => clk_reset_n
    );


  --the_cpu_0_data_master, which is an e_instance
  the_cpu_0_data_master : cpu_0_data_master_arbitrator
    port map(
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_irq => cpu_0_data_master_irq,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_readdata => cpu_0_data_master_readdata,
      cpu_0_data_master_readdatavalid => cpu_0_data_master_readdatavalid,
      cpu_0_data_master_waitrequest => cpu_0_data_master_waitrequest,
      BLUE_s1_readdata_from_sa => BLUE_s1_readdata_from_sa,
      CCD_XY_s1_irq_from_sa => CCD_XY_s1_irq_from_sa,
      CCD_XY_s1_readdata_from_sa => CCD_XY_s1_readdata_from_sa,
      DVAL_s1_readdata_from_sa => DVAL_s1_readdata_from_sa,
      GREEN_s1_readdata_from_sa => GREEN_s1_readdata_from_sa,
      IN_mDATA_0_s1_readdata_from_sa => IN_mDATA_0_s1_readdata_from_sa,
      IN_mDATA_1_s1_readdata_from_sa => IN_mDATA_1_s1_readdata_from_sa,
      IN_mDATAd_0_s1_readdata_from_sa => IN_mDATAd_0_s1_readdata_from_sa,
      IN_mDATAd_1_s1_readdata_from_sa => IN_mDATAd_1_s1_readdata_from_sa,
      LCD_0_control_slave_readdata_from_sa => LCD_0_control_slave_readdata_from_sa,
      LCD_0_control_slave_wait_counter_eq_0 => LCD_0_control_slave_wait_counter_eq_0,
      LEDs_s1_readdata_from_sa => LEDs_s1_readdata_from_sa,
      LUT_DATA_s1_readdata_from_sa => LUT_DATA_s1_readdata_from_sa,
      LUT_INDEX_s1_irq_from_sa => LUT_INDEX_s1_irq_from_sa,
      LUT_INDEX_s1_readdata_from_sa => LUT_INDEX_s1_readdata_from_sa,
      PIX_VALCLK_s1_irq_from_sa => PIX_VALCLK_s1_irq_from_sa,
      PIX_VALCLK_s1_readdata_from_sa => PIX_VALCLK_s1_readdata_from_sa,
      RAW2RGB_CONTROL_OUT_s1_readdata_from_sa => RAW2RGB_CONTROL_OUT_s1_readdata_from_sa,
      RED_s1_readdata_from_sa => RED_s1_readdata_from_sa,
      RESET_OUT_s1_readdata_from_sa => RESET_OUT_s1_readdata_from_sa,
      SWint2_s1_irq_from_sa => SWint2_s1_irq_from_sa,
      SWint2_s1_readdata_from_sa => SWint2_s1_readdata_from_sa,
      SWint_s1_irq_from_sa => SWint_s1_irq_from_sa,
      SWint_s1_readdata_from_sa => SWint_s1_readdata_from_sa,
      clk => clk,
      cpu_0_data_master_address => cpu_0_data_master_address,
      cpu_0_data_master_byteenable => cpu_0_data_master_byteenable,
      cpu_0_data_master_granted_BLUE_s1 => cpu_0_data_master_granted_BLUE_s1,
      cpu_0_data_master_granted_CCD_XY_s1 => cpu_0_data_master_granted_CCD_XY_s1,
      cpu_0_data_master_granted_DVAL_s1 => cpu_0_data_master_granted_DVAL_s1,
      cpu_0_data_master_granted_GREEN_s1 => cpu_0_data_master_granted_GREEN_s1,
      cpu_0_data_master_granted_IN_mDATA_0_s1 => cpu_0_data_master_granted_IN_mDATA_0_s1,
      cpu_0_data_master_granted_IN_mDATA_1_s1 => cpu_0_data_master_granted_IN_mDATA_1_s1,
      cpu_0_data_master_granted_IN_mDATAd_0_s1 => cpu_0_data_master_granted_IN_mDATAd_0_s1,
      cpu_0_data_master_granted_IN_mDATAd_1_s1 => cpu_0_data_master_granted_IN_mDATAd_1_s1,
      cpu_0_data_master_granted_LCD_0_control_slave => cpu_0_data_master_granted_LCD_0_control_slave,
      cpu_0_data_master_granted_LEDs_s1 => cpu_0_data_master_granted_LEDs_s1,
      cpu_0_data_master_granted_LUT_DATA_s1 => cpu_0_data_master_granted_LUT_DATA_s1,
      cpu_0_data_master_granted_LUT_INDEX_s1 => cpu_0_data_master_granted_LUT_INDEX_s1,
      cpu_0_data_master_granted_PIX_VALCLK_s1 => cpu_0_data_master_granted_PIX_VALCLK_s1,
      cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1 => cpu_0_data_master_granted_RAW2RGB_CONTROL_OUT_s1,
      cpu_0_data_master_granted_RED_s1 => cpu_0_data_master_granted_RED_s1,
      cpu_0_data_master_granted_RESET_OUT_s1 => cpu_0_data_master_granted_RESET_OUT_s1,
      cpu_0_data_master_granted_SWint2_s1 => cpu_0_data_master_granted_SWint2_s1,
      cpu_0_data_master_granted_SWint_s1 => cpu_0_data_master_granted_SWint_s1,
      cpu_0_data_master_granted_cpu_0_jtag_debug_module => cpu_0_data_master_granted_cpu_0_jtag_debug_module,
      cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave => cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave,
      cpu_0_data_master_granted_onchip_memory2_0_s1 => cpu_0_data_master_granted_onchip_memory2_0_s1,
      cpu_0_data_master_granted_performance_counter_0_control_slave => cpu_0_data_master_granted_performance_counter_0_control_slave,
      cpu_0_data_master_granted_sysid_control_slave => cpu_0_data_master_granted_sysid_control_slave,
      cpu_0_data_master_granted_timer_0_s1 => cpu_0_data_master_granted_timer_0_s1,
      cpu_0_data_master_qualified_request_BLUE_s1 => cpu_0_data_master_qualified_request_BLUE_s1,
      cpu_0_data_master_qualified_request_CCD_XY_s1 => cpu_0_data_master_qualified_request_CCD_XY_s1,
      cpu_0_data_master_qualified_request_DVAL_s1 => cpu_0_data_master_qualified_request_DVAL_s1,
      cpu_0_data_master_qualified_request_GREEN_s1 => cpu_0_data_master_qualified_request_GREEN_s1,
      cpu_0_data_master_qualified_request_IN_mDATA_0_s1 => cpu_0_data_master_qualified_request_IN_mDATA_0_s1,
      cpu_0_data_master_qualified_request_IN_mDATA_1_s1 => cpu_0_data_master_qualified_request_IN_mDATA_1_s1,
      cpu_0_data_master_qualified_request_IN_mDATAd_0_s1 => cpu_0_data_master_qualified_request_IN_mDATAd_0_s1,
      cpu_0_data_master_qualified_request_IN_mDATAd_1_s1 => cpu_0_data_master_qualified_request_IN_mDATAd_1_s1,
      cpu_0_data_master_qualified_request_LCD_0_control_slave => cpu_0_data_master_qualified_request_LCD_0_control_slave,
      cpu_0_data_master_qualified_request_LEDs_s1 => cpu_0_data_master_qualified_request_LEDs_s1,
      cpu_0_data_master_qualified_request_LUT_DATA_s1 => cpu_0_data_master_qualified_request_LUT_DATA_s1,
      cpu_0_data_master_qualified_request_LUT_INDEX_s1 => cpu_0_data_master_qualified_request_LUT_INDEX_s1,
      cpu_0_data_master_qualified_request_PIX_VALCLK_s1 => cpu_0_data_master_qualified_request_PIX_VALCLK_s1,
      cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1 => cpu_0_data_master_qualified_request_RAW2RGB_CONTROL_OUT_s1,
      cpu_0_data_master_qualified_request_RED_s1 => cpu_0_data_master_qualified_request_RED_s1,
      cpu_0_data_master_qualified_request_RESET_OUT_s1 => cpu_0_data_master_qualified_request_RESET_OUT_s1,
      cpu_0_data_master_qualified_request_SWint2_s1 => cpu_0_data_master_qualified_request_SWint2_s1,
      cpu_0_data_master_qualified_request_SWint_s1 => cpu_0_data_master_qualified_request_SWint_s1,
      cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module => cpu_0_data_master_qualified_request_cpu_0_jtag_debug_module,
      cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave => cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave,
      cpu_0_data_master_qualified_request_onchip_memory2_0_s1 => cpu_0_data_master_qualified_request_onchip_memory2_0_s1,
      cpu_0_data_master_qualified_request_performance_counter_0_control_slave => cpu_0_data_master_qualified_request_performance_counter_0_control_slave,
      cpu_0_data_master_qualified_request_sysid_control_slave => cpu_0_data_master_qualified_request_sysid_control_slave,
      cpu_0_data_master_qualified_request_timer_0_s1 => cpu_0_data_master_qualified_request_timer_0_s1,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_read_data_valid_BLUE_s1 => cpu_0_data_master_read_data_valid_BLUE_s1,
      cpu_0_data_master_read_data_valid_CCD_XY_s1 => cpu_0_data_master_read_data_valid_CCD_XY_s1,
      cpu_0_data_master_read_data_valid_DVAL_s1 => cpu_0_data_master_read_data_valid_DVAL_s1,
      cpu_0_data_master_read_data_valid_GREEN_s1 => cpu_0_data_master_read_data_valid_GREEN_s1,
      cpu_0_data_master_read_data_valid_IN_mDATA_0_s1 => cpu_0_data_master_read_data_valid_IN_mDATA_0_s1,
      cpu_0_data_master_read_data_valid_IN_mDATA_1_s1 => cpu_0_data_master_read_data_valid_IN_mDATA_1_s1,
      cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1 => cpu_0_data_master_read_data_valid_IN_mDATAd_0_s1,
      cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1 => cpu_0_data_master_read_data_valid_IN_mDATAd_1_s1,
      cpu_0_data_master_read_data_valid_LCD_0_control_slave => cpu_0_data_master_read_data_valid_LCD_0_control_slave,
      cpu_0_data_master_read_data_valid_LEDs_s1 => cpu_0_data_master_read_data_valid_LEDs_s1,
      cpu_0_data_master_read_data_valid_LUT_DATA_s1 => cpu_0_data_master_read_data_valid_LUT_DATA_s1,
      cpu_0_data_master_read_data_valid_LUT_INDEX_s1 => cpu_0_data_master_read_data_valid_LUT_INDEX_s1,
      cpu_0_data_master_read_data_valid_PIX_VALCLK_s1 => cpu_0_data_master_read_data_valid_PIX_VALCLK_s1,
      cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1 => cpu_0_data_master_read_data_valid_RAW2RGB_CONTROL_OUT_s1,
      cpu_0_data_master_read_data_valid_RED_s1 => cpu_0_data_master_read_data_valid_RED_s1,
      cpu_0_data_master_read_data_valid_RESET_OUT_s1 => cpu_0_data_master_read_data_valid_RESET_OUT_s1,
      cpu_0_data_master_read_data_valid_SWint2_s1 => cpu_0_data_master_read_data_valid_SWint2_s1,
      cpu_0_data_master_read_data_valid_SWint_s1 => cpu_0_data_master_read_data_valid_SWint_s1,
      cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module => cpu_0_data_master_read_data_valid_cpu_0_jtag_debug_module,
      cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave => cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave,
      cpu_0_data_master_read_data_valid_onchip_memory2_0_s1 => cpu_0_data_master_read_data_valid_onchip_memory2_0_s1,
      cpu_0_data_master_read_data_valid_performance_counter_0_control_slave => cpu_0_data_master_read_data_valid_performance_counter_0_control_slave,
      cpu_0_data_master_read_data_valid_sysid_control_slave => cpu_0_data_master_read_data_valid_sysid_control_slave,
      cpu_0_data_master_read_data_valid_timer_0_s1 => cpu_0_data_master_read_data_valid_timer_0_s1,
      cpu_0_data_master_requests_BLUE_s1 => cpu_0_data_master_requests_BLUE_s1,
      cpu_0_data_master_requests_CCD_XY_s1 => cpu_0_data_master_requests_CCD_XY_s1,
      cpu_0_data_master_requests_DVAL_s1 => cpu_0_data_master_requests_DVAL_s1,
      cpu_0_data_master_requests_GREEN_s1 => cpu_0_data_master_requests_GREEN_s1,
      cpu_0_data_master_requests_IN_mDATA_0_s1 => cpu_0_data_master_requests_IN_mDATA_0_s1,
      cpu_0_data_master_requests_IN_mDATA_1_s1 => cpu_0_data_master_requests_IN_mDATA_1_s1,
      cpu_0_data_master_requests_IN_mDATAd_0_s1 => cpu_0_data_master_requests_IN_mDATAd_0_s1,
      cpu_0_data_master_requests_IN_mDATAd_1_s1 => cpu_0_data_master_requests_IN_mDATAd_1_s1,
      cpu_0_data_master_requests_LCD_0_control_slave => cpu_0_data_master_requests_LCD_0_control_slave,
      cpu_0_data_master_requests_LEDs_s1 => cpu_0_data_master_requests_LEDs_s1,
      cpu_0_data_master_requests_LUT_DATA_s1 => cpu_0_data_master_requests_LUT_DATA_s1,
      cpu_0_data_master_requests_LUT_INDEX_s1 => cpu_0_data_master_requests_LUT_INDEX_s1,
      cpu_0_data_master_requests_PIX_VALCLK_s1 => cpu_0_data_master_requests_PIX_VALCLK_s1,
      cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1 => cpu_0_data_master_requests_RAW2RGB_CONTROL_OUT_s1,
      cpu_0_data_master_requests_RED_s1 => cpu_0_data_master_requests_RED_s1,
      cpu_0_data_master_requests_RESET_OUT_s1 => cpu_0_data_master_requests_RESET_OUT_s1,
      cpu_0_data_master_requests_SWint2_s1 => cpu_0_data_master_requests_SWint2_s1,
      cpu_0_data_master_requests_SWint_s1 => cpu_0_data_master_requests_SWint_s1,
      cpu_0_data_master_requests_cpu_0_jtag_debug_module => cpu_0_data_master_requests_cpu_0_jtag_debug_module,
      cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave => cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave,
      cpu_0_data_master_requests_onchip_memory2_0_s1 => cpu_0_data_master_requests_onchip_memory2_0_s1,
      cpu_0_data_master_requests_performance_counter_0_control_slave => cpu_0_data_master_requests_performance_counter_0_control_slave,
      cpu_0_data_master_requests_sysid_control_slave => cpu_0_data_master_requests_sysid_control_slave,
      cpu_0_data_master_requests_timer_0_s1 => cpu_0_data_master_requests_timer_0_s1,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      cpu_0_jtag_debug_module_readdata_from_sa => cpu_0_jtag_debug_module_readdata_from_sa,
      d1_BLUE_s1_end_xfer => d1_BLUE_s1_end_xfer,
      d1_CCD_XY_s1_end_xfer => d1_CCD_XY_s1_end_xfer,
      d1_DVAL_s1_end_xfer => d1_DVAL_s1_end_xfer,
      d1_GREEN_s1_end_xfer => d1_GREEN_s1_end_xfer,
      d1_IN_mDATA_0_s1_end_xfer => d1_IN_mDATA_0_s1_end_xfer,
      d1_IN_mDATA_1_s1_end_xfer => d1_IN_mDATA_1_s1_end_xfer,
      d1_IN_mDATAd_0_s1_end_xfer => d1_IN_mDATAd_0_s1_end_xfer,
      d1_IN_mDATAd_1_s1_end_xfer => d1_IN_mDATAd_1_s1_end_xfer,
      d1_LCD_0_control_slave_end_xfer => d1_LCD_0_control_slave_end_xfer,
      d1_LEDs_s1_end_xfer => d1_LEDs_s1_end_xfer,
      d1_LUT_DATA_s1_end_xfer => d1_LUT_DATA_s1_end_xfer,
      d1_LUT_INDEX_s1_end_xfer => d1_LUT_INDEX_s1_end_xfer,
      d1_PIX_VALCLK_s1_end_xfer => d1_PIX_VALCLK_s1_end_xfer,
      d1_RAW2RGB_CONTROL_OUT_s1_end_xfer => d1_RAW2RGB_CONTROL_OUT_s1_end_xfer,
      d1_RED_s1_end_xfer => d1_RED_s1_end_xfer,
      d1_RESET_OUT_s1_end_xfer => d1_RESET_OUT_s1_end_xfer,
      d1_SWint2_s1_end_xfer => d1_SWint2_s1_end_xfer,
      d1_SWint_s1_end_xfer => d1_SWint_s1_end_xfer,
      d1_cpu_0_jtag_debug_module_end_xfer => d1_cpu_0_jtag_debug_module_end_xfer,
      d1_jtag_uart_0_avalon_jtag_slave_end_xfer => d1_jtag_uart_0_avalon_jtag_slave_end_xfer,
      d1_onchip_memory2_0_s1_end_xfer => d1_onchip_memory2_0_s1_end_xfer,
      d1_performance_counter_0_control_slave_end_xfer => d1_performance_counter_0_control_slave_end_xfer,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      d1_timer_0_s1_end_xfer => d1_timer_0_s1_end_xfer,
      jtag_uart_0_avalon_jtag_slave_irq_from_sa => jtag_uart_0_avalon_jtag_slave_irq_from_sa,
      jtag_uart_0_avalon_jtag_slave_readdata_from_sa => jtag_uart_0_avalon_jtag_slave_readdata_from_sa,
      jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa => jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa,
      onchip_memory2_0_s1_readdata_from_sa => onchip_memory2_0_s1_readdata_from_sa,
      performance_counter_0_control_slave_readdata_from_sa => performance_counter_0_control_slave_readdata_from_sa,
      reset_n => clk_reset_n,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa,
      timer_0_s1_irq_from_sa => timer_0_s1_irq_from_sa,
      timer_0_s1_readdata_from_sa => timer_0_s1_readdata_from_sa
    );


  --the_cpu_0_instruction_master, which is an e_instance
  the_cpu_0_instruction_master : cpu_0_instruction_master_arbitrator
    port map(
      cpu_0_instruction_master_address_to_slave => cpu_0_instruction_master_address_to_slave,
      cpu_0_instruction_master_latency_counter => cpu_0_instruction_master_latency_counter,
      cpu_0_instruction_master_readdata => cpu_0_instruction_master_readdata,
      cpu_0_instruction_master_readdatavalid => cpu_0_instruction_master_readdatavalid,
      cpu_0_instruction_master_waitrequest => cpu_0_instruction_master_waitrequest,
      clk => clk,
      cpu_0_instruction_master_address => cpu_0_instruction_master_address,
      cpu_0_instruction_master_granted_cpu_0_jtag_debug_module => cpu_0_instruction_master_granted_cpu_0_jtag_debug_module,
      cpu_0_instruction_master_granted_onchip_memory2_0_s1 => cpu_0_instruction_master_granted_onchip_memory2_0_s1,
      cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module => cpu_0_instruction_master_qualified_request_cpu_0_jtag_debug_module,
      cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 => cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1,
      cpu_0_instruction_master_read => cpu_0_instruction_master_read,
      cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module => cpu_0_instruction_master_read_data_valid_cpu_0_jtag_debug_module,
      cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1 => cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1,
      cpu_0_instruction_master_requests_cpu_0_jtag_debug_module => cpu_0_instruction_master_requests_cpu_0_jtag_debug_module,
      cpu_0_instruction_master_requests_onchip_memory2_0_s1 => cpu_0_instruction_master_requests_onchip_memory2_0_s1,
      cpu_0_jtag_debug_module_readdata_from_sa => cpu_0_jtag_debug_module_readdata_from_sa,
      d1_cpu_0_jtag_debug_module_end_xfer => d1_cpu_0_jtag_debug_module_end_xfer,
      d1_onchip_memory2_0_s1_end_xfer => d1_onchip_memory2_0_s1_end_xfer,
      onchip_memory2_0_s1_readdata_from_sa => onchip_memory2_0_s1_readdata_from_sa,
      reset_n => clk_reset_n
    );


  --the_cpu_0, which is an e_ptf_instance
  the_cpu_0 : cpu_0
    port map(
      A_ci_multi_a => cpu_0_custom_instruction_master_multi_a,
      A_ci_multi_b => cpu_0_custom_instruction_master_multi_b,
      A_ci_multi_c => cpu_0_custom_instruction_master_multi_c,
      A_ci_multi_clk_en => cpu_0_custom_instruction_master_multi_clk_en,
      A_ci_multi_dataa => cpu_0_custom_instruction_master_multi_dataa,
      A_ci_multi_datab => cpu_0_custom_instruction_master_multi_datab,
      A_ci_multi_estatus => cpu_0_custom_instruction_master_multi_estatus,
      A_ci_multi_ipending => cpu_0_custom_instruction_master_multi_ipending,
      A_ci_multi_n => cpu_0_custom_instruction_master_multi_n,
      A_ci_multi_readra => cpu_0_custom_instruction_master_multi_readra,
      A_ci_multi_readrb => cpu_0_custom_instruction_master_multi_readrb,
      A_ci_multi_start => cpu_0_custom_instruction_master_multi_start,
      A_ci_multi_status => cpu_0_custom_instruction_master_multi_status,
      A_ci_multi_writerc => cpu_0_custom_instruction_master_multi_writerc,
      d_address => cpu_0_data_master_address,
      d_byteenable => cpu_0_data_master_byteenable,
      d_read => cpu_0_data_master_read,
      d_write => cpu_0_data_master_write,
      d_writedata => cpu_0_data_master_writedata,
      i_address => cpu_0_instruction_master_address,
      i_read => cpu_0_instruction_master_read,
      jtag_debug_module_debugaccess_to_roms => cpu_0_data_master_debugaccess,
      jtag_debug_module_readdata => cpu_0_jtag_debug_module_readdata,
      jtag_debug_module_resetrequest => cpu_0_jtag_debug_module_resetrequest,
      A_ci_multi_done => cpu_0_custom_instruction_master_multi_done,
      A_ci_multi_result => cpu_0_custom_instruction_master_multi_result,
      clk => clk,
      d_irq => cpu_0_data_master_irq,
      d_readdata => cpu_0_data_master_readdata,
      d_readdatavalid => cpu_0_data_master_readdatavalid,
      d_waitrequest => cpu_0_data_master_waitrequest,
      i_readdata => cpu_0_instruction_master_readdata,
      i_readdatavalid => cpu_0_instruction_master_readdatavalid,
      i_waitrequest => cpu_0_instruction_master_waitrequest,
      jtag_debug_module_address => cpu_0_jtag_debug_module_address,
      jtag_debug_module_begintransfer => cpu_0_jtag_debug_module_begintransfer,
      jtag_debug_module_byteenable => cpu_0_jtag_debug_module_byteenable,
      jtag_debug_module_debugaccess => cpu_0_jtag_debug_module_debugaccess,
      jtag_debug_module_select => cpu_0_jtag_debug_module_chipselect,
      jtag_debug_module_write => cpu_0_jtag_debug_module_write,
      jtag_debug_module_writedata => cpu_0_jtag_debug_module_writedata,
      reset_n => cpu_0_custom_instruction_master_reset_n
    );


  --the_cpu_0_fpoint_s1, which is an e_instance
  the_cpu_0_fpoint_s1 : cpu_0_fpoint_s1_arbitrator
    port map(
      cpu_0_fpoint_s1_clk_en => cpu_0_fpoint_s1_clk_en,
      cpu_0_fpoint_s1_dataa => cpu_0_fpoint_s1_dataa,
      cpu_0_fpoint_s1_datab => cpu_0_fpoint_s1_datab,
      cpu_0_fpoint_s1_done_from_sa => cpu_0_fpoint_s1_done_from_sa,
      cpu_0_fpoint_s1_n => cpu_0_fpoint_s1_n,
      cpu_0_fpoint_s1_reset => cpu_0_fpoint_s1_reset,
      cpu_0_fpoint_s1_result_from_sa => cpu_0_fpoint_s1_result_from_sa,
      cpu_0_fpoint_s1_start => cpu_0_fpoint_s1_start,
      clk => clk,
      cpu_0_custom_instruction_master_multi_clk_en => cpu_0_custom_instruction_master_multi_clk_en,
      cpu_0_custom_instruction_master_multi_dataa => cpu_0_custom_instruction_master_multi_dataa,
      cpu_0_custom_instruction_master_multi_datab => cpu_0_custom_instruction_master_multi_datab,
      cpu_0_custom_instruction_master_multi_n => cpu_0_custom_instruction_master_multi_n,
      cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1 => cpu_0_custom_instruction_master_start_cpu_0_fpoint_s1,
      cpu_0_fpoint_s1_done => cpu_0_fpoint_s1_done,
      cpu_0_fpoint_s1_result => cpu_0_fpoint_s1_result,
      cpu_0_fpoint_s1_select => cpu_0_fpoint_s1_select,
      reset_n => clk_reset_n
    );


  --the_cpu_0_fpoint, which is an e_ptf_instance
  the_cpu_0_fpoint : cpu_0_fpoint
    port map(
      done => cpu_0_fpoint_s1_done,
      result => cpu_0_fpoint_s1_result,
      clk => clk,
      clk_en => cpu_0_fpoint_s1_clk_en,
      dataa => cpu_0_fpoint_s1_dataa,
      datab => cpu_0_fpoint_s1_datab,
      n => cpu_0_fpoint_s1_n,
      reset => cpu_0_fpoint_s1_reset,
      start => cpu_0_fpoint_s1_start
    );


  --the_jtag_uart_0_avalon_jtag_slave, which is an e_instance
  the_jtag_uart_0_avalon_jtag_slave : jtag_uart_0_avalon_jtag_slave_arbitrator
    port map(
      cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave => cpu_0_data_master_granted_jtag_uart_0_avalon_jtag_slave,
      cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave => cpu_0_data_master_qualified_request_jtag_uart_0_avalon_jtag_slave,
      cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave => cpu_0_data_master_read_data_valid_jtag_uart_0_avalon_jtag_slave,
      cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave => cpu_0_data_master_requests_jtag_uart_0_avalon_jtag_slave,
      d1_jtag_uart_0_avalon_jtag_slave_end_xfer => d1_jtag_uart_0_avalon_jtag_slave_end_xfer,
      jtag_uart_0_avalon_jtag_slave_address => jtag_uart_0_avalon_jtag_slave_address,
      jtag_uart_0_avalon_jtag_slave_chipselect => jtag_uart_0_avalon_jtag_slave_chipselect,
      jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa => jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa,
      jtag_uart_0_avalon_jtag_slave_irq_from_sa => jtag_uart_0_avalon_jtag_slave_irq_from_sa,
      jtag_uart_0_avalon_jtag_slave_read_n => jtag_uart_0_avalon_jtag_slave_read_n,
      jtag_uart_0_avalon_jtag_slave_readdata_from_sa => jtag_uart_0_avalon_jtag_slave_readdata_from_sa,
      jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa => jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa,
      jtag_uart_0_avalon_jtag_slave_reset_n => jtag_uart_0_avalon_jtag_slave_reset_n,
      jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa => jtag_uart_0_avalon_jtag_slave_waitrequest_from_sa,
      jtag_uart_0_avalon_jtag_slave_write_n => jtag_uart_0_avalon_jtag_slave_write_n,
      jtag_uart_0_avalon_jtag_slave_writedata => jtag_uart_0_avalon_jtag_slave_writedata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      jtag_uart_0_avalon_jtag_slave_dataavailable => jtag_uart_0_avalon_jtag_slave_dataavailable,
      jtag_uart_0_avalon_jtag_slave_irq => jtag_uart_0_avalon_jtag_slave_irq,
      jtag_uart_0_avalon_jtag_slave_readdata => jtag_uart_0_avalon_jtag_slave_readdata,
      jtag_uart_0_avalon_jtag_slave_readyfordata => jtag_uart_0_avalon_jtag_slave_readyfordata,
      jtag_uart_0_avalon_jtag_slave_waitrequest => jtag_uart_0_avalon_jtag_slave_waitrequest,
      reset_n => clk_reset_n
    );


  --the_jtag_uart_0, which is an e_ptf_instance
  the_jtag_uart_0 : jtag_uart_0
    port map(
      av_irq => jtag_uart_0_avalon_jtag_slave_irq,
      av_readdata => jtag_uart_0_avalon_jtag_slave_readdata,
      av_waitrequest => jtag_uart_0_avalon_jtag_slave_waitrequest,
      dataavailable => jtag_uart_0_avalon_jtag_slave_dataavailable,
      readyfordata => jtag_uart_0_avalon_jtag_slave_readyfordata,
      av_address => jtag_uart_0_avalon_jtag_slave_address,
      av_chipselect => jtag_uart_0_avalon_jtag_slave_chipselect,
      av_read_n => jtag_uart_0_avalon_jtag_slave_read_n,
      av_write_n => jtag_uart_0_avalon_jtag_slave_write_n,
      av_writedata => jtag_uart_0_avalon_jtag_slave_writedata,
      clk => clk,
      rst_n => jtag_uart_0_avalon_jtag_slave_reset_n
    );


  --the_onchip_memory2_0_s1, which is an e_instance
  the_onchip_memory2_0_s1 : onchip_memory2_0_s1_arbitrator
    port map(
      cpu_0_data_master_granted_onchip_memory2_0_s1 => cpu_0_data_master_granted_onchip_memory2_0_s1,
      cpu_0_data_master_qualified_request_onchip_memory2_0_s1 => cpu_0_data_master_qualified_request_onchip_memory2_0_s1,
      cpu_0_data_master_read_data_valid_onchip_memory2_0_s1 => cpu_0_data_master_read_data_valid_onchip_memory2_0_s1,
      cpu_0_data_master_requests_onchip_memory2_0_s1 => cpu_0_data_master_requests_onchip_memory2_0_s1,
      cpu_0_instruction_master_granted_onchip_memory2_0_s1 => cpu_0_instruction_master_granted_onchip_memory2_0_s1,
      cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1 => cpu_0_instruction_master_qualified_request_onchip_memory2_0_s1,
      cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1 => cpu_0_instruction_master_read_data_valid_onchip_memory2_0_s1,
      cpu_0_instruction_master_requests_onchip_memory2_0_s1 => cpu_0_instruction_master_requests_onchip_memory2_0_s1,
      d1_onchip_memory2_0_s1_end_xfer => d1_onchip_memory2_0_s1_end_xfer,
      onchip_memory2_0_s1_address => onchip_memory2_0_s1_address,
      onchip_memory2_0_s1_byteenable => onchip_memory2_0_s1_byteenable,
      onchip_memory2_0_s1_chipselect => onchip_memory2_0_s1_chipselect,
      onchip_memory2_0_s1_clken => onchip_memory2_0_s1_clken,
      onchip_memory2_0_s1_readdata_from_sa => onchip_memory2_0_s1_readdata_from_sa,
      onchip_memory2_0_s1_write => onchip_memory2_0_s1_write,
      onchip_memory2_0_s1_writedata => onchip_memory2_0_s1_writedata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_byteenable => cpu_0_data_master_byteenable,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      cpu_0_instruction_master_address_to_slave => cpu_0_instruction_master_address_to_slave,
      cpu_0_instruction_master_latency_counter => cpu_0_instruction_master_latency_counter,
      cpu_0_instruction_master_read => cpu_0_instruction_master_read,
      onchip_memory2_0_s1_readdata => onchip_memory2_0_s1_readdata,
      reset_n => clk_reset_n
    );


  --the_onchip_memory2_0, which is an e_ptf_instance
  the_onchip_memory2_0 : onchip_memory2_0
    port map(
      readdata => onchip_memory2_0_s1_readdata,
      address => onchip_memory2_0_s1_address,
      byteenable => onchip_memory2_0_s1_byteenable,
      chipselect => onchip_memory2_0_s1_chipselect,
      clk => clk,
      clken => onchip_memory2_0_s1_clken,
      write => onchip_memory2_0_s1_write,
      writedata => onchip_memory2_0_s1_writedata
    );


  --the_performance_counter_0_control_slave, which is an e_instance
  the_performance_counter_0_control_slave : performance_counter_0_control_slave_arbitrator
    port map(
      cpu_0_data_master_granted_performance_counter_0_control_slave => cpu_0_data_master_granted_performance_counter_0_control_slave,
      cpu_0_data_master_qualified_request_performance_counter_0_control_slave => cpu_0_data_master_qualified_request_performance_counter_0_control_slave,
      cpu_0_data_master_read_data_valid_performance_counter_0_control_slave => cpu_0_data_master_read_data_valid_performance_counter_0_control_slave,
      cpu_0_data_master_requests_performance_counter_0_control_slave => cpu_0_data_master_requests_performance_counter_0_control_slave,
      d1_performance_counter_0_control_slave_end_xfer => d1_performance_counter_0_control_slave_end_xfer,
      performance_counter_0_control_slave_address => performance_counter_0_control_slave_address,
      performance_counter_0_control_slave_begintransfer => performance_counter_0_control_slave_begintransfer,
      performance_counter_0_control_slave_readdata_from_sa => performance_counter_0_control_slave_readdata_from_sa,
      performance_counter_0_control_slave_reset_n => performance_counter_0_control_slave_reset_n,
      performance_counter_0_control_slave_write => performance_counter_0_control_slave_write,
      performance_counter_0_control_slave_writedata => performance_counter_0_control_slave_writedata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      performance_counter_0_control_slave_readdata => performance_counter_0_control_slave_readdata,
      reset_n => clk_reset_n
    );


  --the_performance_counter_0, which is an e_ptf_instance
  the_performance_counter_0 : performance_counter_0
    port map(
      readdata => performance_counter_0_control_slave_readdata,
      address => performance_counter_0_control_slave_address,
      begintransfer => performance_counter_0_control_slave_begintransfer,
      clk => clk,
      reset_n => performance_counter_0_control_slave_reset_n,
      write => performance_counter_0_control_slave_write,
      writedata => performance_counter_0_control_slave_writedata
    );


  --the_sysid_control_slave, which is an e_instance
  the_sysid_control_slave : sysid_control_slave_arbitrator
    port map(
      cpu_0_data_master_granted_sysid_control_slave => cpu_0_data_master_granted_sysid_control_slave,
      cpu_0_data_master_qualified_request_sysid_control_slave => cpu_0_data_master_qualified_request_sysid_control_slave,
      cpu_0_data_master_read_data_valid_sysid_control_slave => cpu_0_data_master_read_data_valid_sysid_control_slave,
      cpu_0_data_master_requests_sysid_control_slave => cpu_0_data_master_requests_sysid_control_slave,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      sysid_control_slave_address => sysid_control_slave_address,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      reset_n => clk_reset_n,
      sysid_control_slave_readdata => sysid_control_slave_readdata
    );


  --the_sysid, which is an e_ptf_instance
  the_sysid : sysid
    port map(
      readdata => sysid_control_slave_readdata,
      address => sysid_control_slave_address
    );


  --the_timer_0_s1, which is an e_instance
  the_timer_0_s1 : timer_0_s1_arbitrator
    port map(
      cpu_0_data_master_granted_timer_0_s1 => cpu_0_data_master_granted_timer_0_s1,
      cpu_0_data_master_qualified_request_timer_0_s1 => cpu_0_data_master_qualified_request_timer_0_s1,
      cpu_0_data_master_read_data_valid_timer_0_s1 => cpu_0_data_master_read_data_valid_timer_0_s1,
      cpu_0_data_master_requests_timer_0_s1 => cpu_0_data_master_requests_timer_0_s1,
      d1_timer_0_s1_end_xfer => d1_timer_0_s1_end_xfer,
      timer_0_s1_address => timer_0_s1_address,
      timer_0_s1_chipselect => timer_0_s1_chipselect,
      timer_0_s1_irq_from_sa => timer_0_s1_irq_from_sa,
      timer_0_s1_readdata_from_sa => timer_0_s1_readdata_from_sa,
      timer_0_s1_reset_n => timer_0_s1_reset_n,
      timer_0_s1_write_n => timer_0_s1_write_n,
      timer_0_s1_writedata => timer_0_s1_writedata,
      clk => clk,
      cpu_0_data_master_address_to_slave => cpu_0_data_master_address_to_slave,
      cpu_0_data_master_latency_counter => cpu_0_data_master_latency_counter,
      cpu_0_data_master_read => cpu_0_data_master_read,
      cpu_0_data_master_write => cpu_0_data_master_write,
      cpu_0_data_master_writedata => cpu_0_data_master_writedata,
      reset_n => clk_reset_n,
      timer_0_s1_irq => timer_0_s1_irq,
      timer_0_s1_readdata => timer_0_s1_readdata
    );


  --the_timer_0, which is an e_ptf_instance
  the_timer_0 : timer_0
    port map(
      irq => timer_0_s1_irq,
      readdata => timer_0_s1_readdata,
      address => timer_0_s1_address,
      chipselect => timer_0_s1_chipselect,
      clk => clk,
      reset_n => timer_0_s1_reset_n,
      write_n => timer_0_s1_write_n,
      writedata => timer_0_s1_writedata
    );


  --reset is asserted asynchronously and deasserted synchronously
  niosii_reset_clk_domain_synch : niosii_reset_clk_domain_synch_module
    port map(
      data_out => clk_reset_n,
      clk => clk,
      data_in => module_input,
      reset_n => reset_n_sources
    );

  module_input <= std_logic'('1');

  --reset sources mux, which is an e_mux
  reset_n_sources <= Vector_To_Std_Logic(NOT (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT reset_n))) OR std_logic_vector'("00000000000000000000000000000000")) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_jtag_debug_module_resetrequest_from_sa)))) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_0_jtag_debug_module_resetrequest_from_sa))))));
  --vhdl renameroo for output signals
  LCD_E_from_the_LCD_0 <= internal_LCD_E_from_the_LCD_0;
  --vhdl renameroo for output signals
  LCD_RS_from_the_LCD_0 <= internal_LCD_RS_from_the_LCD_0;
  --vhdl renameroo for output signals
  LCD_RW_from_the_LCD_0 <= internal_LCD_RW_from_the_LCD_0;
  --vhdl renameroo for output signals
  out_port_from_the_BLUE <= internal_out_port_from_the_BLUE;
  --vhdl renameroo for output signals
  out_port_from_the_DVAL <= internal_out_port_from_the_DVAL;
  --vhdl renameroo for output signals
  out_port_from_the_GREEN <= internal_out_port_from_the_GREEN;
  --vhdl renameroo for output signals
  out_port_from_the_LEDs <= internal_out_port_from_the_LEDs;
  --vhdl renameroo for output signals
  out_port_from_the_LUT_DATA <= internal_out_port_from_the_LUT_DATA;
  --vhdl renameroo for output signals
  out_port_from_the_RAW2RGB_CONTROL_OUT <= internal_out_port_from_the_RAW2RGB_CONTROL_OUT;
  --vhdl renameroo for output signals
  out_port_from_the_RED <= internal_out_port_from_the_RED;
  --vhdl renameroo for output signals
  out_port_from_the_RESET_OUT <= internal_out_port_from_the_RESET_OUT;

end europa;


--synthesis translate_off

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;



-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your libraries here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>

entity test_bench is 
end entity test_bench;


architecture europa of test_bench is
component niosii is 
           port (
                 -- 1) global signals:
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- the_BLUE
                    signal out_port_from_the_BLUE : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- the_CCD_XY
                    signal in_port_to_the_CCD_XY : IN STD_LOGIC_VECTOR (1 DOWNTO 0);

                 -- the_DVAL
                    signal out_port_from_the_DVAL : OUT STD_LOGIC;

                 -- the_GREEN
                    signal out_port_from_the_GREEN : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- the_IN_mDATA_0
                    signal in_port_to_the_IN_mDATA_0 : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- the_IN_mDATA_1
                    signal in_port_to_the_IN_mDATA_1 : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- the_IN_mDATAd_0
                    signal in_port_to_the_IN_mDATAd_0 : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- the_IN_mDATAd_1
                    signal in_port_to_the_IN_mDATAd_1 : IN STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- the_LCD_0
                    signal LCD_E_from_the_LCD_0 : OUT STD_LOGIC;
                    signal LCD_RS_from_the_LCD_0 : OUT STD_LOGIC;
                    signal LCD_RW_from_the_LCD_0 : OUT STD_LOGIC;
                    signal LCD_data_to_and_from_the_LCD_0 : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_LEDs
                    signal out_port_from_the_LEDs : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_LUT_DATA
                    signal out_port_from_the_LUT_DATA : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);

                 -- the_LUT_INDEX
                    signal in_port_to_the_LUT_INDEX : IN STD_LOGIC_VECTOR (5 DOWNTO 0);

                 -- the_PIX_VALCLK
                    signal in_port_to_the_PIX_VALCLK : IN STD_LOGIC;

                 -- the_RAW2RGB_CONTROL_OUT
                    signal out_port_from_the_RAW2RGB_CONTROL_OUT : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);

                 -- the_RED
                    signal out_port_from_the_RED : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);

                 -- the_RESET_OUT
                    signal out_port_from_the_RESET_OUT : OUT STD_LOGIC;

                 -- the_SWint
                    signal in_port_to_the_SWint : IN STD_LOGIC_VECTOR (7 DOWNTO 0);

                 -- the_SWint2
                    signal in_port_to_the_SWint2 : IN STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component niosii;

                signal LCD_E_from_the_LCD_0 :  STD_LOGIC;
                signal LCD_RS_from_the_LCD_0 :  STD_LOGIC;
                signal LCD_RW_from_the_LCD_0 :  STD_LOGIC;
                signal LCD_data_to_and_from_the_LCD_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal clk :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_a :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_b :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_c :  STD_LOGIC_VECTOR (4 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_estatus :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_ipending :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_0_custom_instruction_master_multi_readra :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_readrb :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_status :  STD_LOGIC;
                signal cpu_0_custom_instruction_master_multi_writerc :  STD_LOGIC;
                signal in_port_to_the_CCD_XY :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal in_port_to_the_IN_mDATA_0 :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal in_port_to_the_IN_mDATA_1 :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal in_port_to_the_IN_mDATAd_0 :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal in_port_to_the_IN_mDATAd_1 :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal in_port_to_the_LUT_INDEX :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal in_port_to_the_PIX_VALCLK :  STD_LOGIC;
                signal in_port_to_the_SWint :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal in_port_to_the_SWint2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal jtag_uart_0_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_uart_0_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal out_port_from_the_BLUE :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal out_port_from_the_DVAL :  STD_LOGIC;
                signal out_port_from_the_GREEN :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal out_port_from_the_LEDs :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal out_port_from_the_LUT_DATA :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal out_port_from_the_RAW2RGB_CONTROL_OUT :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal out_port_from_the_RED :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal out_port_from_the_RESET_OUT :  STD_LOGIC;
                signal reset_n :  STD_LOGIC;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your component and signal declaration here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


begin

  --Set us up the Dut
  DUT : niosii
    port map(
      LCD_E_from_the_LCD_0 => LCD_E_from_the_LCD_0,
      LCD_RS_from_the_LCD_0 => LCD_RS_from_the_LCD_0,
      LCD_RW_from_the_LCD_0 => LCD_RW_from_the_LCD_0,
      LCD_data_to_and_from_the_LCD_0 => LCD_data_to_and_from_the_LCD_0,
      out_port_from_the_BLUE => out_port_from_the_BLUE,
      out_port_from_the_DVAL => out_port_from_the_DVAL,
      out_port_from_the_GREEN => out_port_from_the_GREEN,
      out_port_from_the_LEDs => out_port_from_the_LEDs,
      out_port_from_the_LUT_DATA => out_port_from_the_LUT_DATA,
      out_port_from_the_RAW2RGB_CONTROL_OUT => out_port_from_the_RAW2RGB_CONTROL_OUT,
      out_port_from_the_RED => out_port_from_the_RED,
      out_port_from_the_RESET_OUT => out_port_from_the_RESET_OUT,
      clk => clk,
      in_port_to_the_CCD_XY => in_port_to_the_CCD_XY,
      in_port_to_the_IN_mDATA_0 => in_port_to_the_IN_mDATA_0,
      in_port_to_the_IN_mDATA_1 => in_port_to_the_IN_mDATA_1,
      in_port_to_the_IN_mDATAd_0 => in_port_to_the_IN_mDATAd_0,
      in_port_to_the_IN_mDATAd_1 => in_port_to_the_IN_mDATAd_1,
      in_port_to_the_LUT_INDEX => in_port_to_the_LUT_INDEX,
      in_port_to_the_PIX_VALCLK => in_port_to_the_PIX_VALCLK,
      in_port_to_the_SWint => in_port_to_the_SWint,
      in_port_to_the_SWint2 => in_port_to_the_SWint2,
      reset_n => reset_n
    );


  --default value specified in MODULE SWint ptf port section
  in_port_to_the_SWint <= std_logic_vector'("00000000");
  process
  begin
    clk <= '0';
    loop
       if (clk = '1') then
          wait for 3 ns;
          clk <= not clk;
       else
          wait for 4 ns;
          clk <= not clk;
       end if;
    end loop;
  end process;
  PROCESS
    BEGIN
       reset_n <= '0';
       wait for 70 ns;
       reset_n <= '1'; 
    WAIT;
  END PROCESS;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add additional architecture here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


end europa;



--synthesis translate_on
